import numpy as np
import matplotlib.pyplot as plt
from scipy.optimize import least_squares
import configparser
import winsound; 

def Calc_J(VE_Par_1_cen,VE_Par_2_cen,i_ve,n,p_exp,pp_exp):
    J = np.zeros(nlay,dtype = complex)
    n_norm = n * f_fund / f_Jref;
    om = 2. * np.pi * n * f_fund;
    for il in range(nlay):
        if i_ve[il] == 1:
            VE_Par_1 = VE_Par_1_cen[il] * n_norm**p_exp[il]; 
            VE_Par_2 = VE_Par_2_cen[il] * n_norm**pp_exp[il]; 
            Jloc = VE_Par_1 - 1j * VE_Par_2;
        if i_ve[il] == 2:
            VE_Par_1 = VE_Par_1_cen[il] * n_norm**p_exp[il]; 
            VE_Par_2 = VE_Par_2_cen[il] * n_norm**pp_exp[il]; 
            Gp  = VE_Par_1
            Gpp = VE_Par_2
            Gsqr = Gp**2 + Gpp**2
            Jloc = Gp/Gsqr  - 1j * Gpp/Gsqr;
        if i_ve[il] == 3:
            VE_Par_1 = VE_Par_1_cen[il] * n_norm**p_exp[il]; 
            VE_Par_2 = VE_Par_2_cen[il] * n_norm**pp_exp[il]; 
            Gp  = om*VE_Par_2*1e-3/1e6;
            Gpp = om*VE_Par_1*1e-3/1e6
            Gsqr = Gp**2 + Gpp**2
            Jloc = Gp/Gsqr  - 1j * Gpp/Gsqr;
        if i_ve[il] == 4:
            VE_Par_1 = VE_Par_1_cen[il] * n_norm**p_exp[il]; 
            VE_Par_2 = VE_Par_2_cen[il] * n_norm**pp_exp[il]; 
            Gp  =    VE_Par_1
            Gpp = om*VE_Par_2*1e-3/1e6;
            Gsqr = Gp**2 + Gpp**2
            Jloc = Gp/Gsqr  - 1j * Gpp/Gsqr;
        if i_ve[il] == 5:
            Jabs   = VE_Par_1_cen[il];
            tandel = VE_Par_2_cen[il];
            cosdel = 1./(1.+ tandel**2)**0.5;
            sindel = tandel * cosdel;
            Jp  = Jabs*cosdel * n_norm**p_exp[il]
            Jpp = Jabs*sindel * n_norm**pp_exp[il]
            Jloc = Jp - 1j * Jpp;
        if i_ve[il] == 6:
            Gabs   = VE_Par_1_cen[il];
            tandel = VE_Par_2_cen[il];
            cosdel = 1./(1.+ tandel**2)**0.5;
            sindel = tandel * cosdel;
            Gp  = Gabs*cosdel * n_norm**p_exp[il]
            Gpp = Gabs*sindel * n_norm**pp_exp[il]
            Gsqr = Gp**2 + Gpp**2
            Jloc = Gp/Gsqr  - 1j * Gpp/Gsqr;
        if i_ve[il] == 7:
            etaabs = VE_Par_1_cen[il];
            tandelinv = VE_Par_2_cen[il];
            cosdelinv = 1./(1.+ tandelinv**2)**0.5;
            sindelinv = tandelinv * cosdelinv;
            etap  = etaabs * cosdelinv * n_norm**p_exp[il] 
            etapp = etaabs * sindelinv * n_norm**pp_exp[il] 
            Gp   = om*etapp*1e-3/1e6
            Gpp  = om*etap *1e-3/1e6
            Gsqr = Gp**2 + Gpp**2
            Jloc = Gp/Gsqr  - 1j * Gpp/Gsqr;
        J[il] = Jloc * 1e-6;        
    return J

def Assign_Vals_for_Perturbation_3(d,rho,J,vers,AspRat,n,f_fund,Zq):
    om = 2 * np.pi * n * f_fund
    d_e = d[0]; rho_e = rho[0]; 
    d_f = d[1]; rho_f = rho[1];
    rho_b             = rho[2]; 
    mq = Zq/(2*f_fund)
    J_e = J[0]
    J_f = J[1]
    J_b = J[2]
    Z_e = np.sqrt(rho_e / J_e)
    Z_f = np.sqrt(rho_f / J_f)
    Z_b = np.sqrt(rho_b / J_b)
    k_b = om * (rho_b*J_b)**0.5
    Z_b *= 1 + (vers * k_b)**2; 
    Z_b += 1j * om * rho * vers * 3./2. * np.pi**0.5 * AspRat; 
    mue = rho_e * d_e/mq
    muf = rho_f * d_f/mq
    xil = Z_b/Zq
    zee = (Zq/Z_e)**2 - 1
    zef = (Zq/Z_f)**2 - 1
    nPi = n * np.pi
    return mue,muf,xil,zee,zef,nPi

def Perturbation_3(d,rho,J,vers,AspRat,n,f_fund,Zq):
    mue,muf,xil,zee,zef,nPi = \
      Assign_Vals_for_Perturbation_3(d,rho,J,vers,AspRat,n,f_fund,Zq);
    coeff0 = ((1j*xil)/nPi) + (1j*xil**3)/(3.*nPi) + 1./3.*mue**3*(-3. - nPi**2*zee) + \
        mue*(-1. - (1j*xil)/nPi + xil**2*zee) + \
        mue**2*(1. + xil*((1j/nPi) + 1j*nPi*zee))
    coeff1 = -1. - (1j*xil)/nPi + mue**2*(-3. - nPi**2*zee) + \
        mue*(2. + xil*((2.*1j)/nPi + 2.*1j*nPi*zee)) + xil**2*zef
    coeff2 = 1. + mue*(-3. - nPi**2*zee) - (1j*xil*(1. + nPi**2*zef))/nPi
    coeff3 = 1./3.*(-3. - nPi**2*zef)
    dfbyf = coeff0 + coeff1 * muf + coeff2 * muf**2 + coeff3 * muf**3
    dfc = n*f_fund*dfbyf
    return dfc

def Perturbation_5(d,rho,J,vers,AspRat,n,f_fund,Zq):
    mue,muf,xil,zee,zef,nPi = \
      Assign_Vals_for_Perturbation_3(d,rho,J,vers,AspRat,n,f_fund,Zq);
    coeff0 =((1j*xil)/nPi) + (1j*xil**3)/(3.*nPi) + (1j*xil**5)/(5.*nPi) + \
        1./15.*mue**5*(-15. - 50.*nPi**2*zee + nPi**4.*zee - 2.*nPi**4*zee**2) + \
        mue*(-1 - (1j*xil)/nPi + xil**2*zee + xil**4*zee + \
        xil**3*(-1j/(3.*nPi) + (1j*zee)/nPi)) + \
        mue**2*(1 - 4.*xil**2*zee + xil*((1j/nPi) + 1j*nPi*zee) + \
        xil**3*((1j/(3.*nPi)) - (3.*1j*zee)/nPi + 1j*nPi*zee - 1j*nPi*zee**2)) + \
        mue**3*(-1. - (nPi**2*zee)/3. + xil*(-1j/nPi - 4.*1j*nPi*zee) + \
        xil**2*(10.*zee - (2.*nPi**2*zee)/3. + (4.*nPi**2*zee**2)/3.)) + \
        mue**4*(1. + (4.*nPi**2*zee)/3. + \
        xil*((1j/nPi) + 10.*1j*nPi*zee - 1./3.*1j*nPi**3*zee + 2./3.*1j*nPi**3*zee**2))
    coeff1 = -1. - (1j*xil)/nPi + \
        1./3.*mue**4*(-15. - 50.*nPi**2*zee + nPi**4*zee - 2.*nPi**4*zee**2) + \
        mue**3*(4. + (16.*nPi**2*zee)/3. + \
        xil*(((4*1j)/nPi) + 40.*1j*nPi*zee - 4./3.*1j*nPi**3*zee + \
        8./3.*1j*nPi**3*zee**2)) + xil**2*zef + xil**4*zef \
        +(1j*xil**3*(-1. + 3.*zef))/(3.*nPi) + \
        mue*(2. + xil*(((2.*1j)/nPi) + 2.*1j*nPi*zee) + xil**2*(-6.*zee - 2.*zef) + \
        xil**3*(((2*1j)/(3*nPi)) - (4*1j*zee)/nPi + 2.*1j*nPi*zee - (2*1j*zef) / \
        nPi - 2.*1j*nPi*zee*zef)) + \
        mue**2*(-3. - nPi**2*zee + xil*(-(3.*1j)/nPi - 12.*1j*nPi*zee) + \
        xil**2*(27.*zee - 2.*nPi**2*zee + 3.*nPi**2*zee**2 + 3.*zef + \
        nPi**2*zee*zef))
    coeff2 = 1 - 2./3.*mue**3*(15. + 50.*nPi**2*zee - nPi**4*zee + 2.*nPi**4*zee**2) - \
        4*xil**2*zef + (1j*xil*(1. + nPi**2*zef))/nPi - \
        (1j*xil**3*(-1. + 9.*zef - 3.*nPi**2*zef + 3.*nPi**2*zef**2))/(3.*nPi) + \
        mue*(-3. - nPi**2*zee + xil*(-(3.*1j)/nPi - 9.*1j*nPi*zee - 3*1j*nPi*zef) + \
        xil**2*(18.*zee - 2.*nPi**2*zee + 12.*zef + 4.*nPi**2*zee*zef)) + \
        mue**2*(6. + 8.*nPi**2*zee + \
        xil*(((6.*1j)/nPi) + 54.*1j*nPi*zee - 2.*1j*nPi**3*zee + 3.*1j*nPi**3*zee**2 +\
        6.*1j*nPi*zef + 1j*nPi**3*zee*zef))
    coeff3 =  1./3.*(-3. - nPi**2*zef) + 2./3.*xil**2*zef*(15. - nPi**2 + 2.*nPi**2*zef) - \
        (1j*xil*(1. + 4.*nPi**2*zef))/nPi + \
        1./3.*mue**2*(-30. - 90.*nPi**2*zee + 2.*nPi**4*zee - 3.*nPi**4*zee**2 - \
        10.*nPi**2*zef - nPi**4*zee*zef) + \
        mue*(4. + 4.*nPi**2*zee + (4.*nPi**2*zef)/3. + \
        xil*(((4*1j)/nPi) + 24.*1j*nPi*zee - 4./3.*1j*nPi**3*zee + 16.*1j*nPi*zef +\
        8./3.*1j*nPi**3*zee*zef))
    coeff4 = 1./3.*(3. + 4.*nPi**2*zef) + \
        1./3.*mue*(-15. - 30.*nPi**2*zee + nPi**4*zee - 20.*nPi**2*zef -\
        2.*nPi**4*zee*zef) + \
        ( 1j*xil*(3. + 30.*nPi**2*zef - nPi**4*zef + 2.*nPi**4*zef**2))/(3.*nPi)
    coeff5 =1./15.*(-15. - 50.*nPi**2*zef + nPi**4*zef - 2.*nPi**4*zef**2)
    dfbyf = coeff0 + coeff1 * muf + coeff2 * muf**2 + coeff3 * muf**3 + coeff4 * muf**4 + coeff5 * muf**5
    dfc = n*f_fund*dfbyf
    return dfc

def dfcAMF(d,rho,J,vers,AspRat,n,f_fund,Zq):
    om = 2 * np.pi * n * f_fund
    Z = np.zeros(nlay,dtype = complex)
    k = np.zeros(nlay,dtype = complex)
    for i in range(nlay):
        Z[i] =      (rho[i]/J[i])**0.5 
        k[i] = om * (rho[i]*J[i])**0.5
        if i == 3:
            Z[i] *= 1 + (vers * k[i])**2;  # roughness
            Z[i] += 1j * om * rho * vers * 3./2. * np.pi**0.5 * AspRat; 
    Zp1 = Z[nlay-1]
    amp = np.array([1.+0.*1j,0.+0.*1j])
    for ii in range(nlay-1):
        i = nlay - ii - 2;
        if d[i] > 0 :
            Zrat = Zp1/Z[i];
            Zp1 = Z[i];
            propInterface = 1./2. * np.array([[(1+Zrat)/2.,(1-Zrat)/2.],[(1-Zrat)/2.,(1+Zrat)/2.]])
            propLayer     =         np.array([[np.exp(1j*k[i]*d[i]),0.],[0.,np.exp(-1j*k[i]*d[i])]])
            amp = np.dot(propInterface,amp) 
            amp = np.dot(propLayer,amp)
    Refl = amp[1]/amp[0]
    ZL = Zp1*(1-Refl)/(1+Refl)
    dfc = f_fund *1j /(np.pi * Zq)*ZL   
    return dfc 

def Get_Labels() : 
    keys =   ['t_e','t_f','rho_e','rho_f','rho_b','Jp_e','Jp_f','Jp_b','Jp_exp_e','Jp_exp_f','Jp_exp_b',\
          'Jpp_e','Jpp_f','Jpp_b','Jpp_exp_e','Jpp_exp_f','Jpp_exp_b','vers','AspRat',\
          'i_ve_e','i_ve_f','i_ve_b']
    model_keys = {'AMF' :1, 'PE3' :2, 'PE5' :3}
    IO_Labels = [
    'Thickness Layer 1 [nm]',\
    'Thickness Layer 2 [nm]',\
    'Density Layer 1 [g/cm^3]',\
    'Density Layer 2 [g/cm^3]',\
    'Density Bulk [g/cm^3]',\
    'VE par 1 Layer 1',\
    'VE par 1 Layer 2',\
    'VE par 1 Bulk',\
    'Power Law Expon. beta_p Layer 1',\
    'Power Law Expon. beta_p Layer 2',\
    'Power Law Expon. beta_p Bulk',\
    'VE par 2 Layer 1',\
    'VE par 2 Layer 2',\
    'VE par 2 Bulk',\
    'Power Law Expon. beta_pp Layer 1',\
    'Power Law Expon. beta_pp Layer 2',\
    'Power Law Expon. beta_pp Bulk',\
    'vertical scale of roughness [nm]',\
    'aspect ratio',\
    'choice of VE Pars, Layer 1',\
    'choice of VE Pars, Layer 2',\
    'choice of VE Pars, Bulk']
    IncLabels = ['B_t_e_C','B_t_f_C','B_rho_e_C','B_rho_f_C','B_rho_b_C','B_Jp_e_C',\
          'B_Jp_f_C','B_Jp_b_C','B_Jp_exp_e_C','B_Jp_exp_f_C','B_Jp_exp_b_C',\
          'B_Jpp_e_C','B_Jpp_f_C','B_Jpp_b_C','B_Jpp_exp_e_C','B_Jpp_exp_f_C','B_Jpp_exp_b_C',\
          'B_vers_C','B_AspRat_C','B_i_ve_e_C','B_i_ve_f_C','B_i_ve_b_C']  
    n_inc_Labels =   ['B_fit_inc1','B_fit_inc2','B_fit_inc3','B_fit_inc4','B_fit_inc5',\
                      'B_fit_inc6','B_fit_inc7','B_fit_inc8','B_fit_inc9','B_fit_inc10']
    n_arr_Labels =   ['n_arr[1]','n_arr[2]','n_arr[3]','n_arr[4]','n_arr[5]',\
                      'n_arr[6]','n_arr[7]','n_arr[8]','n_arr[9]','n_arr[10]']
    df_Labels =   ['df1','df2','df3','df4','df5','df6','df7','df8','df9','df10']
    dG_Labels =   ['dG1','dG2','dG3','dG4','dG5','dG6','dG7','dG8','dG9','dG10']
    IO_Labels = dict(zip(keys,IO_Labels))
    IncLabels = dict(zip(keys,IncLabels))
    return keys,model_keys,IO_Labels,IncLabels,n_inc_Labels,n_arr_Labels,df_Labels,dG_Labels

def Read_Config():
    config = configparser.ConfigParser()
    config.read('QPY.qpy')
    IO_vals = []
    for i in range(len(keys)):
        IO_vals = np.append(IO_vals,0)
        SamplePars    = dict(zip(keys,IO_vals))
        RefPars       = dict(zip(keys,IO_vals))
        LimitsMinPars = dict(zip(keys,IO_vals))
        LimitsMaxPars = dict(zip(keys,IO_vals))
        IncPars       = dict(zip(keys,IO_vals))
    for key in keys:
        SamplePars[key]    = float(config.get('Sample', IO_Labels[key],fallback=-9999.))
        RefPars[key]       = float(config.get('Reference', IO_Labels[key],fallback=-9999.))
        LimitsMinPars[key] = float(config.get('LimitsMin', IO_Labels[key],fallback=-9999.))
        LimitsMaxPars[key] = float(config.get('LimitsMax', IO_Labels[key],fallback=-9999.))
        IncPars[key] = int(config.get('Main',IncLabels[key],fallback=0))
    for key in ['i_ve_e','i_ve_f','i_ve_b']:
        SamplePars[key]    = np.int(config.get('Sample', IO_Labels[key],fallback=-9999.))
       
    for i in range(novts):    
        n_inc[i] = np.int(    config.get('Main',n_inc_Labels[i],fallback=0))
        n_arr[i] = np.int(    config.get('Main',n_arr_Labels[i],fallback=2*i+1))
        df[i]    = float(     config.get('Main',df_Labels[i],fallback=0))  
        dG[i]    = float(     config.get('Main',dG_Labels[i],fallback=0))
    x_axis_low_limit = float( config.get('Main','x_axis_low_limit',fallback=1))
    x_axis_up_limit  = float( config.get('Main','x_axis_up_limit' ,fallback=19))
    B_limits_active  = np.int(config.get('Limits','B_Limits_active',fallback=0))
    i_fit_df_DG      = np.int(config.get('Main','i_fit_df_DG',fallback=3))
    err_Df           = float( config.get('Main','err_Df',fallback=1.))
    i_wei_ninv       = np.int(config.get('Main','i_wei_ninv',fallback=1))
    i_model          = np.int(config.get('Main','i_model',fallback=0)) 
    i_action_PyQTM   = np.int(config.get('Main','i_action_PyQTM',fallback=0))
    B_no_Graph_in_Python = np.int(config.get('Main','B_no_Graph_in_Python',fallback=0))
    SampleString     =        config.get('Settings','Sample',fallback='') 
    InfoString       =        config.get('Settings','Info',fallback='') 
    f_fund           = float( config.get('Settings','f_fund',fallback=-9999.))
    Zq               = float( config.get('Settings','Zq',fallback=0)) 
    f_Jref           = float( config.get('Settings','f_Jref',fallback=-9999.))
    chi2_ls_lo_limit = float( config.get('chi2_Landscape','lo_limit',fallback=-9999.))
    chi2_ls_up_limit = float( config.get('chi2_Landscape','up_limit',fallback=-9999.))
    chi2_ls_varied   =        config.get('chi2_Landscape','Varied_Par',fallback=-9999.)
    i_time_direction = np.int(config.get('Multiple','i_time_direction',fallback=0))
    n_skip_dis       = np.int(config.get('Multiple','n_skip_dis',fallback=10))
    for key in keys :
        if IO_Labels[key] == chi2_ls_varied : chi2_ls_varied_key = key; 
    return SamplePars,RefPars,LimitsMinPars,LimitsMaxPars,IncPars,\
        n_inc,n_arr,df,dG,x_axis_low_limit,x_axis_up_limit,B_limits_active,\
        i_fit_df_DG,i_wei_ninv,i_model,i_action_PyQTM,\
        SampleString,InfoString,f_fund,Zq,f_Jref,err_Df,B_no_Graph_in_Python,\
        chi2_ls_lo_limit,chi2_ls_up_limit,chi2_ls_varied_key,i_time_direction,n_skip_dis
        
def Write_Fitted_Config(keys,IO_Labels,FittedPars, FitFile) : 
    config = configparser.ConfigParser()
    config.add_section('Sample')
    for key in keys: config.set('Sample',IO_Labels[key],str(FittedPars[key]))
    with open(FitFile, 'w') as configfile: config.write(configfile)
        
def get_layer_arrays(Pars) :
    d = [Pars['t_e'] * 1e-9,Pars['t_f'] * 1e-9,0]
    rho =      [Pars['rho_e']*1e3, Pars['rho_f']*1e3, Pars['rho_b']*1e3 ]
    VE_Par_1_cen = np.array([Pars['Jp_e' ],Pars['Jp_f' ],Pars['Jp_b' ]])  # conversion factors to SI-system depend on itype
    VE_Par_2_cen = np.array([Pars['Jpp_e'],Pars['Jpp_f'],Pars['Jpp_b']])
    p_exp =   [Pars['Jp_exp_e' ],Pars['Jp_exp_f' ],Pars['Jp_exp_b' ]]
    pp_exp =  [Pars['Jpp_exp_e'],Pars['Jpp_exp_f'],Pars['Jpp_exp_b']]
    i_ve = [Pars['i_ve_e'],Pars['i_ve_f'],Pars['i_ve_b']];
    vers = Pars['vers']
    AspRat = Pars['AspRat']
    return d,rho,VE_Par_1_cen,VE_Par_2_cen,p_exp,pp_exp,vers,AspRat,i_ve

def Syspars_to_FitPars(SamplePars,IncPars):
    nFitPars = 0; 
    for key in keys: nFitPars += IncPars[key]
    FitPars = np.ones(nFitPars); MinPars = np.ones(nFitPars); MaxPars = np.ones(nFitPars);
    Graph_Labels = []
    iFitPar = 0
    for key in keys:
        if IncPars[key] == 1 : 
            FitPars[iFitPar] = SamplePars[key]; 
            MinPars[iFitPar] = LimitsMinPars[key]; 
            MaxPars[iFitPar] = LimitsMaxPars[key]; 
            Graph_Labels = np.append(Graph_Labels,IO_Labels[key]); 
            iFitPar += 1
    nFitPars = iFitPar;        
    return nFitPars,FitPars,MinPars,MaxPars,Graph_Labels        
    
def FitPars_to_SysPars(FitPars,IncPars):
    iFitPar = 0
    for key in keys:
        if IncPars[key] == 1 :
            SamplePars[key] = FitPars[iFitPar]; 
            iFitPar += 1
    return SamplePars 

def FitPars_String():
    FitPars_String = ''; iFitPar = 0;
    for key in keys:
        if IncPars[key] == 1 :
            FitPars_String += key + ' ';
            iFitPar += 1
    return FitPars_String 

def ns_inc_dfcs_inc(n_inc,n_arr,dfcs,novt):
    ns_inc = []; dfcs_inc = [];
    for i in range(novt):
        if n_inc[i] == 1 :
            ns_inc = np.append(ns_inc,n_arr[i])
            dfcs_inc = np.append(dfcs_inc,[dfcs[i]])
    return ns_inc,dfcs_inc        

def fit_model(GuessPars,MinPars,MaxPars,x,y):   
    for i in range(len(GuessPars)) :
        if GuessPars[i] < MinPars[i] : GuessPars[i] = MinPars[i] 
        if GuessPars[i] > MaxPars[i] : GuessPars[i] = MaxPars[i] 
    y_stacked = np.hstack((y.real, y.imag))
    def func(SysPars): #  choice of model  
        ymodel,chi2 = Get_dfcs_fit(x,SysPars,i_model)
        ymodel_stacked = np.hstack((ymodel.real, ymodel.imag))
        ns_inv_stacked = np.hstack((ns_inc, ns_inc))
        if i_wei_ninv == 1 : dev_weighted = y_stacked - ymodel_stacked
        if i_wei_ninv == 2 : dev_weighted = (y_stacked - ymodel_stacked) / ns_inv_stacked;
        if i_wei_ninv == 3 : dev_weighted = (y_stacked - ymodel_stacked) / ns_inv_stacked**2;
        return dev_weighted
#    print('Guess: ' + str(GuessPars) + 'Function: ' + str(func))
    if B_limits_active == 1 : FitResult = least_squares(func,GuessPars,bounds=[MinPars,MaxPars])
    else                    : FitResult = least_squares(func,GuessPars)
    dfcs_fit,chi2 = Get_dfcs_fit(x,FitResult.x,i_model)    
    return FitResult,chi2,dfcs_fit

def Get_dfcs_fit(x,FitPars,i_model):
    dfcs_fit     = np.zeros(len(x),dtype=complex)
    dfcs_fit_ref = np.zeros(len(x),dtype=complex)

    SamplePars = FitPars_to_SysPars(FitPars,IncPars)
    d,rho,VE_Par_1_cen,VE_Par_2_cen,p_exp,pp_exp,vers,AspRat,i_ve = get_layer_arrays(SamplePars)
    for i,n in enumerate(x):        
        J = Calc_J(VE_Par_1_cen,VE_Par_2_cen,i_ve,n,p_exp,pp_exp);
        if i_model == model_keys['AMF'] : 
            dfcs_fit[i] = dfcAMF(d,rho,J,vers,AspRat,n,f_fund,Zq);
        if i_model == model_keys['PE3'] :  
            dfcs_fit[i] = Perturbation_3(d,rho,J,vers,AspRat,n,f_fund,Zq);
        if i_model == model_keys['PE5'] :   
            dfcs_fit[i] = Perturbation_5(d,rho,J,vers,AspRat,n,f_fund,Zq);

    d,rho,VE_Par_1_cen,VE_Par_2_cen,p_exp,pp_exp,vers,AspRat,i_ve = get_layer_arrays(RefPars)
    for i, n in enumerate(x) :
        J = Calc_J(VE_Par_1_cen,VE_Par_2_cen,i_ve,n,p_exp,pp_exp);
        if i_model == model_keys['AMF'] :  
            dfcs_fit_ref[i] = dfcAMF(d,rho,J,vers,AspRat,n,f_fund,Zq);
        if i_model == model_keys['PE3'] :  
            dfcs_fit_ref[i] = Perturbation_3(d,rho,J,vers,AspRat,n,f_fund,Zq);
        if i_model == model_keys['PE5'] :   
            dfcs_fit_ref[i] = Perturbation_5(d,rho,J,vers,AspRat,n,f_fund,Zq);
        dfcs_fit[i] -= dfcs_fit_ref[i]  
    chi2 = 0        
    for i, n in enumerate(x) :
#        print('dfcs_fit:' + str(dfcs_fit[i]) + '   dfcs:' + str(dfcs[i]) + '    n: ' + str(n))
        if   i_wei_ninv == 1 : chi2 += (np.absolute(dfcs_fit[i] - dfcs_inc[i]))**2  
        elif i_wei_ninv == 2 : chi2 += (np.absolute(dfcs_fit[i] - dfcs_inc[i]))**2/n  
        elif i_wei_ninv == 3 : chi2 += (np.absolute(dfcs_fit[i] - dfcs_inc[i]))**2/n**2
    chi2 /= err_Df**2
    nfree = 2 * len(x) - len(FitPars)
    if nfree > 0 : chi2 /= nfree 
    return dfcs_fit, chi2

def Simulate():
#    print('Starting Simulation')
    nsim = np.int((x_axis_up_limit - x_axis_low_limit)*10)
    n_sims = np.linspace(x_axis_low_limit,x_axis_up_limit,nsim)
    dfc_sims     = np.zeros(nsim,dtype = complex)
    dfc_sims_ref = np.zeros(nsim,dtype = complex)

    d,rho,VE_Par_1_cen,VE_Par_2_cen,p_exp,pp_exp,vers,AspRat,i_ve = get_layer_arrays(SamplePars)
    for i in range(len(n_sims)):
        J = Calc_J(VE_Par_1_cen,VE_Par_2_cen,i_ve,n_sims[i],p_exp,pp_exp);
        if i_model == model_keys['AMF'] :  
            dfc_sims[i] = dfcAMF(d,rho,J,vers,AspRat,n_sims[i],f_fund,Zq);
        if i_model == model_keys['PE3'] :  
            dfc_sims[i] = Perturbation_3(d,rho,J,vers,AspRat,n_sims[i],f_fund,Zq);
        if i_model == model_keys['PE5'] :   
            dfc_sims[i] = Perturbation_5(d,rho,J,vers,AspRat,n_sims[i],f_fund,Zq);

    d,rho,VE_Par_1_cen,VE_Par_2_cen,p_exp,pp_exp,vers,AspRat,i_ve = get_layer_arrays(RefPars)
    for i in range(len(n_sims)):
        J = Calc_J(VE_Par_1_cen,VE_Par_2_cen,i_ve,n_sims[i],p_exp,pp_exp);
        if i_model == model_keys['AMF'] :  
            dfc_sims_ref[i] = dfcAMF(d,rho,J,vers,AspRat,n_sims[i],f_fund,Zq);
        if i_model == model_keys['PE3'] :  
            dfc_sims_ref[i] = Perturbation_3(d,rho,J,vers,AspRat,n_sims[i],f_fund,Zq);
        if i_model == model_keys['PE5'] :   
            dfc_sims_ref[i] = Perturbation_5(d,rho,J,vers,AspRat,n_sims[i],f_fund,Zq);
        dfc_sims[i] -= dfc_sims_ref[i] 

    np.savetxt('~QPY_sim.txt', np.transpose([n_sims,dfc_sims.real,dfc_sims.imag]))
    if not B_no_Graph_in_Python : 
        plt.subplot(211); plt.title('$\Delta $f/n');
        plt.plot(ns_inc, dfcs_inc.real/ns_inc, 'x'); 
        plt.plot(n_sims, dfc_sims.real/n_sims, '-');
        plt.subplot(212); plt.title('$\Delta \Gamma $/n');
        plt.plot(ns_inc, dfcs_inc.imag/ns_inc, 'x'); 
        plt.plot(n_sims, dfc_sims.imag/n_sims, '-')
        plt.tight_layout(); plt.show();

novts = 10; nlay = 3;
n_inc = np.zeros(novts,dtype = int)
n_arr = np.zeros(novts,dtype = int)
df = np.zeros(novts)
dG = np.zeros(novts)
freq = 500; dur = 50; 
keys,model_keys,IO_Labels,IncLabels,n_inc_Labels,n_arr_Labels,df_Labels,dG_Labels = Get_Labels()

SamplePars,RefPars,LimitsMinPars,LimitsMaxPars,IncPars,\
    n_inc,n_arr,df,dG,x_axis_low_limit,x_axis_up_limit,B_limits_active,\
    i_fit_df_DG,i_wei_ninv,i_model,i_action_PyQTM,\
    SampleString,InfoString,f_fund,Zq,f_Jref,err_Df,B_no_Graph_in_Python,\
    chi2_ls_lo_limit,chi2_ls_up_limit,chi2_ls_varied_key,i_time_direction,n_skip_dis = Read_Config()
dfcs = df + 1j*dG  
ns_inc,dfcs_inc = ns_inc_dfcs_inc(n_inc,n_arr,dfcs,novts)

if i_action_PyQTM == 1 : Simulate()
if i_action_PyQTM == 2 :   # Fit        
    nFitPars, GuessPars,MinPars,MaxPars,Graph_Labels = Syspars_to_FitPars(SamplePars,IncPars)
    if nFitPars > 0: 
        FitResult,chi2,dfcs_fit = fit_model(GuessPars,MinPars,MaxPars,ns_inc,dfcs_inc)
        FitResultx =  FitResult.x
        SamplePars = FitPars_to_SysPars(FitResultx,IncPars)
        Write_Fitted_Config(keys,IO_Labels,SamplePars, '~QPY_FitPars.txt')
        Simulate()
if i_action_PyQTM == 3 :    # Time Traces    
    nFitPars, GuessPars,MinPars,MaxPars,Graph_Labels = Syspars_to_FitPars(SamplePars,IncPars)
    if nFitPars > 0: 
        data = np.loadtxt('~QPY_Time_Traces.txt');
        line_fitted = np.zeros(nFitPars+3)
        line_fitted_DfDG = np.zeros(2 * novts + 2)
        i_arr = data[:,0]
        time_arr = data[:,1]
        B_First = True;
        for it0 in range(len(data)):
            if i_time_direction == 1 : it = it0
            if i_time_direction == 2 : it = len(data) - 1 - it0
            line_fitted[0]      = int(data[it,0]); line_fitted[1] = data[it,1];
            line_fitted_DfDG[0] = int(data[it,0]); line_fitted_DfDG[1] = data[it,1];
            for i in range(novts): dfcs[i] = data[it,2*i+2] + 1j * data[it,2*i+3];
            ns_inc,dfcs_inc = ns_inc_dfcs_inc(n_inc,n_arr,dfcs,novts)
            FitResult,chi2,dfcs_fit = fit_model(GuessPars,MinPars,MaxPars,ns_inc,dfcs_inc)
            print('i/n' + FitPars_String() + ' Chi^2');
            print('Fit result: ' + str(it) + '/' + str(len(data)) + ' ' + \
                  str(np.around(FitResult.x,4)) + ' ' + str(np.around(chi2,3)));
            for i in range(nFitPars): line_fitted[i+2] =  FitResult.x[i];
            line_fitted[-1] =  chi2;
            ic = 0
            for iovt in range(novts): 
                if n_inc[iovt] == 0:
                    line_fitted_DfDG[2 + 2*iovt  ] =  -9999;
                    line_fitted_DfDG[2 + 2*iovt+1] =  -9999;
                else :    
                    line_fitted_DfDG[2 + 2*iovt  ] =  dfcs_fit[ic].real;
                    line_fitted_DfDG[2 + 2*iovt+1] =  dfcs_fit[ic].imag;
                    ic += 1;

            if B_First : 
                data_fitted = [line_fitted]; 
                data_fitted_DfDG = [line_fitted_DfDG]; 
                B_First = False;
            else       : 
                data_fitted      = np.append(data_fitted     ,[line_fitted],axis = 0)
                data_fitted_DfDG = np.append(data_fitted_DfDG,[line_fitted_DfDG],axis = 0)

            if (it+1)%n_skip_dis == 0 : 
                winsound.Beep(freq, dur);
                np.savetxt('~QPY_Time_Traces_FitPars.txt',data_fitted)
                data_fitted_DfDG = np.append(data_fitted_DfDG,[line_fitted_DfDG],axis = 0)
        np.savetxt('~QPY_Time_Traces_FitPars.txt',data_fitted)
        np.savetxt('~QPY_Time_Traces_fitted_DfDG.txt',data_fitted_DfDG)
        np.savetxt('~QPY_finished.txt',[0])
        winsound.Beep(freq, 5 * dur)
        if not B_no_Graph_in_Python : 
            plt.rcParams["figure.figsize"] = (6.5,7)
            plt.subplot(421); plt.plot(time_arr,np.transpose(data_fitted)[2]); plt.title(Graph_Labels[0]);
            if nFitPars > 1 : plt.subplot(422); plt.plot(time_arr,np.transpose(data_fitted)[3]); plt.title(Graph_Labels[1]);
            if nFitPars > 2 : plt.subplot(423); plt.plot(time_arr,np.transpose(data_fitted)[4]); plt.title(Graph_Labels[2]);
            if nFitPars > 3 : plt.subplot(424); plt.plot(time_arr,np.transpose(data_fitted)[5]); plt.title(Graph_Labels[3]);
            if nFitPars > 4 : plt.subplot(425); plt.plot(time_arr,np.transpose(data_fitted)[6]); plt.title(Graph_Labels[4]);
            if nFitPars > 5 : plt.subplot(426); plt.plot(time_arr,np.transpose(data_fitted)[7]); plt.title(Graph_Labels[5]);
            plt.subplot(427); plt.plot(time_arr,np.transpose(data_fitted)[-1]); plt.title('chi^2');
            plt.tight_layout(); plt.savefig('~TimeTracesFitPars.jpg')
            plt.show();

if i_action_PyQTM == 4 :  #Chi^2 Landscape
    nFitPars, GuessPars,MinPars,MaxPars,Graph_Labels = Syspars_to_FitPars(SamplePars,IncPars)
    if nFitPars > 0: 
        n_chi2 = 30;
        data_fitted = np.zeros((n_chi2,nFitPars+2))
        chi2_ls_x = np.linspace(chi2_ls_lo_limit,chi2_ls_up_limit,n_chi2);
        chi2_ls_chi2 = np.zeros(n_chi2);
        for it, n in enumerate(chi2_ls_x) :
            SamplePars[chi2_ls_varied_key] = chi2_ls_x[it];
            FitResult,chi2,dfcs_fit = fit_model(GuessPars,MinPars,MaxPars,ns_inc,dfcs_inc)
            dfcs_fit, chi2 = Get_dfcs_fit(ns_inc,FitResult.x,i_model)
            if it%5 == 0:
                if not B_no_Graph_in_Python : 
                    plt.rcParams["figure.figsize"] = (6.5,1.5)
                    plt.subplot(121); plt.title('$\Delta $f/n');
                    plt.plot(ns_inc, dfcs_inc.real/ns_inc, 'x'); 
                    plt.plot(ns_inc, dfcs_fit.real/ns_inc, '-');
                    plt.subplot(122); plt.title('$\Delta \Gamma $/n');
                    plt.plot(ns_inc, dfcs_inc.imag/ns_inc, 'x'); 
                    plt.plot(ns_inc, dfcs_fit.imag/ns_inc, '-')
                    plt.tight_layout(); plt.show();

            data_fitted[it,0] = chi2_ls_x[it];
            for i in range(nFitPars):
                data_fitted[it,i+1] =  FitResult.x[i];
            data_fitted[it,nFitPars+1] =  chi2;
        np.savetxt('~QPY_chi2_ls_FitPars.txt',data_fitted)

        if not B_no_Graph_in_Python : 
            plt.rcParams["figure.figsize"] = (6.5,5)
            plt.subplot(421); plt.plot(chi2_ls_x,np.transpose(data_fitted)[1]); plt.title(Graph_Labels[0]);
            if nFitPars > 1 : plt.subplot(422); plt.plot(chi2_ls_x,np.transpose(data_fitted)[2]); plt.title(Graph_Labels[1]);
            if nFitPars > 2 : plt.subplot(423); plt.plot(chi2_ls_x,np.transpose(data_fitted)[3]); plt.title(Graph_Labels[2]);
            if nFitPars > 3 : plt.subplot(424); plt.plot(chi2_ls_x,np.transpose(data_fitted)[4]); plt.title(Graph_Labels[3]);
            if nFitPars > 4 : plt.subplot(425); plt.plot(chi2_ls_x,np.transpose(data_fitted)[5]); plt.title(Graph_Labels[4]);
            if nFitPars > 5 : plt.subplot(426); plt.plot(chi2_ls_x,np.transpose(data_fitted)[6]); plt.title(Graph_Labels[5]);
            plt.subplot(427); plt.plot(chi2_ls_x,np.transpose(data_fitted)[-1]); plt.title('chi^2');
            plt.tight_layout(); plt.savefig('~QPY_chi2_ls_FitPars.jpg')
            plt.show();
