unit QTM_Chi2_Landscape;
interface
uses Windows,Messages,SysUtils,Variants,Classes,Graphics,Controls,Forms,
  Dialogs,QTM_Decl,StdCtrls,Pesgvcl,Pegrpapi,Math, Menus;
const n_chi_max = 30;
type
  Tchi2_Landscape = class(TForm)
    PESGraph1: PESGraph;
    Label1: TLabel; Label2: TLabel; Label3: TLabel;
    lo_limit_Show: TEdit; up_limit_Show: TEdit;
    best_value_label: TLabel;
    i_x_axis_Combox: TComboBox; i_y_axis_Combox: TComboBox; 
    Label4: TLabel; Label5: TLabel;
    MainMenu1: TMainMenu;
    Calculate1: TMenuItem;
    Abort1: TMenuItem;
    GenerateInfoforPython1: TMenuItem;
    ReadResultsfromPython1: TMenuItem;
    procedure Status_Read;
    procedure Arrange;
    procedure Update_Values;
    procedure Update_Graph;
    procedure Read_Panel_Format;
    procedure Write_Panel_Format;
    procedure FormCreate(Sender: TObject);
    procedure i_x_axis_ComboxChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure up_limit_ShowKeyPress(Sender: TObject; var Key: Char);
    procedure lo_limit_ShowKeyPress(Sender: TObject; var Key: Char);
    procedure test_to_Par(test : Double; i_ch : integer);
    procedure Check_Uncheck_variable_parameter(i_w_dir : integer);
    procedure i_y_axis_ComboxChange(Sender: TObject);
    procedure Determine_Fit_Pars_Chi2;
    procedure FormDeactivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Calc_From_Python;
    Function WaitForPython(TimeOutTime: Double) : boolean;
    procedure Change_VE_Pars;
    procedure fit_pars_to_Pars(i : integer);
    procedure Pars_to_fit_pars(i : integer);
    procedure Calculate1Click(Sender: TObject);
    procedure Abort1Click(Sender: TObject);
    procedure GenerateInfoforPython1Click(Sender: TObject);
    procedure ReadResultsfromPython1Click(Sender: TObject);
    procedure suggest_lo_limit_up_limit;
    public
      test_val,chi_arr : array[1..n_chi_max] of Double;
      par_arr : array[1..n_chi_max,1..n_fit_pars_max] of Double;
      best_val,lo_limit,up_limit : Double;
      B_NoClick,B_Stop : Boolean;
      i_x_axis,i_y_axis : integer;
      fit_pointer_red_chi2 : array[1..n_fit_pars_max] of Integer;
      a_Chi2 : TDouble_NP;
      par_min,par_max : Double;
      fit_pointer_old : array[1..n_fit_pars_max] of Integer;
      i_fileage_old,i_fileage_new : integer;
      chi2_Landscape_Pars : TPars;
  end;

var chi2_Landscape: Tchi2_Landscape;

implementation
uses QTM_Main,QTM_Fit,QTM_MIO,QTM_SLA;
{$R *.dfm}

procedure Tchi2_Landscape.FormDeactivate(Sender: TObject); begin Write_Panel_Format; end;
procedure Tchi2_Landscape.FormCreate(Sender: TObject); begin Status_Read; end;
procedure Tchi2_Landscape.FormResize(Sender: TObject); begin Arrange; end;

procedure Tchi2_Landscape.Arrange;
begin
  PESGraph1.Width  := chi2_Landscape.Width  - PESGraph1.Left - 40;
  PESGraph1.Height := chi2_Landscape.Height - PESGraph1.Top  - 60;
end;

procedure Tchi2_Landscape.FormShow(Sender: TObject);
begin
  B_NoClick := True;
  Read_Panel_Format;
  suggest_lo_limit_up_limit;
  i_y_axis := n_fit_pars;
  Arrange;  Update_Values; Update_Graph;
  B_NoClick := False;
end;

procedure Tchi2_Landscape.Status_Read;
begin
  i_x_axis := QTMFile.ReadInteger('chi2_Landscape','i_x_axis',1);
  i_y_axis := QTMFile.ReadInteger('chi2_Landscape','i_y_axis',1);
  lo_limit := QTMFile.ReadFloat('chi2_Landscape','lo_limit',1);
  up_limit := QTMFile.ReadFloat('chi2_Landscape','up_limit',1);
end;

procedure Tchi2_Landscape.suggest_lo_limit_up_limit;
begin
  case fit_pointer[i_x_axis] of
    t_e_ID                 : begin lo_limit := 0.6 * Pars.t_e; up_limit := 1.3 * Pars.t_e; end;
    t_f_ID                 : begin lo_limit := 0.6 * Pars.t_f; up_limit := 1.3 * Pars.t_f; end;

    rho_e_ID               : begin lo_limit := 0.6 * Pars.rho_e; up_limit := 1.3 * Pars.rho_e; end;
    rho_f_ID               : begin lo_limit := 0.6 * Pars.rho_f; up_limit := 1.3 * Pars.rho_f; end;
    rho_b_ID               : begin lo_limit := 0.6 * Pars.rho_b; up_limit := 1.3 * Pars.rho_b; end;

    Jp_e_ID                : begin lo_limit := 0.6 * Pars.Jp_e; up_limit := 1.3 * Pars.Jp_e; end;
    Jp_f_ID                : begin lo_limit := 0.6 * Pars.Jp_f; up_limit := 1.3 * Pars.Jp_f; end;
    Jp_b_ID                : begin lo_limit := 0.6 * Pars.Jp_b; up_limit := 1.3 * Pars.Jp_b; end;

    Jp_exp_e_ID            : begin lo_limit := 0.6 * Pars.Jp_exp_e; up_limit := 1.3 * Pars.Jp_exp_e; end;
    Jp_exp_f_ID            : begin lo_limit := 0.6 * Pars.Jp_exp_f; up_limit := 1.3 * Pars.Jp_exp_f; end;
    Jp_exp_b_ID            : begin lo_limit := 0.6 * Pars.Jp_exp_b; up_limit := 1.3 * Pars.Jp_exp_b; end;

    Jpp_e_ID               : begin lo_limit := 0.6 * Pars.Jpp_e; up_limit := 1.3 * Pars.Jpp_e; end;
    Jpp_f_ID               : begin lo_limit := 0.6 * Pars.Jpp_f; up_limit := 1.3 * Pars.Jpp_f; end;
    Jpp_b_ID               : begin lo_limit := 0.6 * Pars.Jpp_b; up_limit := 1.3 * Pars.Jpp_b; end;

    Jpp_exp_e_ID           : begin lo_limit := 0.6 * Pars.Jpp_exp_e; up_limit := 1.3 * Pars.Jpp_exp_e; end;
    Jpp_exp_f_ID           : begin lo_limit := 0.6 * Pars.Jpp_exp_f; up_limit := 1.3 * Pars.Jpp_exp_f; end;
    Jpp_exp_b_ID           : begin lo_limit := 0.6 * Pars.Jpp_exp_b; up_limit := 1.3 * Pars.Jpp_exp_b; end;

    vers_ID                : begin lo_limit := 0.6 * Pars.vers;      up_limit := 1.3 * Pars.vers; end;
    AspRat_ID              : begin lo_limit := 0.6 * Pars.AspRat;    up_limit := 1.3 * Pars.AspRat; end;
  end;
end;  

procedure Tchi2_Landscape.Update_Values;
var i : integer;
begin
  GenerateInfoforPython1.visible := B_Python_Installed;
  ReadResultsfromPython1.visible := B_Python_Installed;
//  M.Fit_BtnClick(Self);
  best_value_label.caption := FloatToStrf(a_fit[i_x_axis],ffgeneral,10,4);
  Check_uncheck_variable_parameter(1);
  Check_uncheck_variable_parameter(-1);

  i_x_axis_Combox.Clear;
  for i := 1 to n_fit_pars do i_x_axis_Combox.Items.Add(MIO.Graph_Labels(fit_pointer[i]));
  i_x_axis_Combox.Refresh;

  i_y_axis_Combox.Clear;
  for i := 1 to n_fit_pars - 1 do i_y_axis_Combox.Items.Add(MIO.Graph_Labels(fit_pointer_red_chi2[i]));
  i_y_axis_Combox.Items.Add('Chi^2');
  i_y_axis_Combox.Refresh;

  i_x_axis_Combox.ItemIndex := i_x_axis - 1;
  i_y_axis_Combox.ItemIndex := i_y_axis - 1;
  lo_limit_Show.Text := FloatToStrF(lo_limit,ffgeneral,10,4);
  up_limit_Show.Text := FloatToStrF(up_limit,ffgeneral,10,4);
end;

procedure Tchi2_Landscape.Update_Graph;
var p : Integer;
begin
  with PESGraph1 do begin
    PESGraph1.Width := chi2_Landscape.Width - PESGraph1.Left - 30;
    PESGraph1.Height := chi2_Landscape.Height - PESGraph1.Top - 30;
    PEactions := sgreset;  CursorPromptTracking := True; CursorPromptStyle := sgXandYValue;
    AllowZooming := sgHorzPlusVertZooming;     AllowDataHotSpots := True;
    FontSize := sgLarge; ShadowColor := clNone; DataShadows := sgNo3D; GridLineControl := sgNoGrid;
    PesGraph1.Width := chi2_Landscape.Width - PesGraph1.Left - 30;
    PesGraph1.Height := chi2_Landscape.Height- PesGraph1.Top -30;
    NullDataValueX := 0; NullDataValueY := 0;
    MainTitle := '';
    Subtitle := '';
    Subsets := 1;
    PlottingMethod := sgline;
    SubsetLineTypes[0] := PELT_ThinSOLID;
    Points := n_chi_max;
    XaxisLabel := MIO.Graph_Labels(fit_pointer[i_x_axis]);
    if i_y_axis <= n_fit_pars - 1 then YaxisLabel := MIO.Graph_Labels(fit_pointer_red_chi2[i_y_axis])
    else if i_y_axis = n_fit_pars then YaxisLabel := 'chi^2';
    for p := 1 to Points do begin
      XData[0,p-1] := test_val[p];
      if i_y_axis <= n_fit_pars - 1 then YData[0,p-1] := par_arr[p,i_y_axis]
      else if i_y_axis = n_fit_pars then YData[0,p-1] := chi_arr[p]
      else                               YData[0,p-1] := GapV;
    end;
    PEactions := sgReinitAndReset;
  end;
end;

procedure Tchi2_Landscape.Read_Panel_Format;
begin
  Top := Ini.ReadInteger('chi2_Landscape','Top',0);
  Height := Ini.ReadInteger('chi2_Landscape','Height',300);
  Left := Ini.ReadInteger('chi2_Landscape','Left',0);
  Width := Ini.ReadInteger('chi2_Landscape','Width',500);
end;

procedure Tchi2_Landscape.Write_Panel_Format;
begin
  if B_NoClick then Exit;
  Ini.WriteInteger('chi2_Landscape','Top',Top);
  Ini.WriteInteger('chi2_Landscape','Height',Height);
  Ini.WriteInteger('chi2_Landscape','Left',Left);
  Ini.WriteInteger('chi2_Landscape','Width',Width);
  B_Changed := True;
end;

procedure Tchi2_Landscape.i_x_axis_ComboxChange(Sender: TObject);
var i,j : integer;
begin
  i_x_axis := i_x_axis_Combox.ItemIndex + 1; QTMFile.WriteInteger('chi2_Landscape','i_x_axis',i_x_axis);
  for i := 1 to n_chi_max do begin
    test_val[i] := GapV;
    chi_arr[i] := GapV;
    for j := 1 to n_fit_pars do par_arr[i,j] := GapV;
  end;
  suggest_lo_limit_up_limit;
  Update_Values; Update_Graph; B_Changed := True;
end;

procedure Tchi2_Landscape.i_y_axis_ComboxChange(Sender: TObject);
begin
  i_y_axis := i_y_axis_Combox.ItemIndex + 1; QTMFile.WriteInteger('chi2_Landscape','i_y_axis',i_y_axis);
  Update_Values; Update_Graph; B_Changed := True;
end;

procedure Tchi2_Landscape.up_limit_ShowKeyPress(Sender: TObject; var Key: Char);
begin
  up_limit_Show.Color := cl3dLight; if key <> #13 then Exit; if key = #27 then begin up_limit_Show.Color := clwindow; Exit; end;
  up_limit := M.FloatFromEdit(up_limit_Show,up_limit);  //Trim(up_limit_Show.Text));
  QTMFile.WriteFloat('chi2_Landscape','up_limit',up_limit);
  Update_Values; B_Changed := True;
  up_limit_Show.Color := clwindow;
  if key = #13 then key := #0;
end;

procedure Tchi2_Landscape.lo_limit_ShowKeyPress(Sender: TObject;  var Key: Char);
begin
  lo_limit_Show.Color := cl3dLight; if key <> #13 then Exit; if key = #27 then begin lo_limit_Show.Color := clwindow; Exit; end;
  lo_limit := M.FloatFromEdit(lo_limit_Show,lo_limit);  //StrToFloat(Trim(lo_limit_Show.Text));
  QTMFile.WriteFloat('chi2_Landscape','lo_limit',lo_limit);
  update_Values; B_Changed := True; lo_limit_Show.Color := clwindow;
  if key = #13 then key := #0;
end;

procedure Tchi2_Landscape.test_to_Par(test : Double; i_ch : integer);
begin
  case i_ch of
    t_e_ID     : Pars.t_e  := test;
    t_f_ID     : Pars.t_f  := test;

    rho_e_ID    : Pars.rho_e  := test;
    rho_f_ID    : Pars.rho_f  := test;
    rho_b_ID    : Pars.rho_b  := test;

    Jp_e_ID    : Pars.Jp_e  := test;
    Jp_f_ID    : Pars.Jp_f  := test;
    Jp_b_ID    : Pars.Jp_b  := test;

    Jp_exp_e_ID  : Pars.Jp_exp_e  := test;
    Jp_exp_f_ID  : Pars.Jp_exp_f  := test;
    Jp_exp_b_ID  : Pars.Jp_exp_b  := test;

    Jpp_e_ID   : Pars.Jpp_e  := test;
    Jpp_f_ID   : Pars.Jpp_f  := test;
    Jpp_b_ID   : Pars.Jpp_b  := test;

    Jpp_exp_e_ID : Pars.Jpp_exp_e  := test;
    Jpp_exp_f_ID : Pars.Jpp_exp_f  := test;
    Jpp_exp_b_ID : Pars.Jpp_exp_b := test;

    vers_ID    : Pars.vers := test;
    AspRat_ID    : Pars.AspRat := test;
  end;
end;

procedure Tchi2_Landscape.Check_uncheck_variable_parameter(i_w_dir : integer);
begin
  case fit_pointer[i_x_axis] of
    t_e_ID     : case i_w_dir of 1 : B_t_e_C := False; -1 : B_t_e_C := True; end;
    t_f_ID     : case i_w_dir of 1 : B_t_f_C := False; -1 : B_t_f_C := True; end;

    rho_e_ID   : case i_w_dir of 1 : B_rho_e_C := False; -1 : B_rho_e_C := True; end;
    rho_f_ID   : case i_w_dir of 1 : B_rho_f_C := False; -1 : B_rho_f_C := True; end;
    rho_b_ID   : case i_w_dir of 1 : B_rho_b_C := False; -1 : B_rho_b_C := True; end;

    Jp_e_ID    : case i_w_dir of 1 : B_Jp_e_C := False; -1 : B_Jp_e_C := True; end;
    Jp_f_ID    : case i_w_dir of 1 : B_Jp_f_C := False; -1 : B_Jp_f_C := True; end;
    Jp_b_ID    : case i_w_dir of 1 : B_Jp_b_C := False; -1 : B_Jp_b_C := True; end;

    Jp_exp_e_ID: case i_w_dir of 1 : B_Jp_exp_e_C := False; -1 : B_Jp_exp_e_C := True; end;
    Jp_exp_f_ID: case i_w_dir of 1 : B_Jp_exp_f_C := False; -1 : B_Jp_exp_f_C := True; end;
    Jp_exp_b_ID: case i_w_dir of 1 : B_Jp_exp_b_C := False; -1 : B_Jp_exp_b_C := True; end;

    Jpp_e_ID   : case i_w_dir of 1 : B_Jpp_e_C := False; -1 : B_Jpp_e_C := True; end;
    Jpp_f_ID   : case i_w_dir of 1 : B_Jpp_f_C := False; -1 : B_Jpp_f_C := True; end;
    Jpp_b_ID   : case i_w_dir of 1 : B_Jpp_b_C := False; -1 : B_Jpp_b_C := True; end;

    Jpp_exp_e_ID : case i_w_dir of 1 : B_Jpp_exp_e_C := False; -1 : B_Jpp_exp_e_C := True; end;
    Jpp_exp_f_ID : case i_w_dir of 1 : B_Jpp_exp_f_C := False; -1 : B_Jpp_exp_f_C := True; end;
    Jpp_exp_b_ID : case i_w_dir of 1 : B_Jpp_exp_b_C := False; -1 : B_Jpp_exp_b_C := True; end;

    vers_ID    : case i_w_dir of 1 : B_vers_C := False; -1 : B_vers_C := True; end;
    AspRat_ID  : case i_w_dir of 1 : B_AspRat_C := False; -1 : B_AspRat_C := True; end;
  end;
  if i_w_dir = 1 then Determine_Fit_Pars_Chi2;
end;

procedure Tchi2_Landscape.Determine_Fit_Pars_Chi2;
var i, i_count : Integer;
begin
  for i := 1 to n_fit_pars_max do fit_pointer_red_chi2[i] := 0;
  i_count := 0;
  if B_t_e_C       then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := t_e_ID; end;
  if B_t_f_C       then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := t_f_ID; end;
  if B_rho_e_C     then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := rho_e_ID; end;
  if B_rho_f_C     then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := rho_f_ID; end;
  if B_rho_b_C     then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := rho_b_ID; end;
  if B_Jp_e_C      then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jp_e_ID; end;
  if B_Jp_f_C      then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jp_f_ID; end;
  if B_Jp_b_C      then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jp_b_ID; end;
  if B_Jp_exp_e_C  then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jp_exp_e_ID; end;
  if B_Jp_exp_f_C  then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jp_exp_f_ID; end;
  if B_Jp_exp_b_C  then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jp_exp_b_ID; end;
  if B_Jpp_e_C     then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jpp_e_ID; end;
  if B_Jpp_f_C     then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jpp_f_ID; end;
  if B_Jpp_b_C     then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jpp_b_ID; end;
  if B_Jpp_exp_e_C then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jpp_exp_e_ID; end;
  if B_Jpp_exp_f_C then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jpp_exp_f_ID; end;
  if B_Jpp_exp_b_C then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := Jpp_exp_b_ID; end;
  if B_vers_C      then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := vers_ID; end;
  if B_AspRat_C    then begin i_count := i_count + 1; fit_pointer_red_chi2[i_count] := AspRat_ID; end;
end;

procedure Tchi2_Landscape.Calc_From_Python;
var i,j : integer;
begin
  i_action_PyQTM := j_Python_Chi2_Landscape;
  B_no_Graph_in_Python := True;
  M.Write_to_QPY;
  i_fileage_old := fileage(ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_chi2_ls_FitPars.txt');

  if M.ExecuteExe(QPY_exe_fn) then begin
    WaitForPython(5);
    assignfile(infile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_chi2_ls_FitPars.txt');
    Reset(infile);
    for i := 1 to n_chi_max do begin
      Read(infile,test_val[i]);
      for j := 1 to n_fit_pars - 1 do read(infile,par_arr[i,j]);
      readln(infile,chi_arr[i]);
    end;
    closefile(infile);
  end;
end;

Function Tchi2_Landscape.WaitForPython(TimeOutTime: Double) : boolean;
var StartTick: Cardinal;
    B_TimeOut: Boolean;
begin
  StartTick := GetTickCount;
  repeat
    i_fileage_new := Fileage(ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_chi2_ls_FitPars.txt'); M.delay_secs(0.05);
    B_TimeOut := ((StartTick + TimeOutTime * 1000) < GetTickCount)
  until (i_fileage_new > i_fileage_old) or B_TimeOut;
  result := not(B_TimeOut);
end;

procedure Tchi2_Landscape.Change_VE_Pars;
var i_dat,i_par : integer;
    B_non_GapV : Boolean;
    Pars_new : TPars;
begin
  chi2_Landscape_Pars := Pars;
  for i_dat := 1 to n_chi_max do begin
    B_non_GapV := True;
    for i_par := 1 to n_fit_pars - 1 do begin
      if par_arr[i_dat,i_par] = GapV then B_non_GapV := False;
    end;
    if B_non_GapV then begin
      fit_pars_to_Pars(i_dat);
      SLA.Convert_VE_Pars(M.i_layer,M.i_ve_old, M.i_ve_new, chi2_Landscape_Pars, Pars_new);
      chi2_Landscape_Pars := Pars_new;
      Pars_to_fit_pars(i_dat);
    end;
  end;
  Update_Values;
  Update_Graph;
end;

procedure Tchi2_Landscape.fit_pars_to_Pars(i : integer);
var i_par : integer;
begin
  for i_par := 1 to n_fit_pars - 1 do begin
    case fit_pointer_red_chi2[i_par] of
      t_e_ID                 : chi2_Landscape_Pars.t_e  := par_arr[i,i_par];
      t_f_ID                 : chi2_Landscape_Pars.t_f  := par_arr[i,i_par];

      rho_e_ID               : chi2_Landscape_Pars.rho_e  := par_arr[i,i_par];
      rho_f_ID               : chi2_Landscape_Pars.rho_f  := par_arr[i,i_par];
      rho_b_ID               : chi2_Landscape_Pars.rho_b  := par_arr[i,i_par];

      Jp_e_ID                : chi2_Landscape_Pars.Jp_e  := par_arr[i,i_par];
      Jp_f_ID                : chi2_Landscape_Pars.Jp_f  := par_arr[i,i_par];
      Jp_b_ID                : chi2_Landscape_Pars.Jp_b  := par_arr[i,i_par];

      Jp_exp_e_ID            : chi2_Landscape_Pars.Jp_exp_e  := par_arr[i,i_par];
      Jp_exp_f_ID            : chi2_Landscape_Pars.Jp_exp_f  := par_arr[i,i_par];
      Jp_exp_b_ID            : chi2_Landscape_Pars.Jp_exp_b  := par_arr[i,i_par];

      Jpp_e_ID               : chi2_Landscape_Pars.Jpp_e  := par_arr[i,i_par];
      Jpp_f_ID               : chi2_Landscape_Pars.Jpp_f  := par_arr[i,i_par];
      Jpp_b_ID               : chi2_Landscape_Pars.Jpp_b  := par_arr[i,i_par];

      Jpp_exp_e_ID           : chi2_Landscape_Pars.Jpp_exp_e  := par_arr[i,i_par];
      Jpp_exp_f_ID           : chi2_Landscape_Pars.Jpp_exp_f  := par_arr[i,i_par];
      Jpp_exp_b_ID           : chi2_Landscape_Pars.Jpp_exp_b := par_arr[i,i_par];

      vers_ID                : chi2_Landscape_Pars.vers := par_arr[i,i_par];
      AspRat_ID              : chi2_Landscape_Pars.AspRat := par_arr[i,i_par];
    end;
  end;
end;

procedure Tchi2_Landscape.Pars_to_fit_pars(i : integer);
var i_par : integer;
begin
  for i_par := 1 to n_fit_pars - 1 do begin
    case fit_pointer_red_chi2[i_par] of
      t_e_ID                 : par_arr[i,i_par] := chi2_Landscape_Pars.t_e;
      t_f_ID                 : par_arr[i,i_par] := chi2_Landscape_Pars.t_f;

      rho_e_ID               : par_arr[i,i_par] := chi2_Landscape_Pars.rho_e ;
      rho_f_ID               : par_arr[i,i_par] := chi2_Landscape_Pars.rho_f ;
      rho_b_ID               : par_arr[i,i_par] := chi2_Landscape_Pars.rho_b ;

      Jp_e_ID                : par_arr[i,i_par] := chi2_Landscape_Pars.Jp_e ;
      Jp_f_ID                : par_arr[i,i_par] := chi2_Landscape_Pars.Jp_f ;
      Jp_b_ID                : par_arr[i,i_par] := chi2_Landscape_Pars.Jp_b ;

      Jp_exp_e_ID            : par_arr[i,i_par] := chi2_Landscape_Pars.Jp_exp_e ;
      Jp_exp_f_ID            : par_arr[i,i_par] := chi2_Landscape_Pars.Jp_exp_f ;
      Jp_exp_b_ID            : par_arr[i,i_par] := chi2_Landscape_Pars.Jp_exp_b ;

      Jpp_e_ID               : par_arr[i,i_par] := chi2_Landscape_Pars.Jpp_e;
      Jpp_f_ID               : par_arr[i,i_par] := chi2_Landscape_Pars.Jpp_f;
      Jpp_b_ID               : par_arr[i,i_par] := chi2_Landscape_Pars.Jpp_b;

      Jpp_exp_e_ID           : par_arr[i,i_par] := chi2_Landscape_Pars.Jpp_exp_e;
      Jpp_exp_f_ID           : par_arr[i,i_par] := chi2_Landscape_Pars.Jpp_exp_f;
      Jpp_exp_b_ID           : par_arr[i,i_par] := chi2_Landscape_Pars.Jpp_exp_b;

      vers_ID                : par_arr[i,i_par] := chi2_Landscape_Pars.vers;
      AspRat_ID              : par_arr[i,i_par] := chi2_Landscape_Pars.AspRat;
    end;
  end;
end;

procedure Tchi2_Landscape.Calculate1Click(Sender: TObject);
var i,j : integer;
    Errorcode: Byte;
begin
  B_Stop := False;
  for j := 1 to n_fit_pars do fit_pointer_old[j] := fit_pointer[j];
  for i := 1 to n_chi_max do begin
    test_val[i] := 0; chi_arr[i] := 0;
    for j := 1 to n_fit_pars do par_arr[i,j] := 0;
  end;
  if n_fit_pars > 1 then begin
    Check_uncheck_variable_parameter(1);
    if i_fit_method = 2 then Calc_From_Python
    else begin
      for i := 1 to n_chi_max do begin
        Application.ProcessMessages; if B_Stop then Exit;
        test_val[i] := lo_limit + (i-1)/(n_chi_max - 1)*(up_limit - lo_limit);
        test_to_Par(test_val[i],fit_pointer[i_x_axis]);
        n_fit_pars := n_fit_pars - 1;
        for j := 1 to n_fit_pars do fit_pointer[j] := fit_pointer_red_chi2[j];
        M.Fit_BtnClick(Self);
        inc(n_fit_pars);
        for j := 1 to n_fit_pars do fit_pointer[j] := fit_pointer_old[j];
        chi_arr[i] := chisqr;
        for j := 1 to n_fit_pars - 1 do par_arr[i,j] := a_fit[j];
      end;
    end;
    Update_Graph;
    Check_uncheck_variable_parameter(-1);
  end else if (n_fit_pars = 1) then begin
    for i := 1 to n_chi_max do begin
      test_val[i] := lo_limit + (i-1)/(n_chi_max - 1)*(up_limit - lo_limit);
      test_to_Par(test_val[i],i_x_axis);
      MIO.pars_to_a(a_Chi2);
      chi_arr[i] := Fit.func_simplex(a_Chi2, Errorcode);
    end;
    Update_Graph;
  end;
  M.Fit_BtnClick(Self);
  Update_Values;
end;

procedure Tchi2_Landscape.Abort1Click(Sender: TObject);
var j : integer;
begin
  B_Stop := True;
  for j := 1 to n_fit_pars do fit_pointer[j] := fit_pointer_old[j];
  Check_uncheck_variable_parameter(-1);
end;

procedure Tchi2_Landscape.GenerateInfoforPython1Click(Sender: TObject);
var i,j : integer;
    errorcode : Byte;
begin
  for j := 1 to n_fit_pars do fit_pointer_old[j] := fit_pointer[j];
  for i := 1 to n_chi_max do begin
    test_val[i] := 0; chi_arr[i] := 0;
    for j := 1 to n_fit_pars do par_arr[i,j] := 0;
  end;
  if n_fit_pars > 1 then begin
    Check_uncheck_variable_parameter(1);
    B_no_Graph_in_Python := False;
    i_action_PyQTM := j_Python_Chi2_Landscape;
    M.Write_to_QPY;
    Check_uncheck_variable_parameter(-1);
  end else if (n_fit_pars = 1) then begin
    for i := 1 to n_chi_max do begin
      test_val[i] := lo_limit + (i-1)/(n_chi_max - 1)*(up_limit - lo_limit);
      test_to_Par(test_val[i],i_x_axis);
      MIO.pars_to_a(a_Chi2);
      chi_arr[i] := Fit.func_simplex(a_Chi2, Errorcode);
    end;
    Update_Graph;
    M.Fit_BtnClick(Self);
    Update_Values;
  end;
end;

procedure Tchi2_Landscape.ReadResultsfromPython1Click(Sender: TObject);
var i,j : integer;
begin
  assignfile(infile,ExtractFilePath(ParamStr(0)) + '/PyQTM/~QPY_chi2_ls_FitPars.txt');
  Reset(infile);
  for i := 1 to n_chi_max do begin
    Read(infile,test_val[i]);
    for j := 1 to n_fit_pars - 1 do read(infile,par_arr[i,j]);
    readln(infile,chi_arr[i]);
  end;
  closefile(infile);
  Update_Graph;
  Check_uncheck_variable_parameter(-1);
  M.Fit_BtnClick(Self);
  Update_Values;
end;

end.
