unit QTM_Decl;
interface
uses Graphics,Inifiles,StdCtrls, Classes, Messages;

const
      WM_PYTHON_FINISHED = WM_USER + 10;
      j_model_AMF = 1; j_model_PE3 = 2; j_model_PE5 = 3;
      j_xaxis_n = 1; j_xaxis_n2 = 2; j_xaxis_nsqrt = 3; j_xaxis_n_inv = 4; j_xaxis_m_df = 5; j_xaxis_m_dfbyn = 6;
      j_Python_Simulate = 1; j_Python_Fit = 2; j_Python_Time_Traces = 3; j_Python_Chi2_Landscape = 4;

      j_par_Sample = 1; j_par_Ref = 2; j_par_Limits_Min = 3; j_par_Limits_Max = 4; j_par_Multiple = 5;
      j_VE_JpJpp = 1; j_VE_GpGpp = 2; j_VE_etapetapp = 3; j_VE_Gpetap = 4; j_VE_Jabstandel = 5; j_VE_Gabstandel = 6; j_VE_etaabstandelinv = 7;
      GapV = -9999; nhm = 10;
      nlayer_max = 3;
      n_inpol_max = 1000;
      n_dat_max = 10000;
      n_fit_pars_max = 6;
      np = 6; mp = 7;
      i_par_max = 200;
      nprefn = 10;   // Previous File Names

  t_e_ID        = 1;
  t_f_ID        = 2;
  rho_e_ID      = 3;
  rho_f_ID      = 4;
  rho_b_ID      = 5;
  Jp_e_ID       = 6;
  Jp_f_ID       = 7;
  Jp_b_ID       = 8;
  Jp_exp_e_ID   = 9;
  Jp_exp_f_ID   = 10;
  Jp_exp_b_ID   = 11;
  Jpp_e_ID      = 12;
  Jpp_f_ID      = 13;
  Jpp_b_ID      = 14;
  Jpp_exp_e_ID  = 15;
  Jpp_exp_f_ID  = 16;
  Jpp_exp_b_ID  = 17;

  i_ve_e_ID     = 18;
  i_ve_f_ID     = 19;
  i_ve_b_ID     = 20;

  vers_ID       = 21;
  AspRat_ID     = 22;


  nEdits = 19; //Number of Model Edits

  //Error Codes:
  E_SLA_failed      = 1; // B_SLA_failed
  E_kd_failed       = 2; //B_kd_failed
  E_Complex_failed  = 4; //B_Complex_failed
  E_Fit_Failed      = 8; //B_Fit_Failed}
  E_Overflow        = 16; //Floating Point Overflow

  FileTypes: Array[0..1] of string = ('.qtm', '.qtd');
  j_qtm = 0; j_qtd = 1;


 type
  TDouble_nhm  = array[1..nhm] of Double;
  TInte_nhm    = array[1..nhm] of Integer;
  TDouble_npar = array[1..n_fit_pars_max] of Double;
  TInpol       = array[1..n_inpol_max] of Double;

  TDouble_MPbyNP = array[1..mp,0..np] of Double;
  TDouble_MP = array[1..mp] of Double;
  TDouble_NP = array[1..np] of Double;

  TComplex = record real : Double; imag : Double; end;

  TEditWithnoUnit = record
    ID: integer;
    Edit: TEdit;
    Describtion_Label: TLabel;
  end;

  type TEditWithnoUnitArray = array of TEditWithnoUnit;

  TPars = record
    t_e,rho_e,Jp_e,Jpp_e,Jp_exp_e,Jpp_exp_e,
    t_f,rho_f,Jp_f,Jpp_f,Jp_exp_f,Jpp_exp_f,
    rho_b,Jp_b,Jpp_b,Jp_exp_b,Jpp_exp_b : Double;
    i_ve_e,i_ve_f,i_ve_b : Integer;

    vers,AspRat : Double;
  end;

var
  QTMFile,Ini,FitPars_From_QPY,For_Python_File : TInifile;
  qtm_fn,out_fn,line                   : String;
  tmp_fn                               : TStrings;
  infile,outfile                       : Text;
  B_fit_inc                            : array[1..nhm] of Boolean;

  df,dG,df_fit,dG_fit,n_arr            : TDouble_nhm;

  fit_pointer             : array[1..n_fit_pars_max] of Integer;
  IO_labels               : array[1..i_par_max] of string;


  instring, sections, VersionStr : String;
  TmpDirectory_Str : String;

  Pars,Ref_pars,BU_Pars,GPars,Min_Pars,Max_Pars : TPars;

  a_fit                                : TDouble_NP;
  x_inpol,Nn_inpol,df_SLA,dG_SLA,df_Rou,dG_Rou,df_pe3,dG_pe3,df_pe5,dG_pe5 : TInpol;

  status,i_fit_df_dG,i_dfDG_DfnDD,i_wei_ninv,i_fit_method,i_autoscale_x,
  i_rbtn,i_rbtn_old,i_xaxis,i_yaxis,n_fit_pars,n_inpol,ii,nhar_fit,
  i_action_PyQTM : Integer;
  delim_test,chisqr,err_Df,n_min,n_max,x_axis_low_limit,x_axis_up_limit,ftol,
  shift_fac,n_r : Double;

  B_AutoLoad_Prev,B_IncludeFilename,B_no_Graph_in_Python,B_Python_Installed,
  B_from_Multiple, B_fit_failed, B_JpJpp_Zero_Warning,
  B_Show_Exp,B_Show_RoughC,B_Perturbation_Show_All,
  B_Limits_active,B_Changed,B_Exponents_Converted,B_no_model : Boolean;

  B_Layer_1,B_Layer_2,B_liquid_bulk,B_Roughness,

  B_t_e_C,B_rho_e_C,B_Jp_e_C,B_Jpp_e_C,B_Jp_exp_e_C,B_Jpp_exp_e_C,
  B_t_f_C,B_rho_f_C,B_Jp_f_C,B_Jpp_f_C,B_Jp_exp_f_C,B_Jpp_exp_f_C,
  B_rho_b_C,B_Jp_b_C,B_Jpp_b_C,B_Jp_exp_b_C,B_Jpp_exp_b_C,
  B_vers_C,B_AspRat_C : Boolean;

  zero_c,one_c,im_c : TComplex;
  guess : TDouble_NP;

  B_Development : Boolean;
  Sample_String,Info_String : String;
  QPY_fn,QPY_exe_fn : string;

  f_fund,Zq,f_Jref : Double;
  i_model : integer;

  rho_b_default : Double;
  i_ve_e_old, i_ve_f_old, i_ve_b_old : integer;
const
  QTZ_Colors: array[0..nhm] of TColor = (
  {0}  clNone,      {1}  clBlack,   {2} clRed,    {3} clLime, {4} clBlue,
  {5}  clFuchsia,   {6}  clGray,    {7} clPurple, {8} clNavy, {9} clMaroon,
  {10} clGreen);

implementation
begin end.
