unit QTM_Limits_old;
interface
uses Windows,Messages,SysUtils,Classes,Graphics,Controls,Forms,Dialogs,StdCtrls,ExtCtrls,
      Pesgvcl,Menus,Pegrpapi,CheckLst,QTM_Decl,Math,inifiles,Clipbrd,ComCtrls;
type
  TLimits = class(TForm)
  MainMenu1: TMainMenu; Clear1: TMenuItem; Defaults1: TMenuItem; Active1: TMenuItem;
  AMF_Panel: TPanel; Roughness_Panel: TPanel;

  t_e_Min_Show: TEdit; t_f_Min_Show: TEdit; rho_e_Min_Show: TEdit; rho_f_Min_Show: TEdit; rho_b_Min_Show: TEdit; Jp_e_Min_Show: TEdit; Jp_f_Min_Show: TEdit;
  Jp_b_Min_Show: TEdit; Jp_exp_e_Min_Show: TEdit;  Jp_exp_f_Min_Show: TEdit; Jp_exp_b_Min_Show: TEdit; Jpp_e_Min_Show: TEdit; Jpp_f_Min_Show: TEdit;
  Jpp_b_Min_Show: TEdit; Jpp_exp_e_Min_Show: TEdit; Jpp_exp_f_Min_Show: TEdit; Jpp_exp_b_Min_Show: TEdit; Jp_f_Label: TLabel; Jpp_f_Label: TLabel;
  vers_Min_Show: TEdit;
  AspRat_Min_Show: TEdit;

  t_e_Max_Show: TEdit; rho_e_Max_Show: TEdit; Jp_e_Max_Show: TEdit; Jp_exp_e_Max_Show: TEdit; Jpp_e_Max_Show: TEdit; Jpp_exp_e_Max_Show: TEdit;
  t_f_Max_Show: TEdit;  rho_f_Max_Show: TEdit; Jp_f_Max_Show: TEdit; Jp_exp_f_Max_Show: TEdit; Jpp_f_Max_Show: TEdit; Jpp_exp_f_Max_Show: TEdit;
  rho_b_Max_Show: TEdit; Jp_b_Max_Show: TEdit; Jp_exp_b_Max_Show: TEdit; Jpp_b_Max_Show: TEdit; Jpp_exp_b_Max_Show: TEdit;
  vers_Max_Show: TEdit;
  AspRat_Max_Show: TEdit;
  min_e_Label: TLabel; min_f_Label: TLabel; min_b_Label: TLabel; max_e_Label: TLabel; max_f_Label: TLabel; max_b_Label: TLabel;
  Label10: TLabel; Label11: TLabel;
  Label26: TLabel; Label28: TLabel;
  t_e_Label: TLabel; rho_e_Label: TLabel; Jp_e_Label: TLabel; Jp_b_Label: TLabel; plp_e_Label: TLabel;
  Jpp_e_Label: TLabel; plpp_e_Label: TLabel; Jpp_b_Label: TLabel;
  rho_f_Label: TLabel; rho_b_Label: TLabel; plp_b_Label: TLabel; plp_f_Label: TLabel;
  plpp_f_Label: TLabel; plpp_b_Label: TLabel; t_f_Label: TLabel;
    vers_label: TLabel;
    AspRat_label: TLabel; Roughness_label: TLabel;

    procedure Clear_Limits;
    procedure Set_Color(i_par : integer);
    procedure Status_Read;
    procedure Set_Colors_all;
    procedure FormResize(Sender: TObject);
    procedure Read_Panel_Format;
    procedure Write_Panel_Format;
    procedure Arrange;
    procedure Check_For_GapV;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure Check_for_Limits(i_par : integer; var par : Double);
    procedure Update_Values;
    procedure Update_Values_Pars_panel;
    procedure Display_Check_Trivial;
    procedure Exponent_Labels;
    procedure Defaults1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure KeyPressResponse(Sender: TObject; var Key: Char);
    procedure Active1Click(Sender: TObject);
    function IsOverLimit(var FitValues : TDouble_npar): Boolean;

    private
      B_NoClick : Boolean;
      Edit_Min_Fields,Edit_Max_Fields : array[1..19] of TEdit;
      Values_Min,Values_Max : array[1..19] of Double;
end;

var  Limits: TLimits;

implementation

uses QTM_Multiple, QTM_Chi2_Landscape, QTM_Main, QTM_MIO;
{$R *.DFM}

procedure TLimits.FormCreate(Sender: TObject); begin Status_Read; end;

procedure TLimits.Clear1Click(Sender: TObject);    begin Clear_Limits;       Update_Values; end;
procedure TLimits.FormResize(Sender: TObject); begin if B_NoClick then Exit; Arrange; end;
procedure TLimits.FormDeactivate(Sender: TObject); begin Write_Panel_Format; end;
procedure TLimits.FormShow(Sender: TObject);
begin
  B_NoClick := True;
  Read_Panel_Format;
  Update_Values;
  B_NoClick := False;
  Arrange;
end;

procedure TLimits.Status_Read;
begin
  B_Limits_active := QTMFile.ReadBool('Limits','B_Limits_active',True);
  Edit_Min_Fields[1] := t_e_Min_Show;
  Edit_Min_Fields[2] := t_f_Min_Show;
  Edit_Min_Fields[3] := rho_e_Min_Show;
  Edit_Min_Fields[4] := rho_f_Min_Show;
  Edit_Min_Fields[5] := rho_b_Min_Show;
  Edit_Min_Fields[6] := Jp_e_Min_Show;
  Edit_Min_Fields[7] := Jp_f_Min_Show;
  Edit_Min_Fields[8] := Jp_b_Min_Show;
  Edit_Min_Fields[9] := Jp_exp_e_Min_Show;
  Edit_Min_Fields[10] := Jp_exp_f_Min_Show;
  Edit_Min_Fields[11] := Jp_exp_b_Min_Show;
  Edit_Min_Fields[12] := Jpp_e_Min_Show;
  Edit_Min_Fields[13] := Jpp_f_Min_Show;
  Edit_Min_Fields[14] := Jpp_b_Min_Show;
  Edit_Min_Fields[15] := Jpp_exp_e_Min_Show;
  Edit_Min_Fields[16] := Jpp_exp_f_Min_Show;
  Edit_Min_Fields[17] := Jpp_exp_b_Min_Show;
  Edit_Min_Fields[18] := vers_Min_Show;
  Edit_Min_Fields[19] := AspRat_Min_Show;

  Edit_Max_Fields[1] := t_e_Max_Show;
  Edit_Max_Fields[2] := t_f_Max_Show;
  Edit_Max_Fields[3] := rho_e_Max_Show;
  Edit_Max_Fields[4] := rho_f_Max_Show;
  Edit_Max_Fields[5] := rho_b_Max_Show;
  Edit_Max_Fields[6] := Jp_e_Max_Show;
  Edit_Max_Fields[7] := Jp_f_Max_Show;
  Edit_Max_Fields[8] := Jp_b_Max_Show;
  Edit_Max_Fields[9] := Jp_exp_e_Max_Show;
  Edit_Max_Fields[10] := Jp_exp_f_Max_Show;
  Edit_Max_Fields[11] := Jp_exp_b_Max_Show;
  Edit_Max_Fields[12] := Jpp_e_Max_Show;
  Edit_Max_Fields[13] := Jpp_f_Max_Show;
  Edit_Max_Fields[14] := Jpp_b_Max_Show;
  Edit_Max_Fields[15] := Jpp_exp_e_Max_Show;
  Edit_Max_Fields[16] := Jpp_exp_f_Max_Show;
  Edit_Max_Fields[17] := Jpp_exp_b_Max_Show;
  Edit_Max_Fields[18] := vers_Max_Show;
  Edit_Max_Fields[19] := AspRat_Max_Show;
end;


procedure TLimits.Update_Values;
var i : integer;
begin
  case B_Limits_active of
    False : begin
      Caption := 'Limits Inactive';
      Active1.Caption := 'Activate';
      for i := 1 to 19 do begin
        Edit_Min_Fields[i].Enabled := False;
        Edit_Max_Fields[i].Enabled := False;
      end;
    end;
    True : begin
      Caption := 'Limits Active';
      Active1.Caption := 'Deactivate';
      for i := 1 to 19 do begin
        Edit_Min_Fields[i].Enabled := True;
        Edit_Max_Fields[i].Enabled := True;
      end;
    end;
  end;

  with Min_Pars do begin
    vers_Min_Show.Text := FloatToStrF(vers,fffixed,8,3);
    AspRat_Min_Show.Text := FloatToStrF(AspRat,fffixed,8,3);
  end;
  with Max_Pars do begin
    vers_Max_Show.Text := FloatToStrF(vers,fffixed,8,3);
    AspRat_Max_Show.Text := FloatToStrF(AspRat,fffixed,8,3);
  end;
  Display_Check_Trivial;
  Update_Values_Pars_panel;
  Check_For_GapV;
  Set_Colors_all;
end;

procedure TLimits.Exponent_Labels;
begin
  plp_e_Label.Caption := 'PL.Exp. J'''; plpp_e_Label.Caption := 'PL.Exp. J''''';
  plp_f_Label.Caption := 'PL.Exp. J'''; plpp_f_Label.Caption := 'PL.Exp. J''''';
  plp_b_Label.Caption := 'PL.Exp. J'''; plpp_b_Label.Caption := 'PL.Exp. J''''';
end;

procedure TLimits.Read_Panel_Format;
begin
  Top := Ini.ReadInteger('Main','Top',0);
  Height := Ini.ReadInteger('Main','Height',200);
  Left := Ini.ReadInteger('Main','Left',0);
  Width := Ini.ReadInteger('Main','Width',200);
end;

procedure TLimits.Write_Panel_Format;
begin
  if B_NoClick then Exit;
  Ini.WriteInteger('Main','Top',Top);
  Ini.WriteInteger('Main','Height',Height);
  Ini.WriteInteger('Main','Left',Left);
  Ini.WriteInteger('Main','Width',Width); B_Changed := True;
end;

procedure TLimits.Arrange;
begin
  Exponent_Labels;
  if Roughness_Panel.Visible
    then AMF_Panel.Width := Roughness_Panel.Left + Roughness_Panel.Width + 1
    else AMF_Panel.Width := Roughness_Panel.Left;
  Roughness_Panel.Visible := B_Roughness;
end;

procedure TLimits.Update_Values_Pars_panel;
begin
  with Min_pars do begin
    Jp_e_Label.Caption := 'J''(f_cen) [MPa^-1]'; Jpp_e_Label.Caption := 'J''''(f_cen) [MPa^-1]';
    Jp_f_Label.Caption := 'J''(f_cen) [MPa^-1]'; Jpp_f_Label.Caption := 'J''''(f_cen) [MPa^-1]';
    Jp_b_Label.Caption := 'eta''(f_cen) [mPa s]'; Jpp_b_Label.Caption := 'eta''''(f_cen) [mPa s]';

    t_e_Min_Show.Text := FloatToStrF(t_e,fffixed,8,3);
    t_f_Min_Show.Text := FloatToStrF(t_f,fffixed,8,3);
    rho_e_Min_Show.Text := FloatToStrF(rho_e,fffixed,8,3);
    rho_f_Min_Show.Text := FloatToStrF(rho_f,fffixed,8,3);
    rho_b_Min_Show.Text := FloatToStrF(rho_b,fffixed,8,3);
    Jp_e_Min_Show.Text := FloatToStrF(Jp_e,fffixed,8,5);
    Jp_f_Min_Show.Text := FloatToStrF(Jp_f,fffixed,8,5);
    Jpp_e_Min_Show.Text := FloatToStrF(Jpp_e,fffixed,8,5);
    Jpp_f_Min_Show.Text := FloatToStrF(Jpp_f,fffixed,8,5);
    Jp_exp_e_Min_Show.Text := FloatToStrF(Jp_exp_e,fffixed,8,3);
    Jp_exp_f_Min_Show.Text := FloatToStrF(Jp_exp_f,fffixed,8,3);
    Jpp_exp_e_Min_Show.Text := FloatToStrF(Jpp_exp_e,fffixed,8,3);
    Jpp_exp_f_Min_Show.Text := FloatToStrF(Jpp_exp_f,fffixed,8,3);
    Jp_b_Min_Show.Text := FloatToStrF(Jp_b,fffixed,8,5);
    Jpp_b_Min_Show.Text := FloatToStrF(Jpp_b,fffixed,8,5);
    Jp_exp_b_Min_Show.Text := FloatToStrF(Jp_exp_b,fffixed,8,3);
    Jpp_exp_b_Min_Show.Text := FloatToStrF(Jpp_exp_b,fffixed,8,3);
  end;
  with Max_pars do begin
    t_e_Max_Show.Text := FloatToStrF(t_e,fffixed,8,3);
    t_f_Max_Show.Text := FloatToStrF(t_f,fffixed,8,3);
    rho_e_Max_Show.Text := FloatToStrF(rho_e,fffixed,8,3);
    rho_f_Max_Show.Text := FloatToStrF(rho_f,fffixed,8,3);
    rho_b_Max_Show.Text := FloatToStrF(rho_b,fffixed,8,3);
    Jp_e_Max_Show.Text := FloatToStrF(Jp_e,fffixed,8,5);
    Jp_f_Max_Show.Text := FloatToStrF(Jp_f,fffixed,8,5);
    Jpp_e_Max_Show.Text := FloatToStrF(Jpp_e,fffixed,8,5);
    Jpp_f_Max_Show.Text := FloatToStrF(Jpp_f,fffixed,8,5);
    Jp_exp_e_Max_Show.Text := FloatToStrF(Jp_exp_e,fffixed,8,3);
    Jp_exp_f_Max_Show.Text := FloatToStrF(Jp_exp_f,fffixed,8,3);
    Jpp_exp_e_Max_Show.Text := FloatToStrF(Jpp_exp_e,fffixed,8,3);
    Jpp_exp_f_Max_Show.Text := FloatToStrF(Jpp_exp_f,fffixed,8,3);
    Jp_b_Max_Show.Text := FloatToStrF(Jp_b,fffixed,8,5);
    Jpp_b_Max_Show.Text := FloatToStrF(Jpp_b,fffixed,8,5);
    Jp_exp_b_Max_Show.Text := FloatToStrF(Jp_exp_b,fffixed,8,3);
    Jpp_exp_b_Max_Show.Text := FloatToStrF(Jpp_exp_b,fffixed,8,3);
  end;
end;

procedure TLimits.Set_Color(i_par : integer);
var editComp : TEdit;
    MinVal,Maxval,Val : Double;
begin
  case i_par of
    t_e_ID : begin editComp := M.t_e_Show; MinVal := Min_Pars.t_e; MaxVal := Max_Pars.t_e; Val := Pars.t_e; end;
    t_f_ID : begin editComp := M.t_f_Show; MinVal := Min_Pars.t_f; MaxVal := Max_Pars.t_f; Val := Pars.t_f; end;
    rho_e_ID : begin editComp := M.rho_e_Show; MinVal := Min_Pars.rho_e; MaxVal := Max_Pars.rho_e; Val := Pars.rho_e; end;
    rho_f_ID : begin editComp := M.rho_f_Show; MinVal := Min_Pars.rho_f; MaxVal := Max_Pars.rho_f; Val := Pars.rho_f; end;
    rho_b_ID : begin editComp := M.rho_b_Show; MinVal := Min_Pars.rho_b; MaxVal := Max_Pars.rho_b; Val := Pars.rho_b; end;

    Jp_e_ID : begin editComp := M.Jp_e_Show; MinVal := Min_Pars.Jp_e; MaxVal := Max_Pars.Jp_e; Val := Pars.Jp_e; end;
    Jp_f_ID : begin editComp := M.Jp_f_Show; MinVal := Min_Pars.Jp_f; MaxVal := Max_Pars.Jp_f; Val := Pars.Jp_f; end;
    Jp_b_ID : begin editComp := M.Jp_b_Show; MinVal := Min_Pars.Jp_b; MaxVal := Max_Pars.Jp_b; Val := Pars.Jp_b; end;

    Jp_exp_e_ID : begin editComp := M.Jp_exp_e_Show; MinVal := Min_Pars.Jp_exp_e; MaxVal := Max_Pars.Jp_exp_e; Val := Pars.Jp_exp_e; end;
    Jp_exp_f_ID : begin editComp := M.Jp_exp_f_Show; MinVal := Min_Pars.Jp_exp_f; MaxVal := Max_Pars.Jp_exp_f; Val := Pars.Jp_exp_f; end;
    Jp_exp_b_ID : begin editComp := M.Jp_exp_b_Show; MinVal := Min_Pars.Jp_exp_b; MaxVal := Max_Pars.Jp_exp_b; Val := Pars.Jp_exp_b; end;

    Jpp_e_ID : begin editComp := M.Jpp_e_Show;   MinVal := Min_Pars.Jpp_e; MaxVal := Max_Pars.Jpp_e; Val := Pars.Jpp_e; end;
    Jpp_f_ID : begin editComp := M.Jpp_f_Show;   MinVal := Min_Pars.Jpp_f; MaxVal := Max_Pars.Jpp_f; Val := Pars.Jpp_f; end;
    Jpp_b_ID : begin editComp := M.Jpp_b_Show; MinVal := Min_Pars.Jpp_b; MaxVal := Max_Pars.Jpp_b; Val := Pars.Jpp_b; end;

    Jpp_exp_e_ID : begin editComp := M.Jpp_exp_e_Show; MinVal := Min_Pars.Jpp_exp_e; MaxVal := Max_Pars.Jpp_exp_e; Val := Pars.Jpp_exp_e; end;
    Jpp_exp_f_ID : begin editComp := M.Jpp_exp_f_Show; MinVal := Min_Pars.Jpp_exp_f; MaxVal := Max_Pars.Jpp_exp_f; Val := Pars.Jpp_exp_f; end;
    Jpp_exp_b_ID : begin editComp := M.Jpp_exp_b_Show; MinVal := Min_Pars.Jpp_exp_b; MaxVal := Max_Pars.Jpp_exp_b; Val := Pars.Jpp_exp_b; end;

    vers_ID : begin editComp := M.vers_Show; MinVal := Min_Pars.vers; MaxVal := Max_Pars.vers; Val := Pars.vers; end;
    AspRat_ID : begin editComp := M.AspRat_Show; MinVal := Min_Pars.AspRat; MaxVal := Max_Pars.AspRat; Val := Pars.AspRat; end;

    else Exit;
  end;
  editComp.Font.Color := clblack; 
  if ((MinVal = GapV) and (MaxVal = GapV)) or (B_Limits_active = False) then editComp.Color := clwhite
  else editComp.Color := TColor($FFF8F0);

  if B_Limits_active then begin
    if (abs(val) > 1e-24) then begin
      if abs((val - MaxVal)/val) < 1e-9 then begin
        editComp.Font.Color := clred;
      end;
      if abs((val - MinVal)/val) < 1e-9 then begin
        editComp.Font.Color := clred;
      end;
    end else if abs(val - maxVal) < 1e-15 then begin
      editComp.Font.Color := clred;
    end;
    if val < MinVal then begin
      editComp.Font.Color := clred;
    end;
    if val > MaxVal then begin
      editComp.Font.Color := clred;
    end;  
  end else editComp.Font.Color := clblack;
end;

procedure TLimits.Set_Colors_all;
var i : integer;
begin
  for i := 1 to 100 do Set_Color(i);
end;

procedure TLimits.Check_for_Limits(i_par : integer; var par : Double);
begin
  case i_par of
    t_e_ID :  begin
      if (par < Min_pars.t_e) and (Min_pars.t_e <> GapV) then par := Min_pars.t_e;
      if (par > Max_pars.t_e) and (Max_pars.t_e <> GapV) then par := Max_pars.t_e;
    end;
    t_f_ID :  begin
      if (par < Min_pars.t_f)  and (Min_pars.t_f <> GapV) then par := Min_pars.t_f;
      if (par > Max_pars.t_f)  and (Max_pars.t_f <> GapV) then par := Max_pars.t_f;
    end;

    rho_e_ID : begin
      if (par < Min_pars.rho_e)  and (Min_pars.rho_e <> GapV) then par := Min_pars.rho_e;
      if (par > Max_pars.rho_e)  and (Max_pars.rho_e <> GapV) then par := Max_pars.rho_e;
    end;
    rho_f_ID : begin
      if (par < Min_pars.rho_f)  and (Min_pars.rho_f <> GapV) then par := Min_pars.rho_f;
      if (par > Max_pars.rho_f)  and (Max_pars.rho_f <> GapV) then par := Max_pars.rho_f;
    end;
    rho_b_ID : begin
      if (par < Min_pars.rho_b)  and (Min_pars.rho_b <> GapV) then par := Min_pars.rho_b;
      if (par > Max_pars.rho_b)  and (Max_pars.rho_b <> GapV) then par := Max_pars.rho_b;
    end;

    Jp_e_ID : begin
      if (par < Min_pars.Jp_e)  and (Min_pars.Jp_e <> GapV) then par := Min_pars.Jp_e;
      if (par > Max_pars.Jp_e)  and (Max_pars.Jp_e <> GapV) then par := Max_pars.Jp_e;
    end;
    Jp_f_ID : begin
      if (par < Min_pars.Jp_f)  and (Min_pars.Jp_f <> GapV) then par := Min_pars.Jp_f;
      if (par > Max_pars.Jp_f)  and (Max_pars.Jp_f <> GapV) then par := Max_pars.Jp_f;
    end;
    Jp_b_ID : begin
      if (par < Min_pars.Jp_b)  and (Min_pars.Jp_b <> GapV) then par := Min_pars.Jp_b;
      if (par > Max_pars.Jp_b)  and (Max_pars.Jp_b <> GapV) then par := Max_pars.Jp_b;
    end;

    Jp_exp_e_ID : begin
      if (par < Min_pars.Jp_exp_e)  and (Min_pars.Jp_exp_e <> GapV) then par := Min_pars.Jp_exp_e;
      if (par > Max_pars.Jp_exp_e)  and (Max_pars.Jp_exp_e <> GapV) then par := Max_pars.Jp_exp_e;
    end;
    Jp_exp_f_ID : begin
      if (par < Min_pars.Jp_exp_f)  and (Min_pars.Jp_exp_f <> GapV) then par := Min_pars.Jp_exp_f;
      if (par > Max_pars.Jp_exp_f)  and (Max_pars.Jp_exp_f <> GapV) then par := Max_pars.Jp_exp_f;
    end;
    Jp_exp_b_ID : begin
      if (par < Min_pars.Jp_exp_b)  and (Min_pars.Jp_exp_b <> GapV) then par := Min_pars.Jp_exp_b;
      if (par > Max_pars.Jp_exp_b)  and (Max_pars.Jp_exp_b <> GapV) then par := Max_pars.Jp_exp_b;
    end;

    Jpp_e_ID : begin
      if (par < Min_pars.Jpp_e)  and (Min_pars.Jpp_e <> GapV) then par := Min_pars.Jpp_e;
      if (par > Max_pars.Jpp_e)  and (Max_pars.Jpp_e <> GapV) then par := Max_pars.Jpp_e;
    end;
    Jpp_f_ID : begin
      if (par < Min_pars.Jpp_f)  and (Min_pars.Jpp_f <> GapV) then par := Min_pars.Jpp_f;
      if (par > Max_pars.Jpp_f)  and (Max_pars.Jpp_f <> GapV) then par := Max_pars.Jpp_f;
    end;
    Jpp_b_ID : begin
      if (par < Min_pars.Jpp_b)  and (Min_pars.Jpp_b <> GapV) then par := Min_pars.Jpp_b;
      if (par > Max_pars.Jpp_b)  and (Max_pars.Jpp_b <> GapV) then par := Max_pars.Jpp_b;
    end;

    Jpp_exp_e_ID : begin
      if (par < Min_pars.Jpp_exp_e)  and (Min_pars.Jpp_exp_e <> GapV) then par := Min_pars.Jpp_exp_e;
      if (par > Max_pars.Jpp_exp_e)  and (Max_pars.Jpp_exp_e <> GapV) then par := Max_pars.Jpp_exp_e;
    end;
    Jpp_exp_f_ID : begin
      if (par < Min_pars.Jpp_exp_f)  and (Min_pars.Jpp_exp_f <> GapV) then par := Min_pars.Jpp_exp_f;
      if (par > Max_pars.Jpp_exp_f)  and (Max_pars.Jpp_exp_f <> GapV) then par := Max_pars.Jpp_exp_f;
    end;
    Jpp_exp_b_ID : begin
      if (par < Min_pars.Jpp_exp_b)  and (Min_pars.Jpp_exp_b <> GapV) then par := Min_pars.Jpp_exp_b;
      if (par > Max_pars.Jpp_exp_b)  and (Max_pars.Jpp_exp_b <> GapV) then par := Max_pars.Jpp_exp_b;
    end;

    vers_ID : begin
      if (par < Min_pars.vers)  and (Min_pars.vers <> GapV) then par := Min_pars.vers;
      if (par > Max_pars.vers)  and (Max_pars.vers <> GapV) then par := Max_pars.vers;
    end;
    AspRat_ID : begin
      if (par < Min_pars.AspRat)  and (Min_pars.AspRat <> GapV) then par := Min_pars.AspRat;
      if (par > Max_pars.AspRat)  and (Max_pars.AspRat <> GapV) then par := Max_pars.AspRat;
    end;
  end;
end;

function TLimits.IsOverLimit(var FitValues : TDouble_npar): Boolean;
var   i: integer;
    par: double;
begin
  result := true;
  for i := 1 to n_fit_pars do begin
    par := FitValues[i];
    case fit_pointer[i] of
      t_e_ID :  begin
        if (par < Min_pars.t_e) and (Min_pars.t_e <> GapV) and (par <> GapV) then exit;
        if (par > Max_pars.t_e) and (Max_pars.t_e <> GapV) and (par <> GapV) then exit;
      end;
      t_f_ID :  begin
        if (par < Min_pars.t_f)  and (Min_pars.t_f <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.t_f)  and (Max_pars.t_f <> GapV) and (par <> GapV)  then exit;
      end;

      rho_e_ID : begin
        if (par < Min_pars.rho_e)  and (Min_pars.rho_e <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.rho_e)  and (Max_pars.rho_e <> GapV) and (par <> GapV)  then exit;
      end;
      rho_f_ID : begin
        if (par < Min_pars.rho_f)  and (Min_pars.rho_f <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.rho_f)  and (Max_pars.rho_f <> GapV) and (par <> GapV)  then exit;
      end;
      rho_b_ID : begin
        if (par < Min_pars.rho_b)  and (Min_pars.rho_b <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.rho_b)  and (Max_pars.rho_b <> GapV) and (par <> GapV)  then exit;
      end;

      Jp_e_ID : begin
        if (par < Min_pars.Jp_e)  and (Min_pars.Jp_e <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jp_e)  and (Max_pars.Jp_e <> GapV) and (par <> GapV)  then exit;
      end;
      Jp_f_ID : begin
        if (par < Min_pars.Jp_f)  and (Min_pars.Jp_f <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jp_f)  and (Max_pars.Jp_f <> GapV) and (par <> GapV)  then exit;
      end;
      Jp_b_ID : begin
        if (par < Min_pars.Jp_b)  and (Min_pars.Jp_b <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jp_b)  and (Max_pars.Jp_b <> GapV) and (par <> GapV)  then exit;
      end;

      Jp_exp_e_ID : begin
        if (par < Min_pars.Jp_exp_e)  and (Min_pars.Jp_exp_e <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jp_exp_e)  and (Max_pars.Jp_exp_e <> GapV) and (par <> GapV)  then exit;
      end;
      Jp_exp_f_ID : begin
        if (par < Min_pars.Jp_exp_f)  and (Min_pars.Jp_exp_f <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jp_exp_f)  and (Max_pars.Jp_exp_f <> GapV) and (par <> GapV)  then exit;
      end;
      Jp_exp_b_ID : begin
        if (par < Min_pars.Jp_exp_b)  and (Min_pars.Jp_exp_b <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jp_exp_b)  and (Max_pars.Jp_exp_b <> GapV) and (par <> GapV)  then exit;
      end;

      Jpp_e_ID : begin
        if (par < Min_pars.Jpp_e)  and (Min_pars.Jpp_e <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jpp_e)  and (Max_pars.Jpp_e <> GapV) and (par <> GapV)  then exit;
      end;
      Jpp_f_ID : begin
        if (par < Min_pars.Jpp_f)  and (Min_pars.Jpp_f <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jpp_f)  and (Max_pars.Jpp_f <> GapV) and (par <> GapV)  then exit;
      end;
      Jpp_b_ID : begin
        if (par < Min_pars.Jpp_b)  and (Min_pars.Jpp_b <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jpp_b)  and (Max_pars.Jpp_b <> GapV) and (par <> GapV)  then exit;
      end;

      Jpp_exp_e_ID : begin
        if (par < Min_pars.Jpp_exp_e)  and (Min_pars.Jpp_exp_e <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jpp_exp_e)  and (Max_pars.Jpp_exp_e <> GapV) and (par <> GapV)  then exit;
      end;
      Jpp_exp_f_ID : begin
        if (par < Min_pars.Jpp_exp_f)  and (Min_pars.Jpp_exp_f <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jpp_exp_f)  and (Max_pars.Jpp_exp_f <> GapV) and (par <> GapV)  then exit;
      end;
      Jpp_exp_b_ID : begin
        if (par < Min_pars.Jpp_exp_b)  and (Min_pars.Jpp_exp_b <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.Jpp_exp_b)  and (Max_pars.Jpp_exp_b <> GapV) and (par <> GapV)  then exit;
      end;

      vers_ID : begin
        if (par < Min_pars.vers)  and (Min_pars.vers <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.vers)  and (Max_pars.vers <> GapV) and (par <> GapV)  then exit;
      end;
      AspRat_ID : begin
        if (par < Min_pars.AspRat)  and (Min_pars.AspRat <> GapV) and (par <> GapV)  then exit;
        if (par > Max_pars.AspRat)  and (Max_pars.AspRat <> GapV) and (par <> GapV)  then exit;
      end;
    end; //case
  end;
  Result := false;
end;

procedure TLimits.Clear_Limits;
begin
  with Min_Pars do begin
    t_e := GapV; rho_e := GapV; Jp_e := GapV; Jpp_e := GapV; Jp_exp_e := GapV; Jpp_exp_e := GapV;
    t_f := GapV; rho_f := GapV; Jp_f := GapV; Jpp_f := GapV; Jp_exp_f := GapV; Jpp_exp_f := GapV;
    rho_b := GapV; Jp_b := GapV; Jpp_b := GapV; Jp_exp_b := GapV; Jpp_exp_b := GapV;
    vers := GapV; AspRat := GapV;
  end;
  with Max_Pars do begin
    t_e := GapV; rho_e := GapV; Jp_e := GapV; Jpp_e := GapV; Jp_exp_e := GapV; Jpp_exp_e := GapV;
    t_f := GapV; rho_f := GapV; Jp_f := GapV; Jpp_f := GapV; Jp_exp_f := GapV; Jpp_exp_f := GapV;
    rho_b := GapV; Jp_b := GapV; Jpp_b := GapV; Jp_exp_b := GapV; Jpp_exp_b := GapV;
    vers := GapV; AspRat := GapV;
  end;
  MIO.System_Write(j_par_Limits_Min,QTMFile);
  MIO.System_Write(j_par_Limits_Max,QTMFile);
end;

procedure TLimits.Check_For_GapV;
var i : integer;
begin
  with Min_Pars do begin
    Values_Min[1] := t_e;
    Values_Min[2] := t_f;
    Values_Min[3] := rho_e;
    Values_Min[4] := rho_f;
    Values_Min[5] := rho_b;
    Values_Min[6] := Jp_e;
    Values_Min[7] := Jp_f;
    Values_Min[8] := Jp_b;
    Values_Min[9] := Jp_exp_e;
    Values_Min[10] := Jp_exp_f;
    Values_Min[11] := Jp_exp_b;
    Values_Min[12] := Jpp_e;
    Values_Min[13] := Jpp_f;
    Values_Min[14] := Jpp_b;
    Values_Min[15] := Jpp_exp_e;
    Values_Min[16] := Jpp_exp_f;
    Values_Min[17] := Jpp_exp_b;
    Values_Min[18] := vers;
    Values_Min[19] := AspRat;

  end;
  for i := 1 to 19 do if Values_Min[i] = GapV then Edit_Min_Fields[i].Text := '';

  with Max_Pars do begin
    Values_Max[1] := t_e;
    Values_Max[2] := t_f;
    Values_Max[3] := rho_e;
    Values_Max[4] := rho_f;
    Values_Max[5] := rho_b;
    Values_Max[6] := Jp_e;
    Values_Max[7] := Jp_f;
    Values_Max[8] := Jp_b;
    Values_Max[9] := Jp_exp_e;
    Values_Max[10] := Jp_exp_f;
    Values_Max[11] := Jp_exp_b;
    Values_Max[12] := Jpp_e;
    Values_Max[13] := Jpp_f;
    Values_Max[14] := Jpp_b;
    Values_Max[15] := Jpp_exp_e;
    Values_Max[16] := Jpp_exp_f;
    Values_Max[17] := Jpp_exp_b;
    Values_Max[18] := vers;
    Values_Max[19] := AspRat;

  end;
  for i := 1 to 19 do if Values_Max[i] = GapV then Edit_Max_Fields[i].Text := '';
end;

procedure TLimits.Display_Check_Trivial;
begin
  t_e_Min_Show.Visible := B_layer_1;
  t_f_Min_Show.Visible := B_layer_2;
  rho_b_Min_Show.Visible := B_liquid_Bulk;

  rho_e_Min_Show.Visible := B_layer_1;
  rho_f_Min_Show.Visible := B_layer_2;

  Jp_e_Min_Show.Visible := B_layer_1;
  Jp_f_Min_Show.Visible := B_layer_2;
  Jp_b_Min_Show.Visible := B_Liquid_Bulk;

  Jpp_e_Min_Show.Visible := B_layer_1;
  Jpp_f_Min_Show.Visible := B_layer_2;
  Jpp_b_Min_Show.Visible := B_Liquid_Bulk;

  Jp_exp_e_Min_Show.Visible := B_layer_1;;
  Jp_exp_f_Min_Show.Visible := B_layer_2 and not (Pars.i_ve_f = 8);
  Jp_exp_b_Min_Show.Visible :=  B_Liquid_Bulk;

  Jpp_exp_e_Min_Show.Visible := B_layer_1;;
  Jpp_exp_f_Min_Show.Visible := B_layer_2 and not (Pars.i_ve_f = 8);
  Jpp_exp_b_Min_Show.Visible := B_Liquid_Bulk;

  t_e_Max_Show.Visible := B_layer_1;
  t_f_Max_Show.Visible := B_layer_2;
  rho_b_Max_Show.Visible := B_liquid_Bulk;

  rho_e_Max_Show.Visible := B_layer_1;
  rho_f_Max_Show.Visible := B_layer_2;

  Jp_e_Max_Show.Visible := B_layer_1;
  Jp_f_Max_Show.Visible := B_layer_2;
  Jp_b_Max_Show.Visible := B_Liquid_Bulk;

  Jpp_e_Max_Show.Visible := B_layer_1;
  Jpp_f_Max_Show.Visible := B_layer_2;
  Jpp_b_Max_Show.Visible := B_Liquid_Bulk;

  Jp_exp_e_Max_Show.Visible := B_layer_1;;
  Jp_exp_f_Max_Show.Visible := B_layer_2 and not (Pars.i_ve_f = 8);
  Jp_exp_b_Max_Show.Visible := B_Liquid_Bulk;

  Jpp_exp_e_Max_Show.Visible := B_layer_1;;
  Jpp_exp_f_Max_Show.Visible := B_layer_2 and not (Pars.i_ve_f = 8);
  Jpp_exp_b_Max_Show.Visible := B_Liquid_Bulk;

  t_e_Label.Visible := B_layer_1;
  t_f_Label.Visible := B_layer_2;
  rho_b_Label.Visible := B_liquid_bulk;

  rho_e_Label.Visible := B_layer_1;
  rho_f_Label.Visible := B_layer_2;

  Jp_e_Label.Visible := B_layer_1;
  Jp_f_Label.Visible := B_layer_2;
  Jp_b_Label.Visible   := B_Liquid_Bulk;

  Jpp_e_Label.Visible := B_layer_1;
  Jpp_f_Label.Visible := B_layer_2;
  Jpp_b_Label.Visible  := B_Liquid_Bulk;

  plp_e_Label.Visible := B_layer_1;
  plp_f_Label.Visible := B_layer_2;
  plp_b_Label.Visible := B_Liquid_Bulk;

  plpp_e_Label.Visible := B_layer_1;
  plpp_f_Label.Visible := B_layer_2;
  plpp_b_Label.Visible := B_Liquid_Bulk;

  min_e_Label.Visible := B_layer_1;
  min_f_Label.Visible := B_layer_2;
  min_b_Label.Visible := B_Liquid_Bulk;
  max_e_Label.Visible := B_layer_1;
  max_f_Label.Visible := B_layer_2;
  max_b_Label.Visible := B_Liquid_Bulk;
  Roughness_Panel.Visible := B_Liquid_Bulk and B_Roughness;
  Arrange;
end;

procedure TLimits.KeyPressResponse(Sender: TObject; var Key: Char);
var ID,i_min_max : Integer;
    Edit_obj: TEdit;
begin
  if (Sender is TEdit) then Edit_obj := (Sender as TEdit);
  if (Sender as TEdit) = t_e_Min_Show then begin ID := t_e_ID; i_min_max := 1; end;
  if (Sender as TEdit) = t_f_Min_Show then begin ID := t_f_ID; i_min_max := 1; end;
  if (Sender as TEdit) = rho_e_Min_Show then begin ID := rho_e_ID; i_min_max := 1; end;
  if (Sender as TEdit) = rho_f_Min_Show then begin ID := rho_f_ID; i_min_max := 1; end;
  if (Sender as TEdit) = rho_b_Min_Show then begin ID := rho_b_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jp_e_Min_Show then begin ID := Jp_e_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jp_f_Min_Show then begin ID := Jp_f_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jp_b_Min_Show then begin ID := Jp_b_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jp_exp_e_Min_Show then begin ID := Jp_exp_e_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jp_exp_f_Min_Show then begin ID := Jp_exp_f_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jp_exp_b_Min_Show then begin ID := Jp_exp_b_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jpp_e_Min_Show then begin ID := Jpp_e_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jpp_f_Min_Show then begin ID := Jpp_f_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jpp_b_Min_Show then begin ID := Jpp_b_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jpp_exp_e_Min_Show then begin ID := Jpp_exp_e_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jpp_exp_f_Min_Show then begin ID := Jpp_exp_f_ID; i_min_max := 1; end;
  if (Sender as TEdit) = Jpp_exp_b_Min_Show then begin ID := Jpp_exp_b_ID; i_min_max := 1; end;

  if (Sender as TEdit) = AspRat_Min_Show then begin ID := AspRat_ID; i_min_max := 1; end;
  if (Sender as TEdit) = vers_Min_Show then begin ID := vers_ID; i_min_max := 1; end;


  if (Sender as TEdit) = t_e_Max_Show then begin ID := t_e_ID; i_min_max := 2; end;
  if (Sender as TEdit) = t_f_Max_Show then begin ID := t_f_ID; i_min_max := 2; end;
  if (Sender as TEdit) = rho_e_Max_Show then begin ID := rho_e_ID; i_min_max := 2; end;
  if (Sender as TEdit) = rho_f_Max_Show then begin ID := rho_f_ID; i_min_max := 2; end;
  if (Sender as TEdit) = rho_b_Max_Show then begin ID := rho_b_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jp_e_Max_Show then begin ID := Jp_e_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jp_f_Max_Show then begin ID := Jp_f_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jp_b_Max_Show then begin ID := Jp_b_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jp_exp_e_Max_Show then begin ID := Jp_exp_e_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jp_exp_f_Max_Show then begin ID := Jp_exp_f_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jp_exp_b_Max_Show then begin ID := Jp_exp_b_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jpp_e_Max_Show then begin ID := Jpp_e_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jpp_f_Max_Show then begin ID := Jpp_f_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jpp_b_Max_Show then begin ID := Jpp_b_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jpp_exp_e_Max_Show then begin ID := Jpp_exp_e_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jpp_exp_f_Max_Show then begin ID := Jpp_exp_f_ID; i_min_max := 2; end;
  if (Sender as TEdit) = Jpp_exp_b_Max_Show then begin ID := Jpp_exp_b_ID; i_min_max := 2; end;

  if (Sender as TEdit) = AspRat_Max_Show then begin ID := AspRat_ID; i_min_max := 2; end;
  if (Sender as TEdit) = vers_Max_Show then begin ID := vers_ID; i_min_max := 2; end;


  with Sender as TEdit do begin
    Color := cl3dLight; if key <> #13 then Exit; if key = #27 then begin Color := clwindow; Exit; end;
    case i_min_max of
      1 : begin
        case ID of
          t_e_ID :                begin Min_Pars.t_e                := M.FloatFromEdit(Edit_obj,Min_Pars.t_e       ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.t_e,fffixed,8,3); end;
          t_f_ID :                begin Min_Pars.t_f                := M.FloatFromEdit(Edit_obj,Min_Pars.t_f       ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.t_f,fffixed,8,3); end;
          rho_e_ID :              begin Min_Pars.rho_e              := M.FloatFromEdit(Edit_obj,Min_Pars.rho_e     ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.rho_e,fffixed,8,3); end;
          rho_f_ID :              begin Min_Pars.rho_f              := M.FloatFromEdit(Edit_obj,Min_Pars.rho_f     ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.rho_f,fffixed,8,3); end;
          rho_b_ID :              begin Min_Pars.rho_b              := M.FloatFromEdit(Edit_obj,Min_Pars.rho_b     ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.rho_b,fffixed,8,3); end;
          Jp_e_ID :               begin Min_Pars.Jp_e               := M.FloatFromEdit(Edit_obj,Min_Pars.Jp_e      ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jp_e,fffixed,8,3); end;
          Jp_f_ID :               begin Min_Pars.Jp_f               := M.FloatFromEdit(Edit_obj,Min_Pars.Jp_f      ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jp_f,fffixed,8,3); end;
          Jp_b_ID :               begin Min_Pars.Jp_b               := M.FloatFromEdit(Edit_obj,Min_Pars.Jp_b      ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jp_b,fffixed,8,3); end;

          Jp_exp_e_ID :           begin Min_Pars.Jp_exp_e           := M.FloatFromEdit(Edit_obj,Min_Pars.Jp_exp_e  ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jp_exp_e,fffixed,8,3); end;
          Jp_exp_f_ID :           begin Min_Pars.Jp_exp_f           := M.FloatFromEdit(Edit_obj,Min_Pars.Jp_exp_f  ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jp_exp_f,fffixed,8,3); end;
          Jp_exp_b_ID :           begin Min_Pars.Jp_exp_b           := M.FloatFromEdit(Edit_obj,Min_Pars.Jp_exp_b  ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jp_exp_b,fffixed,8,3); end;

          Jpp_e_ID :              begin Min_Pars.Jpp_e              := M.FloatFromEdit(Edit_obj,Min_Pars.Jpp_e     ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jpp_e,fffixed,8,3); end;
          Jpp_f_ID :              begin Min_Pars.Jpp_f              := M.FloatFromEdit(Edit_obj,Min_Pars.Jpp_f     ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jpp_f,fffixed,8,3); end;
          Jpp_b_ID :              begin Min_Pars.Jpp_b              := M.FloatFromEdit(Edit_obj,Min_Pars.Jpp_b     ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jpp_b,fffixed,8,3); end;

          Jpp_exp_e_ID :          begin Min_Pars.Jpp_exp_e          := M.FloatFromEdit(Edit_obj,Min_Pars.Jpp_exp_e ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jpp_exp_e,fffixed,8,3); end;
          Jpp_exp_f_ID :          begin Min_Pars.Jpp_exp_f          := M.FloatFromEdit(Edit_obj,Min_Pars.Jpp_exp_f ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jpp_exp_f,fffixed,8,3); end;
          Jpp_exp_b_ID :          begin Min_Pars.Jpp_exp_b          := M.FloatFromEdit(Edit_obj,Min_Pars.Jpp_exp_b ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.Jpp_exp_b,fffixed,8,3); end;

          AspRat_ID :               begin Min_Pars.AspRat               := M.FloatFromEdit(Edit_obj,Min_Pars.AspRat      ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.AspRat,fffixed,8,3); end;
          vers_ID :               begin Min_Pars.vers               := M.FloatFromEdit(Edit_obj,Min_Pars.vers      ); (Sender as TEdit).Text := FloatToStrF(Min_Pars.vers,fffixed,8,3); end;
        end;
        MIO.System_Write_Part(ID,j_par_Limits_Min,QTMFile);
      end;

      2 : begin
        case ID of
          t_e_ID :                begin Max_Pars.t_e                := M.FloatFromEdit(Edit_obj,Max_Pars.t_e              ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.t_e,fffixed,8,3); end;
          t_f_ID :                begin Max_Pars.t_f                := M.FloatFromEdit(Edit_obj,Max_Pars.t_f              ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.t_f,fffixed,8,3); end;
          rho_e_ID :              begin Max_Pars.rho_e              := M.FloatFromEdit(Edit_obj,Max_Pars.rho_e            ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.rho_e,fffixed,8,3); end;
          rho_f_ID :              begin Max_Pars.rho_f              := M.FloatFromEdit(Edit_obj,Max_Pars.rho_f            ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.rho_f,fffixed,8,3); end;
          rho_b_ID :              begin Max_Pars.rho_b              := M.FloatFromEdit(Edit_obj,Max_Pars.rho_b            ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.rho_b,fffixed,8,3); end;
          Jp_e_ID :               begin Max_Pars.Jp_e               := M.FloatFromEdit(Edit_obj,Max_Pars.Jp_e             ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jp_e,fffixed,8,3); end;
          Jp_f_ID :               begin Max_Pars.Jp_f               := M.FloatFromEdit(Edit_obj,Max_Pars.Jp_f             ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jp_f,fffixed,8,3); end;
          Jp_b_ID :               begin Max_Pars.Jp_b               := M.FloatFromEdit(Edit_obj,Max_Pars.Jp_b             ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jp_b,fffixed,8,3); end;

          Jp_exp_e_ID :           begin Max_Pars.Jp_exp_e           := M.FloatFromEdit(Edit_obj,Max_Pars.Jp_exp_e         ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jp_exp_e,fffixed,8,3); end;
          Jp_exp_f_ID :           begin Max_Pars.Jp_exp_f           := M.FloatFromEdit(Edit_obj,Max_Pars.Jp_exp_f         ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jp_exp_f,fffixed,8,3); end;
          Jp_exp_b_ID :           begin Max_Pars.Jp_exp_b           := M.FloatFromEdit(Edit_obj,Max_Pars.Jp_exp_b         ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jp_exp_b,fffixed,8,3); end;

          Jpp_e_ID :    begin Max_Pars.Jpp_e      := M.FloatFromEdit(Edit_obj,Max_Pars.Jpp_e    ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jpp_e,fffixed,8,3); end;
          Jpp_f_ID :    begin Max_Pars.Jpp_f      := M.FloatFromEdit(Edit_obj,Max_Pars.Jpp_f    ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jpp_f,fffixed,8,3); end;
          Jpp_b_ID :    begin Max_Pars.Jpp_b      := M.FloatFromEdit(Edit_obj,Max_Pars.Jpp_b    ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jpp_b,fffixed,8,3); end;

          Jpp_exp_e_ID : begin Max_Pars.Jpp_exp_e := M.FloatFromEdit(Edit_obj,Max_Pars.Jpp_exp_e); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jpp_exp_e,fffixed,8,3); end;
          Jpp_exp_f_ID : begin Max_Pars.Jpp_exp_f := M.FloatFromEdit(Edit_obj,Max_Pars.Jpp_exp_f); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jpp_exp_f,fffixed,8,3); end;
          Jpp_exp_b_ID : begin Max_Pars.Jpp_exp_b := M.FloatFromEdit(Edit_obj,Max_Pars.Jpp_exp_b); (Sender as TEdit).Text := FloatToStrF(Max_Pars.Jpp_exp_b,fffixed,8,3); end;

          AspRat_ID :    begin Max_Pars.AspRat    := M.FloatFromEdit(Edit_obj,Max_Pars.AspRat   ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.AspRat,fffixed,8,3); end;
          vers_ID :      begin Max_Pars.vers      := M.FloatFromEdit(Edit_obj,Max_Pars.vers     ); (Sender as TEdit).Text := FloatToStrF(Max_Pars.vers,fffixed,8,3); end;
        end;
        MIO.System_Write_Part(ID,j_par_Limits_Max,QTMFile);
      end;
    end;
    Update_Values; Limits.Set_Color(ID); (Sender as TEdit).Color := clwindow;
  end;
end;

procedure TLimits.Active1Click(Sender: TObject);
begin
  B_Limits_Active := not B_Limits_Active;
  QTMFile.WriteBool('Limits','B_Limits_active',B_Limits_active); B_Changed := True;
  Update_Values; Limits.Set_Colors_all;
end;

procedure TLimits.Defaults1Click(Sender: TObject);
begin
  Min_pars.t_e := 0; Max_pars.t_e := 1e4;
  Min_pars.t_f := 0; Max_pars.t_f := 1e4;
  Min_pars.rho_e := 0.1; Max_pars.rho_e := 30;
  Min_pars.rho_f := 0.1; Max_pars.rho_f := 30;
  Min_pars.rho_b := 0.1; Max_pars.rho_b := 30;
  Min_pars.Jp_e  := 0;   Max_pars.Jp_e  := 1e6;
  Min_pars.Jpp_e  := 0;   Max_pars.Jpp_e  := 1e6;
  Min_pars.Jp_f  := 0;   Max_pars.Jp_f  := 1e6;
  Min_pars.Jpp_f  := 0;   Max_pars.Jpp_f  := 1e6;
  Min_pars.Jp_b  := 0.1;   Max_pars.Jp_b  := 1e6;
  Min_pars.Jpp_b  := 0;   Max_pars.Jpp_b  := 1e6;
  Min_pars.Jp_exp_e  := -2;   Max_pars.Jp_exp_e := 0;
  Min_pars.Jpp_exp_e := -1;   Max_pars.Jpp_exp_e := 1;
  Min_pars.Jp_exp_f  := -2;   Max_pars.Jp_exp_f := 0;
  Min_pars.Jpp_exp_f := -1;   Max_pars.Jpp_exp_f := 1;
  Min_pars.Jp_exp_b  := -2;   Max_pars.Jp_exp_b := 0;
  Min_pars.Jpp_exp_b := -1;   Max_pars.Jpp_exp_b := 1;
  Min_pars.vers := 0;         Max_pars.vers := 50;
  Min_pars.AspRat := 1e-3;    Max_pars.AspRat := 1;

  MIO.System_Write(j_par_Limits_Min,QTMFile);
  MIO.System_Write(j_par_Limits_Max,QTMFile);
  Update_Values;
end;


end.

