unit QTM_Settings;
interface
uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, QTM_Decl, StdCtrls, ExtCtrls, StrUtils;

type
  TSettings = class(TForm)
    B_Autoload_Prev_CBox: TCheckBox; B_Show_Exp_CBox: TCheckBox; B_Show_RoughC_CBox: TCheckBox; B_IncludeFilename_CBox: TCheckBox;
    Label1: TLabel; Label4: TLabel; Label5: TLabel; Label2: TLabel; Label3: TLabel; Label6: TLabel;
    Sample_String_Show: TEdit; Info_String_Show: TEdit; f_fund_Show: TEdit; f_Jref_Show: TEdit; Zq_Show: TEdit;
    AMF_Panel: TPanel;
    t_e_Label: TLabel; rho_e_Label: TLabel; Jp_e_Label: TLabel; Jp_b_Label: TLabel;
    plp_e_Label: TLabel; Jpp_e_Label: TLabel; plpp_e_Label: TLabel; Jpp_b_Label: TLabel;
    Jp_f_Label: TLabel; Jpp_f_Label: TLabel; rho_f_Label: TLabel; rho_b_Label: TLabel;
    plp_b_Label: TLabel; plp_f_Label: TLabel; plpp_f_Label: TLabel; plpp_b_Label: TLabel; t_f_Label: TLabel;  Label7: TLabel;
    t_e_Show: TEdit; t_f_Show: TEdit; rho_e_Show: TEdit; rho_f_Show: TEdit; rho_b_Show: TEdit;
    Jp_e_Show: TEdit; Jp_f_Show: TEdit;
    Jp_b_Show: TEdit; Jp_exp_e_Show: TEdit; Jp_exp_f_Show: TEdit;
    Jp_exp_b_Show: TEdit; Jpp_e_Show: TEdit; Jpp_f_Show: TEdit;
    Jpp_b_Show: TEdit; Jpp_exp_e_Show: TEdit;
    Jpp_exp_f_Show: TEdit;
    Jpp_exp_b_Show: TEdit;
    Roughness_Panel: TPanel;
    vers_label: TLabel;
    AspRat_label: TLabel;
    Roughness_label: TLabel;
    vers_Show: TEdit;
    AspRat_Show: TEdit;
    B_Perturbation_Show_All_CBox: TCheckBox;
    B_Python_Installed_CBox: TCheckBox;
    ch_e_ComBox: TComboBox;
    ch_f_ComBox: TComboBox;
    ch_b_ComBox: TComboBox;
    Python_Check_Btn: TButton;

    procedure Read_Panel_Format;
    procedure Write_Panel_Format;
    procedure Status_Read;
    procedure Update_Values;
    procedure B_Show_Exp_CBoxClick(Sender: TObject);
    procedure B_Autoload_Prev_CBoxClick(Sender: TObject);
    procedure B_Show_RoughC_CBoxClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Sample_String_ShowKeyPress(Sender: TObject; var Key: Char);
    procedure Info_String_ShowKeyPress(Sender: TObject; var Key: Char);
    procedure B_IncludeFilename_CBoxClick(Sender: TObject);
    procedure f_fund_ShowKeyPress(Sender: TObject; var Key: Char);
    procedure f_Jref_ShowKeyPress(Sender: TObject; var Key: Char);
    procedure Zq_ShowKeyPress(Sender: TObject; var Key: Char);
    procedure Display_Check_Trivial;
    procedure Exponent_Labels;
    procedure KeyPressResponse(Sender: TObject; var Key: Char);
    procedure B_Perturbation_Show_All_CBoxClick(Sender: TObject);
    procedure B_Python_Installed_CBoxClick(Sender: TObject);
    procedure Change_VE_Pars_All(Sender: TObject);
    procedure Python_Check_BtnClick(Sender: TObject);
  private

  public
    B_NoClick : Boolean;
  end;

var Settings: TSettings;

implementation
uses QTM_Main, QTM_Limits, QTM_MIO, QTM_Multiple, QTM_Chi2_Landscape, QTM_SLA;
{$R *.dfm}

procedure TSettings.FormDeactivate(Sender: TObject); begin Write_Panel_Format; end;
procedure TSettings.FormCreate(Sender: TObject);     begin Status_Read; end;

procedure TSettings.FormShow(Sender: TObject);
begin B_NoClick := True; Read_Panel_Format; Update_Values; B_NoClick := False; end;

procedure TSettings.Read_Panel_Format;
begin
  Top := Ini.ReadInteger('Settings','Top',0);
  Height := Ini.ReadInteger('Settings','Height',800);
  Left := Ini.ReadInteger('Settings','Left',0);
  Width := Ini.ReadInteger('Settings','Width',600);
end;

procedure TSettings.Write_Panel_Format;
begin
  if B_NoClick then Exit;
  Ini.WriteInteger('Settings','Top',Top);
  Ini.WriteInteger('Settings','Height',Height);
  Ini.WriteInteger('Settings','Left',Left);
  Ini.WriteInteger('Settings','Width',Width); B_Changed := True;
end;

procedure TSettings.Status_Read;
begin
  B_Development := Ini.ReadBool('Settings','B_Development',False);
  Ini.WriteBool('Settings','B_Development',B_Development);
  B_Python_Installed := Ini.ReadBool('Settings','B_Python_Installed',False);
  if not B_Python_Installed then i_fit_method := 1;
  B_Show_Exp := QTMFile.ReadBool('Settings','B_Show_Exp',True);
  B_Show_RoughC := QTMFile.ReadBool('Settings','B_Show_RoughC',False);
  B_Perturbation_Show_All := QTMFile.ReadBool('Settings','B_Perturbation_Show_All',False);
  B_IncludeFilename := QTMFile.ReadBool('Settings','B_IncludeFilename',False);
  Sample_String := QTMFile.ReadString('Settings','Sample_String','');
  Info_String   := QTMFile.ReadString('Settings','Info_String','');
  f_fund        := QTMFile.ReadFloat('Settings','f_fund',5e6);
  Zq            := QTMFile.ReadFloat('Settings','Zq',8.8e6);
  f_Jref        := QTMFile.ReadFloat('Settings','f_Jref',30e6);
end;

procedure TSettings.Update_Values;
begin
  B_Show_Exp_CBox.Checked := B_Show_Exp;
  B_Autoload_Prev_CBox.Checked := B_Autoload_Prev;
  B_Show_RoughC_CBox.Checked := B_Show_RoughC;
  B_Perturbation_Show_All_CBox.Checked := B_Perturbation_Show_All;
  B_Python_Installed_CBox.checked := B_Python_Installed;
  B_Perturbation_Show_All_CBox.Enabled := i_model > 1;
  B_Show_RoughC_CBox.enabled := B_Liquid_Bulk and B_Roughness;
  Sample_String_Show.Text := Sample_String;
  Info_String_Show.Text := Info_String;
  B_IncludeFilename_CBox.Checked := B_IncludeFilename;
  f_fund_Show.Text := FloatToStrf(f_fund/1e6,fffixed,8,3);
  f_Jref_Show.Text := FloatToStrf(f_Jref/1e6,fffixed,8,3);
  Zq_Show.Text := FloatToStrf(Zq/1e6,fffixed,8,3);
  Display_Check_Trivial;
//  Ref_pars.i_ve_e := Pars.i_ve_e;
//  Ref_pars.i_ve_f := Pars.i_ve_f;
//  Ref_pars.i_ve_b := Pars.i_ve_b;
  with Ref_Pars do begin
    t_e_Show.Text := FloatToStrF(t_e,fffixed,8,3);
    t_f_Show.Text := FloatToStrF(t_f,fffixed,8,3);
    rho_e_Show.Text := FloatToStrF(rho_e,fffixed,8,3);
    rho_f_Show.Text := FloatToStrF(rho_f,fffixed,8,3);
    rho_b_Show.Text := FloatToStrF(rho_b,fffixed,8,3);
    Jp_e_Show.Text := FloatToStrF(Jp_e,fffixed,8,5);
    Jp_f_Show.Text := FloatToStrF(Jp_f,fffixed,8,5);
    Jpp_e_Show.Text := FloatToStrF(Jpp_e,fffixed,8,5);
    Jpp_f_Show.Text := FloatToStrF(Jpp_f,fffixed,8,5);
    Jp_exp_e_Show.Text := FloatToStrF (Jp_exp_e ,fffixed,8,3);
    Jp_exp_f_Show.Text := FloatToStrF (Jp_exp_f ,fffixed,8,3);
    Jpp_exp_e_Show.Text := FloatToStrF(Jpp_exp_e,fffixed,8,3);
    Jpp_exp_f_Show.Text := FloatToStrF(Jpp_exp_f,fffixed,8,3);
    Jp_b_Show.Text := FloatToStrF(Jp_b,fffixed,8,5);
    Jpp_b_Show.Text := FloatToStrF(Jpp_b,fffixed,8,5);
    Jp_exp_b_Show.Text := FloatToStrF( Jp_exp_b ,fffixed,8,3);
    Jpp_exp_b_Show.Text := FloatToStrF(Jpp_exp_b,fffixed,8,3);
    vers_Show.Text := FloatToStrF(vers,fffixed,8,3);
    AspRat_Show.Text := FloatToStrF(AspRat,fffixed,8,3);
    ch_e_ComBox.ItemIndex    := i_ve_e - 1;
    ch_f_ComBox.ItemIndex    := i_ve_f - 1;
    ch_b_ComBox.ItemIndex    := i_ve_b - 1;
  end;
//  Roughness_Panel.Visible := B_roughness;
  vers_label.Caption := 'vertical scale [nm]';
  AspRat_label.Caption := 'aspect ratio';
end;

procedure TSettings.B_Show_Exp_CBoxClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_Show_Exp := B_Show_Exp_CBox.Checked;
  QTMFile.WriteBool('Settings','B_Show_Exp',B_Show_Exp); M.Update_All; B_Changed := True;
end;

procedure TSettings.B_Autoload_Prev_CBoxClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_Autoload_Prev := B_Autoload_Prev_CBox.Checked;
  Ini.WriteBool('Settings','B_Autoload_Prev',B_Autoload_Prev);
  B_Changed := True;
end;

procedure TSettings.B_Show_RoughC_CBoxClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_Show_RoughC := B_Show_RoughC_CBox.Checked;
  Ini.WriteBool('Settings','B_Show_RoughC',B_Show_RoughC);
  M.Update_All; B_Changed := True;
end;

procedure TSettings.B_Perturbation_Show_All_CBoxClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_Perturbation_Show_All := B_Perturbation_Show_All_CBox.Checked;
  QTMfile.WriteBool('Settings','B_Perturbation_Show_All',B_Perturbation_Show_All);
  M.Update_All; B_Changed := True;
end;

procedure TSettings.B_Python_Installed_CBoxClick(Sender: TObject);
begin
  if B_NoClick then Exit;
  B_Python_Installed := B_Python_Installed_CBox.Checked;
  Ini.WriteBool('Settings','B_Python_Installed',B_Python_Installed);
  M.Update_All;
  if Multiple.Showing then Multiple.Update_Values;
  if Chi2_Landscape.Showing then Chi2_Landscape.Update_Values;
end;

procedure TSettings.Sample_String_ShowKeyPress(Sender: TObject; var Key: Char);
begin
  Sample_String_Show.Color := cl3dLight;
  if key <> #13 then Exit;
  if key = #27 then begin Sample_String_Show.Color := clwindow; Exit; end;
  Sample_String := Sample_String_Show.Text;
  QTMFile.WriteString('Settings','Sample_String',Sample_String); B_Changed := True;
  Sample_String_Show.Color := clwindow;
  M.Update_Graphs;
  if key = #13 then key := #0;
end;

procedure TSettings.Info_String_ShowKeyPress(Sender: TObject; var Key: Char);
begin
  Info_String_Show.Color := cl3dLight; if key <> #13 then Exit; if key = #27 then begin Info_String_Show.Color := clwindow; Exit; end;
  Info_String := Info_String_Show.Text;
  QTMFile.WriteString('Settings','Info_String',Info_String); B_Changed := True;
  Info_String_Show.Color := clwindow;
  M.Update_Graphs;
  if key = #13 then key := #0;
end;

procedure TSettings.B_IncludeFilename_CBoxClick(Sender: TObject);
begin
  B_IncludeFilename := B_IncludeFilename_CBox.Checked;
  QTMFile.WriteBool('Settings','B_IncludeFilename',B_IncludeFilename); B_Changed := True;
  M.Update_Graphs;
end;

procedure TSettings.f_fund_ShowKeyPress(Sender: TObject; var Key: Char);
var f_fund_MHz : Double;
begin
  with Sender as TEdit do begin
    Color := cl3dLight;
    if GetKeyState(VK_DECIMAL) < 0 then Key := DecimalSeparator;
    if key <> #13 then Exit;
    if key = #27 then begin Color := clwindow; Exit; end;
  end;
  f_fund_MHz := f_fund / 1e6;
  f_fund_MHz := M.FloatFromEdit(Sender as TEdit, f_fund_MHz);
  f_fund := f_fund_MHz * 1e6;
  QTMFile.WriteFloat('Settings','f_fund',f_fund); B_Changed := True;
  (Sender as TEdit).Text := FloatToStrf(f_fund_MHz,fffixed,8,3);
  (Sender as TEdit).color := clwindow;
  if key = #13 then key := #0;
end;

procedure TSettings.f_Jref_ShowKeyPress(Sender: TObject; var Key: Char);
var f_Jref_MHz : Double;
begin
  with Sender as TEdit do begin
    Color := cl3dLight;
    if GetKeyState(VK_DECIMAL) < 0 then Key := DecimalSeparator;
    if key <> #13 then Exit;
    if key = #27 then begin Color := clwindow; Exit; end;
  end;
  f_Jref_MHz := f_Jref / 1e6;
  f_Jref_MHz := M.FloatFromEdit(Sender as TEdit, f_Jref_MHz);
  f_Jref := f_Jref_MHz * 1e6;
  QTMFile.WriteFloat('Settings','f_Jref',f_Jref); B_Changed := True;
  (Sender as TEdit).Text := FloatToStrf(f_Jref_MHz,fffixed,8,3);
  (Sender as TEdit).color := clwindow;
  if key = #13 then key := #0;
end;

procedure TSettings.Zq_ShowKeyPress(Sender: TObject; var Key: Char);
var Zq_by_1e6 : Double;
begin
  with Sender as TEdit do begin
    Color := cl3dLight;
    if GetKeyState(VK_DECIMAL) < 0 then Key := DecimalSeparator;
    if key <> #13 then Exit;
    if key = #27 then begin Color := clwindow; Exit; end;
  end;
  Zq_by_1e6 := Zq / 1e6;
  Zq_by_1e6 := M.FloatFromEdit(Sender as TEdit, Zq_by_1e6);
  Zq := Zq_by_1e6 * 1e6;
  QTMFile.WriteFloat('Settings','Zq',Zq); B_Changed := True;
  (Sender as TEdit).Text := FloatToStrf(Zq_by_1e6,fffixed,8,3);
  (Sender as TEdit).color := clwindow;
  if key = #13 then key := #0;
end;

procedure TSettings.KeyPressResponse(Sender: TObject; var Key: Char);
var ID : integer;
    Edit_obj: TEdit;
begin
  if (Sender is TEdit) then Edit_obj := (Sender as TEdit);
  if (Sender as TEdit) = t_e_Show then begin ID := t_e_ID; end;
  if (Sender as TEdit) = t_f_Show then begin ID := t_f_ID; end;
  if (Sender as TEdit) = rho_e_Show then begin ID := rho_e_ID; end;
  if (Sender as TEdit) = rho_f_Show then begin ID := rho_f_ID; end;
  if (Sender as TEdit) = rho_b_Show then begin ID := rho_b_ID; end;
  if (Sender as TEdit) = Jp_e_Show then begin ID := Jp_e_ID; end;
  if (Sender as TEdit) = Jp_f_Show then begin ID := Jp_f_ID; end;
  if (Sender as TEdit) = Jp_b_Show then begin ID := Jp_b_ID; end;
  if (Sender as TEdit) = Jp_exp_e_Show then begin ID := Jp_exp_e_ID; end;
  if (Sender as TEdit) = Jp_exp_f_Show then begin ID := Jp_exp_f_ID; end;
  if (Sender as TEdit) = Jp_exp_b_Show then begin ID := Jp_exp_b_ID; end;
  if (Sender as TEdit) = Jpp_e_Show then begin ID := Jpp_e_ID; end;
  if (Sender as TEdit) = Jpp_f_Show then begin ID := Jpp_f_ID; end;
  if (Sender as TEdit) = Jpp_b_Show then begin ID := Jpp_b_ID; end;
  if (Sender as TEdit) = Jpp_exp_e_Show then begin ID := Jpp_exp_e_ID; end;
  if (Sender as TEdit) = Jpp_exp_f_Show then begin ID := Jpp_exp_f_ID; end;
  if (Sender as TEdit) = Jpp_exp_b_Show then begin ID := Jpp_exp_b_ID; end;
  if (Sender as TEdit) = vers_Show then begin ID := vers_ID; end;
  if (Sender as TEdit) = AspRat_Show then begin ID := AspRat_ID; end;

  with Sender as TEdit do begin
    Color := cl3dLight; if key <> #13 then Exit; if key = #27 then begin Color := clwindow; Exit; end;
    case ID of
      t_e_ID :      begin Ref_Pars.t_e      := M.FloatFromEdit(Edit_obj,Ref_Pars.t_e       ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.t_e,fffixed,8,3); end;
      t_f_ID :      begin Ref_Pars.t_f      := M.FloatFromEdit(Edit_obj,Ref_Pars.t_f       ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.t_f,fffixed,8,3); end;
      rho_e_ID :    begin Ref_Pars.rho_e    := M.FloatFromEdit(Edit_obj,Ref_Pars.rho_e     ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.rho_e,fffixed,8,3); end;
      rho_f_ID :    begin Ref_Pars.rho_f    := M.FloatFromEdit(Edit_obj,Ref_Pars.rho_f     ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.rho_f,fffixed,8,3); end;
      rho_b_ID :    begin Ref_Pars.rho_b    := M.FloatFromEdit(Edit_obj,Ref_Pars.rho_b     ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.rho_b,fffixed,8,3); end;
      Jp_e_ID :     begin Ref_Pars.Jp_e     := M.FloatFromEdit(Edit_obj,Ref_Pars.Jp_e      ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jp_e,fffixed,8,3); end;
      Jp_f_ID :     begin Ref_Pars.Jp_f     := M.FloatFromEdit(Edit_obj,Ref_Pars.Jp_f      ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jp_f,fffixed,8,3); end;
      Jp_b_ID :     begin Ref_Pars.Jp_b     := M.FloatFromEdit(Edit_obj,Ref_Pars.Jp_b      ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jp_b,fffixed,8,3); end;

      Jp_exp_e_ID : begin Ref_Pars.Jp_exp_e := M.FloatFromEdit(Edit_obj,Ref_Pars.Jp_exp_e  ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jp_exp_e,fffixed,8,3); end;
      Jp_exp_f_ID : begin Ref_Pars.Jp_exp_f := M.FloatFromEdit(Edit_obj,Ref_Pars.Jp_exp_f  ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jp_exp_f,fffixed,8,3); end;
      Jp_exp_b_ID : begin Ref_Pars.Jp_exp_b := M.FloatFromEdit(Edit_obj,Ref_Pars.Jp_exp_b  ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jp_exp_b,fffixed,8,3); end;

      Jpp_e_ID :    begin Ref_Pars.Jpp_e    := M.FloatFromEdit(Edit_obj,Ref_Pars.Jpp_e     ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jpp_e,fffixed,8,3); end;
      Jpp_f_ID :    begin Ref_Pars.Jpp_f    := M.FloatFromEdit(Edit_obj,Ref_Pars.Jpp_f     ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jpp_f,fffixed,8,3); end;
      Jpp_b_ID :    begin Ref_Pars.Jpp_b    := M.FloatFromEdit(Edit_obj,Ref_Pars.Jpp_b     ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jpp_b,fffixed,8,3); end;

      Jpp_exp_e_ID :begin Ref_Pars.Jpp_exp_e:= M.FloatFromEdit(Edit_obj,Ref_Pars.Jpp_exp_e ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jpp_exp_e,fffixed,8,3); end;
      Jpp_exp_f_ID :begin Ref_Pars.Jpp_exp_f:= M.FloatFromEdit(Edit_obj,Ref_Pars.Jpp_exp_f ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jpp_exp_f,fffixed,8,3); end;
      Jpp_exp_b_ID :begin Ref_Pars.Jpp_exp_b:= M.FloatFromEdit(Edit_obj,Ref_Pars.Jpp_exp_b ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.Jpp_exp_b,fffixed,8,3); end;

      vers_ID :     begin Ref_Pars.vers     := M.FloatFromEdit(Edit_obj,Ref_Pars.vers      ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.vers,fffixed,8,3); end;
      AspRat_ID :   begin Ref_Pars.AspRat   := M.FloatFromEdit(Edit_obj,Ref_Pars.AspRat      ); (Sender as TEdit).Text := FloatToStrF(Ref_Pars.AspRat,fffixed,8,3); end;
    end;
    MIO.System_Write_Part(ID,j_par_Ref,QTMFile);
    Update_Values; Limits.Set_Color(ID); (Sender as TEdit).Color := clwindow;
    M.Update_Model;
    M.Update_Graphs;
  end;
  if key = #13 then key := #0;
end;

procedure TSettings.Display_Check_Trivial;
begin
  t_e_Show.Visible := B_layer_1;
  t_f_Show.Visible := B_layer_2;
  rho_b_Show.Visible := B_liquid_Bulk;

  rho_e_Show.Visible := B_layer_1 and (Ref_Pars.t_e <> 0);
  rho_f_Show.Visible := B_layer_2 and (Ref_Pars.t_f <> 0);

  Jp_e_Show.Visible := B_layer_1 and (Ref_Pars.t_e <> 0);
  Jp_f_Show.Visible := B_layer_2 and (Ref_Pars.t_f <> 0);
  Jp_b_Show.Visible := B_Liquid_Bulk and (Ref_Pars.rho_b <> 0);

  Jpp_e_Show.Visible := B_layer_1 and (Ref_Pars.t_e <> 0);
  Jpp_f_Show.Visible := B_layer_2 and (Ref_Pars.t_f <> 0);
  Jpp_b_Show.Visible := B_Liquid_Bulk and (Ref_Pars.rho_b <> 0);

  Jp_exp_e_Show.Visible := B_layer_1 and (Ref_Pars.t_e <> 0);
  Jp_exp_f_Show.Visible := B_layer_2 and (Ref_Pars.t_f <> 0);
  Jp_exp_b_Show.Visible :=  B_Liquid_Bulk and (Ref_Pars.rho_b <> 0);

  Jpp_exp_e_Show.Visible := B_layer_1 and (Ref_Pars.t_e <> 0);
  Jpp_exp_f_Show.Visible := B_layer_2 and (Ref_Pars.t_f <> 0);
  Jpp_exp_b_Show.Visible := B_Liquid_Bulk and (Ref_Pars.rho_b <> 0);

  t_e_Label.Visible   := B_layer_1;
  t_f_Label.Visible   := B_layer_2;
  rho_b_Label.Visible := B_liquid_bulk;

  rho_e_Label.Visible := B_layer_1 and (Ref_Pars.t_e <> 0);
  rho_f_Label.Visible := B_layer_2 and (Ref_Pars.t_f <> 0);

  Jp_e_Label.Visible := B_layer_1 and (Ref_Pars.t_e <> 0);
  Jp_f_Label.Visible := B_layer_2 and (Ref_Pars.t_f <> 0);
  Jp_b_Label.Visible := B_Liquid_Bulk and (Ref_Pars.rho_b <> 0);

  Jpp_e_Label.Visible := B_layer_1 and (Ref_Pars.t_e <> 0);
  Jpp_f_Label.Visible := B_layer_2 and (Ref_Pars.t_f <> 0);
  Jpp_b_Label.Visible := B_Liquid_Bulk and (Ref_Pars.rho_b <> 0);

  plp_e_Label.Visible := B_layer_1 and (Ref_Pars.t_e <> 0);
  plp_f_Label.Visible := B_layer_2 and (Ref_Pars.t_f <> 0);
  plp_b_Label.Visible := B_Liquid_Bulk and (Ref_Pars.rho_b <> 0);

  plpp_e_Label.Visible := B_layer_1 and (Ref_Pars.t_e <> 0);
  plpp_f_Label.Visible := B_layer_2 and (Ref_Pars.t_f <> 0);
  plpp_b_Label.Visible := B_Liquid_Bulk and (Ref_Pars.rho_b <> 0);
  Roughness_Panel.Visible := B_Liquid_Bulk and B_Roughness and (Ref_Pars.rho_b <> 0);

  ch_e_ComBox.Visible := B_layer_1;
  ch_f_ComBox.Visible := B_layer_2;
  ch_b_ComBox.Visible := B_liquid_Bulk;

  Exponent_Labels;
end;

procedure TSettings.Exponent_Labels;
begin
  plp_e_Label.Caption := 'PLExp.Re'; plpp_e_Label.Caption := 'PLExp.Im';
  plp_f_Label.Caption := 'PLExp.Re'; plpp_f_Label.Caption := 'PLExp.Im';
  plp_b_Label.Caption := 'PLExp.Re'; plpp_b_Label.Caption := 'PLExp.Im';
  case Ref_Pars.i_ve_e of
    1 : begin
      Jp_e_label.Caption := 'J'' [MPa^-1]';
      Jpp_e_label.Caption := 'J'''' [MPa^-1]';
    end;
    2 : begin
      Jp_e_label.Caption := 'G'' [MPa]';
      Jpp_e_label.Caption := 'G'''' [MPa]';
    end;
    3 : begin
      Jp_e_label.Caption := 'eta'' [mPa s]';
      Jpp_e_label.Caption := 'eta'''' [mPa s]';
    end;
    4 : begin
      Jp_e_label.Caption := 'G'' [MPa]';
      Jpp_e_label.Caption := 'eta'' [mPa s]';
    end;
    5 : begin
      Jp_e_label.Caption := '|J| [MPa^1]';
      Jpp_e_label.Caption := 'tan del';
    end;
    6 : begin
      Jp_e_label.Caption := '|G| [MPa]';
      Jpp_e_label.Caption := 'tan del';
    end;
    7 : begin
      Jp_e_label.Caption := '|eta| [mPa s]';
      Jpp_e_label.Caption := '(tan del)^-1';
    end;
  end;

  case Ref_Pars.i_ve_f of
    1 : begin
      Jp_f_label.Caption := 'J'' [MPa^-1]';
      Jpp_f_label.Caption := 'J'''' [MPa^-1]';
    end;
    2 : begin
      Jp_f_label.Caption := 'G'' [MPa]';
      Jpp_f_label.Caption := 'G'''' [MPa]';
    end;
    3 : begin
      Jp_f_label.Caption := 'eta'' [mPa s]';
      Jpp_f_label.Caption := 'eta'''' [mPa s]';
    end;
    4 : begin
      Jp_f_label.Caption := 'G'' [MPa]';
      Jpp_f_label.Caption := 'eta'' [mPa s]';
    end;
    5 : begin
      Jp_f_label.Caption := '|J| [MPa^1]';
      Jpp_f_label.Caption := 'tan del';
    end;
    6 : begin
      Jp_f_label.Caption := '|G| [MPa]';
      Jpp_f_label.Caption := 'tan del';
    end;
    7 : begin
      Jp_f_label.Caption := '|eta| [mPa s]';
      Jpp_f_label.Caption := '(tan del)^-1';
    end;
  end;

  case Ref_Pars.i_ve_b of
    1 : begin
      Jp_b_label.Caption := 'J'' [MPa^-1]';
      Jpp_b_label.Caption := 'J'''' [MPa^-1]';
    end;
    2 : begin
      Jp_b_label.Caption := 'G'' [MPa]';
      Jpp_b_label.Caption := 'G'''' [MPa]';
    end;
    3 : begin
      Jp_b_label.Caption := 'eta'' [mPa s]';
      Jpp_b_label.Caption := 'eta'''' [mPa s]';
    end;
    4 : begin
      Jp_b_label.Caption := 'G'' [MPa]';
      Jpp_b_label.Caption := 'eta'' [mPa s]';
    end;
    5 : begin
      Jp_b_label.Caption := '|J| [MPa^1]';
      Jpp_b_label.Caption := 'tan del';
    end;
    6 : begin
      Jp_b_label.Caption := '|G| [MPa]';
      Jpp_b_label.Caption := 'tan del';
    end;
    7 : begin
      Jp_b_label.Caption := '|eta| [mPa s]';
      Jpp_b_label.Caption := '(tan del)^-1';
    end;
  end;
end;

procedure TSettings.Change_VE_Pars_All(Sender: TObject);
var Pars_old : TPars;
    i_layer, i_ve_old, i_ve_new : integer;
begin
  move(Ref_Pars,Pars_old,Sizeof(TPars));
  with Sender as TCombobox do begin
    if Name = 'ch_e_ComBox' then begin i_ve_old := Ref_Pars.i_ve_e; i_layer := 1; end;
    if Name = 'ch_f_ComBox' then begin i_ve_old := Ref_Pars.i_ve_f; i_layer := 2; end;
    if Name = 'ch_b_ComBox' then begin i_ve_old := Ref_Pars.i_ve_b; i_layer := 3; end;
    i_ve_new := Itemindex + 1;
  end;
  SLA.Convert_VE_Pars(i_layer,i_ve_old, i_ve_new, Pars_old, Ref_Pars);
  Update_Values;
  M.Update_Values;
  If Multiple.Showing then Multiple.Change_VE_Pars;
  If chi2_Landscape.Showing then chi2_Landscape.Change_VE_Pars;
end;


procedure TSettings.Python_Check_BtnClick(Sender: TObject);
var Sim_File_fn : string;
i_fileage_old : integer;
result : Boolean;
begin
  i_action_PyQTM := j_Python_Simulate; B_no_Graph_in_Python := True;
  Sim_File_fn := GetCurrentDir + '/PyQTM/~QPY_Sim.txt';
  i_fileage_old := fileage(Sim_File_fn);
  M.Write_to_QPY;
  if M.ExecuteExe(QPY_exe_fn) then begin
    result := M.WaitForPython(5);
  end;
  case result of
    True : Messagedlg('Python has responded',mtinformation,[mbOK],0);
    False : Messagedlg('Python does not respond',mtinformation,[mbOK],0);
  end;  
end;

end.
