unit QTM_converted_Exponents;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,QTM_Decl,StrUtils,Clipbrd,Math;
type
  TConverted_Exponents = class(TForm)
    AMF_Panel: TPanel;
    t_e_Label: TLabel;
    rho_e_Label: TLabel;
    Jp_e_Label: TLabel;
    Jp_b_Label: TLabel;
    plp_e_Label: TLabel;
    Jpp_e_Label: TLabel;
    plpp_e_Label: TLabel;
    Jpp_b_Label: TLabel;
    Jp_f_Label: TLabel;
    Jpp_f_Label: TLabel;
    rho_f_Label: TLabel;
    rho_b_Label: TLabel;
    plp_b_Label: TLabel;
    plp_f_Label: TLabel;
    plpp_f_Label: TLabel;
    plpp_b_Label: TLabel;
    t_f_Label: TLabel;
    t_e_Show: TEdit;
    t_f_Show: TEdit;
    rho_e_Show: TEdit;
    rho_f_Show: TEdit;
    rho_b_Show: TEdit;
    Jp_e_Show: TEdit;
    Jp_f_Show: TEdit;
    Jp_b_Show: TEdit;
    Jp_exp_e_Show: TEdit;
    Jp_exp_f_Show: TEdit;
    Jp_exp_b_Show: TEdit;
    Jpp_e_Show: TEdit;
    Jpp_f_Show: TEdit;
    Jpp_b_Show: TEdit;
    Jpp_exp_e_Show: TEdit;
    Jpp_exp_f_Show: TEdit;
    Jpp_exp_b_Show: TEdit;
    Roughness_Panel: TPanel;
    vers_label: TLabel;
    AspRat_label: TLabel;
    Roughness_label: TLabel;
    vers_Show: TEdit;
    AspRat_Show: TEdit;
    To_Clipboard_Btn: TButton;
    procedure To_Clipboard_BtnClick(Sender: TObject);
    procedure Calculate_Exponents;
    procedure Calc_Slopes;
    procedure Update_Values;
    procedure Display_Check_Trivial;
    procedure Set_Labels;
    procedure FormShow(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure Read_Panel_Format;
    procedure Write_Panel_Format;

  private
    Conv_Exp_Pars : TPars;
    B_NoClick : Boolean;
    Jp_of_n, Jpp_of_n : TDouble_nhm;
    slope_p,slope_pp : Double;
  end;

var Converted_Exponents: TConverted_Exponents;

implementation
uses QTM_SLA;
{$R *.dfm}

procedure TConverted_Exponents.FormShow(Sender: TObject);
begin
  B_NoClick := True; Read_Panel_Format;
  Read_Panel_Format;
  Display_Check_Trivial;
  Conv_Exp_Pars := Pars;
  Calculate_Exponents;
  Set_Labels;
  Update_Values;
  B_NoClick := False;
end;

procedure TConverted_Exponents.To_Clipboard_BtnClick(Sender: TObject);
var TextBuf : String; SysClip : TClipBoard;
begin
  SysClip := TClipBoard.Create;
  TextBuf := 'Converted Exponents';
  with Conv_Exp_Pars do begin
    if B_Layer_1 then begin
      Textbuf := Textbuf + 'Layer 1' + #10;
      Textbuf := Textbuf + t_e_label.caption + #9 + FloatToStr(t_e) + #10;
      Textbuf := Textbuf + rho_e_label.caption + #9 + FloatToStr(rho_e) + #10;
      Textbuf := Textbuf + Jp_e_label.caption + #9 + FloatToStr(Jp_e) + #10;
      Textbuf := Textbuf + plp_e_label.caption + #9 + FloatToStr(Jp_exp_e) + #10;
      Textbuf := Textbuf + Jpp_e_label.caption + #9 + FloatToStr(Jpp_e) + #10;
      Textbuf := Textbuf + plpp_e_label.caption + #9 + FloatToStr(Jpp_exp_e) + #10;
    end;
    if B_Layer_2 then begin
      Textbuf := Textbuf + 'Layer 2' + #10;
      Textbuf := Textbuf + t_f_label.caption + #9 + FloatToStr(t_f) + #9;
      Textbuf := Textbuf + rho_f_label.caption + #9 + FloatToStr(rho_f) + #10;
      Textbuf := Textbuf + Jp_f_label.caption + #9 + FloatToStr(Jp_f) + #9;
      Textbuf := Textbuf + plp_f_label.caption + #9 + FloatToStr(Jp_exp_f) + #10;
      Textbuf := Textbuf + Jpp_f_label.caption + #9 + FloatToStr(Jpp_f) + #9;
      Textbuf := Textbuf + plpp_f_label.caption + #9 + FloatToStr(Jpp_exp_f) + #10;
    end;
    if B_Liquid_Bulk then begin
      Textbuf := Textbuf + 'Bulk' + #10;
      Textbuf := Textbuf + rho_b_label.caption + #9 + FloatToStr(rho_b) + #10;
      Textbuf := Textbuf + Jp_b_label.caption + #9 + FloatToStr(Jp_b) + #9;
      Textbuf := Textbuf + plp_b_label.caption + #9 + FloatToStr(Jp_exp_b) + #10;
      Textbuf := Textbuf + Jpp_b_label.caption + #9 + FloatToStr(Jpp_b) + #9;
      Textbuf := Textbuf + plpp_b_label.caption + #9 + FloatToStr(Jpp_exp_b) + #10;
    end;
    if B_roughness then begin
      Textbuf := Textbuf + 'Roughness' + #10;
      Textbuf := Textbuf + vers_label.caption + #9 + FloatToStr(vers) + #9;
      Textbuf := Textbuf + Asprat_label.caption + #9 + FloatToStr(Asprat) + #10;
    end;
  end;
  SysClip.AsText := TextBuf; SysClip.Free;
end;

procedure TConverted_Exponents.Calculate_Exponents;
var ih : integer;
    Jp,Jpp,n_cen: Double;
    Jc_of_n : array[1..nhm] of TComplex;
begin
  n_cen := f_Jref / f_fund;
  if B_layer_1 then begin
    for ih := 1 to nhm do begin
      Jc_of_n[ih] := SLA.Jc(1,n_arr[ih],False);
      Jp_of_n[ih]  := Jc_of_n[ih].real;
      Jpp_of_n[ih] := Jc_of_n[ih].imag;
    end;
    Calc_Slopes;
    Conv_Exp_Pars.Jp_exp_e := Slope_p;
    Conv_Exp_Pars.Jpp_exp_e := Slope_pp;
  end;
  if B_layer_2 then begin
    for ih := 1 to nhm do begin
      Jc_of_n[ih] := SLA.Jc(2,n_arr[ih],False);
      Jp_of_n[ih]  := Jc_of_n[ih].real;
      Jpp_of_n[ih] := Jc_of_n[ih].imag;
    end;
    Calc_Slopes;
    Conv_Exp_Pars.Jp_exp_f := Slope_p;
    Conv_Exp_Pars.Jpp_exp_f := Slope_pp;
  end;
  if B_liquid_bulk then begin
    for ih := 1 to nhm do begin
      Jc_of_n[ih] := SLA.Jc(3,n_arr[ih],False);
      Jp_of_n[ih]  := Jc_of_n[ih].real;
      Jpp_of_n[ih] := Jc_of_n[ih].imag;
    end;
    Calc_Slopes;
    Conv_Exp_Pars.Jp_exp_b := Slope_p;
    Conv_Exp_Pars.Jpp_exp_b := Slope_pp;
  end;
end;

procedure TConverted_Exponents.Calc_Slopes;
var x_avg,yp_avg,ypp_avg,rxyp,rxypp,sxx,Jsqr,om : double;
    norm,ih : integer;
    VE_p_conv, VE_pp_conv,logx,logyp,logypp : TDouble_nhm;
    B_p_nonzero, B_pp_nonzero : Boolean;
begin
  for ih := 1 to nhm do begin
    Jsqr := sqr(Jp_of_n[ih]) + sqr(Jpp_of_n[ih]);
    om := 2 * Pi * n_arr[ih] * f_fund;
    case Pars.i_ve_e of
      1,5 : begin VE_p_conv[ih] := Jp_of_n[ih]; VE_pp_conv[ih] := -Jpp_of_n[ih]; end;
      2,6 : begin
        VE_p_conv[ih] := Jp_of_n[ih]/Jsqr; VE_pp_conv[ih] := Jpp_of_n[ih]/Jsqr;
      end;
      3,7 : begin
        VE_p_conv[ih] := Jpp_of_n[ih]/Jsqr/om; VE_pp_conv[ih] := -Jp_of_n[ih]/Jsqr/om;
      end;
      4 : begin
        VE_p_conv[ih] := Jp_of_n[ih]/Jsqr; VE_pp_conv[ih] := Jpp_of_n[ih]/Jsqr/om;
      end;
    end;
  end;
  x_avg := 0; yp_avg := 0; ypp_avg := 0; norm := 0;
  B_p_nonzero := True;
  B_pp_nonzero := True;

  for ih := 1 to nhm do begin
    if B_fit_inc[ih] then begin
      logx[ih] := log10(n_arr[ih]);
      if VE_p_conv[ih] > 0 then logyp[ih] := log10(VE_p_conv[ih])
      else B_p_nonzero := False;
      if VE_pp_conv[ih] > 0 then logypp[ih] := log10(VE_pp_conv[ih])
      else B_pp_nonzero := False;
      x_avg := x_avg + logx[ih];
      yp_avg := yp_avg + logyp[ih];
      ypp_avg := ypp_avg + logypp[ih];
      norm := norm + 1;
    end;
  end;
  if norm > 0 then begin
    x_avg := x_avg/norm;
    yp_avg := yp_avg/norm;
    ypp_avg := ypp_avg/norm;
  end;
  rxyp := 0; rxypp := 0; sxx := 0;
  for ih := 1 to nhm do begin
    if B_fit_inc[ih] then begin
      rxyp := rxyp + (logx[ih] - x_avg) * (logyp[ih] - yp_avg);
      rxypp := rxypp + (logx[ih] - x_avg) * (logypp[ih] - ypp_avg);
      sxx := sxx + (logx[ih] - x_avg) * (logx[ih] - x_avg);
    end;
  end;
  if B_p_nonzero  then Slope_p  := rxyp/sxx  else Slope_p := 0;
  if B_pp_nonzero then Slope_pp := rxypp/sxx else Slope_pp := 0;
end;

procedure TConverted_Exponents.Update_Values;
begin
  with Conv_Exp_Pars do begin
    t_e_Show.Text := FloatToStrF(t_e,fffixed,8,3);
    t_f_Show.Text := FloatToStrF(t_f,fffixed,8,3);
    rho_e_Show.Text := FloatToStrF(rho_e,fffixed,8,3);
    rho_f_Show.Text := FloatToStrF(rho_f,fffixed,8,3);
    rho_b_Show.Text := FloatToStrF(rho_b,fffixed,8,3);
    Jp_e_Show.Text := FloatToStrF(Jp_e,fffixed,8,5);
    Jp_f_Show.Text := FloatToStrF(Jp_f,fffixed,8,5);
    Jpp_e_Show.Text := FloatToStrF(Jpp_e,fffixed,8,5);
    Jpp_f_Show.Text := FloatToStrF(Jpp_f,fffixed,8,5);
    Jp_exp_e_Show.Text := FloatToStrF (Jp_exp_e ,fffixed,8,3);
    Jp_exp_f_Show.Text := FloatToStrF (Jp_exp_f ,fffixed,8,3);
    Jpp_exp_e_Show.Text := FloatToStrF(Jpp_exp_e,fffixed,8,3);
    Jpp_exp_f_Show.Text := FloatToStrF(Jpp_exp_f,fffixed,8,3);
    Jp_b_Show.Text := FloatToStrF(Jp_b,fffixed,8,5);
    Jpp_b_Show.Text := FloatToStrF(Jpp_b,fffixed,8,5);
    Jp_exp_b_Show.Text := FloatToStrF( Jp_exp_b ,fffixed,8,3);
    Jpp_exp_b_Show.Text := FloatToStrF(Jpp_exp_b,fffixed,8,3);
    vers_Show.Text := FloatToStrF(vers,fffixed,8,3);
    AspRat_Show.Text := FloatToStrF(AspRat,fffixed,8,3);
  end;
  Roughness_Panel.Visible := B_roughness;
end;

procedure TConverted_Exponents.Set_Labels;
begin
  case pars.i_ve_e of
    1 : begin
      Jp_e_label.Caption := 'J''(fcen)[MPa^-1]';
      Jpp_e_label.Caption := 'J''''(fcen)[MPa^-1]';
      plp_e_Label.Caption := 'PL.Exp. J''';
      plpp_e_Label.Caption := 'PL.Exp. J''''';
    end;
    2 : begin
      Jp_e_label.Caption := 'G''(fcen)[MPa]';
      Jpp_e_label.Caption := 'G''''(fcen)[MPa]';
      plp_e_Label.Caption := 'PL.Exp. G''';
      plpp_e_Label.Caption := 'PL.Exp. G''''';
    end;
    3 : begin
      Jp_e_label.Caption := 'eta''(fcen)[mPa s]';
      Jpp_e_label.Caption := 'eta''''(fcen)[mPa s]';
      plp_e_Label.Caption := 'PL.Exp. eta''';
      plpp_e_Label.Caption := 'PL.Exp. eta''''';
    end;
    4 : begin
      Jp_e_label.Caption := 'G''(fcen)[MPa]';
      Jpp_e_label.Caption := 'eta''(fcen)[mPa s]';
      plp_e_Label.Caption := 'PL.Exp. G''';
      plpp_e_Label.Caption := 'PL.Exp. eta''';
    end;
    5 : begin
      Jp_e_label.Caption := '|J|(fcen)[MPa^-1]';
      Jpp_e_label.Caption := 'tan del';
      plp_e_Label.Caption := 'PL.Exp. J''';
      plpp_e_Label.Caption := 'PL.Exp. J''''';
    end;
    6 : begin
      Jp_e_label.Caption := '|G|(fcen)[MPa]';
      Jpp_e_label.Caption := 'tan del';
      plp_e_Label.Caption := 'PL.Exp. G''';
      plpp_e_Label.Caption := 'PL.Exp. G''''';
    end;
    7 : begin
      Jp_e_label.Caption := '|eta|(fcen)[mPa s]';
      Jpp_e_label.Caption := 'tan del';
      plp_e_Label.Caption := 'PL.Exp. eta''';
      plpp_e_Label.Caption := 'PL.Exp. eta''''';
    end;
  end;

  case pars.i_ve_f of
    1 : begin
      Jp_f_label.Caption := 'J''(fcen)[MPa^-1]';
      Jpp_f_label.Caption := 'J''''(fcen)[MPa^-1]';
      plp_f_Label.Caption := 'PL.Exp. J''';
      plpp_f_Label.Caption := 'PL.Exp. J''''';
    end;
    2 : begin
      Jp_f_label.Caption := 'G''(fcen)[MPa]';
      Jpp_f_label.Caption := 'G''''(fcen)[MPa]';
      plp_f_Label.Caption := 'PL.Exp. G''';
      plpp_f_Label.Caption := 'PL.Exp. G''''';
    end;
    3 : begin
      Jp_f_label.Caption := 'eta''(fcen)[mPa s]';
      Jpp_f_label.Caption := 'eta''''(fcen)[mPa s]';
      plp_f_Label.Caption := 'PL.Exp. eta''';
      plpp_f_Label.Caption := 'PL.Exp. eta''''';
    end;
    4 : begin
      Jp_f_label.Caption := 'G''(fcen)[MPa]';
      Jpp_f_label.Caption := 'eta''(fcen)[mPa s]';
      plp_f_Label.Caption := 'PL.Exp. G''';
      plpp_f_Label.Caption := 'PL.Exp. eta''';
    end;
    5 : begin
      Jp_f_label.Caption := '|J|(fcen)[MPa^-1]';
      Jpp_f_label.Caption := 'tan del';
      plp_f_Label.Caption := 'PL.Exp. J''';
      plpp_f_Label.Caption := 'PL.Exp. J''''';
    end;
    6 : begin
      Jp_f_label.Caption := '|G|(fcen)[MPa]';
      Jpp_f_label.Caption := 'tan del';
      plp_f_Label.Caption := 'PL.Exp. G''';
      plpp_f_Label.Caption := 'PL.Exp. G''''';
    end;
    7 : begin
      Jp_f_label.Caption := '|eta|(fcen)[mPa s]';
      Jpp_f_label.Caption := 'tan del';
      plp_f_Label.Caption := 'PL.Exp. eta''';
      plpp_f_Label.Caption := 'PL.Exp. eta''''';
    end;
  end;

  case pars.i_ve_b of
    1 : begin
      Jp_b_label.Caption := 'J''(fcen)[MPa^-1]';
      Jpp_b_label.Caption := 'J''''(fcen)[MPa^-1]';
      plp_b_Label.Caption := 'PL.Exp. J''';
      plpp_b_Label.Caption := 'PL.Exp. J''''';
    end;
    2 : begin
      Jp_b_label.Caption := 'G''(fcen)[MPa]';
      Jpp_b_label.Caption := 'G''''(fcen)[MPa]';
      plp_b_Label.Caption := 'PL.Exp. G''';
      plpp_b_Label.Caption := 'PL.Exp. G''''';
    end;
    3 : begin
      Jp_b_label.Caption := 'eta''(fcen)[mPa s]';
      Jpp_b_label.Caption := 'eta''''(fcen)[mPa s]';
      plp_b_Label.Caption := 'PL.Exp. eta''';
      plpp_b_Label.Caption := 'PL.Exp. eta''''';
    end;
    4 : begin
      Jp_b_label.Caption := 'G''(fcen)[MPa]';
      Jpp_b_label.Caption := 'eta''(fcen)[mPa s]';
      plp_b_Label.Caption := 'PL.Exp. G''';
      plpp_b_Label.Caption := 'PL.Exp. eta''';
    end;
    5 : begin
      Jp_b_label.Caption := '|J|(fcen)[MPa^-1]';
      Jpp_b_label.Caption := 'tan del';
      plp_b_Label.Caption := 'PL.Exp. J''';
      plpp_b_Label.Caption := 'PL.Exp. J''''';
    end;
    6 : begin
      Jp_b_label.Caption := '|G|(fcen)[MPa]';
      Jpp_b_label.Caption := 'tan del';
      plp_b_Label.Caption := 'PL.Exp. G''';
      plpp_b_Label.Caption := 'PL.Exp. G''''';
    end;
    7 : begin
      Jp_b_label.Caption := '|eta|(fcen)[mPa s]';
      Jpp_b_label.Caption := 'tan del';
      plp_b_Label.Caption := 'PL.Exp. eta''';
      plpp_b_Label.Caption := 'PL.Exp. eta''''';
    end;
  end;
end;

procedure TConverted_Exponents.Display_Check_Trivial;
begin
  t_e_Show.Visible := B_layer_1;
  t_f_Show.Visible := B_layer_2;
  rho_b_Show.Visible := B_liquid_Bulk;

  rho_e_Show.Visible := B_layer_1;
  rho_f_Show.Visible := B_layer_2;

  Jp_e_Show.Visible := B_layer_1;
  Jp_f_Show.Visible := B_layer_2;
  Jp_b_Show.Visible := B_Liquid_Bulk;

  Jpp_e_Show.Visible := B_layer_1;
  Jpp_f_Show.Visible := B_layer_2;
  Jpp_b_Show.Visible := B_Liquid_Bulk;

  Jp_exp_e_Show.Visible := B_layer_1;
  Jp_exp_f_Show.Visible := B_layer_2;
  Jp_exp_b_Show.Visible :=  B_Liquid_Bulk;

  Jpp_exp_e_Show.Visible := B_layer_1;
  Jpp_exp_f_Show.Visible := B_layer_2;
  Jpp_exp_b_Show.Visible := B_Liquid_Bulk;

  t_e_Label.Visible := B_layer_1;
  t_f_Label.Visible := B_layer_2;
  rho_b_Label.Visible := B_liquid_bulk;

  rho_e_Label.Visible := B_layer_1;
  rho_f_Label.Visible := B_layer_2;

  Jp_e_Label.Visible := B_layer_1;
  Jp_f_Label.Visible := B_layer_2;
  Jp_b_Label.Visible   := B_Liquid_Bulk;

  Jpp_e_Label.Visible := B_layer_1;
  Jpp_f_Label.Visible := B_layer_2;
  Jpp_b_Label.Visible  := B_Liquid_Bulk;

  plp_e_Label.Visible := B_layer_1;
  plp_f_Label.Visible := B_layer_2;
  plp_b_Label.Visible := B_Liquid_Bulk;

  plpp_e_Label.Visible := B_layer_1;
  plpp_f_Label.Visible := B_layer_2;
  plpp_b_Label.Visible := B_Liquid_Bulk;
  vers_Label.Visible := B_Roughness and B_Liquid_Bulk;
  AspRat_Label.Visible := B_Roughness and B_Liquid_Bulk;
  Roughness_Panel.Visible := B_Liquid_Bulk;
end;

procedure TConverted_Exponents.FormDeactivate(Sender: TObject); begin Write_Panel_Format; end;

procedure TConverted_Exponents.Read_Panel_Format;
begin
  Top := Ini.ReadInteger('Converted_Exponents','Top',0);
  Height := Ini.ReadInteger('Converted_Exponents','Height',800);
  Left := Ini.ReadInteger('Converted_Exponents','Left',0);
  Width := Ini.ReadInteger('Converted_Exponents','Width',600);
end;

procedure TConverted_Exponents.Write_Panel_Format;
begin
  if B_NoClick then Exit;
  Ini.WriteInteger('Converted_Exponents','Top',Top);
  Ini.WriteInteger('Converted_Exponents','Height',Height);
  Ini.WriteInteger('Converted_Exponents','Left',Left);
  Ini.WriteInteger('Converted_Exponents','Width',Width); B_Changed := True;
end;



end.
