(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     67658,       1829]
NotebookOptionsPosition[     63903,       1740]
NotebookOutlinePosition[     64514,       1762]
CellTagsIndexPosition[     64471,       1759]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PertOrder", "=", "3"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"RuleLS", " ", "=", "  ", 
     RowBox[{"ZLS", "->", 
      RowBox[{"I", "  ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Ze", " ", "tane"}], " ", "+", 
          RowBox[{"Zf", " ", "tanf"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           RowBox[{"Zf", "/", "Ze"}], " ", "tane", " ", "tanf"}]}], 
         ")"}]}]}]}]}], ";"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RuleLS", " ", "=", "  ", 
    RowBox[{"ZLS", "\[Rule]", 
     RowBox[{"I", " ", "Ze", " ", 
      RowBox[{
       RowBox[{"(", "   ", 
        RowBox[{
         RowBox[{"Zf", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tane", " ", "Ze"}], " ", "+", " ", 
            RowBox[{"tanf", "  ", "Zf"}]}], ")"}]}], "+", "  ", 
         RowBox[{"I", " ", "Zl", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tanf", " ", "tane", " ", "Ze"}], " ", "-", " ", "Zf"}], 
           ")"}]}]}], ")"}], " ", "/", "\n", "\t\t              ", 
       RowBox[{"-", "\t   ", 
        RowBox[{"(", "   ", 
         RowBox[{
          RowBox[{"Zf", 
           RowBox[{"(", 
            RowBox[{"Ze", " ", "-", " ", 
             RowBox[{"tane", " ", "tanf", "  ", "Zf"}]}], ")"}]}], "+", " ", 
          RowBox[{"I", " ", "Zl", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"tanf", " ", "Ze"}], " ", "+", " ", 
             RowBox[{"tane", " ", "Zf"}]}], ")"}]}]}], ")"}]}]}]}]}]}], ";"}],
   "\[IndentingNewLine]", "         ", 
  RowBox[{"(*", "\t\t", 
   RowBox[{
    RowBox[{"IZe", 
     FractionBox[
      RowBox[{"  ", 
       RowBox[{
        RowBox[{"Zf", " ", 
         RowBox[{"(", " ", 
          RowBox[{
           RowBox[{"Ze", " ", "tane"}], "+", 
           RowBox[{"tanf", " ", "Zf"}]}], " ", ")"}]}], "+", 
        RowBox[{"I", " ", "Za", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"tanf", " ", "tane", "  ", "Ze"}], "-", " ", "Zf"}], 
          ")"}]}]}]}], 
      RowBox[{" ", 
       RowBox[{
        RowBox[{"Zf", 
         RowBox[{"(", 
          RowBox[{"Ze", "-", " ", 
           RowBox[{"tane", " ", "tanf", " ", "Zf"}]}], ")"}]}], "+", 
        RowBox[{"I", " ", "Za", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"tanf", "  ", "Ze"}], "+", 
           RowBox[{"tane", "  ", "Zf"}]}], ")"}]}]}]}]]}], ",", " ", 
    RowBox[{"from", " ", "films_in", "_liq", 
     RowBox[{"_imp", ".", "nb"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RuleZmech", " ", "=", " ", 
   RowBox[{"Zmech", " ", "\[Rule]", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "I"}], " ", "Zq", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", " ", "+", "  ", 
         RowBox[{"tan", "^", "2"}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"2", " ", "tan"}], ")"}]}]}], " ", "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"I", " ", "Zq", " ", "tan"}], ")"}], "^", 
         RowBox[{"-", "1"}]}], " ", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"I", " ", "Zq", " ", "tan"}], " ", "+", " ", "ZLS"}], 
          ")"}], "^", 
         RowBox[{"-", "1"}]}]}], " ", ")"}], "^", 
      RowBox[{"-", "1"}]}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RuleVars", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Ze", "->", 
      RowBox[{"Zq", "/", "\[Xi]e"}]}], ",", "                              ", 
     RowBox[{"Zf", " ", "->", " ", 
      RowBox[{"Zq", " ", "/", " ", "\[Xi]f"}]}], ",", "\n", 
     "\t\t                      ", 
     RowBox[{"de", " ", "->", " ", 
      RowBox[{
       RowBox[{"\[Micro]e", " ", "/", " ", "roe"}], " ", "mq"}]}], ",", 
     "                    ", 
     RowBox[{"df", " ", "->", " ", 
      RowBox[{
       RowBox[{"\[Micro]f", " ", "/", " ", "rof"}], " ", "mq"}]}], ",", "\n", 
     "\t\t                      ", 
     RowBox[{"ke", " ", "->", " ", 
      RowBox[{"2", "  ", "Pi", " ", "n", " ", 
       RowBox[{"f0", " ", "/", " ", "ve"}], 
       RowBox[{"(", 
        RowBox[{"1", "+", "e"}], ")"}]}]}], ",", 
     RowBox[{"kf", " ", "->", " ", 
      RowBox[{"2", "  ", "Pi", " ", "n", " ", 
       RowBox[{"f0", " ", "/", " ", "vf"}], 
       RowBox[{"(", 
        RowBox[{"1", "+", "e"}], ")"}]}]}], ",", "\n", 
     "\t\t                       ", 
     RowBox[{"ve", " ", "->", " ", 
      RowBox[{"Ze", " ", "/", " ", "roe"}]}], ",", "                        ", 
     RowBox[{"vf", " ", "->", " ", 
      RowBox[{"Zf", " ", "/", " ", "rof"}]}], ",", "\n", 
     "\t\t                      ", 
     RowBox[{"xe", " ", "->", " ", 
      RowBox[{"ke", " ", "de"}]}], ",", " ", 
     RowBox[{"xf", " ", "->", 
      RowBox[{"kf", " ", "df"}]}], ",", "\n", "\t\t                      ", 
     RowBox[{"f0", " ", "->", " ", 
      RowBox[{"Zq", " ", "/", 
       RowBox[{"(", 
        RowBox[{"2", "mq"}], ")"}]}]}], ",", " ", 
     RowBox[{"Zl", " ", "->", " ", 
      RowBox[{"\[Xi]l", " ", "Zq"}]}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RuleSimpA", " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", " ", "->", " ", 
       RowBox[{"nPi", " ", "/", " ", "Pi"}]}], ",", " ", 
      RowBox[{"Zq", " ", "->", " ", "1"}], ",", " ", 
      RowBox[{"\[Micro]e", "->", "  ", 
       RowBox[{"A", " ", "\[Micro]eA"}]}], ",", " ", 
      RowBox[{"\[Micro]f", " ", "->", "  ", 
       RowBox[{"A", " ", "\[Micro]fA"}]}], ",", " ", 
      RowBox[{"\[Xi]l", " ", "->", " ", 
       RowBox[{
        RowBox[{"A", "/", "I"}], " ", "\[Xi]lIA"}]}]}], "}"}]}], ";"}], 
  " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RuleTan", " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{"tan", " ", "->", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{"Tan", "[", 
             RowBox[{"n", " ", "Pi", " ", 
              RowBox[{"e", "/", "2"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"e", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}]}], "//",
          "Normal"}], ")"}], "^", 
       RowBox[{"-", "1"}]}]}], "}"}]}], ";"}], "\n", "\t\t", 
  RowBox[{"(*", " ", 
   RowBox[{"Cot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"n\[Pi]", "/", "2"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", "\[Epsilon]"}], ")"}]}]}], "]"}], "=", 
      RowBox[{"-", 
       RowBox[{"Tan", "[", 
        RowBox[{"n\[Pi]\[Epsilon]", "/", "2"}], "]"}]}]}], ",", " ", 
     RowBox[{"Cot", "=", 
      RowBox[{"Tan", "^", 
       RowBox[{"-", "1"}]}]}], ",", 
     RowBox[{"Expand", " ", "Tan"}]}], " "}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"RuleTane", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"tane", " ", "->", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{"Tan", "[", "xe", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"xe", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}]}], "//",
        "Normal"}], ")"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RuleTanf", " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{"tanf", " ", "->", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{"Tan", "[", "xf", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"xf", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}]}], "//",
         "Normal"}], ")"}]}], "}"}]}], ";"}], "\t"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ZMechA", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Zmech", "/.", "RuleZmech"}], "/.", "RuleLS"}], "/.", 
         "RuleTan"}], "/.", "RuleTane"}], "/.", "RuleTanf"}], "//.", 
      "RuleVars"}], "/.", "RuleSimpA"}], "/.", "RuleVars"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ZMechACol", " ", "=", " ", 
   RowBox[{"Collect", "[", 
    RowBox[{"ZMechA", " ", ",", 
     RowBox[{"{", 
      RowBox[{
      "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
       "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ZMeche", "  ", "=", " ", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{"ZMechACol", ",", 
       RowBox[{"{", 
        RowBox[{"e", ",", "0", ",", "1"}], "}"}]}], "]"}], "//", "Normal"}]}],
    ";"}], "\t"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e1", " ", "=", " ", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Coefficient", "[", 
      RowBox[{"ZMeche", ",", "e", ",", " ", "0"}], "]"}]}], "/", 
    RowBox[{"Coefficient", "[", 
     RowBox[{"ZMeche", ",", "e", ",", " ", "1"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"e1A", " ", "=", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{"e1", ",", 
        RowBox[{"{", 
         RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
      "Normal"}], "//", "Cancel"}]}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{"e1ACol", " ", "=", " ", 
   RowBox[{"Collect", "[", 
    RowBox[{"e1A", " ", ",", 
     RowBox[{"{", 
      RowBox[{
      "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
       "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ZMech2e", " ", "=", " ", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ZMechACol", "/.", 
        RowBox[{"e", " ", "->", " ", 
         RowBox[{"e1p", " ", "+", " ", "e2p"}]}]}], "/.", "RuleVars"}], ",", 
      RowBox[{"{", 
       RowBox[{"e2p", ",", "0", ",", "1"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e2", " ", "=", " ", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Coefficient", "[", 
      RowBox[{"ZMech2e", " ", ",", "e2p", ",", " ", "0"}], "]"}]}], "/", 
    RowBox[{"Coefficient", "[", 
     RowBox[{"ZMech2e", " ", ",", "e2p", ",", " ", "1"}], "]"}]}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"e2A", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{"e2", ",", 
       RowBox[{"{", 
        RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
     "Normal"}], "//", "Cancel"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e2ACol", " ", "=", "  ", 
   RowBox[{"Collect", "[", 
    RowBox[{"e2A", " ", ",", 
     RowBox[{"{", 
      RowBox[{
      "e1p", ",", " ", "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", 
       "\[Micro]fA", ",", "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.7481640340922565`*^9, 3.748164046556589*^9}, {
   3.748164269399399*^9, 3.748164331764595*^9}, {3.7481652632253666`*^9, 
   3.7481652698618593`*^9}, {3.7481653469642935`*^9, 
   3.7481655419191647`*^9}, {3.748169651923649*^9, 3.7481697891546736`*^9}, {
   3.748169886180811*^9, 3.7481699292152*^9}, {3.7481700900012803`*^9, 
   3.748170167428537*^9}, {3.7481702691559052`*^9, 3.7481702896597366`*^9}, {
   3.74817035239128*^9, 3.748170443656087*^9}, 3.7481705843390713`*^9, {
   3.748170854008917*^9, 3.7481708869042654`*^9}, {3.74817092526501*^9, 
   3.7481709434368167`*^9}, {3.7481711871164823`*^9, 3.748171192434182*^9}, {
   3.7481716469884644`*^9, 3.7481716864806523`*^9}, {3.74817222271078*^9, 
   3.7481722646851115`*^9}, {3.748172337169611*^9, 3.748172340928857*^9}, {
   3.7481724081368876`*^9, 3.748172443975355*^9}, {3.7481725572436714`*^9, 
   3.7481725697498674`*^9}, 3.748172944181052*^9, 3.748173091088772*^9, 
   3.7481736425066*^9, {3.7481737871977*^9, 3.748173883700263*^9}, {
   3.7481740743306203`*^9, 3.748174080748041*^9}, {3.7481742275881567`*^9, 
   3.7481742603364215`*^9}, 3.748174294583705*^9, 3.7481744210772133`*^9, 
   3.7481750282681136`*^9, 3.748175418164481*^9, 3.748246044362818*^9, 
   3.7482669799228935`*^9, {3.7482670443702555`*^9, 3.748267084818406*^9}, {
   3.7482671254313807`*^9, 3.7482671476889076`*^9}},
 FontSize->14,ExpressionUUID->"8eb609ff-a5b1-4fff-84af-a5fed86834ae"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"e1p2A", " ", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"e1ACol", "      ", "e1ACol"}], ",", 
      RowBox[{"{", 
       RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e1p2ACol", " ", "=", "  ", 
   RowBox[{"Collect", "[", 
    RowBox[{"e1p2A", " ", ",", 
     RowBox[{"{", 
      RowBox[{
      "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
       "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e1p3A", " ", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"e1p2ACol", "        ", "e1ACol"}], ",", 
      RowBox[{"{", 
       RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e1p3ACol", " ", "=", "  ", 
   RowBox[{"Collect", "[", 
    RowBox[{"e1p3A", " ", ",", 
     RowBox[{"{", 
      RowBox[{
      "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
       "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e1p4A", " ", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"e1p3ACol", "        ", "e1ACol"}], ",", 
      RowBox[{"{", 
       RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e1p4ACol", " ", "=", "  ", 
   RowBox[{"Collect", "[", 
    RowBox[{"e1p4A", " ", ",", 
     RowBox[{"{", 
      RowBox[{
      "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
       "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e1p5A", " ", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"e1p4ACol", "        ", "e1ACol"}], ",", 
      RowBox[{"{", 
       RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e1p5ACol", " ", "=", " ", 
   RowBox[{"Collect", "[", 
    RowBox[{"e1p5A", " ", ",", 
     RowBox[{"{", 
      RowBox[{
      "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
       "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Rulee1p", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"e1p", " ", "->", " ", "e1ACol"}], ",", 
     RowBox[{
      RowBox[{"e1p", "^", "2"}], " ", "->", "e1p2ACol"}], ",", 
     RowBox[{
      RowBox[{"e1p", "^", "3"}], " ", "->", "e1p3ACol"}], ",", 
     RowBox[{
      RowBox[{"e1p", "^", "4"}], " ", "->", "e1p4ACol"}], ",", 
     RowBox[{
      RowBox[{"e1p", "^", "5"}], " ", "->", "e1p5ACol"}]}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"e2Ae", " ", "=", " ", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"e2A", "/.", "Rulee1p"}], ",", 
      RowBox[{"{", 
       RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e2tot", " ", "=", " ", 
   RowBox[{"e2Ae", " ", "+", " ", "e1A"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e2totCol", " ", "=", "  ", 
   RowBox[{"Collect", "[", 
    RowBox[{"e2tot", " ", ",", 
     RowBox[{"{", 
      RowBox[{
      "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
       "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.748170630907628*^9, 3.7481706410852146`*^9}, {
   3.7481706850052814`*^9, 3.748170729577833*^9}, {3.7481708284418297`*^9, 
   3.7481708327237673`*^9}, {3.7481709655759625`*^9, 3.748171026909735*^9}, {
   3.748171078291563*^9, 3.7481710832040043`*^9}, {3.7481713261355505`*^9, 
   3.748171341433247*^9}, {3.748171723744011*^9, 3.7481717414345927`*^9}, {
   3.748172272835774*^9, 3.748172291971942*^9}, {3.7481726734118004`*^9, 
   3.7481727222590485`*^9}, 3.7482670944321656`*^9},
 FontSize->14,ExpressionUUID->"2f4906f3-2682-47d7-9afa-865f569ca1d6"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"e2p2A", " ", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"e2totCol", "      ", "e2totCol"}], ",", 
      RowBox[{"{", 
       RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{"e2p2ACol", " ", "=", "  ", 
  RowBox[{"Collect", "[", 
   RowBox[{"e2p2A", ",", 
    RowBox[{"{", 
     RowBox[{
     "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
      "\[Xi]lIA"}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<e2p2ACol done\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"e2p3A", " ", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"e2p2ACol", " ", "e2totCol"}], ",", 
      RowBox[{"{", 
       RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e2p3ACol", " ", "=", "  ", 
   RowBox[{"Collect", "[", 
    RowBox[{"e2p3A", ",", 
     RowBox[{"{", 
      RowBox[{
      "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
       "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<e2p3ACol done\>\"", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e2p4A", " ", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"e2p3ACol", " ", "e2totCol"}], ",", 
      RowBox[{"{", 
       RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e2p4ACol", " ", "=", "  ", 
   RowBox[{"Collect", "[", 
    RowBox[{"e2p4A", ",", 
     RowBox[{"{", 
      RowBox[{
      "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
       "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<e2p4ACol done\>\"", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e2p5A", " ", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"e2p4ACol", " ", "e2totCol"}], ",", 
      RowBox[{"{", 
       RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"e2p5ACol", " ", "=", "  ", 
   RowBox[{"Collect", "[", 
    RowBox[{"e2p5A", ",", 
     RowBox[{"{", 
      RowBox[{
      "A", ",", "nPi", ",", " ", "\[Micro]eA", ",", "\[Micro]fA", ",", 
       "\[Xi]lIA"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", "\"\<e2p5ACol done\>\"", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Rulee2p", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"e1p", " ", "->", " ", "e2totCol"}], ",", 
     RowBox[{
      RowBox[{"e1p", "^", "2"}], " ", "->", "e2p2ACol"}], ",", 
     RowBox[{
      RowBox[{"e1p", "^", "3"}], " ", "->", "e2p3ACol"}], ",", 
     RowBox[{
      RowBox[{"e1p", "^", "4"}], " ", "->", "e2p4ACol"}], ",", 
     RowBox[{
      RowBox[{"e1p", "^", "5"}], " ", "->", "e2p5ACol"}]}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"e3", "=", "  ", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"e2ACol", " ", "/.", "Rulee2p"}], ",", 
      RowBox[{"{", 
       RowBox[{"A", ",", "0", ",", "PertOrder"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPi", ",", "0", ",", "PertOrder"}], "}"}]}], "]"}], "//", 
    "Normal"}]}], ";"}], "\n", 
 RowBox[{"e3tot", " ", "=", " ", 
  RowBox[{
   RowBox[{"e2tot", "+", "e3"}], "//", "Simplify"}]}]}], "Input",
 CellChangeTimes->{{3.748163654304717*^9, 3.748163821326442*^9}, {
   3.748164393000879*^9, 3.7481643959328265`*^9}, 3.7481644725713205`*^9, {
   3.7481713747421927`*^9, 3.7481713930618343`*^9}, {3.7481714248456516`*^9, 
   3.748171448252816*^9}, {3.748171501597872*^9, 3.7481715195687604`*^9}, {
   3.7481717681067877`*^9, 3.74817191654793*^9}, {3.748171996462571*^9, 
   3.748171998514799*^9}, {3.7481720654373007`*^9, 3.7481720659836454`*^9}, {
   3.748172299888593*^9, 3.748172307601018*^9}, {3.748172359501914*^9, 
   3.7481723845695915`*^9}, {3.7481724763831186`*^9, 3.748172602830862*^9}, 
   3.7481727495303555`*^9, {3.748172901694893*^9, 3.7481729068752427`*^9}, 
   3.7481730357725925`*^9, {3.7481731154082813`*^9, 3.7481731186852703`*^9}, {
   3.7481731748008204`*^9, 3.7481731961085234`*^9}, {3.7481734416325903`*^9, 
   3.74817346597526*^9}, 3.748174569019621*^9, {3.74817491261996*^9, 
   3.7481749422986927`*^9}, {3.748174979006757*^9, 3.7481749795237584`*^9}, {
   3.7482671086245213`*^9, 3.7482671128070593`*^9}},
 FontSize->14,ExpressionUUID->"9cf4edd3-0145-47ee-9e2c-3efd5e0f96fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["A", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[Xi]lIA", "2"], 
      SuperscriptBox["nPi", "2"]], "+", 
     SuperscriptBox["\[Micro]eA", "2"], "+", 
     RowBox[{"2", " ", "\[Micro]eA", " ", "\[Micro]fA"}], "+", 
     SuperscriptBox["\[Micro]fA", "2"], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"2", " ", "\[Xi]lIA", " ", "\[Micro]eA"}], "+", 
       RowBox[{"2", " ", "\[Xi]lIA", " ", "\[Micro]fA"}]}], "nPi"]}], ")"}]}],
   "+", 
  RowBox[{
   SuperscriptBox["A", "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox["\[Micro]eA", "3"]}], "-", 
     RowBox[{"6", " ", 
      SuperscriptBox["\[Micro]eA", "2"], " ", "\[Micro]fA"}], "-", 
     RowBox[{"6", " ", "\[Micro]eA", " ", 
      SuperscriptBox["\[Micro]fA", "2"]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["\[Micro]fA", "3"]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        SuperscriptBox["\[Xi]lIA", "2"], " ", "\[Micro]eA"}], "-", 
       RowBox[{"2", " ", 
        SuperscriptBox["\[Xi]lIA", "2"], " ", "\[Micro]fA"}]}], 
      SuperscriptBox["nPi", "2"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "\[Xi]lIA", " ", 
        SuperscriptBox["\[Micro]eA", "2"]}], "-", 
       RowBox[{"8", " ", "\[Xi]lIA", " ", "\[Micro]eA", " ", "\[Micro]fA"}], 
       "-", 
       RowBox[{"4", " ", "\[Xi]lIA", " ", 
        SuperscriptBox["\[Micro]fA", "2"]}]}], "nPi"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.74817275581022*^9, 3.7481729076433964`*^9, 3.7481729879061375`*^9, 
   3.748173039240399*^9, 3.7481731194695206`*^9, {3.748173175684663*^9, 
   3.7481731850830374`*^9}, {3.7481734609907856`*^9, 3.74817346886856*^9}, 
   3.748173677220467*^9, 3.7481743389233837`*^9, 3.7481749990919437`*^9, 
   3.748175050163704*^9, 3.7481754930444975`*^9, 3.7482329820450583`*^9, 
   3.7482460553186445`*^9, 3.748259437665766*^9, 3.748266984965329*^9, {
   3.7482670986314754`*^9, 3.7482671583215947`*^9}, 3.748267201979526*^9, {
   3.7535329597557583`*^9, 3.753532981846184*^9}, 
   3.8305663087772346`*^9},ExpressionUUID->"4e350b41-a370-4210-b2b7-\
6463fd3e2ccf"],

Cell[BoxData["\<\"e2p2ACol done\"\>"], "Print",
 CellChangeTimes->{
  3.748175050163704*^9, 3.7481754930595217`*^9, 3.7482329820651937`*^9, 
   3.7482460553342686`*^9, 3.748259437665766*^9, 3.748266984965329*^9, {
   3.7482670986471*^9, 3.7482671583215947`*^9}, 3.748267201979526*^9, {
   3.7535329597713842`*^9, 3.753532981846184*^9}, 
   3.830566308787224*^9},ExpressionUUID->"84fca609-0443-4226-9acc-\
5678f4d80996"],

Cell[BoxData["\<\"e2p3ACol done\"\>"], "Print",
 CellChangeTimes->{
  3.748175050163704*^9, 3.7481754930595217`*^9, 3.7482329820651937`*^9, 
   3.7482460553342686`*^9, 3.748259437665766*^9, 3.748266984965329*^9, {
   3.7482670986471*^9, 3.7482671583215947`*^9}, 3.748267201979526*^9, {
   3.7535329597713842`*^9, 3.753532981846184*^9}, 
   3.8305663088082066`*^9},ExpressionUUID->"c4bbd7f3-3bc6-40b2-93e0-\
8c7ab732cf11"],

Cell[BoxData["\<\"e2p4ACol done\"\>"], "Print",
 CellChangeTimes->{
  3.748175050163704*^9, 3.7481754930595217`*^9, 3.7482329820651937`*^9, 
   3.7482460553342686`*^9, 3.748259437665766*^9, 3.748266984965329*^9, {
   3.7482670986471*^9, 3.7482671583215947`*^9}, 3.748267201979526*^9, {
   3.7535329597713842`*^9, 3.753532981846184*^9}, 
   3.8305663088112044`*^9},ExpressionUUID->"48466eef-ebe6-4c11-8c70-\
2e6db0fc6544"],

Cell[BoxData["\<\"e2p5ACol done\"\>"], "Print",
 CellChangeTimes->{
  3.748175050163704*^9, 3.7481754930595217`*^9, 3.7482329820651937`*^9, 
   3.7482460553342686`*^9, 3.748259437665766*^9, 3.748266984965329*^9, {
   3.7482670986471*^9, 3.7482671583215947`*^9}, 3.748267201979526*^9, {
   3.7535329597713842`*^9, 3.753532981846184*^9}, 
   3.830566308813202*^9},ExpressionUUID->"f0cb3342-3c6d-4ee0-a202-\
297e285de6a2"],

Cell[BoxData[
 RowBox[{"-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"3", " ", "nPi"}]], 
   RowBox[{"A", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["A", "2"]}], " ", 
       SuperscriptBox["\[Xi]lIA", "3"]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["A", "2"], " ", "nPi", " ", 
       SuperscriptBox["\[Xi]lIA", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[Xi]e", "2"]}], ")"}], " ", "\[Micro]eA"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[Xi]f", "2"]}], ")"}], " ", "\[Micro]fA"}]}], 
        ")"}]}], "+", 
      RowBox[{"3", " ", "\[Xi]lIA", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"A", " ", 
          RowBox[{"(", 
           RowBox[{"\[Micro]eA", "+", "\[Micro]fA"}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["A", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{
                SuperscriptBox["nPi", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SuperscriptBox["\[Xi]e", "2"]}], ")"}]}]}], ")"}], " ", 
             SuperscriptBox["\[Micro]eA", "2"]}], "+", 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{
                SuperscriptBox["nPi", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SuperscriptBox["\[Xi]e", "2"]}], ")"}]}]}], ")"}], " ", 
             "\[Micro]eA", " ", "\[Micro]fA"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{
                SuperscriptBox["nPi", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SuperscriptBox["\[Xi]f", "2"]}], ")"}]}]}], ")"}], " ", 
             SuperscriptBox["\[Micro]fA", "2"]}]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"nPi", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox["A", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"3", "+", 
            RowBox[{
             SuperscriptBox["nPi", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["\[Xi]e", "2"]}], ")"}]}]}], ")"}], " ", 
          SuperscriptBox["\[Micro]eA", "3"]}], "+", 
         RowBox[{"3", " ", "A", " ", 
          SuperscriptBox["\[Micro]eA", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"A", " ", 
             RowBox[{"(", 
              RowBox[{"3", "+", 
               RowBox[{
                SuperscriptBox["nPi", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SuperscriptBox["\[Xi]e", "2"]}], ")"}]}]}], ")"}], " ", 
             "\[Micro]fA"}]}], ")"}]}], "+", 
         RowBox[{"3", " ", "\[Micro]eA", " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"2", " ", "A", " ", "\[Micro]fA"}], "+", 
            RowBox[{
             SuperscriptBox["A", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"3", "+", 
               RowBox[{
                SuperscriptBox["nPi", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SuperscriptBox["\[Xi]e", "2"]}], ")"}]}]}], ")"}], " ", 
             SuperscriptBox["\[Micro]fA", "2"]}]}], ")"}]}], "+", 
         RowBox[{"\[Micro]fA", " ", 
          RowBox[{"(", 
           RowBox[{"3", "-", 
            RowBox[{"3", " ", "A", " ", "\[Micro]fA"}], "+", 
            RowBox[{
             SuperscriptBox["A", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"3", "+", 
               RowBox[{
                SuperscriptBox["nPi", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SuperscriptBox["\[Xi]f", "2"]}], ")"}]}]}], ")"}], " ", 
             SuperscriptBox["\[Micro]fA", "2"]}]}], ")"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Output",
 CellChangeTimes->{
  3.74817275581022*^9, 3.7481729076433964`*^9, 3.7481729879061375`*^9, 
   3.748173039240399*^9, 3.7481731194695206`*^9, {3.748173175684663*^9, 
   3.7481731850830374`*^9}, {3.7481734609907856`*^9, 3.74817346886856*^9}, 
   3.748173677220467*^9, 3.7481743389233837`*^9, 3.7481749990919437`*^9, 
   3.748175050163704*^9, 3.7481754930444975`*^9, 3.7482329820450583`*^9, 
   3.7482460553186445`*^9, 3.748259437665766*^9, 3.748266984965329*^9, {
   3.7482670986314754`*^9, 3.7482671583215947`*^9}, 3.748267201979526*^9, {
   3.7535329597557583`*^9, 3.753532981846184*^9}, 
   3.8305663091059256`*^9},ExpressionUUID->"54f0943d-c3be-4c96-8b43-\
358f20ff6411"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RuleDisp", " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"A", "->", "1"}], ",", 
      RowBox[{"\[Micro]eA", "->", "  ", 
       RowBox[{
        SubscriptBox["\[Micro]", "e"], " ", "/", "A"}]}], ",", " ", 
      RowBox[{"\[Micro]fA", " ", "->", "  ", 
       RowBox[{
        SubscriptBox["\[Micro]", "f"], " ", "/", "A"}]}], ",", " ", 
      RowBox[{"\[Xi]lIA", " ", "\[Rule]", " ", 
       RowBox[{
        RowBox[{"I", " ", "/", " ", "A"}], " ", 
        SubscriptBox["\[Xi]", "liq"]}]}], ",", 
      RowBox[{"\[Xi]e", " ", "->", " ", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         SubscriptBox["\[Zeta]", "e"], " ", "+", " ", "1"}], "]"}]}], ",", 
      RowBox[{"\[Xi]f", " ", "->", " ", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         SubscriptBox["\[Zeta]", "f"], " ", "+", " ", "1"}], "]"}]}]}], 
     "}"}]}], ";"}], " "}], "\[IndentingNewLine]", 
 RowBox[{"e3totDisp", " ", "=", " ", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"e3tot", "//.", "RuleDisp"}], "//", "Simplify"}], ",", 
    RowBox[{"{", " ", 
     RowBox[{
      SubscriptBox["\[Micro]", "f"], ",", 
      SubscriptBox["\[Micro]", "e"], ",", 
      SubscriptBox["\[Xi]", "liq"], ",", "n"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"C0", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Coefficient", "[", 
      RowBox[{"e3totDisp", ",", 
       SubscriptBox["\[Micro]", "f"], ",", " ", "0"}], "]"}], "//", 
     "Cancel"}], " ", ",", 
    RowBox[{"{", " ", 
     RowBox[{
      SubscriptBox["\[Micro]", "e"], ",", 
      SubscriptBox["\[Xi]", "liq"]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"C1", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Coefficient", "[", 
      RowBox[{"e3totDisp", ",", 
       SubscriptBox["\[Micro]", "f"], ",", " ", "1"}], "]"}], "//", 
     "Cancel"}], " ", ",", 
    RowBox[{"{", " ", 
     RowBox[{
      SubscriptBox["\[Micro]", "e"], ",", 
      SubscriptBox["\[Xi]", "liq"]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"C2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Coefficient", "[", 
      RowBox[{"e3totDisp", ",", 
       SubscriptBox["\[Micro]", "f"], ",", " ", "2"}], "]"}], "//", 
     "Cancel"}], " ", ",", 
    RowBox[{"{", " ", 
     RowBox[{
      SubscriptBox["\[Micro]", "e"], ",", 
      SubscriptBox["\[Xi]", "liq"]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"C3", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Coefficient", "[", 
      RowBox[{"e3totDisp", ",", 
       SubscriptBox["\[Micro]", "f"], ",", " ", "3"}], "]"}], "//", 
     "Cancel"}], " ", ",", 
    RowBox[{"{", " ", 
     RowBox[{
      SubscriptBox["\[Micro]", "e"], ",", 
      SubscriptBox["\[Xi]", "liq"]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"C4", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Coefficient", "[", 
      RowBox[{"e3totDisp", ",", 
       SubscriptBox["\[Micro]", "f"], ",", " ", "4"}], "]"}], "//", 
     "Cancel"}], " ", ",", 
    RowBox[{"{", " ", 
     RowBox[{
      SubscriptBox["\[Micro]", "e"], ",", 
      SubscriptBox["\[Xi]", "liq"]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"C5", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Coefficient", "[", 
      RowBox[{"e3totDisp", ",", 
       SubscriptBox["\[Micro]", "f"], ",", " ", "5"}], "]"}], "//", 
     "Cancel"}], " ", ",", 
    RowBox[{"{", " ", 
     RowBox[{
      SubscriptBox["\[Micro]", "e"], ",", 
      SubscriptBox["\[Xi]", "liq"]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.74817353044746*^9, 3.748173584992976*^9}, {
   3.748173703985609*^9, 3.748173736091627*^9}, {3.748174796082732*^9, 
   3.7481748508670387`*^9}, {3.7481759813255634`*^9, 
   3.7481760306358414`*^9}, {3.7481765064236336`*^9, 3.748176534111759*^9}, {
   3.748177561352108*^9, 3.748177592356885*^9}, {3.748177670324708*^9, 
   3.7481777735138073`*^9}, 3.748177804457051*^9, {3.748232896505687*^9, 
   3.7482329078676586`*^9}, {3.748234864945986*^9, 3.748234923307558*^9}, 
   3.7482349707942896`*^9, {3.7482350097737446`*^9, 3.748235101083411*^9}, {
   3.748235138960395*^9, 3.7482351850615077`*^9}, {3.7482352649635005`*^9, 
   3.7482352917403827`*^9}, {3.7482353962104096`*^9, 3.748235400553816*^9}, {
   3.748235740478527*^9, 3.748235781728509*^9}, {3.7482358361701574`*^9, 
   3.7482360622095146`*^9}, 3.7482460691794434`*^9, 
   3.748259534143828*^9},ExpressionUUID->"c84a2895-ef5b-4a8e-8d28-\
79e83dd8416f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     SubscriptBox["\[Xi]", "liq"]}], "nPi"]}], "-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SubsuperscriptBox["\[Xi]", "liq", "3"]}], 
   RowBox[{"3", " ", "nPi"}]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
     RowBox[{
      SubscriptBox["\[Zeta]", "e"], " ", 
      SubsuperscriptBox["\[Xi]", "liq", "2"]}]}], ")"}], " ", 
   SubscriptBox["\[Micro]", "e"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox["nPi", "2"], " ", 
          SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
       SubscriptBox["\[Xi]", "liq"]}], "nPi"]}], ")"}], " ", 
   SubsuperscriptBox["\[Micro]", "e", "2"]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"(", 
    RowBox[{"3", "+", 
     RowBox[{
      SuperscriptBox["nPi", "2"], " ", 
      SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
   SubsuperscriptBox["\[Micro]", "e", "3"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
     RowBox[{
      SubscriptBox["\[Zeta]", "f"], " ", 
      SubsuperscriptBox["\[Xi]", "liq", "2"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"2", "-", 
        FractionBox[
         RowBox[{"2", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{
             SuperscriptBox["nPi", "2"], " ", 
             SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
          SubscriptBox["\[Xi]", "liq"]}], "nPi"]}], ")"}], " ", 
      SubscriptBox["\[Micro]", "e"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"3", "+", 
        RowBox[{
         SuperscriptBox["nPi", "2"], " ", 
         SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
      SubsuperscriptBox["\[Micro]", "e", "2"]}]}], ")"}], " ", 
   SubscriptBox["\[Micro]", "f"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{
          SuperscriptBox["nPi", "2"], " ", 
          SubscriptBox["\[Zeta]", "f"]}]}], ")"}], " ", 
       SubscriptBox["\[Xi]", "liq"]}], "nPi"], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"3", "+", 
        RowBox[{
         SuperscriptBox["nPi", "2"], " ", 
         SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
      SubscriptBox["\[Micro]", "e"]}]}], ")"}], " ", 
   SubsuperscriptBox["\[Micro]", "f", "2"]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"(", 
    RowBox[{"3", "+", 
     RowBox[{
      SuperscriptBox["nPi", "2"], " ", 
      SubscriptBox["\[Zeta]", "f"]}]}], ")"}], " ", 
   SubsuperscriptBox["\[Micro]", "f", "3"]}]}]], "Output",
 CellChangeTimes->{
  3.7482672020329247`*^9, {3.753532960162027*^9, 3.7535329819086847`*^9}, 
   3.8305663092947483`*^9},ExpressionUUID->"715ce5b2-8a35-4adc-a3ee-\
9cc53d74e5a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     SubscriptBox["\[Xi]", "liq"]}], "nPi"]}], "-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SubsuperscriptBox["\[Xi]", "liq", "3"]}], 
   RowBox[{"3", " ", "nPi"}]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
     RowBox[{
      SubscriptBox["\[Zeta]", "e"], " ", 
      SubsuperscriptBox["\[Xi]", "liq", "2"]}]}], ")"}], " ", 
   SubscriptBox["\[Micro]", "e"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["\[ImaginaryI]", "nPi"]}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "nPi", " ", 
         SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
      SubscriptBox["\[Xi]", "liq"]}]}], ")"}], " ", 
   SubsuperscriptBox["\[Micro]", "e", "2"]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "-", 
     RowBox[{
      SuperscriptBox["nPi", "2"], " ", 
      SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
   SubsuperscriptBox["\[Micro]", "e", "3"]}]}]], "Output",
 CellChangeTimes->{
  3.7482672020329247`*^9, {3.753532960162027*^9, 3.7535329819086847`*^9}, 
   3.8305663093067346`*^9},ExpressionUUID->"7b8cbb18-a7c0-4bb0-bbb4-\
b35b6964ec96"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "1"}], "+", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
  RowBox[{
   SubscriptBox["\[Zeta]", "f"], " ", 
   SubsuperscriptBox["\[Xi]", "liq", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"2", "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", " ", "\[ImaginaryI]"}], "nPi"]}], "-", 
        RowBox[{"2", " ", "\[ImaginaryI]", " ", "nPi", " ", 
         SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
      SubscriptBox["\[Xi]", "liq"]}]}], ")"}], " ", 
   SubscriptBox["\[Micro]", "e"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "-", 
     RowBox[{
      SuperscriptBox["nPi", "2"], " ", 
      SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
   SubsuperscriptBox["\[Micro]", "e", "2"]}]}]], "Output",
 CellChangeTimes->{
  3.7482672020329247`*^9, {3.753532960162027*^9, 3.7535329819086847`*^9}, 
   3.830566309312729*^9},ExpressionUUID->"e118ae66-6e63-45d7-9bcf-\
837f18d1208c"],

Cell[BoxData[
 RowBox[{"1", "-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{
       SuperscriptBox["nPi", "2"], " ", 
       SubscriptBox["\[Zeta]", "f"]}]}], ")"}], " ", 
    SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "-", 
     RowBox[{
      SuperscriptBox["nPi", "2"], " ", 
      SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
   SubscriptBox["\[Micro]", "e"]}]}]], "Output",
 CellChangeTimes->{
  3.7482672020329247`*^9, {3.753532960162027*^9, 3.7535329819086847`*^9}, 
   3.830566309317725*^9},ExpressionUUID->"17eae777-0ea0-4bd7-bcbc-\
be5a9f65baf9"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "3"}], "-", 
    RowBox[{
     SuperscriptBox["nPi", "2"], " ", 
     SubscriptBox["\[Zeta]", "f"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.7482672020329247`*^9, {3.753532960162027*^9, 3.7535329819086847`*^9}, 
   3.8305663093227196`*^9},ExpressionUUID->"1ba65ab3-56ea-4fc3-b0e4-\
70bdbb6335bd"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7482672020329247`*^9, {3.753532960162027*^9, 3.7535329819086847`*^9}, 
   3.830566309326716*^9},ExpressionUUID->"cb92b64e-3277-485e-a94d-\
5df08e898ab6"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7482672020329247`*^9, {3.753532960162027*^9, 3.7535329819086847`*^9}, 
   3.830566309329713*^9},ExpressionUUID->"0fae15e9-487d-4e36-b1f0-\
73507f93e3cd"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"subroman", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["\[Xi]", "liq"], "\[Rule]", "xil"}], ",", 
     RowBox[{
      SubscriptBox["\[Zeta]", "e"], "\[Rule]", "zee"}], ",", 
     RowBox[{
      SubscriptBox["\[Zeta]", "f"], "\[Rule]", "zef"}], ",", 
     RowBox[{
      SubscriptBox["\[Micro]", "e"], "\[Rule]", "mue"}], ",", 
     RowBox[{
      SubscriptBox["\[Micro]", "f"], "\[Rule]", "muf"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"C0r", " ", "=", " ", 
  RowBox[{"C0", "/.", "subroman"}]}], "\[IndentingNewLine]", 
 RowBox[{"C1r", " ", "=", " ", 
  RowBox[{"C1", "/.", "subroman"}]}], "\[IndentingNewLine]", 
 RowBox[{"C2r", " ", "=", " ", 
  RowBox[{"C2", "/.", "subroman"}]}], "\[IndentingNewLine]", 
 RowBox[{"C3r", " ", "=", " ", 
  RowBox[{"C3", "/.", "subroman"}]}], "\[IndentingNewLine]", 
 RowBox[{"C4r", " ", "=", " ", 
  RowBox[{"C4", "/.", "subroman"}]}], "\[IndentingNewLine]", 
 RowBox[{"C5r", " ", "=", " ", 
  RowBox[{"C5", "/.", "subroman"}]}]}], "Input",
 CellChangeTimes->{{3.7482673705414624`*^9, 
  3.748267376232731*^9}},ExpressionUUID->"98be2ff1-e106-4614-a6b5-\
1cd5737f5879"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", "xil"}], "nPi"]}], "-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SuperscriptBox["xil", "3"]}], 
   RowBox[{"3", " ", "nPi"}]], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   SuperscriptBox["mue", "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "-", 
     RowBox[{
      SuperscriptBox["nPi", "2"], " ", "zee"}]}], ")"}]}], "+", 
  RowBox[{"mue", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", "xil"}], "nPi"], "+", 
     RowBox[{
      SuperscriptBox["xil", "2"], " ", "zee"}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["mue", "2"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"xil", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["\[ImaginaryI]", "nPi"]}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "nPi", " ", "zee"}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.7481714152656217`*^9, 3.7481735854151273`*^9, {3.748173682852933*^9, 
   3.748173736523258*^9}, 3.7481743511505413`*^9, 3.7481750615915217`*^9, 
   3.7481754952862387`*^9, 3.7481760322001333`*^9, 3.7481765351271105`*^9, {
   3.7481775842418365`*^9, 3.7481775936094456`*^9}, {3.748177676263923*^9, 
   3.7481777741133075`*^9}, 3.74817780490989*^9, 3.748232984968569*^9, 
   3.748234929469035*^9, 3.748234971610237*^9, {3.7482350034592896`*^9, 
   3.7482350434065905`*^9}, {3.74823508743046*^9, 3.7482351032195854`*^9}, {
   3.748235146178369*^9, 3.7482351858392334`*^9}, {3.7482352670465775`*^9, 
   3.748235293105996*^9}, 3.7482354015375795`*^9, 3.748235749677537*^9, 
   3.7482357847896166`*^9, {3.7482358481915636`*^9, 3.7482358926096582`*^9}, {
   3.7482359227050314`*^9, 3.7482359930308228`*^9}, 3.7482360634718475`*^9, {
   3.748246055703699*^9, 3.7482460696479645`*^9}, 3.748259438082081*^9, 
   3.7482595348280773`*^9, 3.7482669850434575`*^9, 3.7482670986783495`*^9, {
   3.7482671393599567`*^9, 3.748267158784374*^9}, 3.7482672020797997`*^9, 
   3.748267371124425*^9, {3.753532960208903*^9, 3.7535329819399366`*^9}, 
   3.830566309357689*^9, 
   3.8305686087402287`*^9},ExpressionUUID->"3f3cc577-34f9-40f7-a712-\
368d5b7ae5bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "1"}], "+", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", "xil"}], "nPi"], "+", 
  RowBox[{
   SuperscriptBox["mue", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "-", 
     RowBox[{
      SuperscriptBox["nPi", "2"], " ", "zee"}]}], ")"}]}], "+", 
  RowBox[{"mue", " ", 
   RowBox[{"(", 
    RowBox[{"2", "+", 
     RowBox[{"xil", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", " ", "\[ImaginaryI]"}], "nPi"]}], "-", 
        RowBox[{"2", " ", "\[ImaginaryI]", " ", "nPi", " ", "zee"}]}], 
       ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["xil", "2"], " ", "zef"}]}]], "Output",
 CellChangeTimes->{
  3.7481714152656217`*^9, 3.7481735854151273`*^9, {3.748173682852933*^9, 
   3.748173736523258*^9}, 3.7481743511505413`*^9, 3.7481750615915217`*^9, 
   3.7481754952862387`*^9, 3.7481760322001333`*^9, 3.7481765351271105`*^9, {
   3.7481775842418365`*^9, 3.7481775936094456`*^9}, {3.748177676263923*^9, 
   3.7481777741133075`*^9}, 3.74817780490989*^9, 3.748232984968569*^9, 
   3.748234929469035*^9, 3.748234971610237*^9, {3.7482350034592896`*^9, 
   3.7482350434065905`*^9}, {3.74823508743046*^9, 3.7482351032195854`*^9}, {
   3.748235146178369*^9, 3.7482351858392334`*^9}, {3.7482352670465775`*^9, 
   3.748235293105996*^9}, 3.7482354015375795`*^9, 3.748235749677537*^9, 
   3.7482357847896166`*^9, {3.7482358481915636`*^9, 3.7482358926096582`*^9}, {
   3.7482359227050314`*^9, 3.7482359930308228`*^9}, 3.7482360634718475`*^9, {
   3.748246055703699*^9, 3.7482460696479645`*^9}, 3.748259438082081*^9, 
   3.7482595348280773`*^9, 3.7482669850434575`*^9, 3.7482670986783495`*^9, {
   3.7482671393599567`*^9, 3.748267158784374*^9}, 3.7482672020797997`*^9, 
   3.748267371124425*^9, {3.753532960208903*^9, 3.7535329819399366`*^9}, 
   3.830566309357689*^9, 
   3.8305686087462206`*^9},ExpressionUUID->"9462b9d3-e990-438e-9a58-\
99fd8672cdfa"],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"mue", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "-", 
     RowBox[{
      SuperscriptBox["nPi", "2"], " ", "zee"}]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", "xil", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{
       SuperscriptBox["nPi", "2"], " ", "zef"}]}], ")"}]}], 
   "nPi"]}]], "Output",
 CellChangeTimes->{
  3.7481714152656217`*^9, 3.7481735854151273`*^9, {3.748173682852933*^9, 
   3.748173736523258*^9}, 3.7481743511505413`*^9, 3.7481750615915217`*^9, 
   3.7481754952862387`*^9, 3.7481760322001333`*^9, 3.7481765351271105`*^9, {
   3.7481775842418365`*^9, 3.7481775936094456`*^9}, {3.748177676263923*^9, 
   3.7481777741133075`*^9}, 3.74817780490989*^9, 3.748232984968569*^9, 
   3.748234929469035*^9, 3.748234971610237*^9, {3.7482350034592896`*^9, 
   3.7482350434065905`*^9}, {3.74823508743046*^9, 3.7482351032195854`*^9}, {
   3.748235146178369*^9, 3.7482351858392334`*^9}, {3.7482352670465775`*^9, 
   3.748235293105996*^9}, 3.7482354015375795`*^9, 3.748235749677537*^9, 
   3.7482357847896166`*^9, {3.7482358481915636`*^9, 3.7482358926096582`*^9}, {
   3.7482359227050314`*^9, 3.7482359930308228`*^9}, 3.7482360634718475`*^9, {
   3.748246055703699*^9, 3.7482460696479645`*^9}, 3.748259438082081*^9, 
   3.7482595348280773`*^9, 3.7482669850434575`*^9, 3.7482670986783495`*^9, {
   3.7482671393599567`*^9, 3.748267158784374*^9}, 3.7482672020797997`*^9, 
   3.748267371124425*^9, {3.753532960208903*^9, 3.7535329819399366`*^9}, 
   3.830566309357689*^9, 
   3.8305686087522125`*^9},ExpressionUUID->"840ea760-9620-4837-ac9d-\
36f58f49b6df"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "3"}], "-", 
    RowBox[{
     SuperscriptBox["nPi", "2"], " ", "zef"}]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.7481714152656217`*^9, 3.7481735854151273`*^9, {3.748173682852933*^9, 
   3.748173736523258*^9}, 3.7481743511505413`*^9, 3.7481750615915217`*^9, 
   3.7481754952862387`*^9, 3.7481760322001333`*^9, 3.7481765351271105`*^9, {
   3.7481775842418365`*^9, 3.7481775936094456`*^9}, {3.748177676263923*^9, 
   3.7481777741133075`*^9}, 3.74817780490989*^9, 3.748232984968569*^9, 
   3.748234929469035*^9, 3.748234971610237*^9, {3.7482350034592896`*^9, 
   3.7482350434065905`*^9}, {3.74823508743046*^9, 3.7482351032195854`*^9}, {
   3.748235146178369*^9, 3.7482351858392334`*^9}, {3.7482352670465775`*^9, 
   3.748235293105996*^9}, 3.7482354015375795`*^9, 3.748235749677537*^9, 
   3.7482357847896166`*^9, {3.7482358481915636`*^9, 3.7482358926096582`*^9}, {
   3.7482359227050314`*^9, 3.7482359930308228`*^9}, 3.7482360634718475`*^9, {
   3.748246055703699*^9, 3.7482460696479645`*^9}, 3.748259438082081*^9, 
   3.7482595348280773`*^9, 3.7482669850434575`*^9, 3.7482670986783495`*^9, {
   3.7482671393599567`*^9, 3.748267158784374*^9}, 3.7482672020797997`*^9, 
   3.748267371124425*^9, {3.753532960208903*^9, 3.7535329819399366`*^9}, 
   3.830566309357689*^9, 
   3.8305686087562113`*^9},ExpressionUUID->"2922e15e-763c-42ff-a98b-\
61990d42c9cb"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7481714152656217`*^9, 3.7481735854151273`*^9, {3.748173682852933*^9, 
   3.748173736523258*^9}, 3.7481743511505413`*^9, 3.7481750615915217`*^9, 
   3.7481754952862387`*^9, 3.7481760322001333`*^9, 3.7481765351271105`*^9, {
   3.7481775842418365`*^9, 3.7481775936094456`*^9}, {3.748177676263923*^9, 
   3.7481777741133075`*^9}, 3.74817780490989*^9, 3.748232984968569*^9, 
   3.748234929469035*^9, 3.748234971610237*^9, {3.7482350034592896`*^9, 
   3.7482350434065905`*^9}, {3.74823508743046*^9, 3.7482351032195854`*^9}, {
   3.748235146178369*^9, 3.7482351858392334`*^9}, {3.7482352670465775`*^9, 
   3.748235293105996*^9}, 3.7482354015375795`*^9, 3.748235749677537*^9, 
   3.7482357847896166`*^9, {3.7482358481915636`*^9, 3.7482358926096582`*^9}, {
   3.7482359227050314`*^9, 3.7482359930308228`*^9}, 3.7482360634718475`*^9, {
   3.748246055703699*^9, 3.7482460696479645`*^9}, 3.748259438082081*^9, 
   3.7482595348280773`*^9, 3.7482669850434575`*^9, 3.7482670986783495`*^9, {
   3.7482671393599567`*^9, 3.748267158784374*^9}, 3.7482672020797997`*^9, 
   3.748267371124425*^9, {3.753532960208903*^9, 3.7535329819399366`*^9}, 
   3.830566309357689*^9, 
   3.830568608759208*^9},ExpressionUUID->"58ead712-e5d7-4c1b-8806-\
fab2f6d1df3c"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7481714152656217`*^9, 3.7481735854151273`*^9, {3.748173682852933*^9, 
   3.748173736523258*^9}, 3.7481743511505413`*^9, 3.7481750615915217`*^9, 
   3.7481754952862387`*^9, 3.7481760322001333`*^9, 3.7481765351271105`*^9, {
   3.7481775842418365`*^9, 3.7481775936094456`*^9}, {3.748177676263923*^9, 
   3.7481777741133075`*^9}, 3.74817780490989*^9, 3.748232984968569*^9, 
   3.748234929469035*^9, 3.748234971610237*^9, {3.7482350034592896`*^9, 
   3.7482350434065905`*^9}, {3.74823508743046*^9, 3.7482351032195854`*^9}, {
   3.748235146178369*^9, 3.7482351858392334`*^9}, {3.7482352670465775`*^9, 
   3.748235293105996*^9}, 3.7482354015375795`*^9, 3.748235749677537*^9, 
   3.7482357847896166`*^9, {3.7482358481915636`*^9, 3.7482358926096582`*^9}, {
   3.7482359227050314`*^9, 3.7482359930308228`*^9}, 3.7482360634718475`*^9, {
   3.748246055703699*^9, 3.7482460696479645`*^9}, 3.748259438082081*^9, 
   3.7482595348280773`*^9, 3.7482669850434575`*^9, 3.7482670986783495`*^9, {
   3.7482671393599567`*^9, 3.748267158784374*^9}, 3.7482672020797997`*^9, 
   3.748267371124425*^9, {3.753532960208903*^9, 3.7535329819399366`*^9}, 
   3.830566309357689*^9, 
   3.830568608761206*^9},ExpressionUUID->"cf0bded4-1f11-40d1-84da-\
fe7bbe77cd1a"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  FractionBox[
   StyleBox[
    RowBox[{
     StyleBox["D",
      FontFamily->"Symbol",
      FontWeight->"Bold"], "f"}]], 
   SubscriptBox["f", "ref"]], "=", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"\[ImaginaryI]", " ", 
      SubscriptBox["\[Xi]", "liq"]}], "nPi"]}], "-", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     SubsuperscriptBox["\[Xi]", "liq", "3"]}], 
    RowBox[{"3", " ", "nPi"}]], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
      RowBox[{
       SubscriptBox["\[Zeta]", "e"], " ", 
       SubsuperscriptBox["\[Xi]", "liq", "2"]}]}], ")"}], " ", 
    SubscriptBox["\[Micro]", "e"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{
           SuperscriptBox["nPi", "2"], " ", 
           SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
        SubscriptBox["\[Xi]", "liq"]}], "nPi"]}], ")"}], " ", 
    SubsuperscriptBox["\[Micro]", "e", "2"]}], "-", 
   RowBox[{
    FractionBox["1", "3"], " ", 
    RowBox[{"(", 
     RowBox[{"3", "+", 
      RowBox[{
       SuperscriptBox["nPi", "2"], " ", 
       SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
    SubsuperscriptBox["\[Micro]", "e", "3"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
      RowBox[{
       SubscriptBox["\[Zeta]", "f"], " ", 
       SubsuperscriptBox["\[Xi]", "liq", "2"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", "-", 
         FractionBox[
          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{
              SuperscriptBox["nPi", "2"], " ", 
              SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
           SubscriptBox["\[Xi]", "liq"]}], "nPi"]}], ")"}], " ", 
       SubscriptBox["\[Micro]", "e"]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"3", "+", 
         RowBox[{
          SuperscriptBox["nPi", "2"], " ", 
          SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
       SubsuperscriptBox["\[Micro]", "e", "2"]}]}], ")"}], " ", 
    SubscriptBox["\[Micro]", "f"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{
           SuperscriptBox["nPi", "2"], " ", 
           SubscriptBox["\[Zeta]", "f"]}]}], ")"}], " ", 
        SubscriptBox["\[Xi]", "liq"]}], "nPi"], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"3", "+", 
         RowBox[{
          SuperscriptBox["nPi", "2"], " ", 
          SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
       SubscriptBox["\[Micro]", "e"]}]}], ")"}], " ", 
    SubsuperscriptBox["\[Micro]", "f", "2"]}], "-", 
   RowBox[{
    FractionBox["1", "3"], " ", 
    RowBox[{"(", 
     RowBox[{"3", "+", 
      RowBox[{
       SuperscriptBox["nPi", "2"], " ", 
       SubscriptBox["\[Zeta]", "f"]}]}], ")"}], " ", 
    SubsuperscriptBox["\[Micro]", "f", "3"]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["C", "\[Micro]f0"], "=", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"\[ImaginaryI]", " ", 
      SubscriptBox["\[Xi]", "liq"]}], "nPi"]}], "-", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     SubsuperscriptBox["\[Xi]", "liq", "3"]}], 
    RowBox[{"3", " ", "nPi"}]], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
      RowBox[{
       SubscriptBox["\[Zeta]", "e"], " ", 
       SubsuperscriptBox["\[Xi]", "liq", "2"]}]}], ")"}], " ", 
    SubscriptBox["\[Micro]", "e"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["\[ImaginaryI]", "nPi"]}], "-", 
         RowBox[{"\[ImaginaryI]", " ", "nPi", " ", 
          SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
       SubscriptBox["\[Xi]", "liq"]}]}], ")"}], " ", 
    SubsuperscriptBox["\[Micro]", "e", "2"]}], "+", 
   RowBox[{
    FractionBox["1", "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "3"}], "-", 
      RowBox[{
       SuperscriptBox["nPi", "2"], " ", 
       SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
    SubsuperscriptBox["\[Micro]", "e", "3"]}]}]}]}], "Input",
 CellChangeTimes->{{3.748235321872416*^9, 3.7482353521538086`*^9}, {
  3.748235423780864*^9, 3.74823543875241*^9}, {3.7482354857369885`*^9, 
  3.748235495250032*^9}, {3.7482433199015207`*^9, 3.7482433344086404`*^9}, {
  3.7482461302755814`*^9, 3.748246231818309*^9}, {3.7482673946741548`*^9, 
  3.7482674325081124`*^9}},ExpressionUUID->"d1e49ee7-4e67-45d1-ad5e-\
3d9e708362a3"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["C", "\[Micro]f1"], "=", 
  RowBox[{
   RowBox[{"-", "1"}], "+", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
   RowBox[{
    SubscriptBox["\[Zeta]", "f"], " ", 
    SubsuperscriptBox["\[Xi]", "liq", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", " ", "\[ImaginaryI]"}], "nPi"]}], "-", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "nPi", " ", 
          SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
       SubscriptBox["\[Xi]", "liq"]}]}], ")"}], " ", 
    SubscriptBox["\[Micro]", "e"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "3"}], "-", 
      RowBox[{
       SuperscriptBox["nPi", "2"], " ", 
       SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
    SubsuperscriptBox["\[Micro]", "e", "2"]}]}]}]], "Input",
 CellChangeTimes->{{3.748235321872416*^9, 3.7482353521538086`*^9}, {
   3.748235423780864*^9, 3.74823543875241*^9}, {3.7482354857369885`*^9, 
   3.748235495250032*^9}, {3.7482433199015207`*^9, 3.7482433344086404`*^9}, {
   3.7482435589475927`*^9, 3.748243571497439*^9}, 
   3.7482674501754313`*^9},ExpressionUUID->"42e40dc0-a637-448b-86f8-\
74fbe8833020"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["C", "\[Micro]f2"], "=", 
  RowBox[{"1", "-", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        SuperscriptBox["nPi", "2"], " ", 
        SubscriptBox["\[Zeta]", "f"]}]}], ")"}], " ", 
     SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "3"}], "-", 
      RowBox[{
       SuperscriptBox["nPi", "2"], " ", 
       SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
    SubscriptBox["\[Micro]", "e"]}]}]}]], "Input",
 CellChangeTimes->{{3.748235321872416*^9, 3.7482353521538086`*^9}, {
   3.748235423780864*^9, 3.74823543875241*^9}, {3.7482354857369885`*^9, 
   3.748235495250032*^9}, {3.7482433199015207`*^9, 3.7482433344086404`*^9}, {
   3.7482435589475927`*^9, 3.7482435959726405`*^9}, 
   3.748267506221266*^9},ExpressionUUID->"fab8f588-fee3-451c-812e-\
4b16fda03624"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["C", "\[Micro]f3"], "=", 
  RowBox[{"1", "-", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        SuperscriptBox["nPi", "2"], " ", 
        SubscriptBox["\[Zeta]", "f"]}]}], ")"}], " ", 
     SubscriptBox["\[Xi]", "liq"]}], "nPi"], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "3"}], "-", 
      RowBox[{
       SuperscriptBox["nPi", "2"], " ", 
       SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
    SubscriptBox["\[Micro]", "e"]}]}]}]], "Input",
 CellChangeTimes->{{3.748235321872416*^9, 3.7482353521538086`*^9}, {
   3.748235423780864*^9, 3.74823543875241*^9}, {3.7482354857369885`*^9, 
   3.748235495250032*^9}, {3.7482433199015207`*^9, 3.7482433344086404`*^9}, {
   3.7482435589475927`*^9, 3.748243624989538*^9}, 3.748244390990243*^9, 
   3.7482675286739416`*^9},ExpressionUUID->"c5da317c-2559-494f-82f1-\
0af36e46b24a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"e3totDisp", "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Xi]", "liq"], "\[Rule]", "0"}], ",", 
    RowBox[{
     SubscriptBox["\[Micro]", "f"], "\[Rule]", "0"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.830566335959649*^9, 
  3.8305663737330914`*^9}},ExpressionUUID->"c1b6ad2c-e899-41af-b336-\
f539926d597d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   SubscriptBox["\[Micro]", "e"]}], "+", 
  SubsuperscriptBox["\[Micro]", "e", "2"], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"(", 
    RowBox[{"3", "+", 
     RowBox[{
      SuperscriptBox["nPi", "2"], " ", 
      SubscriptBox["\[Zeta]", "e"]}]}], ")"}], " ", 
   SubsuperscriptBox["\[Micro]", "e", "3"]}]}]], "Output",
 CellChangeTimes->{{3.830566328958237*^9, 3.83056634147945*^9}, 
   3.830566374557314*^9},ExpressionUUID->"2d228eb9-f23b-4d22-b4ea-\
3d55e45e5c06"]
}, Open  ]]
},
CellGrouping->Manual,
WindowSize->{1316, 676},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{32000, 32000},
PrintingOptions->{"Magnification"->1.,
"PaperOrientation"->"Landscape",
"PaperSize"->{842.04, 594.9599999999999}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
FrontEndVersion->"11.1 for Microsoft Windows (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 12391, 343, 616, "Input", "ExpressionUUID" -> \
"8eb609ff-a5b1-4fff-84af-a5fed86834ae"],
Cell[12974, 367, 4288, 120, 275, "Input", "ExpressionUUID" -> \
"2f4906f3-2682-47d7-9afa-865f569ca1d6"],
Cell[CellGroupData[{
Cell[17287, 491, 4876, 127, 341, "Input", "ExpressionUUID" -> \
"9cf4edd3-0145-47ee-9e2c-3efd5e0f96fa"],
Cell[22166, 620, 2288, 57, 60, "Output", "ExpressionUUID" -> \
"4e350b41-a370-4210-b2b7-6463fd3e2ccf"],
Cell[24457, 679, 419, 7, 22, "Print", "ExpressionUUID" -> \
"84fca609-0443-4226-9acc-5678f4d80996"],
Cell[24879, 688, 421, 7, 22, "Print", "ExpressionUUID" -> \
"c4bbd7f3-3bc6-40b2-93e0-8c7ab732cf11"],
Cell[25303, 697, 421, 7, 22, "Print", "ExpressionUUID" -> \
"48466eef-ebe6-4c11-8c70-2e6db0fc6544"],
Cell[25727, 706, 419, 7, 22, "Print", "ExpressionUUID" -> \
"f0cb3342-3c6d-4ee0-a202-297e285de6a2"],
Cell[26149, 715, 5245, 138, 103, "Output", "ExpressionUUID" -> \
"54f0943d-c3be-4c96-8b43-358f20ff6411"],
Cell[CellGroupData[{
Cell[31419, 857, 4614, 122, 187, "Input", "ExpressionUUID" -> \
"c84a2895-ef5b-4a8e-8d28-79e83dd8416f"],
Cell[36036, 981, 3278, 101, 118, "Output", "ExpressionUUID" -> \
"715ce5b2-8a35-4adc-a3ee-9cc53d74e5a1"],
Cell[39317, 1084, 1456, 45, 60, "Output", "ExpressionUUID" -> \
"7b8cbb18-a7c0-4bb0-bbb4-b35b6964ec96"],
Cell[40776, 1131, 1087, 33, 56, "Output", "ExpressionUUID" -> \
"e118ae66-6e63-45d7-9bcf-837f18d1208c"],
Cell[41866, 1166, 690, 21, 58, "Output", "ExpressionUUID" -> \
"17eae777-0ea0-4bd7-bcbc-be5a9f65baf9"],
Cell[42559, 1189, 403, 12, 53, "Output", "ExpressionUUID" -> \
"1ba65ab3-56ea-4fc3-b0e4-70bdbb6335bd"],
Cell[42965, 1203, 206, 4, 30, "Output", "ExpressionUUID" -> \
"cb92b64e-3277-485e-a94d-5df08e898ab6"],
Cell[43174, 1209, 206, 4, 30, "Output", "ExpressionUUID" -> \
"0fae15e9-487d-4e36-b1f0-73507f93e3cd"],
Cell[CellGroupData[{
Cell[43405, 1217, 1192, 30, 147, "Input", "ExpressionUUID" -> \
"98be2ff1-e106-4614-a6b5-1cd5737f5879"],
Cell[44600, 1249, 2280, 54, 57, "Output", "ExpressionUUID" -> \
"3f3cc577-34f9-40f7-a712-368d5b7ae5bc"],
Cell[46883, 1305, 1976, 43, 56, "Output", "ExpressionUUID" -> \
"9462b9d3-e990-438e-9a58-99fd8672cdfa"],
Cell[48862, 1350, 1659, 33, 56, "Output", "ExpressionUUID" -> \
"840ea760-9620-4837-ac9d-36f58f49b6df"],
Cell[50524, 1385, 1454, 26, 53, "Output", "ExpressionUUID" -> \
"2922e15e-763c-42ff-a98b-61990d42c9cb"],
Cell[51981, 1413, 1286, 19, 30, "Output", "ExpressionUUID" -> \
"58ead712-e5d7-4c1b-8806-fab2f6d1df3c"],
Cell[53270, 1434, 1286, 19, 63, "Output", "ExpressionUUID" -> \
"cf0bded4-1f11-40d1-84da-fe7bbe77cd1a"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[54607, 1459, 5116, 154, 172, "Input", "ExpressionUUID" -> \
"da64086e-04c9-4761-b919-59ebddd0f899"],
Cell[59726, 1615, 1346, 37, 56, "Input", "ExpressionUUID" -> \
"e6cdab27-cc51-4af0-b450-9e63ded51396"],
Cell[61075, 1654, 937, 25, 58, "Input", "ExpressionUUID" -> \
"8292f057-1037-4602-b09b-e7777a54d843"],
Cell[62015, 1681, 959, 25, 58, "Input", "ExpressionUUID" -> \
"627ff2fa-8c04-471d-ba91-58c0d6a91f3c"],
Cell[CellGroupData[{
Cell[62999, 1710, 358, 10, 33, "Input", "ExpressionUUID" -> \
"c1b6ad2c-e899-41af-b336-f539926d597d"],
Cell[63360, 1722, 527, 15, 86, "Output", "ExpressionUUID" -> \
"2d228eb9-f23b-4d22-b4ea-3d55e45e5c06"]
}, Open  ]]
}
]
*)

