{ /////////////////////////////////////////////////////////////////////////////////////////////// }
{ /////////////////////////////////////////////////////////////////////////////////////////////// }
{ PESGraph VCL Interface ///////////////////////////////////////////////////////////////////////// }
{ /////////////////////////////////////////////////////////////////////////////////////////////// }
{ /////////////////////////////////////////////////////////////////////////////////////////////// }
{ // Copyright (C) 1996-1999 Gigasoft, Inc.  All Rights Reserved //}

{$D-}
{$L-}
{$Q-}
{$R-}
{$S-}
{$T-}
{$V-}
{$Y-}

unit Pesgvcl;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
  Controls, Pegrpapi;

{ PESGraph Enumeration Properties //////////////////////////////////////////////////////////////// }
type
   eViewingStyle = (sgColor, sgMonochrome, sgMonoPlusSymbols);
   eDataPrecision = (sgNoDecimals, sgOneDecimal, sgTwoDecimals, sgThreeDecimals);
   eFontSize = (sgLarge, sgMedium, sgSmall);
   eVBoundaryTypes = (sgNone, sgUpper, sgLower, sgUpperPlusLower);
   eAxisScaleControl = (sgAuto, sgLinear, sgLog);
   ePlottingMethod = (sgLine, sgPoint, sgStick, sgPointsPlusBFL, sgPointsPlusBFC, sgPointsPlusSpline, sgSpline,
      sgBubble, sgPointsPlusLine, sgArea, sgBar, sgSpecificPlotMode, sgStep, sgRibbon, sgContourLines, sgContourColors);
   eGridLineControl = (sgYPlusXAxis, sgYAxis, sgXAxis, sgNoGrid);
   eDefOrientation = (sgDriverDefault, sgLandscape, sgPortrait);
   eManualScaleControl = (sgAutoScale, sgManualMin, sgManualMax, sgManualMinAndMax);
   eBubbleSize = (sgSmallBubbles, sgMediumBubbles, sgLargeBubbles);
   eSpecificPlotMode = (sgNormal, sgHighLowBar, sgHighLowLine, sgHighLowClose, sgOpenHighLowClose, sgBoxPlot);
   ePointSize = (sgSmallPoints, sgMediumPoints, sgLargePoints, sgMicroPoints);
   eBestFitDegree = (sgDegree2, sgDegree3, sgDegree4);
   eCurveGranularity = (sgCoarseLines, sgMediumLines, sgFineLines);
   eAllowDataLabels = (sgNoDataLabels, sgDataValues, sgPointLabels, sgDataPointLabels);
   eAllowZooming = (sgNoZooming, sgHorzZooming, sgVertZooming, sgHorzPlusVertZooming);
   eSymbolFrequency = (sgTwentyFourPercent, sgTwentyTwoPrecent, sgTwentyPercent, sgEighteenPercent,
      sgSixteenPercent, sgFourteenPercent, sgTwelvePercent, sgTenPercent, sgEightPercent, sgSixPercent);
   ePEactions = (sgReinitAndReset, sgReinitialize, sgResetImage, sgInvalidateImage, sgMaximize, sgCustomize,
      sgExportDialog, sgTextExportDialog, sgPrintDialog, sgColorDialog, sgFontDialog, sgPopupMenu, sgMetaToClip,
      sgMetaToFile, sgBmpToClip, sgBmpToFile, sgOleToClip, sgReinitCustoms, sgPrintGraph, sgUndoZoom, sgReset,
      gJpegToClip, gJpegToFile);
   eCursorMode = (sgNoCursor, sgVertLine, sgCrossHair, sgInvertedRect, sgFloatingY, sgFloatingXY);
   eCursorPromptStyle = (sgNoPrompt, sgXValue, sgYValue, sgXandYValue);
   eZoomInterfaceOnly = (sgNormalZooming, sgRectangleSelector, sgLineSelector);
   eDateTimeMode = (sgNumericXData, sgVBDateTime, sgDelphiDateTime);
   ePlottingMethodII = (sgLine2, sgPoint2, sgPointsPlusBFL2, sgPointsPlusBFC2,
      sgPointsPlusSpline2, sgSpline2, sgPointsPlusLine2, sgStep2, sgRibbon2);
   eShowAxis = (sgGridPlusAxisLabels, sgAxisLabels, sgGridLabels, sgNoLabels, sgAxisLabelsOnly, sgEmpty);
   eGridStyle = (sgThin, sgThick, sgDot, sgDash);
   eMultiAxesSeparators = (sgNoSeparator, sgThinLine, sgMediumLine, sgThickLine, sgThickPlusTicks);

   eLegendLocation = (sgLegendTop, sgLegendBottom, sgLegendLeft, sgLegendRight);
   eSpecialScaling = (sgNoSpecialScaling, sgFinancialScaling);
   eHotSpotSize = (sgSmallHotSpots, sgMediumHotSpots, sgLargeHotSpots);
   eDataShadows = (sgNo3D, sgWithShadows, sgWithThreeD);
   eAllowUserInterface = (sgNoInterface, sgAllInterface, sgNoKeyboard, sgNoMouse);
   eMinimumPointSize = (sgNoMPS, sgSmallMPS, sgMediumMPS, sgLargeMPS);

   TScrollCode = (scLineUp, scLineDown, scPageUp, scPageDown, scPosition, scTrack, scTop, scBottom, scEndScroll);
   TScrollEvent = procedure(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer) of object;
   TSubsetHotSpot = procedure(Sender: TObject; DblClick: Integer; SubsetIndex: Integer) of object;
   TDataHotSpot = procedure(Sender: TObject; DblClick: Integer; SubsetIndex: Integer; PointIndex: Integer) of object;
   TGraphHotSpot = procedure(Sender: TObject; DblClick: Integer; AxisIndex: Integer; Xval: Double; Yval: Double) of object;
   TAnnotHotSpot = procedure(Sender: TObject; DblClick: Integer; nIndex: Integer) of object;

   TTitle = procedure(Sender: TObject; DblClick: Integer) of object;
   TMultiTitle = procedure(Sender: TObject; DblClick: Integer; nIndex: Integer; nJustification: Integer) of object;
   TYAxisLabel = procedure(Sender: TObject; DblClick: Integer; nAxis: Integer; nRight: Integer) of object;
   TXAxisLabelEvent = procedure(Sender: TObject; DblClick: Integer; nTop: Integer) of object;
   TYAxis = procedure(Sender: TObject; DblClick: Integer; nAxis: Integer; nRight: Integer; Yval: Double) of object;
   TXAxis = procedure(Sender: TObject; DblClick: Integer; nTop: Integer; Xval: Double) of object;

{ PESGraph Class Declaration ///////////////////////////////////////////////////////////////////// }
type
  PESGraph = class(TWinControl)
  private
    { Private declarations }
    r: TRect;
    hObj: Integer;
    hMeta: Integer;
    bSizeAltered: Integer;
    bPrepareImages: Integer;
    hMemBitmap: Integer;
    hTmpBmp: Integer;
    hMemDC: Integer;
    bCacheBmp: Integer;
    nOldMode: Integer;
    nOldROP2: Integer;
    ps: TPaintStruct;
    w: Integer;
    h: Integer;
    l: Longint;
    tmsg: TMessage;
    wOld: Integer;
    lOld: Longint;
    fxratio: Single;
    fyratio: Single;
    tpts :array[0..4] of TPoint;
    hRgn1: HRgn;
    hRgn2: HRgn;
    hRgn3: HRgn;
    min: Integer;
    max: Integer;
    pos: Integer;
    tmpszstr: array[0..100] of Char;
    tmpstring: string;
    bPEcreated: Boolean;
    tmpS: Single;
    tmpD: Double;
    tmpN: Integer;
    tmpPEactions: Integer;
    tmpPEnarg1: Integer;
    tmpPEnarg2: Integer;
    tmpPEstrarg1: string;

    FOnParamUpdate: TNotifyEvent;
    FOnVertScroll: TScrollEvent;
    FOnHorzScroll: TScrollEvent;
    FOnCursorMoved: TNotifyEvent;
    FOnZoomIn: TNotifyEvent;
    FOnZoomOut: TNotifyEvent;
    FOnSubsetHotSpot: TSubsetHotSpot;
    FOnDataHotSpot: TDataHotSpot;
    FOnGraphHotSpot: TGraphHotSpot;
    FOnGraphAnnotHotSpot: TAnnotHotSpot;
    FOnXAxisAnnotHotSpot: TAnnotHotSpot;
    FOnYAxisAnnotHotSpot: TAnnotHotSpot;
    FOnHorzLineAnnotHotSpot: TAnnotHotSpot;
    FOnVertLineAnnotHotSpot: TAnnotHotSpot;
    FOnPreCursorMove: TNotifyEvent;

    FOnCustomizeDlg: TNotifyEvent;
    FOnPopupMenu: TNotifyEvent;

    FOnMainTitle: TTitle;
    FOnSubTitle: TTitle;
    FOnMultiSubTitle: TMultiTitle;
    FOnMultiBottomTitle: TMultiTitle;
    FOnYAxisLabel: TYAxisLabel;
    FOnXAxisLabel: TXAxisLabelEvent;
    FOnYAxis: TYAxis;
    FOnXAxis: TXAxis;

    { ProEssentials Property Access Declarations ////////////////////////////////////////////////////////// }
    procedure ResetandInvalidate;

    function GethObject: Integer;

    function GetViewingStyle: eViewingStyle;
    procedure SetViewingStyle(nValue: eViewingStyle);

    function GetPrepareImages: Boolean;
    procedure SetPrepareImages(bValue: Boolean);

    function GetGraphForeColor: TColor;
    procedure SetGraphForeColor(NewValue: TColor);

    function GetGraphBackColor: TColor;
    procedure SetGraphBackColor(NewValue: TColor);

    function GetDeskColor: TColor;
    procedure SetDeskColor(NewValue: TColor);

    function GetTextColor: TColor;
    procedure SetTextColor(NewValue: TColor);

    function GetShadowColor: TColor;
    procedure SetShadowColor(NewValue: TColor);

    function GetMainTitle: string;
    procedure SetMainTitle(NewValue: string);

    function GetSubTitle: string;
    procedure SetSubTitle(NewValue: string);

    function GetSubsets: Integer;
    procedure SetSubsets(nSubsets: Integer);

    function GetPoints: Integer;
    procedure SetPoints(NewValue: Integer);

    function GetDataPrecision: eDataPrecision;
    procedure SetDataPrecision(NewValue: eDataPrecision);

    function GetAllowCustomization: Boolean;
    procedure SetAllowCustomization(NewValue: Boolean);

    function GetAllowExporting: Boolean;
    procedure SetAllowExporting(NewValue: Boolean);

    function GetAllowMaximization: Boolean;
    procedure SetAllowMaximization(NewValue: Boolean);

    function GetAllowPopup: Boolean;
    procedure SetAllowPopup(NewValue: Boolean);

    function GetAllowUserInterface: eAllowUserInterface;
    procedure SetAllowUserInterface(NewValue: eAllowUserInterface);

    function GetFontSize: eFontSize;
    procedure SetFontSize(NewValue: eFontSize);

    function GetMainTitleFont: string;
    procedure SetMainTitleFont(NewValue: string);

    function GetMainTitleBold: Boolean;
    procedure SetMainTitleBold(NewValue: Boolean);

    function GetMainTitleItalic: Boolean;
    procedure SetMainTitleItalic(NewValue: Boolean);

    function GetMainTitleUnderline: Boolean;
    procedure SetMainTitleUnderline(NewValue: Boolean);

    function GetSubTitleFont: string;
    procedure SetSubTitleFont(NewValue: string);

    function GetSubTitleBold: Boolean;
    procedure SetSubTitleBold(NewValue: Boolean);

    function GetSubTitleItalic: Boolean;
    procedure SetSubTitleItalic(NewValue: Boolean);

    function GetSubTitleUnderline: Boolean;
    procedure SetSubTitleUnderline(NewValue: Boolean);

    function GetLabelFont: string;
    procedure SetLabelFont(NewValue: string);

    function GetLabelBold: Boolean;
    procedure SetLabelBold(NewValue: Boolean);

    function GetLabelItalic: Boolean;
    procedure SetLabelItalic(NewValue: Boolean);

    function GetLabelUnderline: Boolean;
    procedure SetLabelUnderline(NewValue: Boolean);

    function GetXAxisLabel: string;
    procedure SetXAxisLabel(NewValue: string);

    function GetYAxisLabel: string;
    procedure SetYAxisLabel(NewValue: string);

    function GetScrollingSubsets: Integer;
    procedure SetScrollingSubsets(NewValue: Integer);

    function GetVBoundaryTypes: eVBoundaryTypes;
    procedure SetVBoundaryTypes(NewValue: eVBoundaryTypes);

    function GetUpperBoundValue: Double;
    procedure SetUpperBoundValue(NewValue: Double);

    function GetLowerBoundValue: Double;
    procedure SetLowerBoundValue(NewValue: Double);

    function GetUpperBoundText: string;
    procedure SetUpperBoundText(NewValue: string);

    function GetLowerBoundText: string;
    procedure SetLowerBoundText(NewValue: string);

    function GetXAxisScaleControl: eAxisScaleControl;
    procedure SetXAxisScaleControl(NewValue: eAxisScaleControl);

    function GetYAxisScaleControl: eAxisScaleControl;
    procedure SetYAxisScaleControl(NewValue: eAxisScaleControl);

    function GetPlottingMethod: ePlottingMethod;
    procedure SetPlottingMethod(NewValue: ePlottingMethod);

    function GetTreatCompsAsNormal: Boolean;
    procedure SetTreatCompsAsNormal(NewValue: Boolean);

    function GetGridLineControl: eGridLineControl;
    procedure SetGridLineControl(NewValue: eGridLineControl);

    function GetGridInFront: Boolean;
    procedure SetGridInFront(NewValue: Boolean);

    function GetNoScrollingSubsetControl: Boolean;
    procedure SetNoScrollingSubsetControl(NewValue: Boolean);

    function GetGraphDataLabels: Boolean;
    procedure SetGraphDataLabels(NewValue: Boolean);

    function GetDataShadows: eDataShadows;
    procedure SetDataShadows(NewValue: eDataShadows);

    function GetMonoWithSymbols: Boolean;
    procedure SetMonoWithSymbols(NewValue: Boolean);

    function GetThreeDDialogs: Boolean;
    procedure SetThreeDDialogs(NewValue: Boolean);

    function GetDefOrientation: eDefOrientation;
    procedure SetDefOrientation(NewValue: eDefOrientation);

    function GetObjectType: Integer;

    function GetScaleForXData: Integer;
    procedure SetScaleForXData(NewValue: Integer);

    function GetScaleForYData: Integer;
    procedure SetScaleForYData(NewValue: Integer);

    function GetManualScaleControlY: eManualScaleControl;
    procedure SetManualScaleControlY(NewValue: eManualScaleControl);

    function GetManualMinY: Double;
    procedure SetManualMinY(NewValue: Double);

    function GetManualMaxY: Double;
    procedure SetManualMaxY(NewValue: Double);

    function GetManualScaleControlX: eManualScaleControl;
    procedure SetManualScaleControlX(NewValue: eManualScaleControl);

    function GetManualMinX: Double;
    procedure SetManualMinX(NewValue: Double);

    function GetManualMaxX: Double;
    procedure SetManualMaxX(NewValue: Double);

    function GetXData(nSubset: Integer; nPoint: Integer): Single;
    procedure SetXData(nSubset: Integer; nPoint: Integer; NewValue: Single);

    function GetYData(nSubset: Integer; nPoint: Integer): Single;
    procedure SetYData(nSubset: Integer; nPoint: Integer; NewValue: Single);

    function GetZData(nSubset: Integer; nPoint: Integer): Single;
    procedure SetZData(nSubset: Integer; nPoint: Integer; NewValue: Single);

    function GetRandomSubsetsToGraph(nIndex: Integer): Integer;
    procedure SetRandomSubsetsToGraph(nIndex: Integer; NewValue: Integer);

    function GetSubsetLabels(nIndex: Integer): string;
    procedure SetSubsetLabels(nIndex: Integer; NewValue: string);

    function GetPointLabels(nIndex: Integer): string;
    procedure SetPointLabels(nIndex: Integer; NewValue: string);

    function GetComparisonSubsets: Integer;
    procedure SetComparisonSubsets(NewValue: Integer);

    function GetAllowSubsetHotSpots: Boolean;
    procedure SetAllowSubsetHotSpots(NewValue: Boolean);

    function GetAllowGraphHotSpots: Boolean;
    procedure SetAllowGraphHotSpots(NewValue: Boolean);

    function GetAllowDataHotSpots: Boolean;
    procedure SetAllowDataHotSpots(NewValue: Boolean);

    function GetAllowCoordPrompting: Boolean;
    procedure SetAllowCoordPrompting(NewValue: Boolean);

    function GetMarkDataPoints: Boolean;
    procedure SetMarkDataPoints(NewValue: Boolean);

    function GetSubsetColors(nIndex: Integer): TColor;
    procedure SetSubsetColors(nIndex: Integer; NewValue: TColor);

    function GetRYAxisComparisonSubsets: Integer;
    procedure SetRYAxisComparisonSubsets(NewValue: Integer);

    function GetRYAxisLabel: string;
    procedure SetRYAxisLabel(NewValue: string);

    function GetScaleForRYData: Integer;
    procedure SetScaleForRYData(NewValue: Integer);

    function GetRYAxisScaleControl: eAxisScaleControl;
    procedure SetRYAxisScaleControl(NewValue: eAxisScaleControl);

    function GetManualScaleControlRY: eManualScaleControl;
    procedure SetManualScaleControlRY(NewValue: eManualScaleControl);

    function GetManualMinRY: Double;
    procedure SetManualMinRY(NewValue: Double);

    function GetManualMaxRY: Double;
    procedure SetManualMaxRY(NewValue: Double);

    function GetAllowPlotCustomization: Boolean;
    procedure SetAllowPlotCustomization(NewValue: Boolean);

    function GetAllowBubble: Boolean;
    procedure SetAllowBubble(NewValue: Boolean);

    function GetAllowBestFitCurve: Boolean;
    procedure SetAllowBestFitCurve(NewValue: Boolean);

    function GetAllowSpline: Boolean;
    procedure SetAllowSpline(NewValue: Boolean);

    function GetNegativeFromXAxis: Boolean;
    procedure SetNegativeFromXAxis(NewValue: Boolean);

    function GetManualXAxisTicknLine: Boolean;
    procedure SetManualXAxisTicknLine(NewValue: Boolean);

    function GetManualYAxisTicknLine: Boolean;
    procedure SetManualYAxisTicknLine(NewValue: Boolean);

    function GetManualRYAxisTicknLine: Boolean;
    procedure SetManualRYAxisTicknLine(NewValue: Boolean);

    function GetBubbleSize: eBubbleSize;
    procedure SetBubbleSize(NewValue: eBubbleSize);

    function GetSpecificPlotMode: eSpecificPlotMode;
    procedure SetSpecificPlotMode(NewValue: eSpecificPlotMode);

    function GetPointSize: ePointSize;
    procedure SetPointSize(NewValue: ePointSize);

    function GetBestFitDegree: eBestFitDegree;
    procedure SetBestFitDegree(NewValue: eBestFitDegree);

    function GetCurveGranularity: eCurveGranularity;
    procedure SetCurveGranularity(NewValue: eCurveGranularity);

    function GetAllowDataLabels: eAllowDataLabels;
    procedure SetAllowDataLabels(NewValue: eAllowDataLabels);

    function GetManualXAxisTick: Double;
    procedure SetManualXAxisTick(NewValue: Double);

    function GetManualXAxisLine: Double;
    procedure SetManualXAxisLine(NewValue: Double);

    function GetManualYAxisTick: Double;
    procedure SetManualYAxisTick(NewValue: Double);

    function GetManualYAxisLine: Double;
    procedure SetManualYAxisLine(NewValue: Double);

    function GetManualRYAxisTick: Double;
    procedure SetManualRYAxisTick(NewValue: Double);

    function GetManualRYAxisLine: Double;
    procedure SetManualRYAxisLine(NewValue: Double);

    function GetNullDataValueX: Double;
    procedure SetNullDataValueX(NewValue: Double);

    function GetNullDataValueY: Double;
    procedure SetNullDataValueY(NewValue: Double);

    function GetSubsetPointTypes(nIndex: Integer): Integer;
    procedure SetSubsetPointTypes(nIndex: Integer; NewValue: Integer);

    function GetSubsetLineTypes(nIndex: Integer): Integer;
    procedure SetSubsetLineTypes(nIndex: Integer; NewValue: Integer);

    function GetDataPointLabels(nSubset: Integer; nPoint: Integer): string;
    procedure SetDataPointLabels(nSubset: Integer; nPoint: Integer; NewValue: string);

    function GetAllowLine: Boolean;
    procedure SetAllowLine(NewValue: Boolean);

    function GetAllowStick: Boolean;
    procedure SetAllowStick(NewValue: Boolean);

    function GetAllowBar: Boolean;
    procedure SetAllowBar(NewValue: Boolean);

    function GetAllowPoint: Boolean;
    procedure SetAllowPoint(NewValue: Boolean);

    function GetAllowArea: Boolean;
    procedure SetAllowArea(NewValue: Boolean);

    function GetAllowBestFitLine: Boolean;
    procedure SetAllowBestFitLine(NewValue: Boolean);

    function GetAllowZooming: eAllowZooming;
    procedure SetAllowZooming(NewValue: eAllowZooming);

    function GetForceRightYAxis: Boolean;
    procedure SetForceRightYAxis(NewValue: Boolean);

    function GetAllowPointsPlusLine: Boolean;
    procedure SetAllowPointsPlusLine(NewValue: Boolean);

    function GetAllowPointsPlusSpline: Boolean;
    procedure SetAllowPointsPlusSpline(NewValue: Boolean);

    function GetSymbolFrequency: eSymbolFrequency;
    procedure SetSymbolFrequency(NewValue: eSymbolFrequency);

    function GetPEactions: ePEactions;
    procedure SetPEactions(NewValue: ePEactions);

    function GetPEnarg1: Integer;
    procedure SetPEnarg1(NewValue: Integer);

    function GetPEnarg2: Integer;
    procedure SetPEnarg2(NewValue: Integer);

    function GetPEstrarg1: string;
    procedure SetPEstrarg1(NewValue: string);

    function GetScrollingHorzZoom: Boolean;
    procedure SetScrollingHorzZoom(NewValue: Boolean);

    function GetCursorMode: eCursorMode;
    procedure SetCursorMode(NewValue: eCursorMode);

    function GetCursorSubset: Integer;
    procedure SetCursorSubset(NewValue: Integer);

    function GetCursorPoint: Integer;
    procedure SetCursorPoint(NewValue: Integer);

    function GetCursorPromptStyle: eCursorPromptStyle;
    procedure SetCursorPromptStyle(NewValue: eCursorPromptStyle);

    function GetCursorPromptTracking: Boolean;
    procedure SetCursorPromptTracking(NewValue: Boolean);

    function GetMouseCursorControl: Boolean;
    procedure SetMouseCursorControl(NewValue: Boolean);

    function GetShowAnnotations: Boolean;
    procedure SetShowAnnotations(NewValue: Boolean);

    function GetAllowGraphAnnotHotSpots: Boolean;
    procedure SetAllowGraphAnnotHotSpots(NewValue: Boolean);

    function GetGraphAnnotationTextSize: Integer;
    procedure SetGraphAnnotationTextSize(NewValue: Integer);

    function GetAllowAnnotationControl: Boolean;
    procedure SetAllowAnnotationControl(NewValue: Boolean);

    function GetAnnotationsInFront: Boolean;
    procedure SetAnnotationsInFront(NewValue: Boolean);

    function GetGraphAnnotationX(nIndex: Integer): Double;
    procedure SetGraphAnnotationX(nIndex: Integer; NewValue: Double);

    function GetGraphAnnotationY(nIndex: Integer): Double;
    procedure SetGraphAnnotationY(nIndex: Integer; NewValue: Double);

    function GetGraphAnnotationText(nIndex: Integer): string;
    procedure SetGraphAnnotationText(nIndex: Integer; NewValue: string);

    function GetXAxisAnnotation(nIndex: Integer): Double;
    procedure SetXAxisAnnotation(nIndex: Integer; NewValue: Double);

    function GetXAxisAnnotationText(nIndex: Integer): string;
    procedure SetXAxisAnnotationText(nIndex: Integer; NewValue: string);

    function GetYAxisAnnotation(nIndex: Integer): Double;
    procedure SetYAxisAnnotation(nIndex: Integer; NewValue: Double);

    function GetYAxisAnnotationText(nIndex: Integer): string;
    procedure SetYAxisAnnotationText(nIndex: Integer; NewValue: string);

    function GetNoRandomPointsToExport: Boolean;
    procedure SetNoRandomPointsToExport(NewValue: Boolean);

    function GetCursorPageAmount: Integer;
    procedure SetCursorPageAmount(NewValue: Integer);

    function GetXAxisVertNumbering: Boolean;
    procedure SetXAxisVertNumbering(NewValue: Boolean);

    function GetLineGapThreshold: Double;
    procedure SetLineGapThreshold(NewValue: Double);

    function GetHorzLineAnnotation(nIndex: Integer): Double;
    procedure SetHorzLineAnnotation(nIndex: Integer; NewValue: Double);

    function GetHorzLineAnnotationText(nIndex: Integer): string;
    procedure SetHorzLineAnnotationText(nIndex: Integer; NewValue: string);

    function GetHorzLineAnnotationType(nIndex: Integer): Integer;
    procedure SetHorzLineAnnotationType(nIndex: Integer; NewValue: Integer);

    function GetHorzLineAnnotationColor(nIndex: Integer): TColor;
    procedure SetHorzLineAnnotationColor(nIndex: Integer; NewValue: TColor);

    function GetVertLineAnnotation(nIndex: Integer): Double;
    procedure SetVertLineAnnotation(nIndex: Integer; NewValue: Double);

    function GetVertLineAnnotationText(nIndex: Integer): string;
    procedure SetVertLineAnnotationText(nIndex: Integer; NewValue: string);

    function GetVertLineAnnotationType(nIndex: Integer): Integer;
    procedure SetVertLineAnnotationType(nIndex: Integer; NewValue: Integer);

    function GetVertLineAnnotationColor(nIndex: Integer): TColor;
    procedure SetVertLineAnnotationColor(nIndex: Integer; NewValue: TColor);

    function GetShowGraphAnnotations: Boolean;
    procedure SetShowGraphAnnotations(NewValue: Boolean);

    function GetShowXAxisAnnotations: Boolean;
    procedure SetShowXAxisAnnotations(NewValue: Boolean);

    function GetShowYAxisAnnotations: Boolean;
    procedure SetShowYAxisAnnotations(NewValue: Boolean);

    function GetShowHorzLineAnnotations: Boolean;
    procedure SetShowHorzLineAnnotations(NewValue: Boolean);

    function GetShowVertLineAnnotations: Boolean;
    procedure SetShowVertLineAnnotations(NewValue: Boolean);

    function GetAllowXAxisAnnotHotSpots: Boolean;
    procedure SetAllowXAxisAnnotHotSpots(NewValue: Boolean);

    function GetAllowYAxisAnnotHotSpots: Boolean;
    procedure SetAllowYAxisAnnotHotSpots(NewValue: Boolean);

    function GetAllowHorzLineAnnotHotSpots: Boolean;
    procedure SetAllowHorzLineAnnotHotSpots(NewValue: Boolean);

    function GetAllowVertLineAnnotHotSpots: Boolean;
    procedure SetAllowVertLineAnnotHotSpots(NewValue: Boolean);

    function GetGraphAnnotationColor(nIndex: Integer): TColor;
    procedure SetGraphAnnotationColor(nIndex: Integer; NewValue: TColor);

    function GetXAxisAnnotationColor(nIndex: Integer): TColor;
    procedure SetXAxisAnnotationColor(nIndex: Integer; NewValue: TColor);

    function GetYAxisAnnotationColor(nIndex: Integer): TColor;
    procedure SetYAxisAnnotationColor(nIndex: Integer; NewValue: TColor);

    function GetAxesAnnotationTextSize: Integer;
    procedure SetAxesAnnotationTextSize(NewValue: Integer);

    function GetLineAnnotationTextSize: Integer;
    procedure SetLineAnnotationTextSize(NewValue: Integer);

    function GetGraphAnnotationType(nIndex: Integer): Integer;
    procedure SetGraphAnnotationType(nIndex: Integer; NewValue: Integer);

    function GetSubsetsToLegend(nIndex: Integer): Integer;
    procedure SetSubsetsToLegend(nIndex: Integer; NewValue: Integer);

    function GetLegendAnnotationType(nIndex: Integer): Integer;
    procedure SetLegendAnnotationType(nIndex: Integer; NewValue: Integer);

    function GetLegendAnnotationText(nIndex: Integer): string;
    procedure SetLegendAnnotationText(nIndex: Integer; NewValue: string);

    function GetLegendAnnotationColor(nIndex: Integer): TColor;
    procedure SetLegendAnnotationColor(nIndex: Integer; NewValue: TColor);

    function GetZoomInterfaceOnly: eZoomInterfaceOnly;
    procedure SetZoomInterfaceOnly(NewValue: eZoomInterfaceOnly);

    function GetZoomMode: Boolean;
    procedure SetZoomMode(NewValue: Boolean);

    function GetZoomMinX: Double;
    procedure SetZoomMinX(NewValue: Double);

    function GetZoomMaxX: Double;
    procedure SetZoomMaxX(NewValue: Double);

    function GetZoomMinY: Double;
    procedure SetZoomMinY(NewValue: Double);

    function GetZoomMaxY: Double;
    procedure SetZoomMaxY(NewValue: Double);

    function GetVertScrollPos: Integer;
    procedure SetVertScrollPos(NewValue: Integer);

    function GetHorzScrollPos: Integer;
    procedure SetHorzScrollPos(NewValue: Integer);

    function GetAllowDebugOutput: Boolean;
    procedure SetAllowDebugOutput(NewValue: Boolean);

    function GetVertOrient90Degrees: Boolean;
    procedure SetVertOrient90Degrees(NewValue: Boolean);

    function GetPointColors(nSubset: Integer; nPoint: Integer): TColor;
    procedure SetPointColors(nSubset: Integer; nPoint: Integer; NewValue: TColor);

    function GetMultiAxesSubsets(nIndex: Integer): Integer;
    procedure SetMultiAxesSubsets(nIndex: Integer; NewValue: Integer);

    function GetGraphAnnotationAxis(nIndex: Integer): Integer;
    procedure SetGraphAnnotationAxis(nIndex: Integer; NewValue: Integer);

    function GetHorzLineAnnotationAxis(nIndex: Integer): Integer;
    procedure SetHorzLineAnnotationAxis(nIndex: Integer; NewValue: Integer);

    function GetMultiAxesProportions(nIndex: Integer): Single;
    procedure SetMultiAxesProportions(nIndex: Integer; NewValue: Single);

    function GetLegendAnnotationAxis(nIndex: Integer): Integer;
    procedure SetLegendAnnotationAxis(nIndex: Integer; NewValue: Integer);

    function GetWorkingAxis: Integer;
    procedure SetWorkingAxis(NewValue: Integer);

    function GetLogScaleExpLabels: Boolean;
    procedure SetLogScaleExpLabels(NewValue: Boolean);

    function GetUsingXDataII: Boolean;
    procedure SetUsingXDataII(NewValue: Boolean);

    function GetUsingYDataII: Boolean;
    procedure SetUsingYDataII(NewValue: Boolean);

    function GetDateTimeMode: eDateTimeMode;
    procedure SetDateTimeMode(NewValue: eDateTimeMode);

    function GetPlottingMethodII: ePlottingMethodII;
    procedure SetPlottingMethodII(NewValue: ePlottingMethodII);

    function GetBarWidth: Double;
    procedure SetBarWidth(NewValue: Double);

    function GetTXAxisComparisonSubsets: Integer;
    procedure SetTXAxisComparisonSubsets(NewValue: Integer);

    function GetTXAxisLabel: string;
    procedure SetTXAxisLabel(NewValue: string);

    function GetScaleForTXData: Integer;
    procedure SetScaleForTXData(NewValue: Integer);

    function GetTXAxisScaleControl: eAxisScaleControl;
    procedure SetTXAxisScaleControl(NewValue: eAxisScaleControl);

    function GetManualScaleControlTX: eManualScaleControl;
    procedure SetManualScaleControlTX(NewValue: eManualScaleControl);

    function GetManualMinTX: Double;
    procedure SetManualMinTX(NewValue: Double);

    function GetManualMaxTX: Double;
    procedure SetManualMaxTX(NewValue: Double);

    function GetManualTXAxisTicknLine: Boolean;
    procedure SetManualTXAxisTicknLine(NewValue: Boolean);

    function GetManualTXAxisTick: Double;
    procedure SetManualTXAxisTick(NewValue: Double);

    function GetManualTXAxisLine: Double;
    procedure SetManualTXAxisLine(NewValue: Double);

    function GetForceTopXAxis: Boolean;
    procedure SetForceTopXAxis(NewValue: Boolean);

    function GetXAxisOnTop: Boolean;
    procedure SetXAxisOnTop(NewValue: Boolean);

    function GetYAxisOnRight: Boolean;
    procedure SetYAxisOnRight(NewValue: Boolean);

    function GetMultiSubTitles(nIndex: Integer): string;
    procedure SetMultiSubTitles(nIndex: Integer; NewValue: string);

    function GetMultiBottomTitles(nIndex: Integer): string;
    procedure SetMultiBottomTitles(nIndex: Integer; NewValue: string);

    function GetFocalRect: Boolean;
    procedure SetFocalRect(NewValue: Boolean);

    function GetFontSizeGlobalCntl: Single;
    procedure SetFontSizeGlobalCntl(NewValue: Single);

    function GetFontSizeTitleCntl: Single;
    procedure SetFontSizeTitleCntl(NewValue: Single);

    function GetSubsetByPoint: Boolean;
    procedure SetSubsetByPoint(NewValue: Boolean);

    function GetShowYAxis: eShowAxis;
    procedure SetShowYAxis(NewValue: eShowAxis);

    function GetShowRYAxis: eShowAxis;
    procedure SetShowRYAxis(NewValue: eShowAxis);

    function GetShowXAxis: eShowAxis;
    procedure SetShowXAxis(NewValue: eShowAxis);

    function GetShowTXAxis: eShowAxis;
    procedure SetShowTXAxis(NewValue: eShowAxis);

    function GetGridStyle: eGridStyle;
    procedure SetGridStyle(NewValue: eGridStyle);

    function GetInvertedYAxis: Boolean;
    procedure SetInvertedYAxis(NewValue: Boolean);

    function GetInvertedRYAxis: Boolean;
    procedure SetInvertedRYAxis(NewValue: Boolean);

    function GetInvertedXAxis: Boolean;
    procedure SetInvertedXAxis(NewValue: Boolean);

    function GetInvertedTXAxis: Boolean;
    procedure SetInvertedTXAxis(NewValue: Boolean);

    function GetYAxisColor: TColor;
    procedure SetYAxisColor(NewValue: TColor);

    function GetRYAxisColor: TColor;
    procedure SetRYAxisColor(NewValue: TColor);

    function GetXAxisColor: TColor;
    procedure SetXAxisColor(NewValue: TColor);

    function GetTXAxisColor: TColor;
    procedure SetTXAxisColor(NewValue: TColor);

    function GetFontSizeLegendCntl: Single;
    procedure SetFontSizeLegendCntl(NewValue: Single);

    function GetYAxisLongTicks: Boolean;
    procedure SetYAxisLongTicks(NewValue: Boolean);

    function GetRYAxisLongTicks: Boolean;
    procedure SetRYAxisLongTicks(NewValue: Boolean);

    function GetXAxisLongTicks: Boolean;
    procedure SetXAxisLongTicks(NewValue: Boolean);

    function GetTXAxisLongTicks: Boolean;
    procedure SetTXAxisLongTicks(NewValue: Boolean);

    function GetMultiAxesSeparators: eMultiAxesSeparators;
    procedure SetMultiAxesSeparators(NewValue: eMultiAxesSeparators);

    function GetZoomMinAxis: Integer;
    procedure SetZoomMinAxis(NewValue: Integer);

    function GetZoomMaxAxis: Integer;
    procedure SetZoomMaxAxis(NewValue: Integer);

    function GetYDataII(nSubset: Integer; nPoint: Integer): Double;
    procedure SetYDataII(nSubset: Integer; nPoint: Integer; NewValue: Double);

    function GetXDataII(nSubset: Integer; nPoint: Integer): Double;
    procedure SetXDataII(nSubset: Integer; nPoint: Integer; NewValue: Double);

    function GetLeftMargin: string;
    procedure SetLeftMargin(NewValue: string);

    function GetTopMargin: string;
    procedure SetTopMargin(NewValue: string);

    function GetRightMargin: string;
    procedure SetRightMargin(NewValue: string);

    function GetBottomMargin: string;
    procedure SetBottomMargin(NewValue: string);

    function GetAllowOleExport: Boolean;
    procedure SetAllowOleExport(NewValue: Boolean);

    function GetAutoScaleData: Boolean;
    procedure SetAutoScaleData(NewValue: Boolean);

    function GetOverlapMultiAxes(nIndex: Integer): Integer;
    procedure SetOverlapMultiAxes(nIndex: Integer; NewValue: Integer);

    function GetArrowCursor: Integer;
    procedure SetArrowCursor(NewValue: Integer);

    function GetHandCursor: Integer;
    procedure SetHandCursor(NewValue: Integer);

    function GetZoomCursor: Integer;
    procedure SetZoomCursor(NewValue: Integer);

    function GetNoDropCursor: Integer;
    procedure SetNoDropCursor(NewValue: Integer);


    function GetSubsetShades(nIndex: Integer): TColor;
    procedure SetSubsetShades(nIndex: Integer; NewValue: TColor);

    function GetCustom: Boolean;
    procedure SetCustom(NewValue: Boolean);

    function GetCacheBmp: Boolean;
    procedure SetCacheBmp(NewValue: Boolean);

    function GetPainting: Boolean;

    function GetNoCustomParms: Boolean;
    procedure SetNoCustomParms(NewValue: Boolean);

    function GetNoHelp: Boolean;
    procedure SetNoHelp(NewValue: Boolean);

    function GetAllowTitleHotSpots: Boolean;
    procedure SetAllowTitleHotSpots(NewValue: Boolean);

    function GetAllowSubTitleHotSpots: Boolean;
    procedure SetAllowSubTitleHotSpots(NewValue: Boolean);

    function GetAllowBottomTitleHotSpots: Boolean;
    procedure SetAllowBottomTitleHotSpots(NewValue: Boolean);

    function GetAllowJpegOutput: Boolean;
    procedure SetAllowJpegOutput(NewValue: Boolean);

    function GetHelpFileName: string;
    procedure SetHelpFileName(NewValue: string);

    function GetDataHotSpotLimit: Integer;
    procedure SetDataHotSpotLimit(NewValue: Integer);

    function GetHourGlassThreshold: Integer;
    procedure SetHourGlassThreshold(NewValue: Integer);

    function GetNoHiddenLinesInArea: Boolean;
    procedure SetNoHiddenLinesInArea(NewValue: Boolean);

    function GetSpecificPlotModeColor: Boolean;
    procedure SetSpecificPlotModeColor(NewValue: Boolean);

    function GetLogicalLimit: Integer;
    procedure SetLogicalLimit(NewValue: Integer);

    function GetNullDataGaps: Boolean;
    procedure SetNullDataGaps(NewValue: Boolean);

    function GetAllowStep: Boolean;
    procedure SetAllowStep(NewValue: Boolean);

    function GetScrollingVertZoom: Boolean;
    procedure SetScrollingVertZoom(NewValue: Boolean);

    function GetAxisFormatY: string;
    procedure SetAxisFormatY(NewValue: string);

    function GetAxisFormatRY: string;
    procedure SetAxisFormatRY(NewValue: string);

    function GetZoomMinRY: double;
    procedure SetZoomMinRY(NewValue: double);

    function GetZoomMaxRY: double;
    procedure SetZoomMaxRY(NewValue: double);

    function GetThreeDThreshold: Integer;
    procedure SetThreeDThreshold(NewValue: Integer);

    function GetHotSpotSize: eHotSpotSize;
    procedure SetHotSpotSize(NewValue: eHotSpotSize);

    function GetAllowAxisLabelHotSpots: Boolean;
    procedure SetAllowAxisLabelHotSpots(NewValue: Boolean);

    function GetAllowAxisHotSpots: Boolean;
    procedure SetAllowAxisHotSpots(NewValue: Boolean);

    function GetBestFitFix: Boolean;
    procedure SetBestFitFix(NewValue: Boolean);

    function GetBoxPlotColor: TColor;
    procedure SetBoxPlotColor(NewValue: TColor);

    function GetAllowRibbon: Boolean;
    procedure SetAllowRibbon(NewValue: Boolean);

    function GetSpecialScalingY: eSpecialScaling;
    procedure SetSpecialScalingY(NewValue: eSpecialScaling);

    function GetSpecialScalingRY: eSpecialScaling;
    procedure SetSpecialScalingRY(NewValue: eSpecialScaling);

    function GetLogTickThreshold: Integer;
    procedure SetLogTickThreshold(NewValue: Integer);

    function GetBestFitCoeffs(nSubset: Integer; nPoint: Integer): Double;
    // Set Not Supported

    function GetSubsetDegree(nIndex: Integer): Integer;
    procedure SetSubsetDegree(nIndex: Integer; NewValue: Integer);

    function GetGraphAnnotationHotSpot(nIndex: Integer): Integer;
    procedure SetGraphAnnotationHotSpot(nIndex: Integer; NewValue: Integer);

    function GetAutoMinMaxPadding: Integer;
    procedure SetAutoMinMaxPadding(NewValue: Integer);

    function GetLegendLocation: eLegendLocation;
    procedure SetLegendLocation(NewValue: eLegendLocation);

    function GetNoGridLineMultiples: Boolean;
    procedure SetNoGridLineMultiples(NewValue: Boolean);

    function GetStartTime: Double;
    procedure SetStartTime(NewValue: Double);

    function GetEndTime: Double;
    procedure SetEndTime(NewValue: Double);

    function GetAxisFormatX: string;
    procedure SetAxisFormatX(NewValue: string);

    function GetAxisFormatTX: string;
    procedure SetAxisFormatTX(NewValue: string);

    function GetAllowContourLines: Boolean;
    procedure SetAllowContourLines(NewValue: Boolean);

    function GetAllowContourColors: Boolean;
    procedure SetAllowContourColors(NewValue: Boolean);

    function GetManualMinZ: Double;
    procedure SetManualMinZ(NewValue: Double);

    function GetManualMaxZ: Double;
    procedure SetManualMaxZ(NewValue: Double);

    function GetManualScaleControlZ: eManualScaleControl;
    procedure SetManualScaleControlZ(NewValue: eManualScaleControl);

    function GetManualZAxisLine: Double;
    procedure SetManualZAxisLine(NewValue: Double);

    function GetContourLineLabelDensity: Integer;
    procedure SetContourLineLabelDensity(NewValue: Integer);

    function GetSpecialDateTimeMode: Boolean;
    procedure SetSpecialDateTimeMode(NewValue: Boolean);

    function GetMaxDataPrecision: Integer;
    procedure SetMaxDataPrecision(NewValue: Integer);

    function GetAllowPage1: Boolean;
    procedure SetAllowPage1(NewValue: Boolean);

    function GetAllowPage2: Boolean;
    procedure SetAllowPage2(NewValue: Boolean);

    function GetAllowSubsetsPage: Boolean;
    procedure SetAllowSubsetsPage(NewValue: Boolean);

    function GetAllowFontPage: Boolean;
    procedure SetAllowFontPage(NewValue: Boolean);

    function GetAllowColorPage: Boolean;
    procedure SetAllowColorPage(NewValue: Boolean);

    function GetAllowStylePage: Boolean;
    procedure SetAllowStylePage(NewValue: Boolean);

    function GetAllowAxisPage: Boolean;
    procedure SetAllowAxisPage(NewValue: Boolean);

    function GetMinimumPointSize: eMinimumPointSize;
    procedure SetMinimumPointSize(NewValue: eMinimumPointSize);



  protected

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure WMCreate(var Message: TWMCreate); message WM_CREATE;
    procedure WMDestroy(var Message: TWMDestroy); message WM_DESTROY;

    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure WMLButtonDblClk(var Message: TWMLButtonDown); message WM_LBUTTONDBLCLK;
    procedure WMRButtonUp(var Message: TWMRButtonUp); message WM_RBUTTONUP;
    procedure WMKeyDown(var Message: TWMKeyDown); message WM_KEYDOWN;
    procedure WMKeyUp(var Message: TWMKeyUp); message WM_KEYUP;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMVScroll(var Message: TWMVScroll); message WM_VSCROLL;
    procedure WMHScroll(var Message: TWMHScroll); message WM_HSCROLL;
    procedure WMCommand(var Message: TWMCommand); message WM_COMMAND;
    procedure WMEraseBkGnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure WMWindowPosChanging(var Message: TWMWindowPosChanging); message WM_WINDOWPOSCHANGING;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure PEWMInvalidateRect(var Message: TMessage); message PEWM_INVALIDATERECT;

    procedure Loaded; virtual;

    { ProEssentials Unpublished Properties ////////////////////////////////////////////////////////// }
    property hObject: Integer read GethObject;
    property ObjectType: Integer read GetObjectType;
    property ScaleForXData: Integer read GetScaleForXData write SetScaleForXData;
    property ScaleForYData: Integer read GetScaleForYData write SetScaleForYData;
    property XData[nSubset: Integer; nPoint: Integer]: Single read GetXData write SetXData;
    property YData[nSubset: Integer; nPoint: Integer]: Single read GetYData write SetYData;
    property ZData[nSubset: Integer; nPoint: Integer]: Single read GetZData write SetZData;
    property SubsetLabels[nIndex: Integer]: string read GetSubsetLabels write SetSubsetLabels;
    property PointLabels [nIndex: Integer]: string read GetPointLabels write SetPointLabels;
    property ComparisonSubsets: Integer read GetComparisonSubsets write SetComparisonSubsets;
    property TreatCompsAsNormal: Boolean read GetTreatCompsAsNormal write SetTreatCompsAsNormal;
    property RandomSubsetsToGraph[nIndex: Integer]: Integer read GetRandomSubsetsToGraph write SetRandomSubsetsToGraph;
    property SubsetColors[nIndex: Integer]: TColor read GetSubsetColors write SetSubsetColors;
    property RYAxisComparisonSubsets: Integer read GetRYAxisComparisonSubsets write SetRYAxisComparisonSubsets;
    property ScaleForRYData: Integer read GetScaleForRYData write SetScaleForRYData;
    property SubsetPointTypes[nIndex: Integer]: Integer read GetSubsetPointTypes write SetSubsetPointTypes;
    property SubsetLineTypes[nIndex: Integer]: Integer read GetSubsetLineTypes write SetSubsetLineTypes;
    property DataPointLabels [nSubset: Integer; nPoint: Integer]: string read GetDataPointLabels write SetDataPointLabels;
    property PEactions: ePEactions read GetPEactions write SetPEactions;
    property PEnarg1: Integer read GetPEnarg1 write SetPEnarg1;
    property PEnarg2: Integer read GetPEnarg2 write SetPEnarg2;
    property PEstrarg1: string read GetPEstrarg1 write SetPEstrarg1;
    property CursorSubset: Integer read GetCursorSubset write SetCursorSubset;
    property CursorPoint: Integer read GetCursorPoint write SetCursorPoint;
    property GraphAnnotationX[nIndex: Integer]: Double read GetGraphAnnotationX write SetGraphAnnotationX;
    property GraphAnnotationY[nIndex: Integer]: Double read GetGraphAnnotationY write SetGraphAnnotationY;
    property GraphAnnotationText[nIndex: Integer]: string read GetGraphAnnotationText write SetGraphAnnotationText;
    property XAxisAnnotation[nIndex: Integer]: Double read GetXAxisAnnotation write SetXAxisAnnotation;
    property XAxisAnnotationText[nIndex: Integer]: string read GetXAxisAnnotationText write SetXAxisAnnotationText;
    property YAxisAnnotation[nIndex: Integer]: Double read GetYAxisAnnotation write SetYAxisAnnotation;
    property YAxisAnnotationText[nIndex: Integer]: string read GetYAxisAnnotationText write SetYAxisAnnotationText;
    property HorzLineAnnotation[nIndex: Integer]: Double read GetHorzLineAnnotation write SetHorzLineAnnotation;
    property HorzLineAnnotationText[nIndex: Integer]: string read GetHorzLineAnnotationText write SetHorzLineAnnotationText;
    property HorzLineAnnotationType[nIndex: Integer]: Integer read GetHorzLineAnnotationType write SetHorzLineAnnotationType;
    property HorzLineAnnotationColor[nIndex: Integer]: TColor read GetHorzLineAnnotationColor write SetHorzLineAnnotationColor;
    property VertLineAnnotation[nIndex: Integer]: Double read GetVertLineAnnotation write SetVertLineAnnotation;
    property VertLineAnnotationText[nIndex: Integer]: string read GetVertLineAnnotationText write SetVertLineAnnotationText;
    property VertLineAnnotationType[nIndex: Integer]: Integer read GetVertLineAnnotationType write SetVertLineAnnotationType;
    property VertLineAnnotationColor[nIndex: Integer]: TColor read GetVertLineAnnotationColor write SetVertLineAnnotationColor;
    property GraphAnnotationColor[nIndex: Integer]: TColor read GetGraphAnnotationColor write SetGraphAnnotationColor;
    property XAxisAnnotationColor[nIndex: Integer]: TColor read GetXAxisAnnotationColor write SetXAxisAnnotationColor;
    property YAxisAnnotationColor[nIndex: Integer]: TColor read GetYAxisAnnotationColor write SetYAxisAnnotationColor;
    property GraphAnnotationType[nIndex: Integer]: Integer read GetGraphAnnotationType write SetGraphAnnotationType;
    property SubsetsToLegend[nIndex: Integer]: Integer read GetSubsetsToLegend write SetSubsetsToLegend;
    property LegendAnnotationType[nIndex: Integer]: Integer read GetLegendAnnotationType write SetLegendAnnotationType;
    property LegendAnnotationText[nIndex: Integer]: string read GetLegendAnnotationText write SetLegendAnnotationText;
    property LegendAnnotationColor[nIndex: Integer]: TColor read GetLegendAnnotationColor write SetLegendAnnotationColor;
    property ZoomMode: Boolean read GetZoomMode write SetZoomMode;
    property ZoomMinX: Double read GetZoomMinX write SetZoomMinX;
    property ZoomMaxX: Double read GetZoomMaxX write SetZoomMaxX;
    property ZoomMinY: Double read GetZoomMinY write SetZoomMinY;
    property ZoomMaxY: Double read GetZoomMaxY write SetZoomMaxY;
    property VertScrollPos: Integer read GetVertScrollPos write SetVertScrollPos;
    property HorzScrollPos: Integer read GetHorzScrollPos write SetHorzScrollPos;
    property AllowDebugOutput: Boolean read GetAllowDebugOutput write SetAllowDebugOutput;
    property PointColors[nSubset: Integer; nPoint: Integer]: TColor read GetPointColors write SetPointColors;
    property MultiAxesSubsets[nIndex: Integer]: Integer read GetMultiAxesSubsets write SetMultiAxesSubsets;
    property GraphAnnotationAxis[nIndex: Integer]: Integer read GetGraphAnnotationAxis write SetGraphAnnotationAxis;
    property HorzLineAnnotationAxis[nIndex: Integer]: Integer read GetHorzLineAnnotationAxis write SetHorzLineAnnotationAxis;
    property MultiAxesProportions[nIndex: Integer]: Single read GetMultiAxesProportions write SetMultiAxesProportions;
    property LegendAnnotationAxis[nIndex: Integer]: Integer read GetLegendAnnotationAxis write SetLegendAnnotationAxis;
    property WorkingAxis: Integer read GetWorkingAxis write SetWorkingAxis;
    property UsingXDataII: Boolean read GetUsingXDataII write SetUsingXDataII;
    property UsingYDataII: Boolean read GetUsingYDataII write SetUsingYDataII;
    property DateTimeMode: eDateTimeMode read GetDateTimeMode write SetDateTimeMode;

    property TXAxisComparisonSubsets: Integer read GetTXAxisComparisonSubsets write SetTXAxisComparisonSubsets;
    property ScaleForTXData: Integer read GetScaleForTXData write SetScaleForTXData;

    property MultiSubTitles[nIndex: Integer]: string read GetMultiSubTitles write SetMultiSubTitles;
    property MultiBottomTitles[nIndex: Integer]: string read GetMultiBottomTitles write SetMultiBottomTitles;
    property SubsetByPoint: Boolean read GetSubsetByPoint write SetSubsetByPoint;
    property ZoomMinAxis: Integer read GetZoomMinAxis write SetZoomMinAxis;
    property ZoomMaxAxis: Integer read GetZoomMaxAxis write SetZoomMaxAxis;
    property YDataII[nSubset: Integer; nPoint: Integer]: Double read GetYDataII write SetYDataII;
    property XDataII[nSubset: Integer; nPoint: Integer]: Double read GetXDataII write SetXDataII;
    property AutoScaleData: Boolean read GetAutoScaleData write SetAutoScaleData;
    property OverlapMultiAxes[nIndex: Integer]: Integer read GetOverlapMultiAxes write SetOverlapMultiAxes;

    property ArrowCursor: Integer read GetArrowCursor write SetArrowCursor;
    property HandCursor: Integer read GetHandCursor write SetHandCursor;
    property ZoomCursor: Integer read GetZoomCursor write SetZoomCursor;
    property NoDropCursor: Integer read GetNoDropCursor write SetNoDropCursor;

    property SubsetShades[nIndex: Integer]: TColor read GetSubsetShades write SetSubsetShades;
    property Custom: Boolean read GetCustom write SetCustom;
    property CacheBmp: Boolean read GetCacheBmp write SetCacheBmp;
    property Painting: Boolean read GetPainting;

    property BestFitCoeffs[nSubset: Integer; nPoint: Integer]: Double read GetBestFitCoeffs;
    property SubsetDegree[nIndex: Integer]: Integer read GetSubsetDegree write SetSubsetDegree;
    property GraphAnnotationHotSpot[nIndex: Integer]: Integer read GetGraphAnnotationHotSpot write SetGraphAnnotationHotSpot;
   

  published
    { Standard Published Properties //////////////////////////////////////////////////////////////// }
    property Left;
    property Top;
    property Width;
    property Height;
    property Hint;
    property HelpContext;
    property Tag;
    property ShowHint;
    property TabStop;
    property Visible;
    property TabOrder;
    property ParentShowHint;
    property Enabled;
    property Cursor;
    property DragCursor;
    property DragMode;
    property Name;
    property Align;

    { ProEssentials Published Properties ///////////////////////////////////////////////////////////// }
    property ViewingStyle: eViewingStyle read GetViewingStyle write SetViewingStyle;
    property PrepareImages: Boolean  read GetPrepareImages write SetPrepareImages;
    property GraphForeColor: TColor read GetGraphForeColor write SetGraphForeColor;
    property GraphBackColor: TColor read GetGraphBackColor write SetGraphBackColor;
    property DeskColor: TColor read GetDeskColor write SetDeskColor;
    property TextColor: TColor read GetTextColor write SetTextColor;
    property ShadowColor: TColor read GetShadowColor write SetShadowColor;
    property MainTitle: string read GetMainTitle write SetMainTitle;
    property SubTitle: string read GetSubTitle write SetSubTitle;
    property Subsets: Integer  read GetSubsets write SetSubsets;
    property Points: Integer  read GetPoints write SetPoints;
    property DataPrecision: eDataPrecision read GetDataPrecision write SetDataPrecision;
    property AllowCustomization: Boolean  read GetAllowCustomization write SetAllowCustomization;
    property AllowExporting: Boolean  read GetAllowExporting write SetAllowExporting;
    property AllowMaximization: Boolean  read GetAllowMaximization write SetAllowMaximization;
    property AllowPopup: Boolean  read GetAllowPopup write SetAllowPopup;
    property AllowUserInterface: eAllowUserInterface  read GetAllowUserInterface write SetAllowUserInterface;
    property FontSize: eFontSize read GetFontSize write SetFontSize;
    property MainTitleFont: string read GetMainTitleFont write SetMainTitleFont;
    property MainTitleBold: Boolean read GetMainTitleBold write SetMainTitleBold;
    property MainTitleItalic: Boolean read GetMainTitleItalic write SetMainTitleItalic;
    property MainTitleUnderline: Boolean read GetMainTitleUnderline write SetMainTitleUnderline;
    property SubTitleFont: string read GetSubTitleFont write SetSubTitleFont;
    property SubTitleBold: Boolean read GetSubTitleBold write SetSubTitleBold;
    property SubTitleItalic: Boolean read GetSubTitleItalic write SetSubTitleItalic;
    property SubTitleUnderline: Boolean read GetSubTitleUnderline write SetSubTitleUnderline;
    property LabelFont: string read GetLabelFont write SetLabelFont;
    property LabelBold: Boolean read GetLabelBold write SetLabelBold;
    property LabelItalic: Boolean read GetLabelItalic write SetLabelItalic;
    property LabelUnderline: Boolean read GetLabelUnderline write SetLabelUnderline;
    property XAxisLabel: string read GetXAxisLabel write SetXAxisLabel;
    property YAxisLabel: string read GetYAxisLabel write SetYAxisLabel;
    property ScrollingSubsets: Integer read GetScrollingSubsets write SetScrollingSubsets;
    property VBoundaryTypes: eVBoundaryTypes read GetVBoundaryTypes write SetVBoundaryTypes;
    property UpperBoundValue: Double read GetUpperBoundValue write SetUpperBoundValue;
    property LowerBoundValue: Double read GetLowerBoundValue write SetLowerBoundValue;
    property UpperBoundText: string read GetUpperBoundText write SetUpperBoundText;
    property LowerBoundText: string read GetLowerBoundText write SetLowerBoundText;
    property XAxisScaleControl: eAxisScaleControl read GetXAxisScaleControl write SetXAxisScaleControl;
    property YAxisScaleControl: eAxisScaleControl read GetYAxisScaleControl write SetYAxisScaleControl;
    property PlottingMethod: ePlottingMethod read GetPlottingMethod write SetPlottingMethod;
    property GridLineControl: eGridLineControl read GetGridLineControl write SetGridLineControl;
    property GridInFront: Boolean read GetGridInFront write SetGridInFront;
    property NoScrollingSubsetControl: Boolean read GetNoScrollingSubsetControl write SetNoScrollingSubsetControl;
    property GraphDataLabels: Boolean read GetGraphDataLabels write SetGraphDataLabels;
    property DataShadows: eDataShadows read GetDataShadows write SetDataShadows;
    property MonoWithSymbols: Boolean read GetMonoWithSymbols write SetMonoWithSymbols;
    property ThreeDDialogs: Boolean read GetThreeDDialogs write SetThreeDDialogs;
    property DefOrientation: eDefOrientation read GetDefOrientation write SetDefOrientation;
    property ManualScaleControlY: eManualScaleControl read GetManualScaleControlY write SetManualScaleControlY;
    property ManualMinY: Double read GetManualMinY write SetManualMinY;
    property ManualMaxY: Double read GetManualMaxY write SetManualMaxY;
    property ManualScaleControlX: eManualScaleControl read GetManualScaleControlX write SetManualScaleControlX;
    property ManualMinX: Double read GetManualMinX write SetManualMinX;
    property ManualMaxX: Double read GetManualMaxX write SetManualMaxX;
    property AllowSubsetHotSpots: Boolean read GetAllowSubsetHotSpots write SetAllowSubsetHotSpots;
    property AllowGraphHotSpots: Boolean read GetAllowGraphHotSpots write SetAllowGraphHotSpots;
    property AllowDataHotSpots: Boolean read GetAllowDataHotSpots write SetAllowDataHotSpots;
    property AllowCoordPrompting: Boolean read GetAllowCoordPrompting write SetAllowCoordPrompting;
    property MarkDataPoints: Boolean read GetMarkDataPoints write SetMarkDataPoints;

    property RYAxisLabel: string read GetRYAxisLabel write SetRYAxisLabel;
    property RYAxisScaleControl: eAxisScaleControl read GetRYAxisScaleControl write SetRYAxisScaleControl;
    property ManualScaleControlRY: eManualScaleControl read GetManualScaleControlRY write SetManualScaleControlRY;
    property ManualMinRY: Double read GetManualMinRY write SetManualMinRY;
    property ManualMaxRY: Double read GetManualMaxRY write SetManualMaxRY;
    property AllowPlotCustomization: Boolean read GetAllowPlotCustomization write SetAllowPlotCustomization;
    property AllowBubble: Boolean read GetAllowBubble write SetAllowBubble;
    property AllowBestFitCurve: Boolean read GetAllowBestFitCurve write SetAllowBestFitCurve;
    property AllowSpline: Boolean read GetAllowSpline write SetAllowSpline;
    property NegativeFromXAxis: Boolean read GetNegativeFromXAxis write SetNegativeFromXAxis;
    property ManualXAxisTicknLine: Boolean read GetManualXAxisTicknLine write SetManualXAxisTicknLine;
    property ManualYAxisTicknLine: Boolean read GetManualYAxisTicknLine write SetManualYAxisTicknLine;
    property ManualRYAxisTicknLine: Boolean read GetManualRYAxisTicknLine write SetManualRYAxisTicknLine;
    property BubbleSize: eBubbleSize read GetBubbleSize write SetBubbleSize;
    property SpecificPlotMode: eSpecificPlotMode read GetSpecificPlotMode write SetSpecificPlotMode;
    property PointSize: ePointSize read GetPointSize write SetPointSize;
    property BestFitDegree: eBestFitDegree read GetBestFitDegree write SetBestFitDegree;
    property CurveGranularity: eCurveGranularity read GetCurveGranularity write SetCurveGranularity;
    property AllowDataLabels: eAllowDataLabels read GetAllowDataLabels write SetAllowDataLabels;
    property ManualXAxisTick: Double read GetManualXAxisTick write SetManualXAxisTick;
    property ManualXAxisLine: Double read GetManualXAxisLine write SetManualXAxisLine;
    property ManualYAxisTick: Double read GetManualYAxisTick write SetManualYAxisTick;
    property ManualYAxisLine: Double read GetManualYAxisLine write SetManualYAxisLine;
    property ManualRYAxisTick: Double read GetManualRYAxisTick write SetManualRYAxisTick;
    property ManualRYAxisLine: Double read GetManualRYAxisLine write SetManualRYAxisLine;
    property NullDataValueX: Double read GetNullDataValueX write SetNullDataValueX;
    property NullDataValueY: Double read GetNullDataValueY write SetNullDataValueY;
    property AllowLine: Boolean read GetAllowLine write SetAllowLine;
    property AllowStick: Boolean read GetAllowStick write SetAllowStick;
    property AllowBar: Boolean read GetAllowBar write SetAllowBar;
    property AllowPoint: Boolean read GetAllowPoint write SetAllowPoint;
    property AllowArea: Boolean read GetAllowArea write SetAllowArea;
    property AllowBestFitLine: Boolean read GetAllowBestFitLine write SetAllowBestFitLine;
    property AllowZooming: eAllowZooming read GetAllowZooming write SetAllowZooming;
    property ForceRightYAxis: Boolean read GetForceRightYAxis write SetForceRightYAxis;
    property AllowPointsPlusLine: Boolean read GetAllowPointsPlusLine write SetAllowPointsPlusLine;
    property AllowPointsPlusSpline: Boolean read GetAllowPointsPlusSpline write setAllowPointsPlusSpline;
    property SymbolFrequency: eSymbolFrequency read GetSymbolFrequency write SetSymbolFrequency;

    property ScrollingHorzZoom: Boolean read GetScrollingHorzZoom write SetScrollingHorzZoom;
    property CursorMode: eCursorMode read GetCursorMode write SetCursorMode;
    property CursorPromptStyle: eCursorPromptStyle read GetCursorPromptStyle write SetCursorPromptStyle;
    property CursorPromptTracking: Boolean read GetCursorPromptTracking write SetCursorPromptTracking;
    property MouseCursorControl: Boolean read GetMouseCursorControl write SetMouseCursorControl;
    property ShowAnnotations: Boolean read GetShowAnnotations write SetShowAnnotations;
    property AllowGraphAnnotHotSpots: Boolean read GetAllowGraphAnnotHotSpots write SetAllowGraphAnnotHotSpots;
    property GraphAnnotationTextSize: Integer read GetGraphAnnotationTextSize write SetGraphAnnotationTextSize;
    property AllowAnnotationControl: Boolean read GetAllowAnnotationControl write SetAllowAnnotationControl;
    property AnnotationsInFront: Boolean read GetAnnotationsInFront write SetAnnotationsInFront;

    property NoRandomPointsToExport: Boolean read GetNoRandomPointsToExport write SetNoRandomPointsToExport;
    property CursorPageAmount: Integer read GetCursorPageAmount write SetCursorPageAmount;
    property XAxisVertNumbering: Boolean read GetXAxisVertNumbering write SetXAxisVertNumbering;
    property LineGapThreshold: Double read GetLineGapThreshold write SetLineGapThreshold;

    property ShowGraphAnnotations: Boolean read GetShowGraphAnnotations write SetShowGraphAnnotations;
    property ShowXAxisAnnotations: Boolean read GetShowXAxisAnnotations write SetShowXAxisAnnotations;
    property ShowYAxisAnnotations: Boolean read GetShowYAxisAnnotations write SetShowYAxisAnnotations;
    property ShowHorzLineAnnotations: Boolean read GetShowHorzLineAnnotations write SetShowHorzLineAnnotations;
    property ShowVertLineAnnotations: Boolean read GetShowVertLineAnnotations write SetShowVertLineAnnotations;
    property AllowXAxisAnnotHotSpots: Boolean read GetAllowXAxisAnnotHotSpots write SetAllowXAxisAnnotHotSpots;
    property AllowYAxisAnnotHotSpots: Boolean read GetAllowYAxisAnnotHotSpots write SetAllowYAxisAnnotHotSpots;
    property AllowHorzLineAnnotHotSpots: Boolean read GetAllowHorzLineAnnotHotSpots write SetAllowHorzLineAnnotHotSpots;
    property AllowVertLineAnnotHotSpots: Boolean read GetAllowVertLineAnnotHotSpots write SetAllowVertLineAnnotHotSpots;

    property AxesAnnotationTextSize: Integer read GetAxesAnnotationTextSize write SetAxesAnnotationTextSize;
    property LineAnnotationTextSize: Integer read GetLineAnnotationTextSize write SetLineAnnotationTextSize;

    property ZoomInterfaceOnly: eZoomInterfaceOnly read GetZoomInterfaceOnly write SetZoomInterfaceOnly;
    property VertOrient90Degrees: Boolean read GetVertOrient90Degrees write SetVertOrient90Degrees;
    property LogScaleExpLabels: Boolean read GetLogScaleExpLabels write SetLogScaleExpLabels;
    property PlottingMethodII: ePlottingMethodII read GetPlottingMethodII write SetPlottingMethodII;
    property BarWidth: Double read GetBarWidth write SetBarWidth;

    property TXAxisLabel: string read GetTXAxisLabel write SetTXAxisLabel;
    property TXAxisScaleControl: eAxisScaleControl read GetTXAxisScaleControl write SetTXAxisScaleControl;
    property ManualScaleControlTX: eManualScaleControl read GetManualScaleControlTX write SetManualScaleControlTX;
    property ManualMinTX: Double read GetManualMinTX write SetManualMinTX;
    property ManualMaxTX: Double read GetManualMaxTX write SetManualMaxTX;
    property ManualTXAxisTicknLine: Boolean read GetManualTXAxisTicknLine write SetManualTXAxisTicknLine;
    property ManualTXAxisTick: Double read GetManualTXAxisTick write SetManualTXAxisTick;
    property ManualTXAxisLine: Double read GetManualTXAxisLine write SetManualTXAxisLine;
    property ForceTopXAxis: Boolean read GetForceTopXAxis write SetForceTopXAxis;

    property XAxisOnTop: Boolean read GetXAxisOnTop write SetXAxisOnTop;
    property YAxisOnRight: Boolean read GetYAxisOnRight write SetYAxisOnRight;
    property FocalRect: Boolean read GetFocalRect write SetFocalRect;
    property FontSizeGlobalCntl: Single read GetFontSizeGlobalCntl write SetFontSizeGlobalCntl;
    property FontSizeTitleCntl: Single read GetFontSizeTitleCntl write SetFontSizeTitleCntl;
    property ShowYAxis: eShowAxis read GetShowYAxis write SetShowYAxis;
    property ShowRYAxis: eShowAxis read GetShowRYAxis write SetShowRYAxis;
    property ShowXAxis: eShowAxis read GetShowXAxis write SetShowXAxis;
    property ShowTXAxis: eShowAxis read GetShowTXAxis write SetShowTXAxis;

    property GridStyle: eGridStyle read GetGridStyle write SetGridStyle;
    property InvertedYAxis: Boolean read GetInvertedYAxis write SetInvertedYAxis;
    property InvertedRYAxis: Boolean read GetInvertedRYAxis write SetInvertedRYAxis;

    property InvertedXAxis: Boolean read GetInvertedXAxis write SetInvertedXAxis;
    property InvertedTXAxis: Boolean read GetInvertedTXAxis write SetInvertedTXAxis;

    property YAxisColor: TColor read GetYAxisColor write SetYAxisColor;
    property RYAxisColor: TColor read GetRYAxisColor write SetRYAxisColor;
    property XAxisColor: TColor read GetXAxisColor write SetXAxisColor;
    property TXAxisColor: TColor read GetTXAxisColor write SetTXAxisColor;

    property FontSizeLegendCntl: Single read GetFontSizeLegendCntl write SetFontSizeLegendCntl;
    property YAxisLongTicks: Boolean read GetYAxisLongTicks write SetYAxisLongTicks;
    property RYAxisLongTicks: Boolean read GetRYAxisLongTicks write SetRYAxisLongTicks;

    property XAxisLongTicks: Boolean read GetXAxisLongTicks write SetXAxisLongTicks;
    property TXAxisLongTicks: Boolean read GetTXAxisLongTicks write SetTXAxisLongTicks;

    property MultiAxesSeparators: eMultiAxesSeparators read GetMultiAxesSeparators write SetMultiAxesSeparators;

    property LeftMargin: string read GetLeftMargin write SetLeftMargin;
    property TopMargin: string read GetTopMargin write SetTopMargin;
    property RightMargin: string read GetRightMargin write SetRightMargin;
    property BottomMargin: string read GetBottomMargin write SetBottomMargin;
    property AllowOleExport: Boolean read GetAllowOleExport write SetAllowOleExport;

    property NoCustomParms: Boolean read GetNoCustomParms write SetNoCustomParms;
    property NoHelp: Boolean read GetNoHelp write SetNoHelp;
    property AllowTitleHotSpots: Boolean read GetAllowTitleHotSpots write SetAllowTitleHotSpots;
    property AllowSubTitleHotSpots: Boolean read GetAllowSubTitleHotSpots write SetAllowSubTitleHotSpots;
    property AllowBottomTitleHotSpots: Boolean read GetAllowBottomTitleHotSpots write SetAllowBottomTitleHotSpots;
    property AllowJpegOutput: Boolean read GetAllowJpegOutput write SetAllowJpegOutput;
    property HelpFileName: string read GetHelpFileName write SetHelpFileName;

    property DataHotSpotLimit: Integer read GetDataHotSpotLimit write SetDataHotSpotLimit;
    property HourGlassThreshold: Integer read GetHourGlassThreshold write SetHourGlassThreshold;
    property NoHiddenLinesInArea: Boolean read GetNoHiddenLinesInArea write SetNoHiddenLinesInArea;
    property SpecificPlotModeColor: Boolean read GetSpecificPlotModeColor write SetSpecificPlotModeColor;
    property LogicalLimit: Integer read GetLogicalLimit write SetLogicalLimit;
    property NullDataGaps: Boolean read GetNullDataGaps write SetNullDataGaps;
    property AllowStep: Boolean read GetAllowStep write SetAllowStep;
    property ScrollingVertZoom: Boolean read GetScrollingVertZoom write SetScrollingVertZoom;
    property AxisFormatY: string read GetAxisFormatY write SetAxisFormatY;
    property AxisFormatRY: string read GetAxisFormatRY write SetAxisFormatRY;
    property ZoomMinRY: double read GetZoomMinRY write SetZoomMinRY;
    property ZoomMaxRY: double read GetZoomMaxRY write SetZoomMaxRY;
    property ThreeDThreshold: Integer read GetThreeDThreshold write SetThreeDThreshold;
    property HotSpotSize: eHotSpotSize read GetHotSpotSize write SetHotSpotSize;
    property AllowAxisLabelHotSpots: Boolean read GetAllowAxisLabelHotSpots write SetAllowAxisLabelHotSpots;
    property AllowAxisHotSpots: Boolean read GetAllowAxisHotSpots write SetAllowAxisHotSpots;
    property BestFitFix: Boolean read GetBestFitFix write SetBestFitFix;
    property BoxPlotColor: TColor read GetBoxPlotColor write SetBoxPlotColor;
    property AllowRibbon: Boolean read GetAllowRibbon write SetAllowRibbon;
    property SpecialScalingY: eSpecialScaling read GetSpecialScalingY write SetSpecialScalingY;
    property SpecialScalingRY: eSpecialScaling read GetSpecialScalingRY write SetSpecialScalingRY;
    property LogTickThreshold: Integer read GetLogTickThreshold write SetLogTickThreshold;

    property AutoMinMaxPadding: Integer read GetAutoMinMaxPadding write SetAutoMinMaxPadding;
    property LegendLocation: eLegendLocation read GetLegendLocation write SetLegendLocation;
    property NoGridLineMultiples: Boolean read GetNoGridLineMultiples write SetNoGridLineMultiples;

    property StartTime: Double read GetStartTime write SetStartTime;
    property EndTime: Double read GetEndTime write SetEndTime;

    property AxisFormatX: string read GetAxisFormatX write SetAxisFormatX;
    property AxisFormatTX: string read GetAxisFormatTX write SetAxisFormatTX;
    property AllowContourLines: Boolean read GetAllowContourLines write SetAllowContourLines;
    property AllowContourColors: Boolean read GetAllowContourColors write SetAllowContourColors;
    property ManualMinZ: Double read GetManualMinZ write SetManualMinZ;
    property ManualMaxZ: Double read GetManualMaxZ write SetManualMaxZ;
    property ManualScaleControlZ: eManualScaleControl read GetManualScaleControlZ write SetManualScaleControlZ;
    property ManualZAxisLine: Double read GetManualZAxisLine write SetManualZAxisLine;
    property ContourLineLabelDensity: Integer read GetContourLineLabelDensity write SetContourLineLabelDensity;
    property SpecialDateTimeMode: Boolean read GetSpecialDateTimeMode write SetSpecialDateTimeMode;

    property MaxDataPrecision: Integer read GetMaxDataPrecision write SetMaxDataPrecision;
    property AllowPage1: Boolean read GetAllowPage1 write SetAllowPage1;
    property AllowPage2: Boolean read GetAllowPage2 write SetAllowPage2;
    property AllowSubsetsPage: Boolean read GetAllowSubsetsPage write SetAllowSubsetsPage;
    property AllowFontPage: Boolean read GetAllowFontPage write SetAllowFontPage;
    property AllowColorPage: Boolean read GetAllowColorPage write SetAllowColorPage;
    property AllowStylePage: Boolean read GetAllowStylePage write SetAllowStylePage;
    property AllowAxisPage: Boolean read GetAllowAxisPage write SetAllowAxisPage;
    property MinimumPointSize: eMinimumPointsize read GetMinimumPointSize write SetMinimumPointSize;

    { Standard Published Events //////////////////////////////////////////////////////////////// }
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnEnter;
    property OnKeyUp;
    property OnKeyDown;
    property OnExit;
    property OnKeyPress;

    { ProEssentials Published Events //////////////////////////////////////////////////////////////// }
    property OnParamUpdate: TNotifyEvent read FOnParamUpdate write FOnParamUpdate;
    property OnVertScroll: TScrollEvent read FOnVertScroll write FOnVertScroll;
    property OnHorzScroll: TScrollEvent read FOnHorzScroll write FOnHorzScroll;
    property OnCursorMoved: TNotifyEvent read FOnCursorMoved write FOnCursorMoved;
    property OnZoomIn: TNotifyEvent read FOnZoomIn write FOnZoomIn;
    property OnZoomOut: TNotifyEvent read FOnZoomOut write FOnZoomOut;
    property OnSubsetHotSpot: TSubsetHotSpot read FOnSubsetHotSpot write FOnSubsetHotSpot;
    property OnDataHotSpot: TDataHotSpot read FOnDataHotSpot write FOnDataHotSpot;
    property OnGraphHotSpot: TGraphHotSpot read FOnGraphHotSpot write FOnGraphHotSpot;
    property OnGraphAnnotHotSpot: TAnnotHotSpot read FOnGraphAnnotHotSpot write FOnGraphAnnotHotSpot;
    property OnXAxisAnnotHotSpot: TAnnotHotSpot read FOnXAxisAnnotHotSpot write FOnXAxisAnnotHotSpot;
    property OnYAxisAnnotHotSpot: TAnnotHotSpot read FOnYAxisAnnotHotSpot write FOnYAxisAnnotHotSpot;
    property OnHorzLineAnnotHotSpot: TAnnotHotSpot read FOnHorzLineAnnotHotSpot write FOnHorzLineAnnotHotSpot;
    property OnVertLineAnnotHotSpot: TAnnotHotSpot read FOnVertLineAnnotHotSpot write FOnVertLineAnnotHotSpot;
    property OnPreCursorMove: TNotifyEvent read FOnPreCursorMove write FOnPreCursorMove;

    property OnCustomizeDlg: TNotifyEvent read FOnCustomizeDlg write FOnCustomizeDlg;
    property OnPopupMenu: TNotifyEvent read FOnPopupMenu write FOnPopupMenu;

    property OnMainTitle: TTitle read FOnMainTitle write FOnMainTitle;
    property OnSubTitle: TTitle read FOnSubTitle write FOnSubTitle;
    property OnMultiSubTitle: TMultiTitle read FOnMultiSubTitle write FOnMultiSubTitle;
    property OnMultiBottomTitle: TMultiTitle read FOnMultiBottomTitle write FOnMultiBottomTitle;
    property OnYAxisLabel: TYAxisLabel read FOnYAxisLabel write FOnYAxisLabel;
    property OnXAxisLabel: TXAxisLabelEvent read FOnXAxisLabel write FOnXAxisLabel;
    property OnYAxis: TYAxis read FOnYAxis write FOnYAxis;
    property OnXAxis: TXAxis read FOnXAxis write FOnXAxis;

  end;

procedure Register;

implementation

{ /////////////////////////////////////////////////////////////////////////////////////////////// }
{ /////////////////////////////////////////////////////////////////////////////////////////////// }
{ PESGraph Function Interfaces /////////////////////////////////////////////////////////////////// }
{ /////////////////////////////////////////////////////////////////////////////////////////////// }
{ /////////////////////////////////////////////////////////////////////////////////////////////// }

procedure Register;
begin
  RegisterComponents('Additional', [PESGraph]);
end;

constructor PESGraph.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     hObj := 0;
     bPEcreated := False;

     tmpPEnarg1 := 0;
     tmpPEnarg2 := 0;
     tmpPEstrarg1 := '';

     r := Rect(0, 0, 300, 300);
     hObj := PEcreate(PECONTROL_SGRAPH, 0, @r, 0, 12111);
end;

destructor PESGraph.Destroy;
begin
     if (hObj <> 0) then
     begin
          PEdestroy(hObj);
          hObj := 0;
          bPEcreated := False;
     end;
     inherited Destroy;
end;

procedure PESGraph.Loaded;
begin
     inherited Loaded;

     PEreinitialize(hObj);
     PEresetimage(hObj, 0, 0);
     Invalidate;
end;

procedure PESGraph.WMCreate(var Message: TWMCreate);
var
    hTemp: hWnd;
    dwStyle: Longint;
    nID: Integer;
begin
    inherited;
    if (bPEcreated = True) then Exit;

    r := GetClientRect;
    dwStyle := 0;
    nID := 100;

    hTemp := PEcreate(Integer(hObj), dwStyle, @r, Handle, nID);
    if (hTemp <> 0) then
    begin
         PEnset(hTemp, PEP_hwndPARENTALCONTROL, Handle);
         hObj := hTemp;
         PEreinitialize(hObj);
	 PEresetimage(hObj, 0, 0);
 	 bPEcreated := True;
         ShowWindow(hObj, SW_HIDE);
    end;
end;

procedure PESGraph.WMDestroy(var Message: TWMDestroy);
begin
    if (hObj <> 0) then
    begin
       PEdestroy(hObj);
       hObj := 0;
       bPEcreated := False;
    end;
   inherited;
end;

procedure PESGraph.WMPaint(var Message: TWMPaint);
{$IFDEF WIN32}
var
   oldsize: TSize;
{$ENDIF}
begin
    if (hObj <> 0) then
    begin
    	 if (PEnget(hObj, PEP_bPAINTING) <> 0) then Exit;
	 PEnset(hObj, PEP_bPAINTING, 1);

         hMemDC := 0;
         hMemBitmap := 0;
         hMeta := PEgetmeta(hObj);
         r := GetClientRect;
         BeginPaint(Handle, ps);

         bPrepareImages := PEnget(hObj, PEP_bPREPAREIMAGES);
         bSizeAltered := PEnget(hObj, PEP_bINVALID);

         bCacheBmp := PEnget(hObj, PEP_bCACHEBMP);

         if (bPrepareImages <> 0) then
         begin
             if (bCacheBmp <> 0) then
             begin
	        hMemBitmap := PEnget(hObj, PEP_hMEMBITMAP);
	        if ((hMemBitmap = 0) or (bSizealtered <> 0)) then
	            PEallocateindmemory(hObj);
	        hMemDC := PEnget(hObj, PEP_hMEMDC);
             end
             else
             begin
                 hMemDC := CreateCompatibleDC(ps.hdc);
	         SetMapMode(hMemDC, MM_ANISOTROPIC);
    	         hMemBitmap := CreateCompatibleBitmap(ps.hdc, r.right, r.bottom);
             end;
         end;

         if ((bPrepareImages <> 0) and (hMemDC <> 0)) then
         begin
             if (bCacheBmp <> 0) then
	        hMemBitmap := PEnget(hObj, PEP_hMEMBITMAP);

             hTmpBmp := SelectObject(hMemDC, hMemBitmap);

             if ((bCacheBmp = 0) or ((bCacheBmp <> 0) and (bSizeAltered <> 0))) then
             begin
{$IFDEF WIN32}
                 SetViewportExtEx(hMemDC, r.right, r.bottom, @oldsize);
{$ELSE}
                 SetViewportExt(hMemDC, r.right, r.bottom);
{$ENDIF}
                 if (hMeta <> 0) then PlayMetaFile(hMemDC, hMeta);
{$IFDEF WIN32}
                 SetViewportExtEx(ps.hdc, r.right, r.bottom, @oldsize);
{$ELSE}
                 SetViewportExt(ps.hdc, r.right, r.bottom);
{$ENDIF}
             end;

             StretchBlt(ps.hdc, 0, 0, r.right, r.bottom, hMemDC, 0, 0, 5000, 5000, SRCCOPY);
             SelectObject(hMemDC, hTmpBmp);
             bSizeAltered := 0;
             PEnset(hObj, PEP_bINVALID, bSizeAltered);

             if (bCacheBmp = 0) then
             begin
                 if (hMemDC <> 0) then DeleteDC(hMemDC);
        	 if (hMemBitmap <> 0) then DeleteObject(hMemBitmap);
             end;
        end
        else
        begin
            nOldMode := SetMapMode(ps.hdc, MM_ANISOTROPIC);
{$IFDEF WIN32}
            SetViewportExtEx(ps.hdc, r.right, r.bottom, @oldsize);
{$ELSE}
            SetViewportExt(ps.hdc, r.right, r.bottom);
{$ENDIF}
            if (hMeta <> 0) then PlayMetaFile(ps.hdc, hMeta);
            SetMapMode(ps.hdc, nOldMode);
        end;

        if ((GetFocus = Handle) and (PEnget(hObj, PEP_bFOCALRECT) <> 0)) then
        begin
           nOldROP2 := SetROP2(ps.hdc, R2_NOT);
           nOldMode := SetMapMode(ps.hdc, MM_TEXT);
           tpts[0].x := r.left;
           tpts[0].y := r.top;
           tpts[1].x := r.right - 1;
           tpts[1].y := r.top;
           tpts[2].x := r.right - 1;
           tpts[2].y := r.bottom - 1;
           tpts[3].x := r.left;
           tpts[3].y := r.bottom-1;
           tpts[4].x := r.left;
           tpts[4].y := r.top;
           PolyLine(ps.hdc, tpts, 5);
           SetROP2(ps.hdc, nOldROP2);
           SetMapMode(ps.hdc, nOldMode);
        end;

        PEdrawcursor(hObj, ps.hdc, 0);
        EndPaint(HANDLE, ps);
        PEnset(hObj, PEP_bPAINTING, 0);
    end;
end;

procedure PESGraph.WMCommand(var Message: TWMCommand);
begin
   tmsg := TMessage (Message);

{$IFDEF WIN32}
   if ((tmsg.LParam = hObj) and (HIWORD(tmsg.WParam) = PEWN_ZOOMIN)) then
   begin
{$ELSE}
   if ((LOWORD(tmsg.LParam) = hObj) and (HIWORD(tmsg.LParam) = PEWN_ZOOMIN)) then
   begin
{$ENDIF}
        if Assigned(FOnZoomIn) then OnZoomIn(Self);
   end;
{$IFDEF WIN32}
   if ((tmsg.LParam = hObj) and (HIWORD(tmsg.WParam) = PEWN_ZOOMOUT)) then
   begin
{$ELSE}
   if ((LOWORD(tmsg.LParam) = hObj) and (HIWORD(tmsg.LParam) = PEWN_ZOOMOUT)) then
   begin
{$ENDIF}
        if Assigned(FOnZoomOut) then OnZoomOut(Self);
   end;
{$IFDEF WIN32}
   if ((tmsg.LParam = hObj) and (HIWORD(tmsg.WParam) = PEWN_CURSORMOVED)) then
   begin
{$ELSE}
   if ((LOWORD(tmsg.LParam) = hObj) and (HIWORD(tmsg.LParam) = PEWN_CURSORMOVED)) then
   begin
{$ENDIF}
        if Assigned(FOnCursorMoved) then OnCursorMoved(Self);
   end;
{$IFDEF WIN32}
   if ((tmsg.LParam = hObj) and (HIWORD(tmsg.WParam) = PEWN_PRECURSORMOVE)) then
   begin
{$ELSE}
   if ((LOWORD(tmsg.LParam) = hObj) and (HIWORD(tmsg.LParam) = PEWN_PRECURSORMOVE)) then
   begin
{$ENDIF}
        if Assigned(FOnPreCursorMove) then OnPreCursorMove(Self);
   end;

{$IFDEF WIN32}
   if ((tmsg.LParam = hObj) and (HIWORD(tmsg.WParam) = PEWN_CUSTOMIZEDLG)) then
   begin
{$ELSE}
   if ((LOWORD(tmsg.LParam) = hObj) and (HIWORD(tmsg.LParam) = PEWN_CUSTOMIZEDLG)) then
   begin
{$ENDIF}
        if Assigned(FOnCustomizeDlg) then OnCustomizeDlg(Self);
   end;

{$IFDEF WIN32}
   if ((tmsg.LParam = hObj) and (HIWORD(tmsg.WParam) = PEWN_POPUPMENU)) then
   begin
{$ELSE}
   if ((LOWORD(tmsg.LParam) = hObj) and (HIWORD(tmsg.LParam) = PEWN_POPUPMENU)) then
   begin
{$ENDIF}
        if Assigned(FOnPopupMenu) then OnPopupMenu(Self);
   end;

{$IFDEF WIN32}
   if ((tmsg.LParam = hObj) and (HIWORD(tmsg.WParam) = PEWN_CHANGINGPARMS)) then
   begin
{$ELSE}
   if ((LOWORD(tmsg.LParam) = hObj) and (HIWORD(tmsg.LParam) = PEWN_CHANGINGPARMS)) then
   begin
{$ENDIF}
       GetScrollRange(hObj, SB_VERT, min, max);
       if (min = 1) then
       begin
           SetScrollRange(Handle, SB_VERT, min, max, FALSE);
           pos := GetScrollPos(hObj, SB_VERT);
           SetScrollPos(Handle, SB_VERT, pos, TRUE);
       end
       else
       begin
           SetScrollRange(Handle, SB_VERT, 0, 0, FALSE);
           SetScrollPos(Handle, SB_VERT, 0, TRUE);
       end;

       GetScrollRange(hObj, SB_HORZ, min, max);
       if (min = 1) then
       begin
           SetScrollRange(Handle, SB_HORZ, min, max, FALSE);
           pos := GetScrollPos(hObj, SB_HORZ);
           SetScrollPos(Handle, SB_HORZ, pos, TRUE);
       end
       else
       begin
           SetScrollRange(Handle, SB_HORZ, 0, 0, FALSE);
           SetScrollPos(Handle, SB_HORZ, 0, TRUE);
       end;

       if Assigned(FOnParamUpdate) then OnParamUpdate(Self);
   end;
end;

procedure PESGraph.WMSize(var Message: TWMSize);
begin
    if (hObj <> 0) then
    begin
        GetWindowRect(HANDLE, r);
        w := r.right - r.left;
        h := r.bottom - r.top;
        if (w < 50) then w := 50;
        if (h < 50) then h := 50;
        MoveWindow(hObj, 0, 0, w, h, FALSE);
        ShowWindow(hObj, SW_HIDE);
     end;
   inherited;
end;

procedure PESGraph.WMMouseMove(var Message: TWMMouseMove);
begin
   tmsg := TMessage (Message);
   if not (csDesigning in ComponentState) then
   begin
     if (hObj <> 0) then
     begin
          if ((tmsg.WParam <> wOld) or (tmsg.LParam <> lOld)) then
          begin
              SendMessage(hObj, WM_MOUSEMOVE, tmsg.WParam, tmsg.LParam);
              wOld := tmsg.WParam;
              lOld := tmsg.LParam;
          end;
     end;
   end;
   inherited;
end;

procedure PESGraph.WMWindowPosChanging(var Message: TWMWindowPosChanging);
begin
   if (Message.WindowPos^.cx < 50) then Message.WindowPos^.cx := 50;
   if (Message.WindowPos^.cy < 50) then Message.WindowPos^.cy := 50;
   inherited;
end;

procedure PESGraph.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
   inherited;
   tmsg := TMessage (Message);
   if not (csDesigning in ComponentState) then
   begin
      if (hObj <> 0) then
      begin
           Message.Result := DLGC_WANTARROWS or DLGC_WANTALLKEYS;
      end;
   end;
end;

procedure PESGraph.WMLButtonDown(var Message: TWMLButtonDown);
var
    HSData: THotSpotData;
    GL: TGraphLoc;
    n: Integer;
    pt: TPoint;
    nX: Integer;
    nY: Integer;
    dX: Double;
    dY: Double;
    n2: Integer;
    n3: Integer;    
begin
   tmsg := TMessage (Message);
   if not (csDesigning in ComponentState) then
   begin
      SendMessage(hObj, WM_LBUTTONDOWN, tmsg.WParam, tmsg.LParam);

      n := (Integer(Message.Keys) and Integer(MK_SHIFT)) or
           (Integer(Message.Keys) and Integer(MK_RBUTTON)) or
           (Integer(Message.Keys) and Integer(MK_MBUTTON)) or
           (Integer(Message.Keys) and Integer(MK_CONTROL));

      if (n <> 0) then
      begin
         inherited;
         Exit;
      end;

      PEvget(hObj, PEP_structHOTSPOTDATA, @HSData);
      if (HSData.nHotSpotType = PEHS_NONE) then
      begin
         inherited;
         Exit;
      end;

      if (HSData.nHotSpotType = PEHS_GRAPH) then
      begin
          PEvget(hObj, PEP_structGRAPHLOC, @GL);
          if Assigned(FOnGraphHotSpot) then OnGraphHotSpot(Self, 0, GL.nAxis, GL.fXval, GL.fYval);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_DATAPOINT) then
      begin
          if Assigned(FOnDataHotSpot) then OnDataHotSpot(Self, 0, HSData.w1, HSdata.w2);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_SUBSET) then
      begin
          if Assigned(FOnSubsetHotSpot) then OnSubsetHotSpot(Self, 0, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_ANNOTATION) then
      begin
          if Assigned(FOnGraphAnnotHotSpot) then OnGraphAnnotHotSpot(Self, 0, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_XAXISANNOTATION) then
      begin
          if Assigned(FOnXAxisAnnotHotSpot) then OnXAxisAnnotHotSpot(Self, 0, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_YAXISANNOTATION) then
      begin
          if Assigned(FOnYAxisAnnotHotSpot) then OnYAxisAnnotHotSpot(Self, 0, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_HORZLINEANNOTATION) then
      begin
          if Assigned(FOnHorzLineAnnotHotSpot) then OnHorzLineAnnotHotSpot(Self, 0, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_MAINTITLE) then
      begin
          if Assigned(FOnMainTitle) then OnMainTitle(Self, 0);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_SUBTITLE) then
      begin
          if Assigned(FOnSubTitle) then OnSubTitle(Self, 0);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_MULTISUBTITLE) then
      begin
          if Assigned(FOnMultiSubTitle) then OnMultiSubTitle(Self, 0, HSData.w1, HSData.w2);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_MULTIBOTTOMTITLE) then
      begin
          if Assigned(FOnMultiBottomTitle) then OnMultiBottomTitle(Self, 0, HSData.w1, HSData.w2);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_YAXISLABEL) then
      begin
          if Assigned(FOnYAxisLabel) then OnYAxisLabel(Self, 0, HSData.w1, HSData.w2);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_XAXISLABEL) then
      begin
          if Assigned(FOnXAxisLabel) then OnXAxisLabel(Self, 0, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_YAXIS) then
      begin
          if Assigned(FOnYAxis) then
          begin
              n2 := HSData.w1;
              n3 := HSData.w2;
              PEvget(hObj, PEP_ptLASTMOUSEMOVE, @pt);
	      nX := pt.x;
	      nY := pt.y;
              PEconvpixeltograph(hObj, @n2, @nX, @nY, @dX, @dY, n3, 0, 0);
              OnYAxis(Self, 0, HSData.w1, HSData.w2, dY);
          end;
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_XAXIS) then
      begin
          if Assigned(FOnXAxis) then
          begin
              n := 0;
              PEvget(hObj, PEP_ptLASTMOUSEMOVE, @pt);
	      nX := pt.x;
	      nY := pt.y;
              PEconvpixeltograph(hObj, @n, @nX, @nY, @dX, @dY, 0, HSData.w1, 0);
              OnXAxis(Self, 0, HSData.w1, dX);
          end;
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_VERTLINEANNOTATION) then
      begin
          if Assigned(FOnVertLineAnnotHotSpot) then OnVertLineAnnotHotSpot(Self, 0, HSData.w1);
          Exit;
      end;
   end;
   inherited;
end;

procedure PESGraph.WMLButtonUp(var Message: TWMLButtonUp);
begin
   tmsg := TMessage (Message);
   if not (csDesigning in ComponentState) then
   begin
      SendMessage(hObj, WM_LBUTTONUP, tmsg.WParam, tmsg.LParam);
   end;
   inherited;
end;

procedure PESGraph.WMLButtonDblClk(var Message: TWMLButtonDown);
var
    HSData: THotSpotData;
    GL: TGraphLoc;
    n: Integer;
    pt: TPoint;
    nX: Integer;
    nY: Integer;
    dX: Double;
    dY: Double;
    n2: Integer;
    n3: Integer;    
begin

   tmsg := TMessage (Message);
   if not (csDesigning in ComponentState) then
   begin
      SendMessage(hObj, WM_LBUTTONDBLCLK, tmsg.WParam, tmsg.LParam);

      n := (Integer(Message.Keys) and Integer(MK_SHIFT)) or
           (Integer(Message.Keys) and Integer(MK_RBUTTON)) or
           (Integer(Message.Keys) and Integer(MK_MBUTTON)) or
           (Integer(Message.Keys) and Integer(MK_CONTROL));

      if (n <> 0) then
      begin
         inherited;
         Exit;
      end;

      PEvget(hObj, PEP_structHOTSPOTDATA, @HSData);
      if (HSData.nHotSpotType = PEHS_NONE) then
      begin
         inherited;
         Exit;
      end;

      if (HSData.nHotSpotType = PEHS_GRAPH) then
      begin
          PEvget(hObj, PEP_structGRAPHLOC, @GL);
          if Assigned(FOnGraphHotSpot) then OnGraphHotSpot(Self, 1, GL.nAxis, GL.fXval, GL.fYval);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_DATAPOINT) then
      begin
          if Assigned(FOnDataHotSpot) then OnDataHotSpot(Self, 1, HSData.w1, HSdata.w2);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_SUBSET) then
      begin
          if Assigned(FOnSubsetHotSpot) then OnSubsetHotSpot(Self, 1, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_ANNOTATION) then
      begin
          if Assigned(FOnGraphAnnotHotSpot) then OnGraphAnnotHotSpot(Self, 1, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_XAXISANNOTATION) then
      begin
          if Assigned(FOnXAxisAnnotHotSpot) then OnXAxisAnnotHotSpot(Self, 1, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_YAXISANNOTATION) then
      begin
          if Assigned(FOnYAxisAnnotHotSpot) then OnYAxisAnnotHotSpot(Self, 1, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_HORZLINEANNOTATION) then
      begin
          if Assigned(FOnHorzLineAnnotHotSpot) then OnHorzLineAnnotHotSpot(Self, 1, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_MAINTITLE) then
      begin
          if Assigned(FOnMainTitle) then OnMainTitle(Self, 1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_SUBTITLE) then
      begin
          if Assigned(FOnSubTitle) then OnSubTitle(Self, 1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_MULTISUBTITLE) then
      begin
          if Assigned(FOnMultiSubTitle) then OnMultiSubTitle(Self, 1, HSData.w1, HSData.w2);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_MULTIBOTTOMTITLE) then
      begin
          if Assigned(FOnMultiBottomTitle) then OnMultiBottomTitle(Self, 1, HSData.w1, HSData.w2);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_YAXISLABEL) then
      begin
          if Assigned(FOnYAxisLabel) then OnYAxisLabel(Self, 1, HSData.w1, HSData.w2);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_XAXISLABEL) then
      begin
          if Assigned(FOnXAxisLabel) then OnXAxisLabel(Self, 1, HSData.w1);
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_YAXIS) then
      begin
          if Assigned(FOnYAxis) then
          begin
              n2 := HSData.w1;
              n3 := HSData.w2;
              PEvget(hObj, PEP_ptLASTMOUSEMOVE, @pt);
	      nX := pt.x;
	      nY := pt.y;
              PEconvpixeltograph(hObj, @n2, @nX, @nY, @dX, @dY, n3, 0, 0);
              OnYAxis(Self, 1, HSData.w1, HSData.w2, dY);
          end;
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_XAXIS) then
      begin
          if Assigned(FOnXAxis) then
          begin
              n := 0;
              PEvget(hObj, PEP_ptLASTMOUSEMOVE, @pt);
	      nX := pt.x;
	      nY := pt.y;
              PEconvpixeltograph(hObj, @n, @nX, @nY, @dX, @dY, 0, HSData.w1, 0);
              OnXAxis(Self, 1, HSData.w1, dX);
          end;
          Exit;
      end
      else if (HSData.nHotSpotType = PEHS_VERTLINEANNOTATION) then
      begin
          if Assigned(FOnVertLineAnnotHotSpot) then OnVertLineAnnotHotSpot(Self, 1, HSData.w1);
          Exit;
      end;
   end;
   inherited;
end;

procedure PESGraph.WMRButtonUp(var Message: TWMRButtonUp);
begin
   tmsg := TMessage (Message);
   if not (csDesigning in ComponentState) then
   begin
      SendMessage(hObj, WM_RBUTTONDOWN, tmsg.WParam, tmsg.LParam);
   end;
   inherited;
end;

procedure PESGraph.WMKeyDown(var Message: TWMKeyDown);
begin

   inherited;

   tmsg := TMessage (Message);
   if not (csDesigning in ComponentState) then
   begin
      SendMessage(hObj, WM_KEYDOWN, tmsg.WParam, tmsg.LParam);
   end;
end;

procedure PESGraph.WMKeyUp(var Message: TWMKeyUp);
begin

   inherited;

   tmsg := TMessage (Message);
   if not (csDesigning in ComponentState) then
   begin
      SendMessage(hObj, WM_KEYUP, tmsg.WParam, tmsg.LParam);
   end;
end;

procedure PESGraph.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
     Message.Result := 1;
end;

procedure PESGraph.WMSetFocus(var Message: TWMSetFocus);
begin
     r := GetClientRect;
     hRgn1 := CreateRectRgnIndirect(r);
     r.left := r.left + 2;
     r.top := r.top + 2;
     r.right := r.right - 2;
     r.bottom := r.bottom - 2;
     hRgn2 := CreateRectRgnIndirect(r);
     hRgn3 := CreateRectRgnIndirect(r);
     CombineRgn(hRgn3, hRgn1, hRgn2, RGN_XOR);
     InvalidateRgn(Handle, hRgn3, FALSE);
     DeleteObject(hRgn1);
     DeleteObject(hRgn2);
     DeleteObject(hRgn3);
     inherited;
end;

procedure PESGraph.WMKillFocus(var Message: TWMKillFocus);
begin
     r := GetClientRect;
     hRgn1 := CreateRectRgnIndirect(r);
     r.left := r.left + 2;
     r.top := r.top + 2;
     r.right := r.right - 2;
     r.bottom := r.bottom - 2;
     hRgn2 := CreateRectRgnIndirect(r);
     hRgn3 := CreateRectRgnIndirect(r);
     CombineRgn(hRgn3, hRgn1, hRgn2, RGN_XOR);
     InvalidateRgn(Handle, hRgn3, FALSE);
     DeleteObject(hRgn1);
     DeleteObject(hRgn2);
     DeleteObject(hRgn3);
    inherited;
end;

procedure PESGraph.WMVScroll(var Message: TWMVScroll);
var
   dw: Longint;
   pos: Integer;
   code: Integer;
begin
     inherited;

     if (IsWindowVisible(Handle) <> False) then
     begin
          SetFocus;
          UpdateWindow(Handle);
     end;
     tmsg := TMessage (Message);

{$IFDEF WIN32}
      pos := HIWORD(tmsg.WParam);
      code := LOWORD(tmsg.WParam);
{$ELSE}
      pos := LOWORD(tmsg.LParam);
      code := tmsg.WParam;
{$ENDIF}

{$IFDEF WIN32}
     if (tmsg.LParam = hObj) then
     begin
{$ELSE}
     if (HIWORD(tmsg.LParam) = hObj) then
     begin
{$ENDIF}
         if (code <> SB_ENDSCROLL) then
         begin
              SetScrollPos(Handle, SB_VERT, pos, TRUE);
              UpdateWindow(Handle);
              if Assigned(FOnVertScroll) then OnVertScroll(Self, TScrollCode(Message.ScrollCode), pos);
         end;
     end
     else if (hObj <> 0) then
     begin
{$IFDEF WIN32}
          dw := MakeLong(code, pos);
          SendMessage(hObj, WM_VSCROLL, dw, 0);
{$ELSE}
          dw := MakeLong(pos, 0);
          SendMessage(hObj, WM_VSCROLL, code, dw);
{$ENDIF}
     end;
end;

procedure PESGraph.WMHScroll(var Message: TWMHScroll);
var
   dw: Longint;
   pos: Integer;
   code: Integer;
begin
     inherited;

     if (IsWindowVisible(Handle) <> False) then
     begin
          SetFocus;
          UpdateWindow(Handle);
     end;
     tmsg := TMessage (Message);

{$IFDEF WIN32}
      pos := HIWORD(tmsg.WParam);
      code := LOWORD(tmsg.WParam);
{$ELSE}
      pos := LOWORD(tmsg.LParam);
      code := tmsg.WParam;
{$ENDIF}

{$IFDEF WIN32}
     if (tmsg.LParam = hObj) then
     begin
{$ELSE}
     if (HIWORD(tmsg.LParam) = hObj) then
     begin
{$ENDIF}
         if (code <> SB_ENDSCROLL) then
         begin
              SetScrollPos(Handle, SB_HORZ, pos, TRUE);
              UpdateWindow(Handle);
              if Assigned(FOnHorzScroll) then OnHorzScroll(Self, TScrollCode(Message.ScrollCode), pos);
         end;
     end
     else if (hObj <> 0) then
     begin
{$IFDEF WIN32}
          dw := MakeLong(code, pos);
          SendMessage(hObj, WM_HSCROLL, dw, 0);
{$ELSE}
          dw := MakeLong(pos, 0);
          SendMessage(hObj, WM_HSCROLL, code, dw);
{$ENDIF}
     end;
end;

procedure PESGraph.PEWMInvalidateRect(var Message: TMessage);
begin
     if (Message.LParam <> 0) then
     begin
          r := GetClientRect;
          fxratio := r.right / 5000.0;
          fyratio := r.bottom / 5000.0;

          r := PRect(Message.LParam)^;

          r.top := Round(r.top * fyratio);
          r.left := Round(r.left * fxratio);
          r.right := Round(r.right * fxratio);
          r.bottom := Round(r.bottom * fyratio);
          InvalidateRect(Handle, @r, FALSE);
     end
     else
     begin
          Invalidate;
     end;
end;

{ /////////////////////////////////////////////////////////////////////////////////////////////// }
{ /////////////////////////////////////////////////////////////////////////////////////////////// }
{ PESGraph Property Interfaces /////////////////////////////////////////////////////////////////// }
{ /////////////////////////////////////////////////////////////////////////////////////////////// }
{ /////////////////////////////////////////////////////////////////////////////////////////////// }

procedure PESGraph.ResetandInvalidate;
begin
   if ((csDesigning in ComponentState) and (bPEcreated <> False)) then
   begin
        PEreinitialize(hObj);
        PEresetImage(hObj, 0, 0);
        Invalidate;
   end;
end;

function PESGraph.GethObject: Integer;
begin
     Result := hObj;
end;

procedure PESGraph.SetViewingStyle(nValue: eViewingStyle);
begin
     PEnset(hObj, PEP_nVIEWINGSTYLE, Integer(nValue));
     ResetandInvalidate;
end;
function PESGraph.GetViewingStyle: eViewingStyle;
begin
     Result := eViewingStyle(PEnget(hObj, PEP_nVIEWINGSTYLE));
end;

procedure PESGraph.SetPrepareImages(bValue: Boolean);
begin
     PEnset(hObj, PEP_bPREPAREIMAGES, Integer(bValue));
end;
function PESGraph.GetPrepareImages: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bPrepareImages));
end;

procedure PESGraph.SetGraphForeColor(NewValue: TColor);
begin
{$IFDEF WIN32}
     PEnset(hObj, PEP_dwGRAPHFORECOLOR, ColorToRGB(NewValue));
{$ELSE}
     PElset(hObj, PEP_dwGRAPHFORECOLOR, ColorToRGB(NewValue));
{$ENDIF}
     ResetandInvalidate;
end;
function PESGraph.GetGraphForeColor: TColor;
begin
{$IFDEF WIN32}
     Result := TColor(PEnget(hObj, PEP_dwGRAPHFORECOLOR));
{$ELSE}
     Result := TColor(PElget(hObj, PEP_dwGRAPHFORECOLOR));
{$ENDIF}
end;

procedure PESGraph.SetGraphBackColor(NewValue: TColor);
begin
{$IFDEF WIN32}
     PEnset(hObj, PEP_dwGRAPHBACKCOLOR, ColorToRGB(NewValue));
{$ELSE}
     PElset(hObj, PEP_dwGRAPHBACKCOLOR, ColorToRGB(NewValue));
{$ENDIF}
     ResetandInvalidate;
end;
function PESGraph.GetGraphBackColor: TColor;
begin
{$IFDEF WIN32}
     Result := TColor(PEnget(hObj, PEP_dwGRAPHBACKCOLOR));
{$ELSE}
     Result := TColor(PElget(hObj, PEP_dwGRAPHBACKCOLOR));
{$ENDIF}
end;

procedure PESGraph.SetDeskColor(NewValue: TColor);
begin
{$IFDEF WIN32}
     PEnset(hObj, PEP_dwDESKCOLOR, ColorToRGB(NewValue));
{$ELSE}
     PElset(hObj, PEP_dwDESKCOLOR, ColorToRGB(NewValue));
{$ENDIF}
     ResetandInvalidate;
end;
function PESGraph.GetDeskColor: TColor;
begin
{$IFDEF WIN32}
     Result := TColor(PEnget(hObj, PEP_dwDESKCOLOR));
{$ELSE}
     Result := TColor(PElget(hObj, PEP_dwDESKCOLOR));
{$ENDIF}
end;

procedure PESGraph.SetTextColor(NewValue: TColor);
begin
{$IFDEF WIN32}
     PEnset(hObj, PEP_dwTEXTCOLOR, ColorToRGB(NewValue));
{$ELSE}
     PElset(hObj, PEP_dwTEXTCOLOR, ColorToRGB(NewValue));
{$ENDIF}
     ResetandInvalidate;
end;
function PESGraph.GetTextColor: TColor;
begin
{$IFDEF WIN32}
     Result := TColor(PEnget(hObj, PEP_dwTEXTCOLOR));
{$ELSE}
     Result := TColor(PElget(hObj, PEP_dwTEXTCOLOR));
{$ENDIF}
end;

procedure PESGraph.SetShadowColor(NewValue: TColor);
begin
{$IFDEF WIN32}
     PEnset(hObj, PEP_dwSHADOWCOLOR, ColorToRGB(NewValue));
{$ELSE}
     PElset(hObj, PEP_dwSHADOWCOLOR, ColorToRGB(NewValue));
{$ENDIF}
     ResetandInvalidate;
end;
function PESGraph.GetShadowColor: TColor;
begin
{$IFDEF WIN32}
     Result := TColor(PEnget(hObj, PEP_dwSHADOWCOLOR));
{$ELSE}
     Result := TColor(PElget(hObj, PEP_dwSHADOWCOLOR));
{$ENDIF}
end;

procedure PESGraph.SetMainTitle(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szMAINTITLE, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetMainTitle: string;
begin
     PEszget(hObj, PEP_szMAINTITLE, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetSubTitle(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szSUBTITLE, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetSubTitle: string;
begin
     PEszget(hObj, PEP_szSUBTITLE, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetSubsets(nSubsets: Integer);
begin
     PEnset(hObj, PEP_nSUBSETS, nSubsets);
     ResetandInvalidate;
end;
function PESGraph.GetSubsets: Integer;
begin
     Result := PEnget(hObj, PEP_nSUBSETS);
end;

procedure PESGraph.SetPoints(NewValue: Integer);
begin
     PEnset(hObj, PEP_nPOINTS, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetPoints: Integer;
begin
     Result := PEnget(hObj, PEP_nPOINTS);
end;

procedure PESGraph.SetDataPrecision(NewValue: eDataPrecision);
begin
     PEnset(hObj, PEP_nDATAPRECISION, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetDataPrecision: eDataPrecision;
begin
     Result := eDataPrecision(PEnget(hObj, PEP_nDATAPRECISION));
end;

procedure PESGraph.SetAllowCustomization(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWCUSTOMIZATION, Integer(NewValue));
end;
function PESGraph.GetAllowCustomization: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWCUSTOMIZATION));
end;

procedure PESGraph.SetAllowExporting(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWEXPORTING, Integer(NewValue));
end;
function PESGraph.GetAllowExporting: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWEXPORTING));
end;

procedure PESGraph.SetAllowMaximization(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWMAXIMIZATION, Integer(NewValue));
end;
function PESGraph.GetAllowMaximization: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWMAXIMIZATION));
end;

procedure PESGraph.SetAllowPopup(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWPOPUP, Integer(NewValue));
end;
function PESGraph.GetAllowPopup: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWPOPUP));
end;

procedure PESGraph.SetAllowUserInterface(NewValue: eAllowUserInterface);
begin
     PEnset(hObj, PEP_bALLOWUSERINTERFACE, Integer(NewValue));
end;
function PESGraph.GetAllowUserInterface: eAllowUserInterface;
begin
     Result := eAllowUserInterface(PEnget(hObj, PEP_bALLOWUSERINTERFACE));
end;

procedure PESGraph.SetFontSize(NewValue: eFontSize);
begin
     PEnset(hObj, PEP_nFONTSIZE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetFontSize: eFontSize;
begin
     Result := eFontSize(PEnget(hObj, PEP_nFONTSIZE));
end;


procedure PESGraph.SetMainTitleFont(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szMAINTITLEFONT, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetMainTitleFont: string;
begin
     PEszget(hObj, PEP_szMAINTITLEFONT, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetMainTitleBold(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bMAINTITLEBOLD, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetMainTitleBold: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bMAINTITLEBOLD));
end;

procedure PESGraph.SetMainTitleItalic(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bMAINTITLEITALIC, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetMainTitleItalic: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bMAINTITLEITALIC));
end;

procedure PESGraph.SetMainTitleUnderline(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bMAINTITLEUNDERLINE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetMainTitleUnderline: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bMAINTITLEUNDERLINE));
end;

procedure PESGraph.SetSubTitleFont(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szSUBTITLEFONT, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetSubTitleFont: string;
begin
     PEszget(hObj, PEP_szSUBTITLEFONT, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetSubTitleBold(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSUBTITLEBOLD, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetSubTitleBold: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSUBTITLEBOLD));
end;

procedure PESGraph.SetSubTitleItalic(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSUBTITLEITALIC, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetSubTitleItalic: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSUBTITLEITALIC));
end;

procedure PESGraph.SetSubTitleUnderline(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSUBTITLEUNDERLINE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetSubTitleUnderline: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSUBTITLEUNDERLINE));
end;

procedure PESGraph.SetLabelFont(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szLABELFONT, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetLabelFont: string;
begin
     PEszget(hObj, PEP_szLABELFONT, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetLabelBold(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bLABELBOLD, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetLabelBold: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bLABELBOLD));
end;

procedure PESGraph.SetLabelItalic(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bLABELITALIC, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetLabelItalic: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bLABELITALIC));
end;

procedure PESGraph.SetLabelUnderline(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bLABELUNDERLINE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetLabelUnderline: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bLABELUNDERLINE));
end;

procedure PESGraph.SetXAxisLabel(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szXAXISLABEL, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetXAxisLabel: string;
begin
     PEszget(hObj, PEP_szXAXISLABEL, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetYAxisLabel(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szYAXISLABEL, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetYAxisLabel: string;
begin
     PEszget(hObj, PEP_szYAXISLABEL, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetScrollingSubsets(NewValue: Integer);
begin
     PEnset(hObj, PEP_nSCROLLINGSUBSETS, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetScrollingSubsets: Integer;
begin
     Result := PEnget(hObj, PEP_nSCROLLINGSUBSETS);
end;

procedure PESGraph.SetVBoundaryTypes(NewValue: eVBoundaryTypes);
begin
     PEnset(hObj, PEP_nVBOUNDARYTYPES, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetVBoundaryTypes: eVBoundaryTypes;
begin
     Result := eVBoundaryTypes(PEnget(hObj, PEP_nVBOUNDARYTYPES));
end;

procedure PESGraph.SetUpperBoundValue(NewValue: Double);
begin
     PEvset(hObj, PEP_fUPPERBOUNDVALUE, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetUpperBoundValue: Double;
begin
     PEvget(hObj, PEP_fUPPERBOUNDVALUE, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetLowerBoundValue(NewValue: Double);
begin
     PEvset(hObj, PEP_fLOWERBOUNDVALUE, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetLowerBoundValue: Double;
begin
     PEvget(hObj, PEP_fLOWERBOUNDVALUE, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetUpperBoundText(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szUPPERBOUNDTEXT, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetUpperBoundText: string;
begin
     PEszget(hObj, PEP_szUPPERBOUNDTEXT, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetLowerBoundText(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szLOWERBOUNDTEXT, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetLowerBoundText: string;
begin
     PEszget(hObj, PEP_szLOWERBOUNDTEXT, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetXAxisScaleControl(NewValue: eAxisScaleControl);
begin
     PEnset(hObj, PEP_nXAXISSCALECONTROL, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetXAxisScaleControl: eAxisScaleControl;
begin
     Result := eAxisScaleControl(PEnget(hObj, PEP_nXAXISSCALECONTROL));
end;

procedure PESGraph.SetYAxisScaleControl(NewValue: eAxisScaleControl);
begin
     PEnset(hObj, PEP_nYAXISSCALECONTROL, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetYAxisScaleControl: eAxisScaleControl;
begin
     Result := eAxisScaleControl(PEnget(hObj, PEP_nYAXISSCALECONTROL));
end;

procedure PESGraph.SetPlottingMethod(NewValue: ePlottingMethod);
var
   pm: Integer;
   nv: Integer;
begin
     nv := Integer(NewValue);
     case nv of
          0: pm := 0;
          1: pm := 2;
          2: pm := 4;
          3: pm := 8;
          4: pm := 13;
          5: pm := 15;
          6: pm := 16;
          7: pm := 12;
          8: pm := 17;
          9: pm := 3;
          10: pm := 1;
          11: pm := 11;

          12: pm := 21;
          13: pm := 22;
          14: pm := 23;
          15: pm := 24;

     end;
     PEnset(hObj, PEP_nPLOTTINGMETHOD, pm);
     ResetandInvalidate;
end;
function PESGraph.GetPlottingMethod: ePlottingMethod;
var
   pm: Integer;
begin
     pm := PEnget(hObj, PEP_nPLOTTINGMETHOD);
     case pm of
          0: Result := ePlottingMethod(0);
          1: Result := ePlottingMethod(10);
          2: Result := ePlottingMethod(1);
          3: Result := ePlottingMethod(9);
          4: Result := ePlottingMethod(2);
          8: Result := ePlottingMethod(3);
          11: Result := ePlottingMethod(11);
          12: Result := ePlottingMethod(7);
          13: Result := ePlottingMethod(4);
          15: Result := ePlottingMethod(5);
          16: Result := ePlottingMethod(6);
          17: Result := ePlottingMethod(8);

          21: Result := ePlottingMethod(12);
          22: Result := ePlottingMethod(13);
          23: Result := ePlottingMethod(14);
          24: Result := ePlottingMethod(15);

     end;
end;

procedure PESGraph.SetTreatCompsAsNormal(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bTREATCOMPSASNORMAL, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetTreatCompsAsNormal: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bTREATCOMPSASNORMAL));
end;

procedure PESGraph.SetGridLineControl(NewValue: eGridLineControl);
begin
     PEnset(hObj, PEP_nGRIDLINECONTROL, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetGridLineControl: eGridLineControl;
begin
     Result := eGridLineControl(PEnget(hObj, PEP_nGRIDLINECONTROL));
end;

procedure PESGraph.SetGridInFront(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bGRIDINFRONT, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetGridInFront: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bGRIDINFRONT));
end;

procedure PESGraph.SetNoScrollingSubsetControl(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bNOSCROLLINGSUBSETCONTROL, Integer(NewValue));
end;
function PESGraph.GetNoScrollingSubsetControl: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bNOSCROLLINGSUBSETCONTROL));
end;

procedure PESGraph.SetGraphDataLabels(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bGRAPHDATALABELS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetGraphDataLabels: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bGRAPHDATALABELS));
end;

procedure PESGraph.SetDataShadows(NewValue: eDataShadows);
begin
     PEnset(hObj, PEP_bDATASHADOWS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetDataShadows: eDataShadows;
begin
     Result := eDataShadows(PEnget(hObj, PEP_bDATASHADOWS));
end;

procedure PESGraph.SetMonoWithSymbols(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bMONOWITHSYMBOLS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetMonoWithSymbols: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bMONOWITHSYMBOLS));
end;

procedure PESGraph.SetThreeDDialogs(NewValue: Boolean);
begin
     PEnset(hObj, PEP_b3DDIALOGS, Integer(NewValue));
end;
function PESGraph.GetThreeDDialogs: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_b3DDIALOGS));
end;

procedure PESGraph.SetDefOrientation(NewValue: eDefOrientation);
begin
     PEnset(hObj, PEP_nDEFORIENTATION, Integer(NewValue));
end;
function PESGraph.GetDefOrientation: eDefOrientation;
begin
     Result := eDefOrientation(PEnget(hObj, PEP_nDEFORIENTATION));
end;

function PESGraph.GetObjectType: Integer;
begin
     Result := PEnget(hObj, PEP_nOBJECTTYPE);
end;

procedure PESGraph.SetScaleForXData(NewValue: Integer);
begin
     PEnset(hObj, PEP_nSCALEFORXDATA, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetScaleForXData: Integer;
begin
     Result := PEnget(hObj, PEP_nSCALEFORXDATA);
end;

procedure PESGraph.SetScaleForYData(NewValue: Integer);
begin
     PEnset(hObj, PEP_nSCALEFORYDATA, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetScaleForYData: Integer;
begin
     Result := PEnget(hObj, PEP_nSCALEFORYDATA);
end;

procedure PESGraph.SetManualScaleControlY(NewValue: eManualScaleControl);
begin
     PEnset(hObj, PEP_nMANUALSCALECONTROLY, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetManualScaleControlY: eManualScaleControl;
begin
     Result := eManualScaleControl(PEnget(hObj, PEP_nMANUALSCALECONTROLY));
end;

procedure PESGraph.SetManualMinY(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALMINY, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualMinY: Double;
begin
     PEvget(hObj, PEP_fMANUALMINY, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualMaxY(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALMAXY, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualMaxY: Double;
begin
     PEvget(hObj, PEP_fMANUALMAXY, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualScaleControlX(NewValue: eManualScaleControl);
begin
     PEnset(hObj, PEP_nMANUALSCALECONTROLX, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetManualScaleControlX: eManualScaleControl;
begin
     Result := eManualScaleControl(PEnget(hObj, PEP_nMANUALSCALECONTROLX));
end;

procedure PESGraph.SetManualMinX(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALMINX, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualMinX: Double;
begin
     PEvget(hObj, PEP_fMANUALMINX, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualMaxX(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALMAXX, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualMaxX: Double;
begin
     PEvget(hObj, PEP_fMANUALMAXX, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetXData(nSubset: Integer; nPoint: Integer; NewValue: Single);
begin
     PEvsetcellEx(hObj, PEP_faXDATA, nSubset, nPoint, @NewValue);
end;
function PESGraph.GetXData(nSubset: Integer; nPoint: Integer): Single;
begin
     PEvgetcellEx(hObj, PEP_faXDATA, nSubset, nPoint, @tmpS);
     Result := tmpS;
end;

procedure PESGraph.SetYData(nSubset: Integer; nPoint: Integer; NewValue: Single);
begin
     PEvsetcellEx(hObj, PEP_faYDATA, nSubset, nPoint, @NewValue);
end;
function PESGraph.GetYData(nSubset: Integer; nPoint: Integer): Single;
begin
     PEvgetcellEx(hObj, PEP_faYDATA, nSubset, nPoint, @tmpS);
     Result := tmpS;
end;

procedure PESGraph.SetZData(nSubset: Integer; nPoint: Integer; NewValue: Single);
begin
     PEvsetcellEx(hObj, PEP_faZDATA, nSubset, nPoint, @NewValue);
end;
function PESGraph.GetZData(nSubset: Integer; nPoint: Integer): Single;
begin
     PEvgetcellEx(hObj, PEP_faZDATA, nSubset, nPoint, @tmpS);
     Result := tmpS;
end;

procedure PESGraph.SetRandomSubsetsToGraph(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naRANDOMSUBSETSTOGRAPH, nIndex, @NewValue);
end;
function PESGraph.GetRandomSubsetsToGraph(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naRANDOMSUBSETSTOGRAPH, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetSubsetLabels(nIndex: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcell(hObj, PEP_szaSUBSETLABELS, nIndex, @tmpszstr);
end;
function PESGraph.GetSubsetLabels(nIndex: Integer): string;
begin
     PEvgetcell(hObj, PEP_szaSUBSETLABELS, nIndex, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetPointLabels(nIndex: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcell(hObj, PEP_szaPOINTLABELS, nIndex, @tmpszstr);
end;
function PESGraph.GetPointLabels(nIndex: Integer): string;
begin
     PEvgetcell(hObj, PEP_szaPOINTLABELS, nIndex, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetComparisonSubsets(NewValue: Integer);
begin
     PEnset(hObj, PEP_nCOMPARISONSUBSETS, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetComparisonSubsets: Integer;
begin
     Result := PEnget(hObj, PEP_nCOMPARISONSUBSETS);
end;

procedure PESGraph.SetAllowSubsetHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWSUBSETHOTSPOTS, Integer(NewValue));
end;
function PESGraph.GetAllowSubsetHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWSUBSETHOTSPOTS));
end;

procedure PESGraph.SetAllowGraphHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWGRAPHHOTSPOTS, Integer(NewValue));
end;
function PESGraph.GetAllowGraphHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWGRAPHHOTSPOTS));
end;

procedure PESGraph.SetAllowDataHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWDATAHOTSPOTS, Integer(NewValue));
end;
function PESGraph.GetAllowDataHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWDATAHOTSPOTS));
end;

procedure PESGraph.SetAllowCoordPrompting(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWCOORDPROMPTING, Integer(NewValue));
end;
function PESGraph.GetAllowCoordPrompting: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWCOORDPROMPTING));
end;

procedure PESGraph.SetMarkDataPoints(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bMARKDATAPOINTS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetMarkDataPoints: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bMARKDATAPOINTS));
end;

procedure PESGraph.SetSubsetColors(nIndex: Integer; NewValue: TColor);
begin
     l := ColorToRGB(NewValue);
     PEvsetcell(hObj, PEP_dwaSUBSETCOLORS, nIndex, @l);
end;
function PESGraph.GetSubsetColors(nIndex: Integer): TColor;
begin
     PEvgetcell(hObj, PEP_dwaSUBSETCOLORS, nIndex, @l);
     Result := TColor(l);
end;

procedure PESGraph.SetRYAxisComparisonSubsets(NewValue: Integer);
begin
     PEnset(hObj, PEP_nRYAXISCOMPARISONSUBSETS, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetRYAxisComparisonSubsets: Integer;
begin
     Result := PEnget(hObj, PEP_nRYAXISCOMPARISONSUBSETS);
end;

procedure PESGraph.SetRYAxisLabel(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szRYAXISLABEL, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetRYAxisLabel: string;
begin
     PEszget(hObj, PEP_szRYAXISLABEL, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetScaleForRYData(NewValue: Integer);
begin
     PEnset(hObj, PEP_nSCALEFORRYDATA, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetScaleForRYData: Integer;
begin
     Result := PEnget(hObj, PEP_nSCALEFORRYDATA);
end;

procedure PESGraph.SetRYAxisScaleControl(NewValue: eAxisScaleControl);
begin
     PEnset(hObj, PEP_nRYAXISSCALECONTROL, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetRYAxisScaleControl: eAxisScaleControl;
begin
     Result := eAxisScaleControl(PEnget(hObj, PEP_nRYAXISSCALECONTROL));
end;

procedure PESGraph.SetManualScaleControlRY(NewValue: eManualScaleControl);
begin
     PEnset(hObj, PEP_nMANUALSCALECONTROLRY, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetManualScaleControlRY: eManualScaleControl;
begin
     Result := eManualScaleControl(PEnget(hObj, PEP_nMANUALSCALECONTROLRY));
end;

procedure PESGraph.SetManualMinRY(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALMINRY, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualMinRY: Double;
begin
     PEvget(hObj, PEP_fMANUALMINRY, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualMaxRY(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALMAXRY, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualMaxRY: Double;
begin
     PEvget(hObj, PEP_fMANUALMAXRY, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetAllowPlotCustomization(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWPLOTCUSTOMIZATION, Integer(NewValue));
end;
function PESGraph.GetAllowPlotCustomization: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWPLOTCUSTOMIZATION));
end;

procedure PESGraph.SetAllowBubble(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWBUBBLE, Integer(NewValue));
end;
function PESGraph.GetAllowBubble: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWBUBBLE));
end;

procedure PESGraph.SetAllowBestFitCurve(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWBESTFITCURVE, Integer(NewValue));
end;
function PESGraph.GetAllowBestFitCurve: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWBESTFITCURVE));
end;

procedure PESGraph.SetAllowSpline(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWSPLINE, Integer(NewValue));
end;
function PESGraph.GetAllowSpline: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWSPLINE));
end;

procedure PESGraph.SetNegativeFromXAxis(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bNEGATIVEFROMXAXIS, Integer(NewValue));
end;
function PESGraph.GetNegativeFromXAxis: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bNEGATIVEFROMXAXIS));
end;

procedure PESGraph.SetManualXAxisTicknLine(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bMANUALXAXISTICKNLINE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetManualXAxisTicknLine: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bMANUALXAXISTICKNLINE));
end;

procedure PESGraph.SetManualYAxisTicknLine(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bMANUALYAXISTICKNLINE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetManualYAxisTicknLine: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bMANUALYAXISTICKNLINE));
end;

procedure PESGraph.SetManualRYAxisTicknLine(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bMANUALRYAXISTICKNLINE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetManualRYAxisTicknLine: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bMANUALRYAXISTICKNLINE));
end;

procedure PESGraph.SetBubbleSize(NewValue: eBubbleSize);
begin
     PEnset(hObj, PEP_nBUBBLESIZE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetBubbleSize: eBubbleSize;
begin
     Result := eBubbleSize(PEnget(hObj, PEP_nBUBBLESIZE));
end;

procedure PESGraph.SetSpecificPlotMode(NewValue: eSpecificPlotMode);
begin
     PEnset(hObj, PEP_nSPECIFICPLOTMODE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetSpecificPlotMode: eSpecificPlotMode;
begin
     Result := eSpecificPlotMode(PEnget(hObj, PEP_nSPECIFICPLOTMODE));
end;

procedure PESGraph.SetPointSize(NewValue: ePointSize);
begin
     PEnset(hObj, PEP_nPOINTSIZE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetPointSize: ePointSize;
begin
     Result := ePointSize(PEnget(hObj, PEP_nPOINTSIZE));
end;

procedure PESGraph.SetBestFitDegree(NewValue: eBestFitDegree);
begin
     PEnset(hObj, PEP_nBESTFITDEGREE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetBestFitDegree: eBestFitDegree;
begin
     Result := eBestFitDegree(PEnget(hObj, PEP_nBESTFITDEGREE));
end;

procedure PESGraph.SetCurveGranularity(NewValue: eCurveGranularity);
begin
     PEnset(hObj, PEP_nCURVEGRANULARITY, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetCurveGranularity: eCurveGranularity;
begin
     Result := eCurveGranularity(PEnget(hObj, PEP_nCURVEGRANULARITY));
end;

procedure PESGraph.SetAllowDataLabels(NewValue: eAllowDataLabels);
begin
     PEnset(hObj, PEP_nALLOWDATALABELS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowDataLabels: eAllowDataLabels;
begin
     Result := eAllowDataLabels(PEnget(hObj, PEP_nALLOWDATALABELS));
end;

procedure PESGraph.SetManualXAxisTick(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALXAXISTICK, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualXAxisTick: Double;
begin
     PEvget(hObj, PEP_fMANUALXAXISTICK, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualXAxisLine(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALXAXISLINE, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualXAxisLine: Double;
begin
     PEvget(hObj, PEP_fMANUALXAXISLINE, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualYAxisTick(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALYAXISTICK, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualYAxisTick: Double;
begin
     PEvget(hObj, PEP_fMANUALYAXISTICK, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualYAxisLine(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALYAXISLINE, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualYAxisLine: Double;
begin
     PEvget(hObj, PEP_fMANUALYAXISLINE, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualRYAxisTick(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALRYAXISTICK, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualRYAxisTick: Double;
begin
     PEvget(hObj, PEP_fMANUALRYAXISTICK, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualRYAxisLine(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALRYAXISLINE, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualRYAxisLine: Double;
begin
     PEvget(hObj, PEP_fMANUALRYAXISLINE, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetNullDataValueX(NewValue: Double);
begin
     PEvset(hObj, PEP_fNULLDATAVALUEX, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetNullDataValueX: Double;
begin
     PEvget(hObj, PEP_fNULLDATAVALUEX, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetNullDataValueY(NewValue: Double);
begin
     PEvset(hObj, PEP_fNULLDATAVALUE, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetNullDataValueY: Double;
begin
     PEvget(hObj, PEP_fNULLDATAVALUE, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetSubsetPointTypes(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naSUBSETPOINTTYPES, nIndex, @NewValue);
end;
function PESGraph.GetSubsetPointTypes(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naSUBSETPOINTTYPES, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetSubsetLineTypes(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naSUBSETLINETYPES, nIndex, @NewValue);
end;
function PESGraph.GetSubsetLineTypes(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naSUBSETLINETYPES, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetDataPointLabels(nSubset: Integer; nPoint: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcellEx(hObj, PEP_szaDATAPOINTLABELS, nSubset, nPoint, @tmpszstr);
end;
function PESGraph.GetDataPointLabels(nSubset: Integer; nPoint: Integer): string;
begin
     PEvgetcellEx(hObj, PEP_szaDATAPOINTLABELS, nSubset, nPoint, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetAllowLine(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWLINE, Integer(NewValue));
end;
function PESGraph.GetAllowLine: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWLINE));
end;

procedure PESGraph.SetAllowStick(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWSTICK, Integer(NewValue));
end;
function PESGraph.GetAllowStick: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWSTICK));
end;

procedure PESGraph.SetAllowBar(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWBAR, Integer(NewValue));
end;
function PESGraph.GetAllowBar: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWBAR));
end;

procedure PESGraph.SetAllowPoint(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWPOINT, Integer(NewValue));
end;
function PESGraph.GetAllowPoint: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWPOINT));
end;

procedure PESGraph.SetAllowArea(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWAREA, Integer(NewValue));
end;
function PESGraph.GetAllowArea: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWAREA));
end;

procedure PESGraph.SetAllowBestFitLine(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWBESTFITLINE, Integer(NewValue));
end;
function PESGraph.GetAllowBestFitLine: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWBESTFITLINE));
end;

procedure PESGraph.SetAllowZooming(NewValue: eAllowZooming);
begin
     PEnset(hObj, PEP_nALLOWZOOMING, Integer(NewValue));
end;
function PESGraph.GetAllowZooming: eAllowZooming;
begin
     Result := eAllowZooming(PEnget(hObj, PEP_nALLOWZOOMING));
end;

procedure PESGraph.SetForceRightYAxis(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bFORCERIGHTYAXIS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetForceRightYAxis: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bFORCERIGHTYAXIS));
end;

procedure PESGraph.SetAllowPointsPlusLine(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWPOINTSPLUSLINE, Integer(NewValue));
end;
function PESGraph.GetAllowPointsPlusLine: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWPOINTSPLUSLINE));
end;

procedure PESGraph.SetAllowPointsPlusSpline(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWPOINTSPLUSSPLINE, Integer(NewValue));
end;
function PESGraph.GetAllowPointsPlusSpline: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWPOINTSPLUSSPLINE));
end;

procedure PESGraph.SetSymbolFrequency(NewValue: eSymbolFrequency);
begin
     PEnset(hObj, PEP_nSYMBOLFREQUENCY, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetSymbolFrequency: eSymbolFrequency;
begin
     Result := eSymbolFrequency(PEnget(hObj, PEP_nSYMBOLFREQUENCY));
end;

procedure PESGraph.SetPEactions(NewValue: ePEactions);
var
   n: Integer;
   bFullPage: Boolean;
   tpt: TPoint;
begin
     n := Integer(NewValue);

     if (n = 0) then
     begin
          PEreinitialize(hObj);
          PEresetimage(hObj, 0, 0);
          Invalidate;
     end
     else if (n = 1) then
     begin
          PEreinitialize(hObj);
     end
     else if (n = 2) then
     begin
          PEresetimage(hObj, tmpPEnarg1, tmpPEnarg2);
     end
     else if (n = 3) then
     begin
          Invalidate;
     end
     else if (n = 4) then
     begin
          PElaunchmaximize(hObj);
     end
     else if (n = 5) then
     begin
          PElaunchcustomize(hObj);
     end
     else if (n = 6) then
     begin
          PElaunchexport(hObj);
     end
     else if (n = 7) then
     begin
          StrPCopy(tmpszstr, tmpPEstrarg1);
          PElaunchtextexport(hObj, Integer(tmpPEnarg1), @tmpszstr);
     end
     else if (n = 8) then
     begin
          if ((tmpPEnarg1 = 0) and (tmpPEnarg2 = 0)) then
          begin
             bFullPage := TRUE;
          end
          else
          begin
             bFullPage := FALSE;
          end;
          tpt.x := tmpPEnarg1;
          tpt.y := tmpPEnarg2;
          PElaunchprintdialog(hObj, Integer(bFullPage), @tpt);
     end
     else if (n = 9) then
     begin
          PElaunchcolordialog(hObj);
     end
     else if (n = 10) then
     begin
          PElaunchfontdialog(hObj);
     end
     else if (n = 11) then
     begin
          tpt.x := tmpPEnarg1;
          tpt.y := tmpPEnarg2;
          PElaunchpopupmenu(hObj, @tpt);
     end
     else if (n = 12) then
     begin
          tpt.x := tmpPEnarg1;
          tpt.y := tmpPEnarg2;
          PEcopymetatoclipboard(hObj, @tpt);
     end
     else if (n = 13) then
     begin
          tpt.x := tmpPEnarg1;
          tpt.y := tmpPEnarg2;
          StrPCopy(tmpszstr, tmpPEstrarg1);
          PEcopymetatofile(hObj, @tpt, @tmpszstr);
     end
     else if (n = 14) then
     begin
          tpt.x := tmpPEnarg1;
          tpt.y := tmpPEnarg2;
          PEcopybitmaptoclipboard(hObj, @tpt);
     end
     else if (n = 15) then
     begin
          tpt.x := tmpPEnarg1;
          tpt.y := tmpPEnarg2;
          StrPCopy(tmpszstr, tmpPEstrarg1);
          PEcopybitmaptofile(hObj, @tpt, @tmpszstr);
     end
     else if (n = 16) then
     begin
          tpt.x := tmpPEnarg1;
          tpt.y := tmpPEnarg2;
          PEcopyoletoclipboard(hObj, @tpt);
     end
     else if (n = 17) then
     begin
          PEreinitializecustoms(hObj);
     end
     else if (n = 18) then
     begin
          PEprintgraph(hObj, 0, 0, 0, PEnget(hObj, PEP_nDEFORIENTATION));
     end
     else if (n = 19) then
     begin
{$IFDEF WIN32}
          SendMessage(hObj, WM_COMMAND, MAKELONG(53053, 0), 0);
{$ELSE}
          SendMessage(hObj, WM_COMMAND, 53053, 0);
{$ENDIF}
     end
     else if (n = 20) then
     begin
          PEreset(hObj);
     end
     else if (n = 21) then
     begin
          tpt.x := tmpPEnarg1;
          tpt.y := tmpPEnarg2;
          PEcopyjpegtoclipboard(hObj, @tpt);
     end
     else if (n = 22) then
     begin
          tpt.x := tmpPEnarg1;
          tpt.y := tmpPEnarg2;
          StrPCopy(tmpszstr, tmpPEstrarg1);
          PEcopyjpegtofile(hObj, @tpt, @tmpszstr);
     end;
end;
function PESGraph.GetPEactions: ePEactions;
begin
     Result := ePEactions(tmpPEactions);
end;

procedure PESGraph.SetPEnarg1(NewValue: Integer);
begin
     tmpPEnarg1 := NewValue;
end;
function PESGraph.GetPEnarg1: Integer;
begin
     Result := tmpPEnarg1;
end;

procedure PESGraph.SetPEnarg2(NewValue: Integer);
begin
     tmpPEnarg2 := NewValue;
end;
function PESGraph.GetPEnarg2: Integer;
begin
     Result := tmpPEnarg2;
end;

procedure PESGraph.SetPEstrarg1(NewValue: string);
begin
     tmpPEstrarg1 := NewValue;
end;
function PESGraph.GetPEstrarg1: string;
begin
     Result := tmpPEstrarg1;
end;

procedure PESGraph.SetScrollingHorzZoom(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSCROLLINGHORZZOOM, Integer(NewValue));
end;
function PESGraph.GetScrollingHorzZoom: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSCROLLINGHORZZOOM));
end;

procedure PESGraph.SetCursorMode(NewValue: eCursorMode);
begin
     PEnset(hObj, PEP_nCURSORMODE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetCursorMode: eCursorMode;
begin
     Result := eCursorMode(PEnget(hObj, PEP_nCURSORMODE));
end;

procedure PESGraph.SetCursorSubset(NewValue: Integer);
begin
     PEnset(hObj, PEP_nCURSORSUBSET, NewValue);
end;
function PESGraph.GetCursorSubset: Integer;
begin
     Result := PEnget(hObj, PEP_nCURSORSUBSET);
end;

procedure PESGraph.SetCursorPoint(NewValue: Integer);
begin
     PEnset(hObj, PEP_nCURSORPOINT, NewValue);
end;
function PESGraph.GetCursorPoint: Integer;
begin
     Result := PEnget(hObj, PEP_nCURSORPOINT);
end;

procedure PESGraph.SetCursorPromptStyle(NewValue: eCursorPromptStyle);
begin
     PEnset(hObj, PEP_nCURSORPROMPTSTYLE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetCursorPromptStyle: eCursorPromptStyle;
begin
     Result := eCursorPromptStyle(PEnget(hObj, PEP_nCURSORPROMPTSTYLE));
end;

procedure PESGraph.SetCursorPromptTracking(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bCURSORPROMPTTRACKING, Integer(NewValue));
end;
function PESGraph.GetCursorPromptTracking: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bCURSORPROMPTTRACKING));
end;

procedure PESGraph.SetMouseCursorControl(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bMOUSECURSORCONTROL, Integer(NewValue));
end;
function PESGraph.GetMouseCursorControl: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bMOUSECURSORCONTROL));
end;

procedure PESGraph.SetShowAnnotations(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSHOWANNOTATIONS, Integer(NewValue));
end;
function PESGraph.GetShowAnnotations: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSHOWANNOTATIONS));
end;

procedure PESGraph.SetAllowGraphAnnotHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWGRAPHANNOTHOTSPOTS, Integer(NewValue));
end;
function PESGraph.GetAllowGraphAnnotHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWGRAPHANNOTHOTSPOTS));
end;

procedure PESGraph.SetGraphAnnotationTextSize(NewValue: Integer);
begin
     PEnset(hObj, PEP_nGRAPHANNOTATIONTEXTSIZE, NewValue);
end;
function PESGraph.GetGraphAnnotationTextSize: Integer;
begin
     Result := PEnget(hObj, PEP_nGRAPHANNOTATIONTEXTSIZE);
end;

procedure PESGraph.SetAllowAnnotationControl(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWANNOTATIONCONTROL, Integer(NewValue));
end;
function PESGraph.GetAllowAnnotationControl: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWANNOTATIONCONTROL));
end;

procedure PESGraph.SetAnnotationsInFront(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bANNOTATIONSINFRONT, Integer(NewValue));
end;
function PESGraph.GetAnnotationsInFront: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bANNOTATIONSINFRONT));
end;

procedure PESGraph.SetGraphAnnotationX(nIndex: Integer; NewValue: Double);
begin
     PEvsetcell(hObj, PEP_faGRAPHANNOTATIONX, nIndex, @NewValue);
end;
function PESGraph.GetGraphAnnotationX(nIndex: Integer): Double;
begin
     PEvgetcell(hObj, PEP_faGRAPHANNOTATIONX, nIndex, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetGraphAnnotationY(nIndex: Integer; NewValue: Double);
begin
     PEvsetcell(hObj, PEP_faGRAPHANNOTATIONY, nIndex, @NewValue);
end;
function PESGraph.GetGraphAnnotationY(nIndex: Integer): Double;
begin
     PEvgetcell(hObj, PEP_faGRAPHANNOTATIONY, nIndex, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetGraphAnnotationText(nIndex: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcell(hObj, PEP_szaGRAPHANNOTATIONTEXT, nIndex, @tmpszstr);
end;
function PESGraph.GetGraphAnnotationText(nIndex: Integer): string;
begin
     PEvgetcell(hObj, PEP_szaGRAPHANNOTATIONTEXT, nIndex, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetXAxisAnnotation(nIndex: Integer; NewValue: Double);
begin
     PEvsetcell(hObj, PEP_faXAXISANNOTATION, nIndex, @NewValue);
end;
function PESGraph.GetXAxisAnnotation(nIndex: Integer): Double;
begin
     PEvgetcell(hObj, PEP_faXAXISANNOTATION, nIndex, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetXAxisAnnotationText(nIndex: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcell(hObj, PEP_szaXAXISANNOTATIONTEXT, nIndex, @tmpszstr);
end;
function PESGraph.GetXAxisAnnotationText(nIndex: Integer): string;
begin
     PEvgetcell(hObj, PEP_szaXAXISANNOTATIONTEXT, nIndex, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetYAxisAnnotation(nIndex: Integer; NewValue: Double);
begin
     PEvsetcell(hObj, PEP_faYAXISANNOTATION, nIndex, @NewValue);
end;
function PESGraph.GetYAxisAnnotation(nIndex: Integer): Double;
begin
     PEvgetcell(hObj, PEP_faYAXISANNOTATION, nIndex, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetYAxisAnnotationText(nIndex: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcell(hObj, PEP_szaYAXISANNOTATIONTEXT, nIndex, @tmpszstr);
end;
function PESGraph.GetYAxisAnnotationText(nIndex: Integer): string;
begin
     PEvgetcell(hObj, PEP_szaYAXISANNOTATIONTEXT, nIndex, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetNoRandomPointsToExport(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bNORANDOMPOINTSTOEXPORT, Integer(NewValue));
end;
function PESGraph.GetNoRandomPointsToExport: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bNORANDOMPOINTSTOEXPORT));
end;

procedure PESGraph.SetCursorPageAmount(NewValue: Integer);
begin
     PEnset(hObj, PEP_nCURSORPAGEAMOUNT, NewValue);
end;
function PESGraph.GetCursorPageAmount: Integer;
begin
     Result := PEnget(hObj, PEP_nCURSORPAGEAMOUNT);
end;

procedure PESGraph.SetXAxisVertNumbering(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bXAXISVERTNUMBERING, Integer(NewValue));
end;
function PESGraph.GetXAxisVertNumbering: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bXAXISVERTNUMBERING));
end;

procedure PESGraph.SetLineGapThreshold(NewValue: Double);
begin
     PEvset(hObj, PEP_fLINEGAPTHRESHOLD, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetLineGapThreshold: Double;
begin
     PEvget(hObj, PEP_fLINEGAPTHRESHOLD, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetHorzLineAnnotation(nIndex: Integer; NewValue: Double);
begin
     PEvsetcell(hObj, PEP_faHORZLINEANNOTATION, nIndex, @NewValue);
end;
function PESGraph.GetHorzLineAnnotation(nIndex: Integer): Double;
begin
     PEvgetcell(hObj, PEP_faHORZLINEANNOTATION, nIndex, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetHorzLineAnnotationText(nIndex: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcell(hObj, PEP_szaHORZLINEANNOTATIONTEXT, nIndex, @tmpszstr);
end;
function PESGraph.GetHorzLineAnnotationText(nIndex: Integer): string;
begin
     PEvgetcell(hObj, PEP_szaHORZLINEANNOTATIONTEXT, nIndex, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetHorzLineAnnotationType(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naHORZLINEANNOTATIONTYPE, nIndex, @NewValue);
end;
function PESGraph.GetHorzLineAnnotationType(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naHORZLINEANNOTATIONTYPE, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetHorzLineAnnotationColor(nIndex: Integer; NewValue: TColor);
begin
     l := ColorToRGB(NewValue);
     PEvsetcell(hObj, PEP_dwaHORZLINEANNOTATIONCOLOR, nIndex, @l);
end;
function PESGraph.GetHorzLineAnnotationColor(nIndex: Integer): TColor;
begin
     PEvgetcell(hObj, PEP_dwaHORZLINEANNOTATIONCOLOR, nIndex, @l);
     Result := TColor(l);
end;

procedure PESGraph.SetVertLineAnnotation(nIndex: Integer; NewValue: Double);
begin
     PEvsetcell(hObj, PEP_faVERTLINEANNOTATION, nIndex, @NewValue);
end;
function PESGraph.GetVertLineAnnotation(nIndex: Integer): Double;
begin
     PEvgetcell(hObj, PEP_faVERTLINEANNOTATION, nIndex, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetVertLineAnnotationText(nIndex: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcell(hObj, PEP_szaVERTLINEANNOTATIONTEXT, nIndex, @tmpszstr);
end;
function PESGraph.GetVertLineAnnotationText(nIndex: Integer): string;
begin
     PEvgetcell(hObj, PEP_szaVERTLINEANNOTATIONTEXT, nIndex, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetVertLineAnnotationType(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naVERTLINEANNOTATIONTYPE, nIndex, @NewValue);
end;
function PESGraph.GetVertLineAnnotationType(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naVERTLINEANNOTATIONTYPE, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetVertLineAnnotationColor(nIndex: Integer; NewValue: TColor);
begin
     l := ColorToRGB(NewValue);
     PEvsetcell(hObj, PEP_dwaVERTLINEANNOTATIONCOLOR, nIndex, @l);
end;
function PESGraph.GetVertLineAnnotationColor(nIndex: Integer): TColor;
begin
     PEvgetcell(hObj, PEP_dwaVERTLINEANNOTATIONCOLOR, nIndex, @l);
     Result := TColor(l);
end;

procedure PESGraph.SetShowGraphAnnotations(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSHOWGRAPHANNOTATIONS, Integer(NewValue));
end;
function PESGraph.GetShowGraphAnnotations: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSHOWGRAPHANNOTATIONS));
end;

procedure PESGraph.SetShowXAxisAnnotations(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSHOWXAXISANNOTATIONS, Integer(NewValue));
end;
function PESGraph.GetShowXAxisAnnotations: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSHOWXAXISANNOTATIONS));
end;

procedure PESGraph.SetShowYAxisAnnotations(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSHOWYAXISANNOTATIONS, Integer(NewValue));
end;
function PESGraph.GetShowYAxisAnnotations: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSHOWYAXISANNOTATIONS));
end;

procedure PESGraph.SetShowHorzLineAnnotations(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSHOWHORZLINEANNOTATIONS, Integer(NewValue));
end;
function PESGraph.GetShowHorzLineAnnotations: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSHOWHORZLINEANNOTATIONS));
end;

procedure PESGraph.SetShowVertLineAnnotations(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSHOWVERTLINEANNOTATIONS, Integer(NewValue));
end;
function PESGraph.GetShowVertLineAnnotations: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSHOWVERTLINEANNOTATIONS));
end;

procedure PESGraph.SetAllowXAxisAnnotHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWXAXISANNOTHOTSPOTS, Integer(NewValue));
end;
function PESGraph.GetAllowXAxisAnnotHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWXAXISANNOTHOTSPOTS));
end;

procedure PESGraph.SetAllowYAxisAnnotHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWYAXISANNOTHOTSPOTS, Integer(NewValue));
end;
function PESGraph.GetAllowYAxisAnnotHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWYAXISANNOTHOTSPOTS));
end;

procedure PESGraph.SetAllowHorzLineAnnotHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWHORZLINEANNOTHOTSPOTS, Integer(NewValue));
end;
function PESGraph.GetAllowHorzLineAnnotHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWHORZLINEANNOTHOTSPOTS));
end;

procedure PESGraph.SetAllowVertLineAnnotHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWVERTLINEANNOTHOTSPOTS, Integer(NewValue));
end;
function PESGraph.GetAllowVertLineAnnotHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWVERTLINEANNOTHOTSPOTS));
end;

procedure PESGraph.SetGraphAnnotationColor(nIndex: Integer; NewValue: TColor);
begin
     l := ColorToRGB(NewValue);
     PEvsetcell(hObj, PEP_dwaGRAPHANNOTATIONCOLOR, nIndex, @l);
end;
function PESGraph.GetGraphAnnotationColor(nIndex: Integer): TColor;
begin
     PEvgetcell(hObj, PEP_dwaGRAPHANNOTATIONCOLOR, nIndex, @l);
     Result := TColor(l);
end;

procedure PESGraph.SetXAxisAnnotationColor(nIndex: Integer; NewValue: TColor);
begin
     l := ColorToRGB(NewValue);
     PEvsetcell(hObj, PEP_dwaXAXISANNOTATIONCOLOR, nIndex, @l);
end;
function PESGraph.GetXAxisAnnotationColor(nIndex: Integer): TColor;
begin
     PEvgetcell(hObj, PEP_dwaXAXISANNOTATIONCOLOR, nIndex, @l);
     Result := TColor(l);
end;

procedure PESGraph.SetYAxisAnnotationColor(nIndex: Integer; NewValue: TColor);
begin
     l := ColorToRGB(NewValue);
     PEvsetcell(hObj, PEP_dwaYAXISANNOTATIONCOLOR, nIndex, @l);
end;
function PESGraph.GetYAxisAnnotationColor(nIndex: Integer): TColor;
begin
     PEvgetcell(hObj, PEP_dwaYAXISANNOTATIONCOLOR, nIndex, @l);
     Result := TColor(l);
end;

procedure PESGraph.SetAxesAnnotationTextSize(NewValue: Integer);
begin
     PEnset(hObj, PEP_nAXESANNOTATIONTEXTSIZE, NewValue);
end;
function PESGraph.GetAxesAnnotationTextSize: Integer;
begin
     Result := PEnget(hObj, PEP_nAXESANNOTATIONTEXTSIZE);
end;

procedure PESGraph.SetLineAnnotationTextSize(NewValue: Integer);
begin
     PEnset(hObj, PEP_nLINEANNOTATIONTEXTSIZE, NewValue);
end;
function PESGraph.GetLineAnnotationTextSize: Integer;
begin
     Result := PEnget(hObj, PEP_nLINEANNOTATIONTEXTSIZE);
end;

procedure PESGraph.SetGraphAnnotationType(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naGRAPHANNOTATIONTYPE, nIndex, @NewValue);
end;
function PESGraph.GetGraphAnnotationType(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naGRAPHANNOTATIONTYPE, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetSubsetsToLegend(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naSUBSETSTOLEGEND, nIndex, @NewValue);
end;
function PESGraph.GetSubsetsToLegend(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naSUBSETSTOLEGEND, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetLegendAnnotationType(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naLEGENDANNOTATIONTYPE, nIndex, @NewValue);
end;
function PESGraph.GetLegendAnnotationType(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naLEGENDANNOTATIONTYPE, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetLegendAnnotationText(nIndex: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcell(hObj, PEP_szaLEGENDANNOTATIONTEXT, nIndex, @tmpszstr);
end;
function PESGraph.GetLegendAnnotationText(nIndex: Integer): string;
begin
     PEvgetcell(hObj, PEP_szaLEGENDANNOTATIONTEXT, nIndex, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetLegendAnnotationColor(nIndex: Integer; NewValue: TColor);
begin
     l := ColorToRGB(NewValue);
     PEvsetcell(hObj, PEP_dwaLEGENDANNOTATIONCOLOR, nIndex, @l);
end;
function PESGraph.GetLegendAnnotationColor(nIndex: Integer): TColor;
begin
     PEvgetcell(hObj, PEP_dwaLEGENDANNOTATIONCOLOR, nIndex, @l);
     Result := TColor(l);
end;

procedure PESGraph.SetZoomInterfaceOnly(NewValue: eZoomInterfaceOnly);
begin
     PEnset(hObj, PEP_nZOOMINTERFACEONLY, Integer(NewValue));
end;
function PESGraph.GetZoomInterfaceOnly: eZoomInterfaceOnly;
begin
     Result := eZoomInterfaceOnly(PEnget(hObj, PEP_nZOOMINTERFACEONLY));
end;

procedure PESGraph.SetZoomMode(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bZOOMMODE, Integer(NewValue));
end;
function PESGraph.GetZoomMode: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bZOOMMODE));
end;

procedure PESGraph.SetZoomMinX(NewValue: Double);
begin
     PEvset(hObj, PEP_fZOOMMINX, @NewValue, 0);
end;
function PESGraph.GetZoomMinX: Double;
begin
     PEvget(hObj, PEP_fZOOMMINX, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetZoomMaxX(NewValue: Double);
begin
     PEvset(hObj, PEP_fZOOMMAXX, @NewValue, 0);
end;
function PESGraph.GetZoomMaxX: Double;
begin
     PEvget(hObj, PEP_fZOOMMAXX, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetZoomMinY(NewValue: Double);
begin
     PEvset(hObj, PEP_fZOOMMINY, @NewValue, 0);
end;
function PESGraph.GetZoomMinY: Double;
begin
     PEvget(hObj, PEP_fZOOMMINY, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetZoomMaxY(NewValue: Double);
begin
     PEvset(hObj, PEP_fZOOMMAXY, @NewValue, 0);
end;
function PESGraph.GetZoomMaxY: Double;
begin
     PEvget(hObj, PEP_fZOOMMAXY, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetVertScrollPos(NewValue: Integer);
begin
     PEnset(hObj, PEP_nVERTSCROLLPOS, NewValue);
end;
function PESGraph.GetVertScrollPos: Integer;
begin
     Result := PEnget(hObj, PEP_nVERTSCROLLPOS);
end;

procedure PESGraph.SetHorzScrollPos(NewValue: Integer);
begin
     PEnset(hObj, PEP_nHORZSCROLLPOS, NewValue);
end;
function PESGraph.GetHorzScrollPos: Integer;
begin
     Result := PEnget(hObj, PEP_nHORZSCROLLPOS);
end;

procedure PESGraph.SetAllowDebugOutput(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWDEBUGOUTPUT, Integer(NewValue));
end;
function PESGraph.GetAllowDebugOutput: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWDEBUGOUTPUT));
end;

procedure PESGraph.SetVertOrient90Degrees(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bVERTORIENT90DEGREES, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetVertOrient90Degrees: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bVERTORIENT90DEGREES));
end;

procedure PESGraph.SetPointColors(nSubset: Integer; nPoint: Integer; NewValue: TColor);
begin
     l := Longint(NewValue);
     PEvsetcellEx(hObj, PEP_dwaPOINTCOLORS, nSubset, nPoint, @l);
end;
function PESGraph.GetPointColors(nSubset: Integer; nPoint: Integer): TColor;
begin
     PEvgetcellEx(hObj, PEP_dwaPOINTCOLORS, nSubset, nPoint, @l);
     Result := TColor(l);
end;

procedure PESGraph.SetMultiAxesSubsets(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naMULTIAXESSUBSETS, nIndex, @NewValue);
end;
function PESGraph.GetMultiAxesSubsets(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naMULTIAXESSUBSETS, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetGraphAnnotationAxis(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naGRAPHANNOTATIONAXIS, nIndex, @NewValue);
end;
function PESGraph.GetGraphAnnotationAxis(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naGRAPHANNOTATIONAXIS, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetHorzLineAnnotationAxis(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naHORZLINEANNOTATIONAXIS, nIndex, @NewValue);
end;
function PESGraph.GetHorzLineAnnotationAxis(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naHORZLINEANNOTATIONAXIS, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetMultiAxesProportions(nIndex: Integer; NewValue: Single);
begin
     PEvsetcell(hObj, PEP_faMULTIAXESPROPORTIONS, nIndex, @NewValue);
end;
function PESGraph.GetMultiAxesProportions(nIndex: Integer): Single;
begin
     PEvgetcell(hObj, PEP_faMULTIAXESPROPORTIONS, nIndex, @tmpS);
     Result := tmpS;
end;

procedure PESGraph.SetLegendAnnotationAxis(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naLEGENDANNOTATIONAXIS, nIndex, @NewValue);
end;
function PESGraph.GetLegendAnnotationAxis(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naLEGENDANNOTATIONAXIS, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetWorkingAxis(NewValue: Integer);
begin
     PEnset(hObj, PEP_nWORKINGAXIS, NewValue);
end;
function PESGraph.GetWorkingAxis: Integer;
begin
     Result := PEnget(hObj, PEP_nWORKINGAXIS);
end;

procedure PESGraph.SetLogScaleExpLabels(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bLOGSCALEEXPLABELS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetLogScaleExpLabels: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bLOGSCALEEXPLABELS));
end;

procedure PESGraph.SetUsingXDataII(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bUSINGXDATAII, Integer(NewValue));
end;
function PESGraph.GetUsingXDataII: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bUSINGXDATAII));
end;

procedure PESGraph.SetUsingYDataII(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bUSINGYDATAII, Integer(NewValue));
end;
function PESGraph.GetUsingYDataII: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bUSINGYDATAII));
end;

procedure PESGraph.SetDateTimeMode(NewValue: eDateTimeMode);
begin
     PEnset(hObj, PEP_nDATETIMEMODE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetDateTimeMode: eDateTimeMode;
begin
     Result := eDateTimeMode(PEnget(hObj, PEP_nDATETIMEMODE));
end;

procedure PESGraph.SetPlottingMethodII(NewValue: ePlottingMethodII);
var
   pm: Integer;
   nv: Integer;
begin
     nv := Integer(NewValue);
     case nv of
          0: pm := 0;
          1: pm := 2;
          2: pm := 8;
          3: pm := 13;
          4: pm := 15;
          5: pm := 16;
          6: pm := 17;
          7: pm := 21;
          8: pm := 22;
     end;
     PEnset(hObj, PEP_nPLOTTINGMETHODII, pm);
     ResetandInvalidate;
end;
function PESGraph.GetPlottingMethodII: ePlottingMethodII;
var
   pm: Integer;
begin
     pm := PEnget(hObj, PEP_nPLOTTINGMETHODII);
     case pm of
          0: Result := ePlottingMethodII(0);
          2: Result := ePlottingMethodII(1);
          8: Result := ePlottingMethodII(2);
          13: Result := ePlottingMethodII(3);
          15: Result := ePlottingMethodII(4);
          16: Result := ePlottingMethodII(5);
          17: Result := ePlottingMethodII(6);
          21: Result := ePlottingMethodII(7);
          22: Result := ePlottingMethodII(8);
     end;
end;

procedure PESGraph.SetBarWidth(NewValue: Double);
begin
     PEvset(hObj, PEP_fBARWIDTH, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetBarWidth: Double;
begin
     PEvget(hObj, PEP_fBARWIDTH, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetTXAxisComparisonSubsets(NewValue: Integer);
begin
     PEnset(hObj, PEP_nTXAXISCOMPARISONSUBSETS, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetTXAxisComparisonSubsets: Integer;
begin
     Result := PEnget(hObj, PEP_nTXAXISCOMPARISONSUBSETS);
end;

procedure PESGraph.SetTXAxisLabel(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szTXAXISLABEL, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetTXAxisLabel: string;
begin
     PEszget(hObj, PEP_szTXAXISLABEL, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetScaleForTXData(NewValue: Integer);
begin
     PEnset(hObj, PEP_nSCALEFORTXDATA, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetScaleForTXData: Integer;
begin
     Result := PEnget(hObj, PEP_nSCALEFORTXDATA);
end;

procedure PESGraph.SetTXAxisScaleControl(NewValue: eAxisScaleControl);
begin
     PEnset(hObj, PEP_nTXAXISSCALECONTROL, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetTXAxisScaleControl: eAxisScaleControl;
begin
     Result := eAxisScaleControl(PEnget(hObj, PEP_nTXAXISSCALECONTROL));
end;

procedure PESGraph.SetManualScaleControlTX(NewValue: eManualScaleControl);
begin
     PEnset(hObj, PEP_nMANUALSCALECONTROLTX, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetManualScaleControlTX: eManualScaleControl;
begin
     Result := eManualScaleControl(PEnget(hObj, PEP_nMANUALSCALECONTROLTX));
end;

procedure PESGraph.SetManualMinTX(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALMINTX, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualMinTX: Double;
begin
     PEvget(hObj, PEP_fMANUALMINTX, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualMaxTX(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALMAXTX, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualMaxTX: Double;
begin
     PEvget(hObj, PEP_fMANUALMAXTX, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualTXAxisTicknLine(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bMANUALTXAXISTICKNLINE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetManualTXAxisTicknLine: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bMANUALTXAXISTICKNLINE));
end;

procedure PESGraph.SetManualTXAxisTick(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALTXAXISTICK, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualTXAxisTick: Double;
begin
     PEvget(hObj, PEP_fMANUALTXAXISTICK, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualTXAxisLine(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALTXAXISLINE, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualTXAxisLine: Double;
begin
     PEvget(hObj, PEP_fMANUALTXAXISLINE, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetForceTopXAxis(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bFORCETOPXAXIS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetForceTopXAxis: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bFORCETOPXAXIS));
end;

procedure PESGraph.SetXAxisOnTop(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bXAXISONTOP, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetXAxisOnTop: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bXAXISONTOP));
end;

procedure PESGraph.SetYAxisOnRight(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bYAXISONRIGHT, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetYAxisOnRight: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bYAXISONRIGHT));
end;

procedure PESGraph.SetMultiSubTitles(nIndex: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcell(hObj, PEP_szaMULTISUBTITLES, nIndex, @tmpszstr);
end;
function PESGraph.GetMultiSubTitles(nIndex: Integer): string;
begin
     PEvgetcell(hObj, PEP_szaMULTISUBTITLES, nIndex, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetMultiBottomTitles(nIndex: Integer; NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEvsetcell(hObj, PEP_szaMULTIBOTTOMTITLES, nIndex, @tmpszstr);
end;
function PESGraph.GetMultiBottomTitles(nIndex: Integer): string;
begin
     PEvgetcell(hObj, PEP_szaMULTIBOTTOMTITLES, nIndex, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetFocalRect(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bFOCALRECT, Integer(NewValue));
end;
function PESGraph.GetFocalRect: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bFOCALRECT));
end;

procedure PESGraph.SetFontSizeGlobalCntl(NewValue: Single);
begin
     PEvset(hObj, PEP_fFONTSIZEGLOBALCNTL, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetFontSizeGlobalCntl: Single;
begin
     PEvget(hObj, PEP_fFONTSIZEGLOBALCNTL, @tmpS);
     Result := tmpS;
end;

procedure PESGraph.SetFontSizeTitleCntl(NewValue: Single);
begin
     PEvset(hObj, PEP_fFONTSIZETITLECNTL, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetFontSizeTitleCntl: Single;
begin
     PEvget(hObj, PEP_fFONTSIZETITLECNTL, @tmpS);
     Result := tmpS;
end;

procedure PESGraph.SetSubsetByPoint(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSUBSETBYPOINT, Integer(NewValue));
end;
function PESGraph.GetSubsetByPoint: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSUBSETBYPOINT));
end;

procedure PESGraph.SetShowYAxis(NewValue: eShowAxis);
begin
     PEnset(hObj, PEP_nSHOWYAXIS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetShowYAxis: eShowAxis;
begin
     Result := eShowAxis(PEnget(hObj, PEP_nSHOWYAXIS));
end;

procedure PESGraph.SetShowRYAxis(NewValue: eShowAxis);
begin
     PEnset(hObj, PEP_nSHOWRYAXIS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetShowRYAxis: eShowAxis;
begin
     Result := eShowAxis(PEnget(hObj, PEP_nSHOWRYAXIS));
end;

procedure PESGraph.SetShowXAxis(NewValue: eShowAxis);
begin
     PEnset(hObj, PEP_nSHOWXAXIS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetShowXAxis: eShowAxis;
begin
     Result := eShowAxis(PEnget(hObj, PEP_nSHOWXAXIS));
end;

procedure PESGraph.SetShowTXAxis(NewValue: eShowAxis);
begin
     PEnset(hObj, PEP_nSHOWTXAXIS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetShowTXAxis: eShowAxis;
begin
     Result := eShowAxis(PEnget(hObj, PEP_nSHOWTXAXIS));
end;

procedure PESGraph.SetGridStyle(NewValue: eGridStyle);
begin
     PEnset(hObj, PEP_nGRIDSTYLE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetGridStyle: eGridStyle;
begin
     Result := eGridStyle(PEnget(hObj, PEP_nGRIDSTYLE));
end;

procedure PESGraph.SetInvertedYAxis(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bINVERTEDYAXIS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetInvertedYAxis: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bINVERTEDYAXIS));
end;

procedure PESGraph.SetInvertedRYAxis(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bINVERTEDRYAXIS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetInvertedRYAxis: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bINVERTEDRYAXIS));
end;

procedure PESGraph.SetInvertedXAxis(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bINVERTEDXAXIS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetInvertedXAxis: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bINVERTEDXAXIS));
end;

procedure PESGraph.SetInvertedTXAxis(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bINVERTEDTXAXIS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetInvertedTXAxis: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bINVERTEDTXAXIS));
end;

procedure PESGraph.SetYAxisColor(NewValue: TColor);
begin
{$IFDEF WIN32}
     PEnset(hObj, PEP_dwYAXISCOLOR, ColorToRGB(NewValue));
{$ELSE}
     PElset(hObj, PEP_dwYAXISCOLOR, ColorToRGB(NewValue));
{$ENDIF}
     ResetandInvalidate;
end;
function PESGraph.GetYAxisColor: TColor;
begin
{$IFDEF WIN32}
     Result := TColor(PEnget(hObj, PEP_dwYAXISCOLOR));
{$ELSE}
     Result := TColor(PElget(hObj, PEP_dwYAXISCOLOR));
{$ENDIF}
end;

procedure PESGraph.SetRYAxisColor(NewValue: TColor);
begin
{$IFDEF WIN32}
     PEnset(hObj, PEP_dwRYAXISCOLOR, ColorToRGB(NewValue));
{$ELSE}
     PElset(hObj, PEP_dwRYAXISCOLOR, ColorToRGB(NewValue));
{$ENDIF}
     ResetandInvalidate;
end;
function PESGraph.GetRYAxisColor: TColor;
begin
{$IFDEF WIN32}
     Result := TColor(PEnget(hObj, PEP_dwRYAXISCOLOR));
{$ELSE}
     Result := TColor(PElget(hObj, PEP_dwRYAXISCOLOR));
{$ENDIF}
end;

procedure PESGraph.SetXAxisColor(NewValue: TColor);
begin
{$IFDEF WIN32}
     PEnset(hObj, PEP_dwXAXISCOLOR, ColorToRGB(NewValue));
{$ELSE}
     PElset(hObj, PEP_dwXAXISCOLOR, ColorToRGB(NewValue));
{$ENDIF}
     ResetandInvalidate;
end;
function PESGraph.GetXAxisColor: TColor;
begin
{$IFDEF WIN32}
     Result := TColor(PEnget(hObj, PEP_dwXAXISCOLOR));
{$ELSE}
     Result := TColor(PElget(hObj, PEP_dwXAXISCOLOR));
{$ENDIF}
end;

procedure PESGraph.SetTXAxisColor(NewValue: TColor);
begin
{$IFDEF WIN32}
     PEnset(hObj, PEP_dwTXAXISCOLOR, ColorToRGB(NewValue));
{$ELSE}
     PElset(hObj, PEP_dwTXAXISCOLOR, ColorToRGB(NewValue));
{$ENDIF}
     ResetandInvalidate;
end;
function PESGraph.GetTXAxisColor: TColor;
begin
{$IFDEF WIN32}
     Result := TColor(PEnget(hObj, PEP_dwTXAXISCOLOR));
{$ELSE}
     Result := TColor(PElget(hObj, PEP_dwTXAXISCOLOR));
{$ENDIF}
end;

procedure PESGraph.SetFontSizeLegendCntl(NewValue: Single);
begin
     PEvset(hObj, PEP_fFONTSIZELEGENDCNTL, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetFontSizeLegendCntl: Single;
begin
     PEvget(hObj, PEP_fFONTSIZELEGENDCNTL, @tmpS);
     Result := tmpS;
end;

procedure PESGraph.SetYAxisLongTicks(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bYAXISLONGTICKS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetYAxisLongTicks: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bYAXISLONGTICKS));
end;

procedure PESGraph.SetRYAxisLongTicks(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bRYAXISLONGTICKS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetRYAxisLongTicks: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bRYAXISLONGTICKS));
end;

procedure PESGraph.SetXAxisLongTicks(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bXAXISLONGTICKS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetXAxisLongTicks: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bXAXISLONGTICKS));
end;

procedure PESGraph.SetTXAxisLongTicks(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bTXAXISLONGTICKS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetTXAxisLongTicks: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bTXAXISLONGTICKS));
end;

procedure PESGraph.SetMultiAxesSeparators(NewValue: eMultiAxesSeparators);
begin
     PEnset(hObj, PEP_nMULTIAXESSEPARATORS, Integer(NewValue));
end;
function PESGraph.GetMultiAxesSeparators: eMultiAxesSeparators;
begin
     Result := eMultiAxesSeparators(PEnget(hObj, PEP_nMULTIAXESSEPARATORS));
end;

procedure PESGraph.SetZoomMinAxis(NewValue: Integer);
begin
     PEnset(hObj, PEP_nZOOMMINAXIS, NewValue);
end;
function PESGraph.GetZoomMinAxis: Integer;
begin
     Result := PEnget(hObj, PEP_nZOOMMINAXIS);
end;

procedure PESGraph.SetZoomMaxAxis(NewValue: Integer);
begin
     PEnset(hObj, PEP_nZOOMMAXAXIS, NewValue);
end;
function PESGraph.GetZoomMaxAxis: Integer;
begin
     Result := PEnget(hObj, PEP_nZOOMMAXAXIS);
end;

procedure PESGraph.SetYDataII(nSubset: Integer; nPoint: Integer; NewValue: Double);
begin
     PEvsetcellEx(hObj, PEP_faYDATAII, nSubset, nPoint, @NewValue);
end;
function PESGraph.GetYDataII(nSubset: Integer; nPoint: Integer): Double;
begin
     PEvgetcellEx(hObj, PEP_faYDATAII, nSubset, nPoint, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetXDataII(nSubset: Integer; nPoint: Integer; NewValue: Double);
begin
     PEvsetcellEx(hObj, PEP_faXDATAII, nSubset, nPoint, @NewValue);
end;
function PESGraph.GetXDataII(nSubset: Integer; nPoint: Integer): Double;
begin
     PEvgetcellEx(hObj, PEP_faXDATAII, nSubset, nPoint, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetLeftMargin(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szLEFTMARGIN, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetLeftMargin: string;
begin
     PEszget(hObj, PEP_szLEFTMARGIN, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetTopMargin(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szTOPMARGIN, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetTopMargin: string;
begin
     PEszget(hObj, PEP_szTOPMARGIN, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetRightMargin(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szRIGHTMARGIN, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetRightMargin: string;
begin
     PEszget(hObj, PEP_szRIGHTMARGIN, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetBottomMargin(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szBOTTOMMARGIN, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetBottomMargin: string;
begin
     PEszget(hObj, PEP_szBOTTOMMARGIN, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetAllowOleExport(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWOLEEXPORT, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowOleExport: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWOLEEXPORT));
end;

procedure PESGraph.SetAutoScaleData(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bAUTOSCALEDATA, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAutoScaleData: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bAUTOSCALEDATA));
end;

procedure PESGraph.SetOverlapMultiAxes(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naOVERLAPMULTIAXES, nIndex, @NewValue);
end;
function PESGraph.GetOverlapMultiAxes(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naOVERLAPMULTIAXES, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetArrowCursor(NewValue: Integer);
begin
     PEnset(hObj, PEP_hARROWCURSOR, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetArrowCursor: Integer;
begin
     Result := PEnget(hObj, PEP_hARROWCURSOR);
end;

procedure PESGraph.SetHandCursor(NewValue: Integer);
begin
     PEnset(hObj, PEP_hHANDCURSOR, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetHandCursor: Integer;
begin
     Result := PEnget(hObj, PEP_hHANDCURSOR);
end;

procedure PESGraph.SetZoomCursor(NewValue: Integer);
begin
     PEnset(hObj, PEP_hZOOMCURSOR, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetZoomCursor: Integer;
begin
     Result := PEnget(hObj, PEP_hZOOMCURSOR);
end;

procedure PESGraph.SetNoDropCursor(NewValue: Integer);
begin
     PEnset(hObj, PEP_hNODROPCURSOR, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetNoDropCursor: Integer;
begin
     Result := PEnget(hObj, PEP_hNODROPCURSOR);
end;


procedure PESGraph.SetSubsetShades(nIndex: Integer; NewValue: TColor);
begin
     l := ColorToRGB(NewValue);
     PEvsetcell(hObj, PEP_dwaSUBSETSHADES, nIndex, @l);
end;
function PESGraph.GetSubsetShades(nIndex: Integer): TColor;
begin
     PEvgetcell(hObj, PEP_dwaSUBSETSHADES, nIndex, @l);
     Result := TColor(l);
end;

procedure PESGraph.SetCustom(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bCUSTOM, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetCustom: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bCUSTOM));
end;

procedure PESGraph.SetCacheBmp(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bCACHEBMP, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetCacheBmp: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bCACHEBMP));
end;

function PESGraph.GetPainting: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bPAINTING));
end;

procedure PESGraph.SetNoCustomParms(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bNOCUSTOMPARMS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetNoCustomParms: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bNOCUSTOMPARMS));
end;

procedure PESGraph.SetNoHelp(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bNOHELP, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetNoHelp: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bNOHELP));
end;

procedure PESGraph.SetAllowTitleHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWTITLEHOTSPOTS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowTitleHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWTITLEHOTSPOTS));
end;

procedure PESGraph.SetAllowSubTitleHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWSUBTITLEHOTSPOTS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowSubTitleHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWSUBTITLEHOTSPOTS));
end;

procedure PESGraph.SetAllowBottomTitleHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWBOTTOMTITLEHOTSPOTS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowBottomTitleHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWBOTTOMTITLEHOTSPOTS));
end;

procedure PESGraph.SetAllowJpegOutput(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWJPEGOUTPUT, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowJpegOutput: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWJPEGOUTPUT));
end;

procedure PESGraph.SetHelpFileName(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szHELPFILENAME, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetHelpFileName: string;
begin
     PEszget(hObj, PEP_szHELPFILENAME, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetDataHotSpotLimit(NewValue: Integer);
begin
     PEnset(hObj, PEP_nDATAHOTSPOTLIMIT, NewValue);
//     ResetandInvalidate;
end;
function PESGraph.GetDataHotSpotLimit: Integer;
begin
     Result := PEnget(hObj, PEP_nDATAHOTSPOTLIMIT);
end;

procedure PESGraph.SetHourGlassThreshold(NewValue: Integer);
begin
     PEnset(hObj, PEP_nHOURGLASSTHRESHOLD, NewValue);
//     ResetandInvalidate;
end;
function PESGraph.GetHourGlassThreshold: Integer;
begin
     Result := PEnget(hObj, PEP_nHOURGLASSTHRESHOLD);
end;

procedure PESGraph.SetNoHiddenLinesInArea(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bNOHIDDENLINESINAREA, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetNoHiddenLinesInArea: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bNOHIDDENLINESINAREA));
end;

procedure PESGraph.SetSpecificPlotModeColor(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSPECIFICPLOTMODECOLOR, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetSpecificPlotModeColor: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSPECIFICPLOTMODECOLOR));
end;

procedure PESGraph.SetLogicalLimit(NewValue: Integer);
begin
     PEnset(hObj, PEP_nLOGICALLIMIT, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetLogicalLimit: Integer;
begin
     Result := PEnget(hObj, PEP_nLOGICALLIMIT);
end;

procedure PESGraph.SetNullDataGaps(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bNULLDATAGAPS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetNullDataGaps: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bNULLDATAGAPS));
end;

procedure PESGraph.SetAllowStep(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWSTEP, Integer(NewValue));
end;
function PESGraph.GetAllowStep: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWSTEP));
end;

procedure PESGraph.SetScrollingVertZoom(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSCROLLINGVERTZOOM, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetScrollingVertZoom: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSCROLLINGVERTZOOM));
end;

procedure PESGraph.SetAxisFormatY(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szAXISFORMATY, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetAxisFormatY: string;
begin
     PEszget(hObj, PEP_szAXISFORMATY, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetAxisFormatRY(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szAXISFORMATRY, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetAxisFormatRY: string;
begin
     PEszget(hObj, PEP_szAXISFORMATRY, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetZoomMinRY(NewValue: Double);
begin
     PEvset(hObj, PEP_fZOOMMINRY, @NewValue, 0);
end;
function PESGraph.GetZoomMinRY: Double;
begin
     PEvget(hObj, PEP_fZOOMMINRY, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetZoomMaxRY(NewValue: Double);
begin
     PEvset(hObj, PEP_fZOOMMAXRY, @NewValue, 0);
end;
function PESGraph.GetZoomMaxRY: Double;
begin
     PEvget(hObj, PEP_fZOOMMAXRY, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetThreeDThreshold(NewValue: Integer);
begin
     PEnset(hObj, PEP_n3DTHRESHOLD, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetThreeDThreshold: Integer;
begin
     Result := PEnget(hObj, PEP_n3DTHRESHOLD);
end;

procedure PESGraph.SetHotSpotSize(NewValue: eHotSpotSize);
begin
     PEnset(hObj, PEP_nHOTSPOTSIZE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetHotSpotSize: eHotSpotSize;
begin
     Result := eHotSpotSize(PEnget(hObj, PEP_nHOTSPOTSIZE));
end;

procedure PESGraph.SetAllowAxisLabelHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWAXISLABELHOTSPOTS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowAxisLabelHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWAXISLABELHOTSPOTS));
end;

procedure PESGraph.SetAllowAxisHotSpots(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWAXISHOTSPOTS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowAxisHotSpots: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWAXISHOTSPOTS));
end;

procedure PESGraph.SetBestFitFix(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bBESTFITFIX, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetBestFitFix: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bBESTFITFIX));
end;

procedure PESGraph.SetBoxPlotColor(NewValue: TColor);
begin
{$IFDEF WIN32}
     PEnset(hObj, PEP_dwBOXPLOTCOLOR, ColorToRGB(NewValue));
{$ELSE}
     PElset(hObj, PEP_dwBOXPLOTCOLOR, ColorToRGB(NewValue));
{$ENDIF}
     ResetandInvalidate;
end;
function PESGraph.GetBoxPlotColor: TColor;
begin
{$IFDEF WIN32}
     Result := TColor(PEnget(hObj, PEP_dwBOXPLOTCOLOR));
{$ELSE}
     Result := TColor(PElget(hObj, PEP_dwBOXPLOTCOLOR));
{$ENDIF}
end;

procedure PESGraph.SetAllowRibbon(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWRIBBON, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowRibbon: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWRIBBON));
end;

procedure PESGraph.SetSpecialScalingY(NewValue: eSpecialScaling);
begin
     PEnset(hObj, PEP_nSPECIALSCALINGY, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetSpecialScalingY: eSpecialScaling;
begin
     Result := eSpecialScaling(PEnget(hObj, PEP_nSPECIALSCALINGY));
end;

procedure PESGraph.SetSpecialScalingRY(NewValue: eSpecialScaling);
begin
     PEnset(hObj, PEP_nSPECIALSCALINGRY, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetSpecialScalingRY: eSpecialScaling;
begin
     Result := eSpecialScaling(PEnget(hObj, PEP_nSPECIALSCALINGRY));
end;

procedure PESGraph.SetLogTickThreshold(NewValue: Integer);
begin
     PEnset(hObj, PEP_nLOGTICKTHRESHOLD, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetLogTickThreshold: Integer;
begin
     Result := PEnget(hObj, PEP_nLOGTICKTHRESHOLD);
end;

function PESGraph.GetBestFitCoeffs(nSubset: Integer; nPoint: Integer): Double;
var
   o: Integer;
begin
     o := (nSubset * 10) + nPoint;
     PEvgetcell(hObj, PEP_faBESTFITCOEFFS, o, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetSubsetDegree(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naSUBSETDEGREE, nIndex, @NewValue);
end;
function PESGraph.GetSubsetDegree(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naSUBSETDEGREE, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetGraphAnnotationHotSpot(nIndex: Integer; NewValue: Integer);
begin
     PEvsetcell(hObj, PEP_naGRAPHANNOTATIONHOTSPOT, nIndex, @NewValue);
end;
function PESGraph.GetGraphAnnotationHotSpot(nIndex: Integer): Integer;
begin
     PEvgetcell(hObj, PEP_naGRAPHANNOTATIONHOTSPOT, nIndex, @tmpN);
     Result := tmpN;
end;

procedure PESGraph.SetAutoMinMaxPadding(NewValue: Integer);
begin
     PEnset(hObj, PEP_nAUTOMINMAXPADDING, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetAutoMinMaxPadding: Integer;
begin
     Result := PEnget(hObj, PEP_nAUTOMINMAXPADDING);
end;

procedure PESGraph.SetLegendLocation(NewValue: eLegendLocation);
begin
     PEnset(hObj, PEP_nLEGENDLOCATION, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetLegendLocation: eLegendLocation;
begin
     Result := eLegendLocation(PEnget(hObj, PEP_nLEGENDLOCATION));
end;

procedure PESGraph.SetNoGridLineMultiples(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bNOGRIDLINEMULTIPLES, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetNoGridLineMultiples: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bNOGRIDLINEMULTIPLES));
end;

procedure PESGraph.SetStartTime(NewValue: Double);
begin
     PEvset(hObj, PEP_fSTARTTIME, @NewValue, 0);
end;
function PESGraph.GetStartTime: Double;
begin
     PEvget(hObj, PEP_fSTARTTIME, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetEndTime(NewValue: Double);
begin
     PEvset(hObj, PEP_fENDTIME, @NewValue, 0);
end;
function PESGraph.GetEndTime: Double;
begin
     PEvget(hObj, PEP_fENDTIME, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetAxisFormatX(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szAXISFORMATX, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetAxisFormatX: string;
begin
     PEszget(hObj, PEP_szAXISFORMATX, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetAxisFormatTX(NewValue: string);
begin
     StrPCopy(tmpszstr, NewValue);
     PEszset(hObj, PEP_szAXISFORMATTX, @tmpszstr);
     ResetandInvalidate;
end;
function PESGraph.GetAxisFormatTX: string;
begin
     PEszget(hObj, PEP_szAXISFORMATTX, @tmpszstr);
     tmpstring := StrPas(tmpszstr);
     Result := tmpstring;
end;

procedure PESGraph.SetAllowContourLines(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWCONTOURLINES, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowContourLines: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWCONTOURLINES));
end;

procedure PESGraph.SetAllowContourColors(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWCONTOURCOLORS, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetAllowContourColors: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWCONTOURCOLORS));
end;

procedure PESGraph.SetManualMinZ(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALMINZ, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualMinZ: Double;
begin
     PEvget(hObj, PEP_fMANUALMINZ, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualMaxZ(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALMAXZ, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualMaxZ: Double;
begin
     PEvget(hObj, PEP_fMANUALMAXZ, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetManualScaleControlZ(NewValue: eManualScaleControl);
begin
     PEnset(hObj, PEP_nMANUALSCALECONTROLZ, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetManualScaleControlZ: eManualScaleControl;
begin
     Result := eManualScaleControl(PEnget(hObj, PEP_nMANUALSCALECONTROLZ));
end;

procedure PESGraph.SetManualZAxisLine(NewValue: Double);
begin
     PEvset(hObj, PEP_fMANUALZAXISLINE, @NewValue, 0);
     ResetandInvalidate;
end;
function PESGraph.GetManualZAxisLine: Double;
begin
     PEvget(hObj, PEP_fMANUALZAXISLINE, @tmpD);
     Result := tmpD;
end;

procedure PESGraph.SetContourLineLabelDensity(NewValue: Integer);
begin
     PEnset(hObj, PEP_nCONTOURLINELABELDENSITY, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetContourLineLabelDensity: Integer;
begin
     Result := PEnget(hObj, PEP_nCONTOURLINELABELDENSITY);
end;

procedure PESGraph.SetSpecialDateTimeMode(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bSPECIALDATETIMEMODE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetSpecialDateTimeMode: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bSPECIALDATETIMEMODE));
end;


procedure PESGraph.SetMaxDataPrecision(NewValue: Integer);
begin
     PEnset(hObj, PEP_nMAXDATAPRECISION, NewValue);
     ResetandInvalidate;
end;
function PESGraph.GetMaxDataPrecision: Integer;
begin
     Result := PEnget(hObj, PEP_nMAXDATAPRECISION);
end;

procedure PESGraph.SetAllowPage1(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWPAGE1, Integer(NewValue));
end;
function PESGraph.GetAllowPage1: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWPAGE1));
end;

procedure PESGraph.SetAllowPage2(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWPAGE2, Integer(NewValue));
end;
function PESGraph.GetAllowPage2: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWPAGE2));
end;

procedure PESGraph.SetAllowSubsetsPage(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWSUBSETSPAGE, Integer(NewValue));
end;
function PESGraph.GetAllowSubsetsPage: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWSUBSETSPAGE));
end;

procedure PESGraph.SetAllowFontPage(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWFONTPAGE, Integer(NewValue));
end;
function PESGraph.GetAllowFontPage: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWFONTPAGE));
end;

procedure PESGraph.SetAllowColorPage(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWCOLORPAGE, Integer(NewValue));
end;
function PESGraph.GetAllowColorPage: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWCOLORPAGE));
end;

procedure PESGraph.SetAllowStylePage(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWSTYLEPAGE, Integer(NewValue));
end;
function PESGraph.GetAllowStylePage: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWSTYLEPAGE));
end;

procedure PESGraph.SetAllowAxisPage(NewValue: Boolean);
begin
     PEnset(hObj, PEP_bALLOWAXISPAGE, Integer(NewValue));
end;
function PESGraph.GetAllowAxisPage: Boolean;
begin
     Result := Boolean(PEnget(hObj, PEP_bALLOWAXISPAGE));
end;

procedure PESGraph.SetMinimumPointSize(NewValue: eMinimumPointSize);
begin
     PEnset(hObj, PEP_nMINIMUMPOINTSIZE, Integer(NewValue));
     ResetandInvalidate;
end;
function PESGraph.GetMinimumPointSize: eMinimumPointSize;
begin
     Result := eMinimumPointSize(PEnget(hObj, PEP_nMINIMUMPOINTSIZE));
end;




end.
